#ifndef TGL_H
#define TGL_H

#include "../config.h"
#include "../globals.h"
#include "../figlet.h"

#include <windows.h>   // Header File For Windows
#include <math.h>      // Header File For Windows Math Library		( ADD )
#include <stdio.h>     // Header File For Standard Input/Output	( ADD )
#include <stdarg.h>    // Header File For Variable Argument Routines	( ADD )
#include <gl/gl.h>     // Header File For The OpenGL32 Library
#include <gl/glu.h>    // Header File For The GLu32 Library
#include <gl/glaux.h>  // Header File For The GLaux Library

class TGl : public Figlet {
public:
	HDC		    hDC;       // Private GDI Device Context
	HGLRC		  hRC; 	     // Permanent Rendering Context
	HWND		  hWnd;      // Holds Our Window Handle
	HINSTANCE	hInstance; // Holds The Instance Of The Application

	GLuint	base;			   // Base Display List For The Font Set	( ADD )
	GLfloat	rot;			   // Used To Rotate The Text		( ADD )

	int keys[256];		   // Array Used For The Keyboard Routine
	int active;		       // Window Active Flag Set To TRUE By Default
	int fullscreen;	     // Fullscreen Flag Set To Fullscreen Mode By Default

	GLYPHMETRICSFLOAT gmf[256];	// Storage For Information About Our Font
	
	TGl( void);
	~TGl( void);

	void signal( void);
	void instance( void);
	void idle( void);

	GLvoid BuildFont(GLvoid);
	GLvoid KillFont(GLvoid);
	GLvoid glPrint(const char *, ...);
	int DrawGLScene(GLvoid);
	GLvoid KillGLWindow(GLvoid);
	int CreateGLWindow(char *, int, int, int, int);
	int InitGL(GLvoid);
	GLvoid ReSizeGLScene(GLsizei width, GLsizei height);
};

#endif
