#include <time.h>
#ifdef WIN32
  #include <string.h>
  #include <time.h>
  #include <ctype.h>
  #include <windows.h>
#else
  #include <sys/time.h>
  #include <ctype.h>
  #include <time.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <unistd.h>
  #include <fcntl.h>
  #include <netdb.h>
  #include <stdlib.h>

  #include <netdb.h> 
  #include <arpa/inet.h>
  #include <netinet/in.h>
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <string.h>
#endif

#include "enc/encryption.h"

#include <string>
#include <map>

#include "globals.h"
#include <stdarg.h>
#include <ctype.h>
#include "sendcdkeycheck.h"
#include "commandlist.h"
#include "command.h"
#include "display.h"
#include "mylib.h"
//#include "vars.h"
#include "bot.h"
//#include "cas.h"
#include "vercheck.h"
// #include "gtk_profile.h"
#include "tools/build.h"

#include "config.h"

extern VerCheck *vercheck[4];
//extern Display *getDisp();
extern CommandList commandlist;
//extern Vars vars;
//extern Cas cas;
extern int done;

extern int cmd_Handler( char *, char *);


//===
// Returns 1 on success.
// Assumes buf is a 256 byte buffer. Will auto-terminate w/ a \0 on success.
int parseMsg( char *buf, Obj *obj_spkr, char *input, char *text, int clienttype) {
	//if (input)
	//	fprintf( stderr, "DEBUG: parseMsg called with input=>\"%s\"\n", input);
	//if (text)
	//	fprintf( stderr, "DEBUG: parseMsg called with text=>\"%s\"\n", text);

	//===
	// Quick sanity check.
		if (!buf) return 0;
		*buf = 0;

		if (!obj_spkr) return 0;
		if (!input) return 0;

		//char *input = globals->db->getObj("vars")->getVar( variable);
		//if (!input) return 0;

	//===
	// Ok, we are good.
		int pos = 0; int isdash = 0;

		while (*input && (pos < 255)) {
			//fprintf( stderr, "DEBUG: parseMsg pos=>%d input is %c\n", pos, *input);
			switch( *input) {
				case '&':
					input++;
					switch( *input) {
						case '&':
							buf[pos++] = *input;
							break;
						case '1':
						case '2':
						case '3':
						case '4':
						case '5':
						case '6':
						case '7':
						case '8':
						case '9':
							buf[pos++] = *input - '0';
							break;
						case 'a':
						case 'A':
						case 'b':
						case 'B':
						case 'c':
						case 'C':
						case 'd':
						case 'D':
						case 'e':
						case 'E':
						case 'f':
						case 'F':
							buf[pos++] = toupper(*input) - 'A' + 10;
							break;
					} break;
				case '%':
					input++;
					switch( *input) {
						case '(': // This one is rather complex.
							{
								//===
								// We expect this to look like %(flags) or %(latency) etc.
								char mybuf[ 256];
								strncpy( mybuf, input + 1, sizeof( mybuf) - 1);
								mybuf[ sizeof( mybuf) - 1] = 0;
								if (char *t = strchr( mybuf, ')')) {
									input++;
									*t = 0;
								}
								input += strlen( mybuf);
								
								char *res = obj_spkr->getVar( mybuf);
								if (res) {
									//===
									// Append the thingy
										strncpy( &buf[pos], res, 255 - pos);
										pos += strlen( res);
										if (pos > 255)
											pos = 255;
								}
							}
							break;
						case '-':
							input++;
							switch( *input) {
								case '1': // First parameters
								case '2':
								case '3':
								case '4':
								case '5':
								case '6':
								case '7':
								case '8':
								case '9':
									int n = *input - '0';

									char myBuf[ 256];
									strncpy( myBuf, text, sizeof( myBuf) - 1);
									myBuf[ sizeof( myBuf) - 1] = '\0';
										
									if (char *res = gettermnz( myBuf, n)) {
										
										strncpy( &buf[pos], res, 255 - pos);
										pos += strlen( res);
										if (pos > 255)
											pos = 255;
									}
									break;
							}
							break;
						case '1': // First parameters
						case '2':
						case '3':
						case '4':
						case '5':
						case '6':
						case '7':
						case '8':
						case '9':
							{
								int n = *input - '0';
								// fprintf( stderr, "DEBUG: parseMsg pos=>%d input is %c\n", pos, *input);
								if (text) {
									char myBuf[ 256];
									strncpy( myBuf, text, sizeof( myBuf) - 1);
									myBuf[ sizeof( myBuf) - 1] = '\0';

									// fprintf( stderr, "DEBUG: parseMsg is calling gettermn with n=>%d\n", n);
								//fprintf( stderr, "DEBUG: parseMsg 1 pos=>%d input is %c\n", pos, *input);
									char *res = gettermn( myBuf, n);
								//fprintf( stderr, "DEBUG: parseMsg 2 pos=>%d input is %c\n", pos, *input);
									if (res) {
										//return 0;
								//fprintf( stderr, "DEBUG: parseMsg 3 pos=>%d input is %c\n", pos, *input);
										strncpy( &buf[pos], res, 255 - pos);
								//fprintf( stderr, "DEBUG: parseMsg 4 pos=>%d input is %c\n", pos, *input);
										pos += strlen( res);
								//fprintf( stderr, "DEBUG: parseMsg 5 pos=>%d input is %c\n", pos, *input);
										if (pos > 255)
											pos = 255;
									}
								} //else
								//fprintf( stderr, "DEBUG: parseMsg pos=>%d input is %c\n", pos, *input);
								//	return 0;
							} break;
						case 'n': // The username in normal :)
							strncpy( &buf[pos], obj_spkr->getName(), 255 - pos);
							pos += strlen( obj_spkr->getName());
							if (pos > 255)
								pos = 255;
							break;
						case 'u': // The username w/ the *'s
							switch( clienttype) {
								case CLIENT_D2DV:
								case CLIENT_D2XP:
									buf[pos++] = '*';
								break;
							}
							if (pos < 255) {
								strncpy( &buf[pos], obj_spkr->getName(), 255 - pos);
								pos += strlen( obj_spkr->getName());
								if (pos > 255)
									pos = 255;
							}
							break;
						case 'V':
							{
								char buf2[ 256];
								sprintf( buf2, "%d", BUILD);
								strncpy( &buf[pos], buf2, 255 - pos);
								pos += strlen( buf2);
								if (pos > 255)
									pos = 255;
							}
							break;
						case 'Y': // Year
						case 'T': // Year
						case 'D': // Year
						case 'H': // Hours in %.2d
						case 'M': // Minutes in %.2d
						case 'S': // Seconds in %.2d
							{
								time_t t = time( 0);
								struct tm *_tm = localtime( &t);
								char tmpbuf[32]; tmpbuf[0] = '\0';
								switch( *input) {
									case 'Y': sprintf( tmpbuf, "%d", _tm->tm_year + 1900); break;
									case 'T': sprintf( tmpbuf, "%d", _tm->tm_mon + 1); break;
									case 'D': sprintf( tmpbuf, "%d", _tm->tm_mday); break;
									case 'H': sprintf( tmpbuf, "%.2d", _tm->tm_hour); break;
									case 'M': sprintf( tmpbuf, "%.2d", _tm->tm_min); break;
									case 'S': sprintf( tmpbuf, "%.2d", _tm->tm_sec); break;
								}
								strncpy( &buf[pos], tmpbuf, 255 - pos);
								pos += strlen( tmpbuf);
								if (pos > 255)
									pos = 255;
							} break;
						case '%':
							buf[pos++] = *input;
							break;
						default:
							break;
					}
					break;
				default:
					buf[pos++] = *input;
			}
			input++;
		}
		
	//===
	// Return
		buf[pos] = 0;

		//fprintf( stderr, "DEBUG: parseMsg returning with buf=>\"%s\"\n", buf);

		return 1;
}

int hex( char ch) {
	if ((ch >= '0') && (ch <= '9'))
		return ch - '0';
	
	if ((ch >= 'A') && (ch <= 'F'))
		return ch - 'A' + 10;

	if ((ch >= 'a') && (ch <= 'f'))
		return ch - 'a' + 10;

	return 0;
}

unsigned char zenc_crc( unsigned char *buf) {
  unsigned char ch = 0xAA; int n = 1;

  while (*buf)
    ch ^= *buf++ * 69069 ^ n++;

  return( ch < 32 ? ~ch : ch);
}

char *hex_decrypt( char *msg) {
  static char buf[ 1024];

  char *dest = &buf[0];
  char *src = msg + 1;

  // First check if it's hex.
//    if (!(strlen( msg) % 1)) {
//      strcpy( buf, msg);
//      return( buf);
//    }

    while (*src) {
      if (!isxdigit( *src)) {
        strcpy( buf, msg);
        return( buf);
      }
      src++;
    }

  // Now let's decode this.
    src = msg + 1;

    while (*src && *(src + 1)) {
      *dest = hex( *src) * 16 + hex(*(src+1));
      dest++;
      src += 2;
    }

  *dest = 0;

  return( buf);
}

// 0 - seed0
// 1 - seed1
// 2 - crc0 - seed0,seed1,' ',' ',string
// 3 - crc1 - seed0,seed1,crc0,' ',crypted msg
unsigned char *zenc_decrypt( unsigned char *msg) {
  int len = strlen( (char *)msg);
  if (len++ < 4) return( NULL);

  static unsigned char buf[ 1024], buf2[ 1024];

  strcpy( (char *)buf2, (char *)msg);
  bzero( buf, sizeof( buf));

  unsigned char crc0 = msg[2], crc1 = msg[3];

  buf2[3] = ' ';

  if (zenc_crc(buf2) != crc1) return( NULL);
  unsigned int seed = (msg[1] << 8) + msg[0];

  int i = 4;
  unsigned char *tmp = buf2 + 4;
   
  while (*tmp) {
    for (int o = 32; o < 256; o++)
        if ((unsigned char)(((o + seed) % 224) + 32) == *tmp) {
	buf[i] = o;
        break;   
      }
      
    seed = 69069 * seed + buf[i];

    tmp++;
    i++;
  }
  buf[i] = 0;

  buf[0] = buf2[0];
  buf[1] = buf2[1];
  buf[2] = ' ';
  buf[3] = ' ';

  if (zenc_crc( buf) == crc0) {
    memmove( buf, buf + 4, len);
    return( buf);
  }
  return( NULL);
}

char *Decrypt( char *src) {
  char source[ 1024];
  bzero( source, sizeof( source));
  strcpy( source, src);

  static char dest[ 1024];
  int len = source[0] - 64, pos = 0;
  for(int i = 1; i < (len * 2); i += 2)
    dest[pos++] = (source[i + 1] - 63) ^ (source[i] - 100);
  dest[pos] = 0;
  return( dest);
}

char *getStr( char *buf, int start, int num) {
  int size = *(u16 *)(buf + 2);
  char *tmp = buf + start;

  while (--num && (tmp - buf) < size)
    tmp += strlen(tmp) + 1;

  if ((tmp - buf) <= size)
    return( tmp);
  else
    return( 0);
}

char *trim2( char *buf) {
  char *p;
 
  for(p = buf; *p; p++)
    if ((*p == '\r') || (*p == '\n'))
      *p = ' ';

  p = buf;
  while ( isspace( *p))
    p++;
 
  strcpy( buf, p);
 
  int n = strlen( buf);
 
  if (n) {
    p = buf + n - 1;
 
    while ( isspace( *p))
      *p-- = '\0';
  }

  return( buf);
}



Bot::Bot( void) {
	objbot = NULL;

	pthread_mutex_init( &mutex, NULL);
	pkey = new std::list<char *>;
	profile = new std::list<char *>;
	profileMap = new std::map<u32,std::string>;
	input = new Input( this);

  clist = new CList( this);
  disp = new Display();
  //#ifdef DISP_GTK
  //  disp = new Window( this);
  //#else
  //  #ifdef WIN32
  //    disp = new Window( this);
  //  #else
  //    disp = getDisp();
  //  #endif
  //#endif

	lag_spoof = 0;
	lastlag = 100;
	active = 0;
	plug = 0;

	queue = new Enqueue();

  queue->addHandler( this);

  // window = 0;
  bzero( username,      sizeof( username));
  bzero( password,      sizeof( password));
  bzero( server,        sizeof( server));
  bzero( cdkey,         sizeof( cdkey));
  bzero( cdkey2,        sizeof( cdkey2));
  bzero( nick,          sizeof( nick));
  bzero( registered,    sizeof( registered));
  bzero( commandset,    sizeof( commandset));
  bzero( curchannel,    sizeof( curchannel));
  bzero( bindaddy,      sizeof( bindaddy));
  
  bzero( socks4_server, sizeof( socks4_server));
  socks4_port = 1080;
  bzero( socks4_userid, sizeof( socks4_userid));

  spawn = 0;
  display = 1; // 0 = off, 1 = on, 2 = gui

  bzero( homechannel, sizeof( homechannel));

  lastconnect_t = 0;

  session_num = session_key = 0;
  filter = 0;

  lastadd_time = lastidle_time = 0;
  lastadd_num = 0;

  profile_lastval = 0;
  profile_lasttime = 0;

  msg_lasttime = 0;
  latency = 0;

  clientType = 0;

  // Command Variables
    cmdIdle_d = 0;
    cmdIdle_t = 0;
    bzero( cmdIdle_msg, sizeof( cmdIdle_msg));

    cmdMode = 0;

  // Quotes
    firstQuote = 0;
    numQuotes = quoteStatus = 0;
    lastQuote = 0;

  proxy = new Proxy( this);
}

Bot::~Bot( void) {
	//===
	// Todo: delete pkey
	
	delete input;

  if (clist)
    delete clist;
  if (disp) // && (disp != getDisp()))
    delete disp;

  if (queue)
    delete queue;
}

void Bot::clear( void) {
  
}

int Bot::pkt_connected( void) {
	debug(("Bot::pkt_connected was called"));

	if (!isActive()) {
		debug(("Bot::pkt_connected called w/ a non-active bot."));
		netclose();
		return( -1);
	}
	
	if (Network::pkt_connected()) {
		debug(("Bot::pkt_connected, Network::pkt_connected told us we are not really connected."));
		return( -1);
	}
  
	debug(("Bot::pkt_connected is displaying text"));
	*disp << CBWHITE << "Info:  " << CBCYAN << getName() << CWHITE << " has connected." << endl;

	debug(("Bot::pkt_connected is raw sening a byte"));
	char ch = 1; rawsend( 1, &ch);

	debug(("Bot::pkt_connected is switching on getClientType()"));
	switch (getClientType()) {
		case CLIENT_W2BN: {
			debug(("Bot::pkt_connected is on CLIENT_W2BN"));
			*this << (u32)0x00000100 // unk - ver ?
				   << (u32)0x00000100 // unk - ver ?
			      << (u32)0xc8032dc1 // server ip ? 193.45.3.200 for europe1 ?! why why why
			      << (u32)0x04dff085 // client_id
			      << (u32)0xa2ebcc1f // client_token
			      << ""              // host
			      << "";             // user
			sendpkt( 0x1eff);
  	    
			//0000  ff 12 3c 00 20 f4 be d4 - 94 8b c2 01 20 b4 9b c6 ................
			//0010  51 8b c2 01 e0 01 00 00 - 09 04 00 00 09 04 00 00 ................
			//0020  09 04 00 00 65 65 75 00 - 31 00 55 53 41 00 55 6e ....enu.1.USA.Un
			//0030  69 74 65 64 20 53 74 61 - 74 65 73 00             ited States.

			debug(("Bot::pkt_connected is on CLIENT_W2BN - 1"));

        double secs = time(0) + 11644473600.0;
        secs += 3600 * 8; // heh
        *this << (u32)(secs*.0000001)
              << (u32)(secs*.00232830643653869628);

			secs -= 3600 * 8; // heh
        // Same for WC2 and SC

			debug(("Bot::pkt_connected is on CLIENT_W2BN - 2"));


        *this << (u32)(secs*.0000001)
            << (u32)(secs*.00232830643653869628)
            << (u32)0x000001e0 // time bias - TODO: blah whatever >;-) hope they don't care
            << (u32)0x00000409 // english
            << (u32)0x00000409 // english
            << (u32)0x00000409 // english
            << "enu"
            << "1"
            << "USA"
            << "United States";
			sendpkt( 0x12ff);

			debug(("Bot::pkt_connected is on CLIENT_W2BN - 3"));

        
			*this << (u32)0x49583836 //"68XINB2WO"
			      << (u32)0x5732424e //(u16)0
			      << (u32)0x0000004f //;
			      << (u32)0;
			sendpkt( 0x06ff);
			
			} break;
		case CLIENT_STAR:
			debug(("Bot::pkt_connected is on CLIENT_STAR"));
			*this << (u32)getSpawn()      // spawn ?
			      << (u32)0x49583836      // 68XI
			      << (u32)getClientType() // RATS
			      << (u32)0xc5            // client_token
			      << (u32)0               // ?
			      << (u32)0xf300000a      // ?
			      << (u32)0x000001e0      // bias
			      << (u32)0x00000409      // thingy
			      << (u32)0x00000409      // thingy
			      << "USA"                //
			      << "United States";     //
			sendpkt( 0x50ff);
			break;
		case CLIENT_SEXP:
			debug(("Bot::pkt_connected is on CLIENT_SEXP"));
			*this << (u32)getSpawn()      // spawn ?
			      << (u32)0x49583836      // 68XI
			      << (u32)getClientType() // RATS
			      << (u32)0xc5            // client_token
			      << (u32)0               // ?
			      << (u32)0xfe00000a      // ?
			      << (u32)0x000001e0      // bias
			      << (u32)0x00000409      // thingy
			      << (u32)0x00000409      // thingy
			      << "USA"                //
			      << "United States";     //
			sendpkt( 0x50ff);
			break;
		case CLIENT_JSTR:
			debug(("Bot::pkt_connected is on CLIENT_JSTR"));
			*this << (u32)0x00000001
			      << (u32)0x00000000
			      << (u32)0x00000000
			      << (u32)0x00000000
			      << (u32)0x00000000
			      << ""              // host
			      << "";             // user
			sendpkt( 0x1eff);
			break;
		case CLIENT_D2DV:
			debug(("Bot::pkt_connected is on CLIENT_D2DV"));
			*disp << "Error: D2DV has not been implemented yet. Disabled bot to avoid ip ban." << endl;
			setActive( 0);
			netclose();
			break;
			//  *this << (u32)getSpawn()      // spawn ?
			//        << (u32)0x49583836      // 68XI
			//        << (u32)getClientType() // VD2D
			//        << (u32)0x09            // client_token
			//        << (u32)0               // ?
			//        << (u32)0               // ?
			//        << (u32)0x000001e0      // bias
			//        << (u32)0x00000409      // thingy
			//        << (u32)0x00000409      // thingy
			//        << "USA"                //
			//        << "United States";     //
			//  sendpkt( 0x50ff);
			//  break;
		case CLIENT_D2XP:
			debug(("Bot::pkt_connected is on CLIENT_D2XP"));
			*this << (u32)0           // ? spawn ?
			      << (u32)0x49583836  // 68XI
			      << (u32)0x44325850  // PX2D
			      << (u32)0x09        // version
			      << (u32)0x00        // ?
			      << (u32)0x00        // ?
            << (u32)0x01e0         // bias
            << (u32)0x0409         // english
            << (u32)0x0409         // english
            << "USA"               //
            << "United States";
			sendpkt( 0x50ff);
			break;
		default:
			debug(("Bot::pkt_connected is on CLIENT_UNKNOWN"));
			*disp << "Error: Unknown client type, disabling to avoid ip ban." << endl;
			setActive( 0);
			netclose();
			break;
	}

	debug(("Bot::~pkt_connected was called"));
	return( 0);
}

void Bot::idle( void) {
	debug(("Bot::Idle()"));

	if (!isActive())
		return;

	if (getfd() == -1) {
    //if (!cas.isReady()) return;

	//===
	// Per popular request.
	{
		char *delay = globals->db->getObj("vars")->getVar("reconnect_delay");
		if (!delay)
			globals->db->getObj("vars")->setVar("reconnect_delay", "3");
		int idelay = 3;

		if (delay)
			idelay = atoi( delay);
		
		if ((time(0) - lastconnect_t) < idelay)
			return;
	}

    // TODO: These should be moved to a cleanup routine.
      session_num = session_key = 0;
      filter = 0;
      lastadd_time = lastidle_time = 0;
      lastadd_num = 0;
      profile_lastval = 0;
      profile_lasttime = 0;
      msg_lasttime = 0;
      latency = 0;
      lastping = time( 0);
      
    *disp << CBWHITE << "Info:  " << CBCYAN << getName() << CWHITE << " is not connected. Connecting to " << getServer() << endl;
    //input->update();
    #ifdef DEBUGBOT
      *disp << CBWHITE << "DEBUGBOT  " << CWHITE << "The clear/update thingy worked." << endl;
      //input->update();
    #endif

    lastconnect_t = time( 0);

    #ifdef DEBUGBOT
      *disp << CBWHITE << "DEBUGBOT  " << CWHITE << "Connecting to server..." << endl;
      //input->update();
    #endif

    if (netopen( getServer(), 6112, socks4_server, socks4_port, socks4_userid, bindaddy)) {
      *disp << CBWHITE << "Error: " << CBCYAN << getName() << CBRED <<" was unable to connect to server." << endl;
      //input->update();
      return;
    }

    #ifdef DEBUGBOT
      *disp << CBWHITE << "DEBUGBOT  " << CWHITE << "Netopened returned." << endl;
      //input->update();
    #endif

    return;
  }

  if (!filter) {
    #ifndef DEBUGBOT
      if (lastping &&  ((time(0) - lastping) > 120)) {
        *disp << CBYELLOW << "Sys:   " << CWHITE << "Have not heard from bnet in 120 seconds. Reconnecting." << endl;
        //input->update();
        netclose();
      }
    #endif

    //#ifdef DEBUGBOT
    //  *disp << CBWHITE << "DEBUGBOT: " << CWHITE << "Bot::Idle() is returning [NO FILTER]" << endl;
    //  //input->update();
    //#endif
    return;
  }
  
	debug(("Bot::Idle is handling all the checks"));

	checkAdds();

	{
		char *rejoin = objbot->getVar("auto_rejoin");
		if (!rejoin || (rejoin && atoi(rejoin)))
			checkHomeChannel();
	}

	checkOps();
	checkQuotes();
	checkIdle();
	checkPKey();
	checkProfile();

	debug(("Bot::Idle is handling the queue"));

	queue->idle();
}

int Bot::checkAdds( void) {
  if ((time(0) - lastadd_time) > 15) {
    lastadd_time = time(0);
    u32 buf[5] = { 0x001415FF, 0x49583836, 0x5732424E, 0, 0 };
    buf[4] = time( 0);

    switch (getClientType()) {
      case CLIENT_W2BN:
      case CLIENT_STAR:
      case CLIENT_SEXP:
      case CLIENT_JSTR:
      case CLIENT_D2DV:
      case CLIENT_D2XP:
        *this << (u32)0x49583836      // IX86
              << (u32)getClientType()
              << (u32)lastadd_num
              << (u32)time(0);
        sendpkt( 0x15ff);
        break;
    }

	// MFT
    //if (char *tmp = vars.getVar("debug_idle"))
    //  if (atoi( tmp)) {
    //    *disp << CBCYAN << "Info:  " << CBWHITE << "Sending a add request" << CWHITE << endl;
    //    //input->update();
    //  }

  }

  if ((time(0) - lastidle_time) > 90) {
    lastidle_time = time(0);
    u32 buf = 0x000400ff;

		// MFT
    //if (char *tmp = vars.getVar("debug_idle"))
    //  if (atoi( tmp)) {
    //    *disp << CBCYAN << "Info:  " << CBWHITE << "Sending a NULL packet" << CWHITE << endl;
    //    //input->update();
    //  }

    rawsend( 4, (char *)&buf);
  }
  return( 0);
}

int Bot::checkOps( void) {
  if (!strncasecmp( curchannel, "clan ", 5))
    return( 0);

  if (clist->getSize() != 1)
    return( 0);

  CUser *user = clist->getFirst();
  if (!user) return( 0);
  if (user->getFlags() & 2) return( 0);
    
  if ((time(0) - msg_lasttime) < 6) return( 0);

  *this << "/join The Void";
  sendpkt( 0x0eff);

  char buf[ 1024];
  sprintf( buf, "/join %s", curchannel);
  *this << buf;
  sendpkt( 0x0eff);

  // msg_lasttime = time(0) + 3;

  return( 0);
}

int Bot::checkHomeChannel( void) {
  if (*getHomeChannel())
    if (strcasecmp( getHomeChannel(), getCurChannel()))
      enqueue( 7, "/join %s", getHomeChannel());
  return( 0);
}

int Bot::checkIdle( void) {
  #ifdef DEBUGBRITNEY
    if (!cmdIdle_d) {
      cmdIdle_t = time( 0);
      cmdIdle_d = 60;
    }
  #endif

  if (!cmdIdle_d)
    return( 0);

  if ((time(0) - cmdIdle_t) >= cmdIdle_d) {
    cmdIdle_t = time( 0);

    enqueue( 7, "%s", cmdIdle_msg);
  }
  return( 0);
}

int Bot::pkt_send( int pkt_len, char *pkt_buf) {
	if (!filter) return( -1);
	if (getfd() == -1) return( -1);
	if (time(0) < msg_lasttime) return( -1);

	msg_lasttime = time(0) + 3 + (pkt_len / 30);

	//===
	// Is it a /msg ?
		if (!strncasecmp( pkt_buf, "/msg ", 5)) {
			char *term3 = gettermnz( pkt_buf, 3);
			char *txt = NULL;
			
			if (term3)
				txt = (char *)zenc_decrypt( (unsigned char *)term3);
				
			if (txt) {
				char buf[1024];
				strcpy( buf, pkt_buf);
				char *user = gettermn( buf, 2);
				
				*disp << CWHITE  << "["  << CBBLUE  << printTime()        << CWHITE << "] "
				      << CWHITE << "/msg " << user << CBRED << " zENC" << CBWHITE << "> " << CWHITE << txt << endl;
				//input->update();
			}
		} else {
			char *txt = (char *)zenc_decrypt( (unsigned char *)pkt_buf);
			if (txt) {
				// MFT
				//{ 
				//	char *tmp;
				//	if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
				//		*disp << CWHITE << getName() << " ";
				//}
				*disp << CWHITE  << "["  << CBBLUE  << printTime()        << CWHITE << "] "
				      << CBRED << "zENC" << CBWHITE << "> " << CWHITE << txt << endl;
				//input->update();
			} else {
    			if (strncasecmp( pkt_buf, "/me ", 4)) {
					*disp << CWHITE  << "["  << CBBLUE << printTime()      << CWHITE << "] "
					      << CBWHITE << "> " << CWHITE << pkt_buf << endl;
					//input->update();
				}
			}
		}
		
	//===
	// Ok, send the packet.
		if (!strncasecmp( pkt_buf, "/join ", 6)) {
			char buf[ 1024];
			strcpy( buf, pkt_buf);

			char *tmp = gettermn( pkt_buf, 2);
			if (!tmp) return( 0);

			// if (strcasecmp( buf + (tmp - pkt_buf), "The Void"))
			// msg_lasttime = time(0) - 3;

			if (strlen( tmp) > 31)
				tmp[31] = 0;
			
			*this << (u32)2
			      << (buf + (tmp - pkt_buf));
			
			sendpkt( 0x0cff);
			//msg_lasttime = time(0) + atoi( vars.getVar( "rejoin_pause"));
		} else {
			*this << pkt_buf;
			sendpkt( 0x0eff);
			
			//if (atoi(vars.getVar("use_delay")))
			//	msg_lasttime = time(0);
		}

	return( 0);
}


int Bot::pkt_00( int pkt_len, char *pkt_buf) {
  //if (char *tmp = vars.getVar("debug_idle"))
  //  if (atoi( tmp)) {
  //    *disp << CBCYAN << "Info:  " << CBWHITE << "Received a NULL packet." << CWHITE << endl;
  //    //input->update();
  //  }

  return( 0);
}


int Bot::pkt_04( int pkt_len, char *pkt_buf) {
  #ifdef DEBUGBOT
    *disp << "Info:  Received a list of the servers" << endl;
    //input->update();
  #endif
  return( 0);
}


// 0000   FF 05 14 00 00 00 00 00 - 00 00 00 00 00 00 00 00   ................
// 0010   00 00 00 00             -                           ....
int Bot::pkt_05( int pkt_len, char *pkt_buf) {

	#ifdef DEBUG
		*disp << CBWHITE << "Info:  " << CBCYAN << getName() << CWHITE << "[0x05ff] Version Info Received" << endl;
	#endif

	if (pkt_len != 0x14) {
		*disp << "Error: Packet 0x05ff was " << pkt_len << " bytes long." << endl
		      << "       Perhaps we are sending an old 0x1eff." << endl;
		disp->hexdump( pkt_len, pkt_buf);
		setActive( 0);
		netclose();
		return( -1);
	}
	
	if (*(u32 *)(pkt_buf + 4) > 2) {
		*disp << "Error: Packet 0x05ff returned " << *(u32 *)(pkt_buf + 4) << " for the server version.!" << endl
		      << "       Did the server change something MAJOR!? Is our 0x1eff correct?" << endl;
		disp->hexdump( pkt_len, pkt_buf);
		setActive( 0);
		netclose();
 		return( -1);
	}

	return( 0);
}


// FF 06 5A 00 00 56 CD F6   09 28 BC 01 49 58 38 36    ..Z..V...(..IX86
// 76 65 72 37 2E 6D 70 71   00 41 3D 31 30 32 36 30    ver7.mpq.A=10260
// 34 34 33 35 34 20 42 3D   34 31 33 32 36 33 30 37    44354 B=41326307
// 31 31 20 43 3D 32 33 30   32 34 31 31 33 32 38 20    11 C=2302411328
// 34 20 41 3D 41 5E 53 20   42 3D 42 5E 43 20 43 3D    4 A=A^S B=B^C C=
// 43 5E 41 20 41 3D 41 2B   42 00                      C^A A=A+B.
int Bot::pkt_06( int pkt_len, char *pkt_buf) {

	//===
	// Get the packet variables.
		int hash_mpq = 0;
		char *hash_equ = (pkt_buf + strlen( (pkt_buf + 0x08)) + 0x09);

		{
			char *tmp = strchr( (pkt_buf + 0x08), '.');
			if (tmp)
				hash_mpq = atoi( tmp - 1);
		}
	
	//===
	// Are we faking the hashes?
		int fakehash = objbot->getVarN("fakehash");
		u32 result;

		if (fakehash) {
			result = rand();
		} else {

	//===
	// Parse the hashes
		Obj *objHash = globals->db->getObj("hash");
		if (!objHash) {
			objHash = new Obj("hash");
			globals->db->append( objHash);
		}
		
		Obj *objClient = NULL;

		switch( getClientType()) {
			case CLIENT_W2BN:
				objClient = objHash->getObj("w2bn");
				break;
		}

		if (!objClient) {
			*disp << "Error: Could not find hash files, or did not recognize the client." << endl;
			*disp << "       Did you net set them yet?" << endl;
			*disp << "Info:  Disabled bot to avoid IP ban." << endl;
			setActive( 0);
			netclose();
			return -1;
		}
				
		char *f1 = objClient->getVar("exe");
		char *f2 = objClient->getVar("dll");
		char *f3 = objClient->getVar("snp");
					
		if (!f1 || (!f2 || !f3)) {
			*disp << "Error: All three hash files are not set. Did you not set them yet?" << endl;
			*disp << "Info:  Disabled bot to avoid IP ban." << endl;
			setActive( 0);
			netclose();
			return -1;
		}

	//===
	// Do the actual hashes
		VerCheck vercheck;
				
		switch( vercheck.checkRevision( hash_equ, hash_mpq, &result, f1, f2, f3)) {
			case 0:
				break;
			case -1:
				*disp << "Error: Invalid parameters passed to revision check" << endl;
				*disp << "Info:  Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
			case -2:
				*disp << "Error:  We were unable to find the hash files." << endl;
				*disp << "        Please verify the hash files below are correct:" << endl;
				*disp << "File:   " << f1 << endl;
				*disp << "File:   " << f2 << endl;
				*disp << "File:   " << f3 << endl;
				*disp << "Info:   Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
			default:
				*disp << "Error: Received an unknown result from checkRevision" << endl;
				*disp << "Info:  Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
		}
	}

	//===
	// Send the results.
		switch( getClientType()) {
			case CLIENT_W2BN:
				{
					char *war2 = "Warcraft II BNE.exe 05/15/01 20:53:20 712704";

					*this << (u32)0x49583836 << (u32)0x5732424e
					     << (u32)0x0000004f << (u32)0x02000200
					     << result << war2;
					this->sendpkt( 0x07ff);
				} break;
			default:
				*disp << "Error: We are parsing an unknown client." << endl;
				*disp << "Info:  Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
		}

	return( 0);
}


int Bot::pkt_07( int pkt_len, char *pkt_buf) {

	if (pkt_len < 0x0A) {
		*disp << "Error: Packet 0x07ff was " << pkt_len << " bytes long." << endl
		      << "       Packet was too short." << endl;
		setActive( 0);
		netclose();
		return( -1);
	}


	if (*(u32 *)(pkt_buf + 4) != 0x02) {
		*disp << "Error: Packet 0x07ff did not return ok. Return: " << *(u32 *)(pkt_buf + 4) << endl;
		if (*(u32 *)(pkt_buf + 4) == 0x01) {
			*disp << "       From the looks of the packet I would say we need to upgrade." << endl
			      << "       There is a file \"" << (pkt_buf + 8) << "\" encoded in the message." << endl;
		}
		setActive( 0);
		netclose();
		return( -1);
	}

	#ifdef DEBUGBOT
		*disp << "Info:  [0x07ff] Server auth_ok received." << endl
		      << "       Sending [0x14ff] I got your UDP packet" << endl
		      << "       Sending [0x2dff] Icon Request (Acting like the real deal :D)" << endl;
	#endif


	sendpkt( 0x2dff);
	{
		//===
		// If plug is set, ignore this.
		if (!plug) {
			char *tmp2 = "tenb";
			*this << *(u32 *)tmp2;
			sendpkt( 0x14ff);
		}
	}

	#ifdef DEBUGBOT
		*disp << "       Sending [0x36ff] CD-Key." << endl;
	#endif

	switch( getClientType()) {
		case CLIENT_W2BN:
			{
				char *tmp = SendCDKeyCheck( getCDKey(), session_key, getRegister(), rand(), getSpawn());
				this->rawsend( 48 + strlen( getRegister()) + 1, tmp);
			}
			break;
	}
	

//  switch( getClientType()) {
//    case CLIENT_W2BN:
////mft
////      cas.SendCDKeyWar2( this, getCDKey(), session_key, getRegister(), rand(), getSpawn()); // 0x3DDF1A22);
//      break;
//    case CLIENT_STAR:
//    case CLIENT_SEXP:
////mft
////      cas.SendCDKeyStar( this, getCDKey(), session_key, getRegister(), rand(), getSpawn()); // 0x3DDF1A22);
//      break;
//    #ifdef FEATURE_JSTR
//    case CLIENT_JSTR: // Jap StarCraft
//      *this << (u32)getSpawn()
//            << getCDKey()
//            << getName();
//      sendpkt( 0x30ff);
//      break;
//    #endif
//  }
//
//  //[08:25:09] Legendary: like ff 30 ?? ?? 00 00 00 00 cdkey 00 name 00
//  //$packet=$packet."starcraftj.exe 11\/04\/01 19:46:34 1323008\0";

  return( 0);
}


int Bot::pkt_13( int pkt_len, char *pkt_buf) {
  if (pkt_len != 4) {
    *disp << CBYELLOW << "Received a 0x13ff packet with a funky length." << CWHITE << endl;
    disp->hexdump( pkt_len, pkt_buf);
    //input->update();
  } else {
    *disp << CBYELLOW << "Battle.net told us to get lost. (Probably for flooding)" << CWHITE << endl;
    //input->update();
  }
  netclose();
  return( 0);
}

int Bot::pkt_0a( int pkt_len, char *pkt_buf) {
  // TODO !!!

  // disp << "Info:  Received a 0A packet >;-)" << endl;
  // disp.hexdump( pkt_len, pkt_buf);
  // input.update();

  return( 0);
}


int Bot::pkt_0b( int pkt_len, char *pkt_buf) {
  #ifdef DEBUGBOT
    *disp << "Info:  Received a list of the public channels" << endl;
    //input->update();
  #endif
  return( 0);
}


int Bot::pkt_0c( int pkt_len, char *pkt_buf) {
  // 0000   FF 0C 0E 00 02 00 00 00 - 62 6C 6F 6F 64 00         ........blood.
  // 0000   FF 0C 10 00 02 00 00 00 - 24 42 4C 4F 4F 44 24 00   ........$BLOOD$.
  #ifdef DEBUGBOT
    *disp << "Info:  Received a raw join packet" << endl;
    //input->update();
  #endif
  return( 0);
}


// Users in a channel (on channel join)
//   0000   FF 0F 40 00 01 00 00 00 - 00 00 00 00 6D 00 00 00   ..@.........m...
//   0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 4B 69 6C 6C   ............Kill
//   0020   65 72 5F 4B 61 68 6E 00 - 4E 42 32 57 20 30 20 30   er_Kahn.NB2W 0 0
//   0030   20 32 31 20 30 20 30 20 - 30 20 30 20 30 20 30 00    21 0 0 0 0 0 0.
int Bot::pkt_0f_01( int pkt_len, char *pkt_buf) {

	//===
	// Add the user to the channel list.
		CUser *cuser = new CUser();
		if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
			cuser->setName( tmp + 1);
		else
      	cuser->setName( pkt_buf + 0x1C);
		cuser->setFlags( *(u32 *)(pkt_buf + 0x08));
		cuser->setLatency( *(s32 *)(pkt_buf + 0x0C));
		cuser->setProduct( *(u32 *)(pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1));

		clist->addUser( cuser);
		disp->addUser( cuser->getName(), cuser->getLatency(), *(u32 *)(pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1), *(u32 *)(pkt_buf + 0x08));

	//===
	// Grab the user's record.
		Obj *obj_spkr = globals->userdb->getObj("userdb")->getObj( cuser->getName());
		if (!obj_spkr) {
			obj_spkr = new Obj( cuser->getName());
			globals->userdb->getObj("userdb")->append( obj_spkr);
		}
		obj_spkr->setVar("latency", cuser->getLatency());
		obj_spkr->setVar("product", cuser->getProduct());
		obj_spkr->setVar("cflags",  cuser->getFlags());

	//===
	// Call the onList function handler.
		dynHandler( "_onList", obj_spkr, NULL);

// MFT
//===
//    switch( display) {
//      case 0: break;
//      case 1:
//
//        char *tmp;
//        if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
//          *disp << CWHITE << getName() << " ";
//
//        *disp << CWHITE  << "["    << CBBLUE   << printTime()        << CWHITE << "] "
//             << CBWHITE << "*** " << CBPURPLE << cuser->getName()    << " "
//             << CBWHITE << " ["   << CBCYAN   << cuser->getLatency() << CBGREEN << "ms" << CBWHITE << "] "
//             << CBWHITE << " ["   << CBGREEN  << cuser->getProduct() << CBWHITE << "] "
//             << CBWHITE << " ["   << CBGREEN  << cuser->getFlags() << CBWHITE << "] " << CWHITE << endl;
//
//        //input->update();
//        break;
//    }

  return( 0);
}


//===
// User has joined the channel.
int Bot::pkt_0f_02( int pkt_len, char *pkt_buf) {
	Obj *dbvars = globals->db->getObj("vars");

	//===
	// Add the user to the channel list.
		CUser *cuser = new CUser();
		if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
			cuser->setName( tmp + 1);
		else
      	cuser->setName( pkt_buf + 0x1C);
		cuser->setFlags( *(u32 *)(pkt_buf + 0x08));
		cuser->setLatency( *(s32 *)(pkt_buf + 0x0C));
		cuser->setProduct( *(u32 *)(pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1));

		clist->addUser( cuser);
		disp->addUser( cuser->getName(), cuser->getLatency(), *(u32 *)(pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1), *(u32 *)(pkt_buf + 0x08));

	//===
	// Grab the user's record.
		Obj *obj_spkr = globals->userdb->getObj("userdb")->getObj( cuser->getName());
		if (!obj_spkr) {
			obj_spkr = new Obj( cuser->getName());
			globals->userdb->getObj("userdb")->append( obj_spkr);
		}
		obj_spkr->setVar("latency", cuser->getLatency());
		obj_spkr->setVar("product", cuser->getProduct());
		obj_spkr->setVar("cflags",  cuser->getFlags());

	//===
	// Display the user has joined the channel.
		if (dbvars->getVarN("beep_onjoin"))
			printf("\a");

	//===
	// Call the onJoin function handler.
		dynHandler( "_onJoin", obj_spkr, NULL);

	// MFT, handled through dynamic thingy(tm)
	//===
	// Are they tag banned?
	//	Obj *tagbans = globals->db->getObj("tagbans");
	//	if (tagbans) {
	//		sLList *i = tagbans->objFirst;
	//		while (i) {
	//			i = i->next;
	//		}
	//	}

	return( 0);
}


//===
// SamuelJack has left the channel.
// > 0000   FF 0F 2D 00 03 00 00 00 - 00 00 00 00 32 02 00 00   ..-.........2...
// > 0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 4C 65 67 65   ............Lege
// > 0020   6E 64 60 49 6C 6C 75 6D - 69 6E 61 00 00            nd llumina..
int Bot::pkt_0f_03( int pkt_len, char *pkt_buf) {

	//===
	// Get the username.
		char *username = pkt_buf + 0x1C;
		if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
			username = tmp + 1;

	//===
	// Get the user.
		CUser *cuser = clist->getUser( username);

		if (!cuser) {
			*disp << "Debug: Received a channel leave by \"" << username << "\"." << endl
			      << "       We didn't know they were in the channel!" << endl;
			//input->update();
			return( 0);
		}
  
	// MFT
	//===
	// Show the channel part.
	//	if (char *tmp = vars.getVar("show_joins"))
	//		if (atoi(tmp)) {
	//			if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
	//				*disp << CWHITE << getName() << " ";
	//				
	//			*disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] "
	//			      << CBWHITE << "*** " << CBRED << cuser->getName() << CBWHITE << " has left the channel." << CWHITE << endl;
	//			//input->update();
	//		}

	//===
	// Grab the user's record.
		Obj *obj_spkr = globals->userdb->getObj("userdb")->getObj( cuser->getName());
		if (!obj_spkr) {
			obj_spkr = new Obj( cuser->getName());
			globals->userdb->getObj("userdb")->append( obj_spkr);
		}

	//===
	// Call the onPart function handler.
		dynHandler( "_onPart", obj_spkr, 0);
		//if (Command *cmd = commandlist.getCommand( getCommandSet()))
		//	if (Obj *dyncmd = globals->db->getObj("dyncmd")->getObj("onPart"))
		//		cmd->dynHandler( this, dyncmd, obj_spkr, NULL, 0);

	//===
	// Remove the user from the channel list.
		disp->delUser( cuser->getName());

		if (clist->delUser( cuser->getName())) {
			*disp << "Debug: clist->delUser() returned an error." << endl;
			//input->update();
		}

  return( 0);
}


// Private message.
//> 0000   FF 0F 47 00 04 00 00 00 - 00 00 00 00 82 07 00 00   ..G.............
//> 0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 44 61 72 6B   ............Dark
//> 0020   7E 53 63 72 65 61 6D 00 - 74 68 61 6E 6B 20 79 6F   ~Scream.thank yo
//> 0030   75 20 77 68 61 74 20 69 - 73 20 74 68 65 79 20 62   u what is they b
//> 0040   69 64 64 69 6E 67 00    -                           idding.
int Bot::pkt_0f_04( int pkt_len, char *pkt_buf) {
	//===
	// Parse the message.
		char *username = pkt_buf + 0x1C;
		char *message  = pkt_buf + 0x1D + strlen( username);

		if (char *t = strchr( pkt_buf + 0x1C, '*'))
			username = t + 1;

	//===
	// Grab the user's record.
		Obj *obj_spkr = globals->userdb->getObj("userdb")->getObj( username);
		if (!obj_spkr) {
			obj_spkr = new Obj( username);
			globals->userdb->getObj("userdb")->append( obj_spkr);
		}

	//===
	// zEnc encrypted?
		char *cmsg = (char *)zenc_decrypt( (unsigned char *)message);
		if (cmsg) {
			char buf[256];
			strcpy( buf, cmsg);
			char *dcc = (char *)zenc_decrypt( (unsigned char *)buf);
			if (dcc) {

				//===
				// Call the onPublic_DCC function handler.
					if (Command *cmd = commandlist.getCommand( getCommandSet())) {
						dynHandler( "_onPrivate_DCC", obj_spkr, cmsg);
						cmd->handleCommand( this, username, cmsg, 0);
					}
					return 0;

			} else {
				cmsg = buf;

				//===
				// Call the onPublic_zEnc function handler.
					if (Command *cmd = commandlist.getCommand( getCommandSet())) {
						dynHandler( "_onPrivate_zEnc", obj_spkr, cmsg);
						cmd->handleCommand( this, username, cmsg, 0);
					}
					return 0;
			}
		}

	//===
	// Public Message
		if (Command *cmd = commandlist.getCommand( getCommandSet())) {
			dynHandler( "_onPrivate", obj_spkr, message);
			cmd->handleCommand( this, username, message, 0);
		}	

	return 0;

//	//===
//	// Get the username.
//		char *tmpname = pkt_buf + 0x1C;
//		if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
//			tmpname = tmp + 1;
//
//	//===
//	// Make sure the user db exists.
//		Obj *db = globals->userdb->getObj("userdb");
//		if (!db) {
//			db = new Obj("userdb");
//			globals->userdb->append( db);
//		}
//
//	//===
//	// If they are +A then ignore the message.
//		if (Obj *obj_spkr = db->getObj( tmpname)) {
//			char *flags = obj_spkr->getVar("flags");
//			if (flags && strchr( flags, 'A'))
//				return( 0);
//		}
//		
//    char *tmp;
//    if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
//      *disp << CWHITE << getName() << " ";
//    *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
//    
//    if (char *tmp = vars.getVar("beep_onpriv"))
//      if (atoi(tmp))
//        printf("\a");
//        
//	char *msg = pkt_buf + 0x1D + strlen( pkt_buf + 0x1C);
//	char *cmsg = (char *)zenc_decrypt( (unsigned char *)msg);
//	if (cmsg) {
//		*disp << CBCYAN << "[" << CBGREEN << tmpname << CBCYAN << "]" << CBWHITE << ": " 
//		      << CBWHITE << "[" << CBRED << "zENC" << CBWHITE << "] "
//            << CWHITE << cmsg << endl;
//	} else {
//		*disp << CBCYAN << "[" << CBGREEN << tmpname << CBCYAN << "]" << CBWHITE << ": " 
//		      << CWHITE << msg << endl;
//	}
//    //input->update();
//
//    if (Command *cmd = commandlist.getCommand( getCommandSet())) {
//		if (cmsg)
//	      cmd->handleCommand( this, tmpname, cmsg, 1);
//		else
//	      cmd->handleCommand( this, tmpname, msg, 1);
//    } else {
//      *disp << "Error: " << getName() << " - no command handler was found" << endl;
//      //input->update();
//    }
//
//  return( 0);
}


// PUBLIC MESSAGE
// SamuelJack: I am really cool!
//> 0000   FF 0F 37 00 05 00 00 00 - 00 00 00 00 1F 00 00 00   ..7.............
//> 0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 4A 6F 72 64   ............Jord
//> 0020   61 6E 34 33 38 35 00 61 - 6C 74 61 72 20 61 6C 6C   an4385.altar all
//> 0030   79 20 79 61 75 3F 00    -                           y yau?.
int Bot::pkt_0f_05( int pkt_len, char *pkt_buf) {

	//===
	// Parse the message.
		char *username = pkt_buf + 0x1C;
		char *message  = pkt_buf + 0x1D + strlen( username);

		if (char *t = strchr( pkt_buf + 0x1C, '*'))
			username = t + 1;
		
	//===
	// Grab the user's record.
		Obj *obj_spkr = globals->userdb->getObj("userdb")->getObj( username);
		if (!obj_spkr) {
			obj_spkr = new Obj( username);
			globals->userdb->getObj("userdb")->append( obj_spkr);
		}


	//===
	// zEnc encrypted?
		char *cmsg = (char *)zenc_decrypt( (unsigned char *)message);
		if (cmsg) {
			char buf[256];
			strcpy( buf, cmsg);
			char *dcc = (char *)zenc_decrypt( (unsigned char *)buf);
			if (dcc) {

				//===
				// Call the onPublic_DCC function handler.
					if (Command *cmd = commandlist.getCommand( getCommandSet())) {
						dynHandler( "_onPublic_DCC", obj_spkr, cmsg);
						cmd->handleCommand( this, username, cmsg, 0);
					}
					return 0;

			} else {
				cmsg = buf;

				//===
				// Call the onPublic_zEnc function handler.
					if (Command *cmd = commandlist.getCommand( getCommandSet())) {
						dynHandler( "_onPublic_zEnc", obj_spkr, cmsg);
						cmd->handleCommand( this, username, cmsg, 0);
					}
					return 0;
			}
		}

	//===
	// Public Message
		if (Command *cmd = commandlist.getCommand( getCommandSet())) {
			dynHandler( "_onPublic", obj_spkr, message);
			cmd->handleCommand( this, username, message, 0);
		}	

	return 0;
		
	//===
	// CLEANUP !!!
//        switch(*(pkt_buf + 0x1D + strlen( pkt_buf + 0x1C))) {
//          case '':
//            *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] "
//                  << CBGREEN << username << CBWHITE << ": "
//                  << CBWHITE << "[" << CBRED << "vL" << CBWHITE << "] "
//                  << CWHITE  << Decrypt( pkt_buf + 0x1D + strlen( pkt_buf + 0x1C) + 1) << endl;
//            break;
//          case '':
//            *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] "
//                  << CBGREEN << username << CBWHITE << ": "
//                  << CBWHITE << "[" << CBRED << "HEX" << CBWHITE << "] "
//                  << CWHITE  << hex_decrypt( pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)) << endl;
//            break;
//          default:
//            *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] "
//                  << CBGREEN << username << CBWHITE << ": "
//                  << CWHITE << (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)) << endl;
//        }
//
//      if (Command *cmd = commandlist.getCommand( getCommandSet())) {
//        if (cmsg)
//          cmd->handleCommand( this, tmpname, cmsg, 0);
//        else
//          cmd->handleCommand( this, tmpname, msg, 0);
//      } else {
//        *disp << "Error: " << getName() << " - no command handler was found" << endl;
//      }
//      // cmd_Handler( pkt_buf + 0x1C, pkt_buf + 0x1D + strlen( pkt_buf + 0x1C));
//
//      //if (*(pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)) == '') {
//      //  char *p = Decrypt( pkt_buf + 0x1D + strlen( pkt_buf + 0x1C) + 1);
//      //  *disp << "DEBUG: Decrypted - " << p << endl;
//      //  //input->update();
//      //}
//
//      //input->update();
//    };
	return( 0);
}

//Info:  *** Received from server ***
//  0000   FF 0F 80 00 06 00 00 00 - 00 00 00 00 9C 00 00 00   ................
//  0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 42 61 74 74   ............Batt
//  0020   6C 65 2E 6E 65 74 00 54 - 68 69 73 20 42 61 74 74   le.net.This Batt
//  0030   6C 65 2E 6E 65 74 20 73 - 65 72 76 65 72 20 69 73   le.net server is
//  0040   20 67 6F 69 6E 67 20 64 - 6F 77 6E 20 66 6F 72 20    going down for 
//  0050   6D 61 69 6E 74 65 6E 61 - 6E 63 65 2E 20 20 50 6C   maintenance.  Pl
//  0060   65 61 73 65 20 63 6F 6E - 6E 65 63 74 20 74 6F 20   ease connect to 
//  0070   61 6E 6F 74 68 65 72 20 - 73 65 72 76 65 72 2E 00   another server..
int Bot::pkt_0f_06( int pkt_len, char *pkt_buf) {
	return 0;
}

int Bot::pkt_0f_07( int pkt_len, char *pkt_buf) {
  // Channel Join (by you)
  //   0000   FF 0F 3B 00 07 00 00 00 - 01 00 00 00 5E 00 00 00   ..;.........^...
  //   0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 44 53 7E 42   ............DS~B
  //   0020   6F 74 21 00 57 61 72 32 - 20 4C 61 64 64 65 72 20   ot!.War2 Ladder
  //   0030   43 68 61 6C 6C 65 6E 67 - 65 73 00                  Challenges.

  filter = 1;

  // let's see what lastlag was
    if (lag_spoof) {
      int t = *(u32 *)(pkt_buf + 0x0c);
      if ((t >= 10) || (t < 0)) {
        *disp << CBWHITE << "Info:  " << CWHITE << "Lag - is " << CBCYAN << t << CBWHITE << "ms "
                                      << CWHITE << "- was " << CBCYAN << lastlag << CBWHITE << "ms "
                                      << CWHITE << "- 0point " << CBCYAN << lastlag + t << CBWHITE << "ms" << endl;
        //input->update();

        lastlag = lastlag + t;
        sendpkt( 0x10ff);
        sendpkt( 0x02ff);

        netclose();
        return( -1);
      }
    }


  // Main window update.
  //  #ifndef DISP_CON
  //  	#ifndef DISP_GTK
  //    	*getDisp() << CBWHITE << getName() << CWHITE << " has joined " << CBCYAN
  //      	        << (pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1) << CWHITE << endl;
//		#endif
//    #endif

  // Update our /who listing.
    clist->clear();
    disp->clearUsers();

    clist->setChannel( pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1);
    proxy->setChan( pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1);


    //{
    //  char *tmp;
    //  if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
    //    *disp << CWHITE << getName() << " ";
    //}
    char bob[32];
    sprintf( bob, "0x%.8x", *(u32 *)(pkt_buf + 0x08));
    *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
    *disp << CBWHITE << "*** You have joined channel " << CBGREEN << (pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1) 
          << CWHITE << "  [flags: " << CCYAN << bob << CWHITE << "]" << endl;
    strncpy( curchannel, (pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1), sizeof( curchannel) -1);

	// Let's see what happens if we remove this
    //if (strcasecmp( pkt_buf + 0x1C + strlen( pkt_buf + 0x1C) + 1, homechannel))
    //  if (*homechannel) {
    //    // disp << "Debug: Sending channel join request " 
    //    // disp << "[" << (pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1) << "]  "
    //    //      << "[" << homechannel << "]" << endl;
    //    char buf[ 1024];
	//
	//        //sprintf( buf, "/join %s", homechannel);
   //     if (atoi(vars.getVar("auto_rejoin")))
   //       enqueue( 4, "/join %s", homechannel);
   //   }
   // //input->update();

  return( 0);
}


int Bot::pkt_0f_09( int pkt_len, char *pkt_buf) {
  #ifdef DEBUGBOT
    *disp << "DEBUGBOT: User flags changed (IGNOREING IGNORING)" << endl;
    //input->update();
    return( 0);
  #endif

  char *tmpname = pkt_buf + 0x1C;
  if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
    tmpname = tmp + 1;

  // Todo: Ops status change.
  //  0000   FF 0F 26 00 09 00 00 00 - 02 00 00 00 0B 00 00 00   ..&.............
  //  0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 44 53 7E 42   ............DS~B
  //  0020   6F 74 39 21 00 00       -                           ot9!..

  CUser *cuser = clist->getUser( tmpname);

  if (cuser) {
    cuser->setFlags( *(u32 *)(pkt_buf + 0x08));
    cuser->setLatency( *(s32 *)(pkt_buf + 0x0C));
  }

  // Handle the Display
    //if (char *tmp = vars.getVar("show_joins"))
    //  if (atoi(tmp)) {
    //    if (tmp = vars.getVar("beep_onjoin"))
    //      if (atoi(tmp))
    //        printf("\a");

        switch( display) {
          case 0: break;
          case 1:
            break;

            //if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
            //  *disp << CWHITE << getName() << " ";

              *disp << CWHITE  << "["    << CBBLUE   << printTime()        << CWHITE << "] "
                    << CBWHITE << "*** " << CBPURPLE << cuser->getName()    << " "
                    << CBWHITE << " ["   << CBCYAN   << cuser->getLatency() << CBGREEN << "ms" << CBWHITE << "] "
                    << CBWHITE << " ["   << CBGREEN  << cuser->getProduct() << CBWHITE << "] "
                    << CBWHITE << " ["   << CBGREEN  << cuser->getFlags() << CBWHITE << "] "
                    << CBWHITE << " has changed status." << CWHITE << endl;

            //input->update();
          case 2:
            break;
        }
      //}


  return( 0);
}

int Bot::pkt_0f_0A( int pkt_len, char *pkt_buf) {
  // Message sent by you.
  //> 0000   FF 0F 48 00 0A 00 00 00 - 00 00 00 00 B5 01 00 00   ..H.............
  //> 0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 2D 6C 29 72   ............-l)r
  //> 0020   61 67 6F 6E 2D 00 57 65 - 6C 63 6F 6D 65 20 74 6F   agon-.Welcome to
  //> 0030   20 74 68 65 20 63 68 61 - 6E 6E 65 6C 20 2D 6C 29    the channel -l)
  //> 0040   72 61 67 6F 6E 2D 2E 00 -                           ragon-..

  char *tmpname = pkt_buf + 0x1C;
  if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
    tmpname = tmp + 1;

  *disp << "/msg " << tmpname << " " << (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)) << endl;
  //input->update();

  return( 0);
}


int Bot::pkt_0f_12( int pkt_len, char *pkt_buf) {
  // System Message
  //   0000   FF 0F 45 00 12 00 00 00 - 10 00 00 00 EA 00 00 00   ..E.............
  //   0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 44 53 7E 42   ............DS~B
  //   0020   6F 74 21 00 54 68 69 73 - 20 73 65 72 76 65 72 20   ot!.This server
  //   0030   69 73 20 68 6F 73 74 65 - 64 20 62 79 20 45 78 6F   is hosted by Exo
  //   0040   64 75 73 2E 00          -                           dus..

//    { char *tmp;
//    if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
//      *disp << CWHITE << getName() << " ";
//    }
    *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
    *disp << CBWHITE << "*** " << CWHITE << (pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1) << CWHITE << endl;
    //input->update();

  return( 0);
}


int Bot::pkt_0f_13( int pkt_len, char *pkt_buf) {
  // 0000   FF 0F 41 00 13 00 00 00 - 00 00 00 00 06 00 00 00   ..A.............
  // 0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 44 53 7E 42   ............DS~B
  // 0020   6F 74 39 21 00 54 68 61 - 74 20 75 73 65 72 20 69   ot9!.That user i
  // 0030   73 20 6E 6F 74 20 6C 6F - 67 67 65 64 20 6F 6E 2E   s not logged on.
  // 0040   00                      -                           .

//    { char *tmp;
//    if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
//      *disp << CWHITE << getName() << " ";
//    }
    *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
    *disp << CBWHITE << "*** " << CBRED << (pkt_buf + 0x1c + strlen( pkt_buf + 0x1c) + 1) << CWHITE << endl;
    //input->update();

  return( 0);
}

int Bot::pkt_0f_17( int pkt_len, char *pkt_buf) {
  // ACTION user looks around
  //> 0000   FF 0F 31 00 17 00 00 00 - 10 00 00 00 CB 00 00 00 ..1.............
  //> 0010   00 00 00 00 0D F0 AD BA - 0D F0 AD BA 44 53 7E 42 ............DS~B
  //> 0020   6F 74 21 00 6C 6F 6F 6B - 73 20 61 72 6F 75 6E 64   ot!.looks around
  //> 0030   00                      -                           .

  char *tmpname = pkt_buf + 0x1C;
  if (char *tmp = strchr( pkt_buf + 0x1C, '*'))
    tmpname = tmp + 1;

      //{ char *tmp;
        //if ((tmp = vars.getVar("show_idles")) && !atoi(tmp)) {
        //  
          // Damn shaddup! Geezus! >;-)
          //if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "-- Stygian ", 11))
          //  if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "--- Stygian ", 12))
          //    if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "- vLBBot ", 9))
          //if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "is a ", 5))
          //  if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "is an ", 6))
          //    if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "NuLLKLoCk: ", 11)) 
          //      if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "-=^un4^=-: ", 11)) 
          //        if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "AutoHeal is a ", 14))
          //          if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "vLBBot - a ", 11))
          //            if (strncmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "~The Gate |{eepers~ -- ", 23))
          //              if (strcmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "  . dr  zL"))
          //                if (strcmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "b. lz v.  b z"))
          //                  if (strcmp( (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), "- Chewbacca Bot v2.0a2 - anti-idle")) {
        //    if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
        //      *disp << CWHITE << getName() << " ";
        //
        //    *disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
        //    *disp << CBYELLOW << tmpname << " " << (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)) << CWHITE << endl;
        //  }
        //} else {
        //  if ((tmp = vars.getVar("show_bots")) && atoi(tmp) && getName() && *getName())
        //    *disp << CWHITE << getName() << " ";

	//===
	// This should be passed to onAction
	//	*disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
	//	*disp << CBYELLOW << tmpname << " " << (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)) << CWHITE << endl;

	//===
	// Grab the user's record.
		Obj *obj_spkr = globals->userdb->getObj("userdb")->getObj( tmpname);
		if (!obj_spkr) {
			obj_spkr = new Obj( tmpname);
			globals->userdb->getObj("userdb")->append( obj_spkr);
		}

	//===
	// Call the onAction function handler.
		//if (Command *cmd = commandlist.getCommand( getCommandSet()))
		//	if (Obj *dyncmd = globals->db->getObj("dyncmd")->getObj("onAction"))
		//		cmd->dynHandler( this, dyncmd, obj_spkr, (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)), 0);
		dynHandler( "_onAction", obj_spkr, (pkt_buf + 0x1D + strlen( pkt_buf + 0x1C)));

        //}
      //}
      ////input->update();

   // if (Command *cmd = commandlist.getCommand( getCommandSet())) {
   //   cmd->handleCommand( this, tmpname, pkt_buf + 0x1D + strlen( pkt_buf + 0x1C), 0);
   // } else {
   //   *disp << "Error: " << getName() << " - no command handler was found" << endl;
   //   //input->update();
   // }

  return( 0);
}


int Bot::pkt_0f( int pkt_len, char *pkt_buf) {
  if (pkt_len < 6)
    return( -1);

	debug(("Bot::pkt_0f was called w/ packetid => 0x%.4x", *(u16 *)(pkt_buf + 4)));

  switch( *(u16 *)(pkt_buf + 4)) {
    case 0x01: return( pkt_0f_01( pkt_len, pkt_buf));
    case 0x02: return( pkt_0f_02( pkt_len, pkt_buf));
    case 0x03: return( pkt_0f_03( pkt_len, pkt_buf));
    case 0x04: return( pkt_0f_04( pkt_len, pkt_buf));
    case 0x05: return( pkt_0f_05( pkt_len, pkt_buf));
    case 0x07: return( pkt_0f_07( pkt_len, pkt_buf));
    case 0x09: return( pkt_0f_09( pkt_len, pkt_buf));
    case 0x0A: return( pkt_0f_0A( pkt_len, pkt_buf));
    case 0x12: return( pkt_0f_12( pkt_len, pkt_buf));
    case 0x13: return( pkt_0f_13( pkt_len, pkt_buf));
    case 0x17: return( pkt_0f_17( pkt_len, pkt_buf));
    default:
      *disp << "Info:  *** Received from server ***" << endl;
      disp->hexdump( pkt_len, pkt_buf);
      //input->update();
  }

  return( 0);
}


int Bot::pkt_15( int len, char *buf) {
//  if (char *tmp = vars.getVar("debug_idle"))
//    if (atoi( tmp)) {
//      *disp << CBCYAN << "Info:  " << CBWHITE << "Received an add from the server." << CWHITE << endl;
//      // hexdump( len, buf, stdout, 1);
//      // send( cfd, buf, len, 0);
//      //input->update();
//    }
  lastadd_num = *(u32 *)(buf + 4);

  // === Let the server know we went out and downloaded the add *cough* BS ===
    u32 tmp[ 5] = { 0x001221FF, 0x49583836, 0x5732424E, lastadd_num, 0 };
    tmp[2] = getClientType();
    //switch( getClientType()) {
    //  case 2: // RTSJ
    //    tmp[3] = 0x4A535452;
    //    break;
    //  case 1:
    //    tmp[3] = 0x53544152;
    //    break;
    //  default:
    //    break;
    //}
    rawsend( 0x12, (char *)tmp);

  return( 0);
}


//===
// This is used for server messages, like "Your connection has been terminated" or
// "server is going down", or "you have been disc'd for flooding", etc. You *must*
// close the connection or ipban. >;-)
int Bot::pkt_19( int pkt_len, char *pkt_buf) {
  // 0000   FF 19 3C 00 10 00 00 00 - 59 6F 75 20 68 61 76 65   ..<.....You have
  // 0010   20 62 65 65 6E 20 64 69 - 73 63 6F 6E 6E 65 63 74    been disconnect
  // 0020   65 64 20 66 6F 72 20 66 - 6C 6F 6F 64 69 6E 67 2E   ed for flooding.
  // 0030   00 42 61 74 74 6C 65 2E - 6E 65 74 00               .Battle.net.
  *disp << "*** " << (pkt_buf + 8) << endl;
  //input->update();
  netclose();
  return( 0);
}


int Bot::pkt_1d( int pkt_len, char *pkt_buf) {
  
	if (pkt_len != 0x0c) {
		*disp << "Error: Packet 0x1dff was " << pkt_len << " bytes long." << endl
		      << "       Something is suspicious jim." << endl;
		disp->hexdump( pkt_len, pkt_buf);
		setActive( 0);
		netclose();
		return( -1);
	}

	session_num = *(u32 *)(pkt_buf + 4);
	session_key = *(u32 *)(pkt_buf + 8);

	#ifdef DEBUGBOT
		*disp << "Info:  [0x1dff] Session Number: " << session_num << " Session_key: " << session_key << endl
		      << "       Sending [0x12ff] CLIENT_COUNTRYINFO" << endl;
	#endif

  // bnetd time stuffs
// Is sent on packet connect
//  {
//        double secs = time(0) + 11644473600.0;
//        secs += 3600 * 8; // heh
//        *this << (u32)(secs*.0000001)
//            << (u32)(secs*.00232830643653869628);
//        secs -= 3600 * 8; // heh
//
//        // Same for WC2 and SC
//        *this << (u32)(secs*.0000001)
//            << (u32)(secs*.00232830643653869628)
//            << (u32)0          // time bias - TODO: blah whatever >;-) hope they don't care
//            << (u32)0x00000409 // english
//            << (u32)0x00000409 // english
//            << (u32)0x00000409 // english
//            << "enu"
//            << "1"
//            << "USA"
//            << "United States";
//        sendpkt( 0x12ff);
//      }
      //mine
      //  < 0000   FF 12 3C 00 EF 04 00 00 - CE F9 C0 01 EF 04 00 00   ..<.............
      //  < 0010   8B F9 C0 01 00 00 00 00 - 09 04 00 00 09 04 00 00   ................
      //  < 0020   09 04 00 00 65 6E 75 00 - 31 00 55 53 41 00 55 6E   ....enu.1.USA.Un
      //  < 0030   69 74 65 64 20 53 74 61 - 74 65 73 00               ited States.
      //correct
      //    0000   FF 12 3C 00 C0 D7 42 DF - 7A F9 C0 01 C0 FF E3 32
      //    0010   40 F9 C0 01 E0 01 00 00 - 09 04 00 00 09 04 00 00
      //    0020   09 04 00 00 65 6E 75 00 - 31 00 55 53 41 00 55 6E   ....enu.1.USA.United
      //    0030   69 74 65 64 20 53 74 61 - 74 65 73 00 
      //correct
      //< 0050     FF 06 14 00 36 38 58 49 - 4E 42 32 57 4F 00 00 00
      //           00 00 00 00
      //mine
      //< 0000     FF 06 14 00 36 38 58 49 - 4E 42 32 57 4F 00 00 00   ....68XINB2WO...
      //< 0010     00 00 00 00             -                           ....
//
//      #ifdef DEBUGBOT
//        *disp << "       Sending [0x06ff] CLIENT_PROGIDENT" << endl;
//        //input->update();
//      #endif
//
//      switch( getClientType()) {
//        case CLIENT_W2BN:
//          *this << (u32)0x49583836 //"68XINB2WO"
//                << (u32)0x5732424e //(u16)0
//                << (u32)0x0000004f //;
//                << (u32)0;
//          sendpkt( 0x06ff);
//          break;
//        case CLIENT_STAR:
//        case CLIENT_SEXP:
//          *this << (u32)0x49583836 // 68XI
//                << (u32)getClientType() // RATS
//                << (u32)0x000000c3 // ?
//                << (u32)0;
//          sendpkt( 0x06ff);
//          break;
//        #ifdef FEATURE_JSTR
//        case CLIENT_JSTR:
//          *this << (u32)0x49583836 // 68XI
//                << (u32)getClientType() // 
//                << (u32)0x000000a9 // ?
//                << (u32)0;
//          sendpkt( 0x06ff);
//          break;
//        #endif
//      }

	return( 0);
}



int Bot::pkt_25( int pkt_len, char *pkt_buf) {
  //*disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
  //*disp << CBWHITE << "*** " << CBRED << "PING " << *(u32 *)(pkt_buf + 4) << CWHITE << endl;
  ////input->update();
  lastping = time( 0);

  if (lag_spoof)
    *(u32 *)(pkt_buf + 4) += lastlag;

  *this << *(u32 *)(pkt_buf + 4);
  sendpkt( 0x25ff);

  // rawsend( pkt_len, pkt_buf);
  
  return( 0);
}

void Bot::showProfile( const char *txt, const char *msg) {
  *disp << CBGREEN << txt << CBCYAN;

  while (*msg) {
    switch (*msg) {
      case '\r': break;
      case '\n': *disp << endl << "          ";
                 break;
      default:
        if (*msg >= 32)
          *disp << *msg;
    }
    msg++;
  }
  *disp << CWHITE << endl;
}


// TODO: Make sure server data is valid, and not hostile.
int Bot::pkt_26( int pkt_len, char *pkt_buf) {
	//*disp << CBWHITE << "Info:  " << CWHITE << "Received a profile packet." << endl;
	//disp->hexdump( pkt_len, pkt_buf);

	switch( *(u32 *)(pkt_buf + 0x08)) {
		case 2:
			*disp << CBWHITE << "Info:  " << CBRED << "Remind Eurijk! to fix this. Code: 202907" << endl;
			return 0;
		case 5:
			break;
		default:
			*disp << CBWHITE << "Info:  " << CWHITE << "Received an invalid profile packet, ignoring." << endl;
			return 0;
	}

	lock();
	std::string username = (*profileMap)[ *(u32 *)(pkt_buf + 0x0c)];
	unlock();
	if (username.empty()) {
		*disp << CBWHITE << "Info:  " << CWHITE << "Received a profile packet, but we did not issue it!" << endl;
		return 0;
	}
	
	"-= Profile =-";
	char *sex = pkt_buf + 0x10;
	char *age = sex + strlen( sex) + 1;
	char *loc = age + strlen( age) + 1;
	char *desc = loc + strlen( loc) + 1;

	char needle[4] = { 0x0a, 0x0a, 0x0a, 0x00 };
	char *tmp = strstr( sex, needle);
	if (tmp)
		*tmp = 0;

	showProfile( "Username: ", username.c_str());
	showProfile( "Sex:      ", sex);
	showProfile( "Age:      ", age);
	showProfile( "Location: ", loc);
	showProfile( "Desc:     ", desc);

	if (tmp) {
		tmp += 3;
		showProfile( "RSA:", "Found public RSA key");
		*disp << "RSA Key is " << strlen( tmp) << " bytes long" << endl;
		std::string rsakey;
		while (*tmp) {
			rsakey.append( 1, *tmp);
			tmp++;
		}
		*disp << "RSAKey is now: " << rsakey.c_str() << endl;
		Encryption *enc = new Encryption();
		std::string ph2 = enc->xdebase64(rsakey);
		std::string rsa = enc->hex(ph2);

		*disp << "PH2 is: " << ph2.c_str() << endl;
		*disp << "RSA Hex length is: " << rsa.length() << endl;
		delete enc;

		Obj *userdb = globals->userdb->getObj("userdb");
		if (!userdb) {
			userdb = new Obj("userdb");
			globals->userdb->append( userdb);
		}
		
		Obj *user = userdb->getObj( username.c_str());
		if (!user) {
			user = new Obj( username.c_str());
			userdb->append( user);
		}
		
		user->setVar("publicRSA", rsa.c_str());
	}

	return( 0);
}


// FF 29 08 00 01 00 00 00
int Bot::pkt_29( int pkt_len, char *pkt_buf) {

	#ifdef DEBUGBOT
		*disp << "Info:  [0x29ff] Received user/pass response" << endl;
 		//input->update();
	#endif

	if (*(u16 *)(pkt_buf + 2) != 8) {
		*disp << "Error: Invalid password packet received. Aborting." << endl;
		setActive( 0);
		netclose();
		return( -1);
	}

	if (*(u32 *)(pkt_buf + 4) != 1) {
		*disp << "Error: Invalid password. Creating account." << endl;

		char _password[256];
		strcpy( _password, password);
		u32 hash[ 5];

		HashData( _password, strlen( _password), (char *)hash);
		*this << hash[0] << hash[1] << hash[2] << hash[3] << hash[4] << getName();
		sendpkt( 0x02AFF);

		return( -1);
	}

  #ifdef DEBUGBOT
    *disp << "       Password was valid." << endl
          << "       Sending [0x0aff] Realm login" << endl;
    //input->update();
  #endif

  *this << username
        << "";
  sendpkt( 0x0aff);

  #ifdef DEBUGBOT
    *disp << "       Sending [0x0bff] Prog Ident" << endl;
    //input->update();
  #endif

  *this << getClientType();
  sendpkt( 0x0bff);

  //switch( getClientType()) {
  //  case 0:
  //    *this << (u32)0x5732424E; // "NB2W"
  //    sendpkt( 0x0bff);
  //    break;
  //  case 1:
  //    *this << (u32)0x53544152; // "RATS"
  //    sendpkt( 0x0bff);
  //    break;
  //  case 2:
  //    *this << (u32)0x4A535452; // "japthingy"
  //    sendpkt( 0x0bff);
  //    break;
  //}

  #ifdef DEBUGBOT
    *disp << "       Sending [0x0cff] Channel Join" << endl;
    //input->update();
  #endif

  msg_lasttime = time(0);
  char *bob = "The Void";
  char *tmp = getHomeChannel();
  if (!tmp) tmp = bob;
  //switch( getClientType()) {
  //  case 0: {
  //    if (!tmp) tmp = bob;
  *this << (u32)2
        << tmp; // War2BNE USA-"; // << "war2bne";
  sendpkt( 0x0cff);
  //    }
  //    break;
  //  case 1:
  //    *this << (u32)1
  //          << tmp; // Starcraft USA-";
  //    sendpkt( 0x0cff);
  //    break;
  //  case 2:
  //    *this << (u32)1
  //          << tmp; //Starcraft USA-";
  //    sendpkt( 0x0cff);
  //    break;
  //}

  return( 0);
}

int Bot::pkt_2a( int pkt_len, char *pkt_buf) {
  // 0000   FF 2A 18 00 01 00 00 00 - 13 00 00 00 78 52 82 02   .*..........xR..
  // 0010   00 00 00 00 00 00 00 00 -                           ........
  netclose();
  return( 0);
}

int Bot::pkt_2d( int pkt_len, char *pkt_buf) {
  //< 0000   FF 2D 16 00 80 10 FD 1D - 38 C4 BF 01 69 63 6F 6E   .-......8...icon
  //< 0010   73 2E 62 6E 69 00       -                           s.bni.

  #ifdef DEBUGBOT
    *disp << "Info:  [0x2dff] Received Icon Reply" << endl;
    //input->update();
  #endif

  switch (getClientType()) {
    case CLIENT_STAR:
    case CLIENT_SEXP:
      #ifdef DEBUGBOT
        *disp << "       Sending [0x29ff] Username & password hash" << endl;
        //input->update();
      #endif

          {
            char lpResult[ 1024], lpResult2[ 1024];
            HashData( password, strlen( password), lpResult);
            u32 seed = rand();
            *(u32 *)(lpResult2 + 0) = seed;
            *(u32 *)(lpResult2 + 4) = session_key;
            memcpy( lpResult2 + 8, lpResult, 4 * 5);
            HashData( lpResult2, 4 * 7, lpResult);
            *this << (u32)seed
                  << (u32)session_key
                  << *(u32 *)(lpResult + 0)
                  << *(u32 *)(lpResult + 4)
                  << *(u32 *)(lpResult + 8)
                  << *(u32 *)(lpResult + 12)
                  << *(u32 *)(lpResult + 16)
                  << username;
            sendpkt( 0x29ff);
          }
      break;
//
//
//      #ifdef DEBUGBOT
//        *disp << "       Sending [0x33ff] File info request. (icons_STAR.bni)" << endl;
//        //input->update();
//      #endif
//
//      *this << (u32)0x1d  /// strange @ 1d
//            << (u32)0
//            << "icons_STAR.bni";
//      sendpkt( 0x33ff);
//
//      #ifdef DEBUGBOT
//        *disp << "       Sending [0x33ff] File info request. (tos_USA.txt)" << endl;
//        //input->update();
//      #endif
//
//      *this << (u32)0x1a // first request
//            << (u32)0
//            << "tos_USA.txt";
//      sendpkt( 0x33ff);
//
//      #ifdef DEBUGBOT
//        *disp << "       Sending [0x33ff] File info request. (bnserver.ini)" << endl;
//        //input->update();
//      #endif
//
//      *this << (u32)0x1b // second request
//            << (u32)0
//            << "bnserver.ini";
//      sendpkt( 0x33ff);
//
//      #ifdef DEBUGBOT
//        *disp << "       Sending [0x26ff] Profile request (yeah right!)" << endl;
//        //input->update();
//      #endif
//
//      *this << (u32)1  // 1 profile request
//            << (u32)0x13
//            << (u32)rand()
//            << getName()
//            << "profile\\sex"
//            << "profile\\age"
//            << "profile\\location"
//            << "profile\\description"
//            << "Record\\Star\\0\\wins"
//            << "Record\\Star\\0\\losses"
//            << "Record\\Star\\0\\disconnects"
//            << "Record\\Star\\0\\last game"
//            << "Record\\Star\\0\\last game result"
//            << "Record\\Star\\1\\wins"
//            << "Record\\Star\\1\\losses"
//            << "Record\\Star\\1\\disconnects"
//            << "Record\\Star\\1\\rating"
//            << "Record\\Star\\1\\high rating"
//            << "DynKey\\Star\\1\\rank"
//            << "Record\\Star\\1\\high rank"
//            << "Record\\Star\\1\\last game"
//            << "Record\\Star\\1\\last game result"
//            << "";
//      sendpkt( 0x26ff);
//    break;
  }

  return( 0);
}

//===
// CDKey reply.
int Bot::pkt_30( int pkt_len, char *pkt_buf) {
  // 0000   FF 30 09 00 02 00 00 00 - 00                        .0.......
  #ifdef DEBUGBOT
    *disp << "Info:  [0x30ff] Received cdkey reply." << endl;
    //input->update();
  #endif

  switch (*(u32 *)(pkt_buf + 4)) {
    case 1:
      *disp << "Info:  [0x30ff] Received ok cdkey." << endl;
      //input->update();
      break;
    default:
      *disp << "Info:  Did *not* receive ok for cdkey." << endl;
      //input->update();
      netclose();
      #ifdef DEBUGBOT
        done++;
      #endif
      return( -1);
  }

      #ifdef DEBUGBOT
        *disp << "       Sending [0x29ff] Username & password hash" << endl;
        //input->update();
      #endif

//=== I believe this got moved to a 2d response
//          {
//            char lpResult[ 1024], lpResult2[ 1024];
//            HashData( password, strlen( password), lpResult);
//            u32 seed = rand();
//            *(u32 *)(lpResult2 + 0) = seed;
//            *(u32 *)(lpResult2 + 4) = session_key;
//            memcpy( lpResult2 + 8, lpResult, 4 * 5);
//            HashData( lpResult2, 4 * 7, lpResult);
//            *this << (u32)seed
//                  << (u32)session_key
//                  << *(u32 *)(lpResult + 0)
//                  << *(u32 *)(lpResult + 4)
//                  << *(u32 *)(lpResult + 8)
//                  << *(u32 *)(lpResult + 12)
//                  << *(u32 *)(lpResult + 16)
//                  << username;
//            sendpkt( 0x29ff);
//          }
      
  return 0;
}

//===
// File timestamp info.
int Bot::pkt_33( int pkt_len, char *pkt_buf) {
  #ifdef DEBUGBOT
    *disp << "Info:  [0x33ff] Received a file timestamp info packet" << endl;
    //input->update();
  #endif

  return( 0);
}

//< 0000   FF 36 09 00 02 00 00 00 - 00                        .6.......
int Bot::pkt_36( int pkt_len, char *pkt_buf) {

	#ifdef DEBUGBOT
		*disp << "Info:  [0x36ff] Server CD reply" << endl;
	#endif

	if (*(u16 *)(pkt_buf + 2) < 0x09) {
		*disp << "Error: Packet [0x36ff] was too short." << endl;
		setActive( 0);
		netclose();
		return( -1);
	}

	switch (*(u32 *)(pkt_buf + 4)) {
		case 1:
      #ifdef DEBUGBOT
        *disp << "       CD Key Checked Ok" << endl;
        //input->update();
      #endif

      switch( getClientType()) {
        case CLIENT_W2BN: // WarCraft
          #ifdef DEBUGBOT
            *disp << "       Sending [0x33ff] File info request. (tos_USA.txt)" << endl;
            //input->update();
          #endif

          *this << (u32)0x1A // first request
                << (u32)0
                << "tos_USA.txt";
          sendpkt( 0x33ff);

          #ifdef DEBUGBOT
            *disp << "       Sending [0x33ff] File info request. (bnserver.ini)" << endl;
            //input->update();
          #endif

          *this << (u32)0x1B // second request
                << (u32)0
                << "bnserver.ini";
          sendpkt( 0x33ff);

          #ifdef DEBUGBOT
            *disp << "       Sending [0x26ff] Profile request (yeah right!)" << endl;
            //input->update();
          #endif

          // Sending username/password hash.
          //   0000   FF 29 29 00 9A 63 49 35 - 70 33 D9 CF ?? ?? ?? ??   .))..cI5p3..????
          //   0010   ?? ?? ?? ?? ?? ?? ?? ?? - ?? ?? ?? ?? ?? ?? ?? ??   ????????????????
          //   0020   44 53 7E 42 6F 74 36 21 - 00                        DS~Bot6!.

          #ifdef DEBUGBOT
            *disp << "       Sending [0x29ff] Username & password hash" << endl;
            //input->update();
          #endif

          {
            char lpResult[ 1024], lpResult2[ 1024];
            HashData( password, strlen( password), lpResult);
            u32 seed = rand();
            *(u32 *)(lpResult2 + 0) = seed;
            *(u32 *)(lpResult2 + 4) = session_key;
            memcpy( lpResult2 + 8, lpResult, 4 * 5);
            HashData( lpResult2, 4 * 7, lpResult);
            *this << (u32)seed
                  << (u32)session_key
                  << *(u32 *)(lpResult + 0)
                  << *(u32 *)(lpResult + 4)
                  << *(u32 *)(lpResult + 8)
                  << *(u32 *)(lpResult + 12)
                  << *(u32 *)(lpResult + 16)
                  << username;
            sendpkt( 0x29ff);
          }
          break;
        case CLIENT_STAR:
        case CLIENT_SEXP: // StarCraft
          #ifdef DEBUGBOT
            *disp << "       Sending [0x33ff] File info request. (icons_STAR.bni)" << endl;
            //input->update();
          #endif

          *this << (u32)0x1A // first request
                << (u32)0
                << "icons_STAR.bni";
          sendpkt( 0x33ff);

          #ifdef DEBUGBOT
            *disp << "       Sending [0x33ff] File info request. (tos_USA.txt)" << endl;
            //input->update();
          #endif

          *this << (u32)0x1B // first request
                << (u32)0
                << "tos_USA.txt";
          sendpkt( 0x33ff);


          #ifdef DEBUGBOT
            *disp << "       Sending [0x33ff] File info request. (bnserver.ini)" << endl;
            //input->update();
          #endif

          *this << (u32)0x1C // second request
                << (u32)0
                << "bnserver.ini";
          sendpkt( 0x33ff);

          #ifdef DEBUGBOT
            *disp << "       Sending [0x26ff] Profile request (yeah right!)" << endl;
            //input->update();
          #endif

          #ifdef DEBUGBOT
            *disp << "       Sending [0x29ff] Username & password hash" << endl;
            //input->update();
          #endif

          {
            char lpResult[ 1024], lpResult2[ 1024];
            HashData( password, strlen( password), lpResult);
            u32 seed = rand();
            *(u32 *)(lpResult2 + 0) = seed;
            *(u32 *)(lpResult2 + 4) = session_key;
            memcpy( lpResult2 + 8, lpResult, 4 * 5);
            HashData( lpResult2, 4 * 7, lpResult);
            *this << (u32)seed
                  << (u32)session_key
                  << *(u32 *)(lpResult + 0)
                  << *(u32 *)(lpResult + 4)
                  << *(u32 *)(lpResult + 8)
                  << *(u32 *)(lpResult + 12)
                  << *(u32 *)(lpResult + 16)
                  << username;
            sendpkt( 0x29ff);
          }
          break;
        #ifdef FEATURE_JSTR
        case CLIENT_JSTR: // Jap Starcraft
          #ifdef DEBUGBOT
            *disp << "       Sending [0x33ff] File info request. (bnserver.ini)" << endl;
            //input->update();
          #endif

          *this << (u32)0x1A // first request
                << (u32)0
                << "bnserver.ini";
          sendpkt( 0x33ff);

          #ifdef DEBUGBOT
            *disp << "       Sending [0x26ff] Profile request (yeah right!)" << endl;
            //input->update();
          #endif

          #ifdef DEBUGBOT
            *disp << "       Sending [0x29ff] Username & password hash" << endl;
            //input->update();
          #endif

          {
            char lpResult[ 1024], lpResult2[ 1024];
            HashData( password, strlen( password), lpResult);
            u32 seed = rand();
            *(u32 *)(lpResult2 + 0) = seed;
            *(u32 *)(lpResult2 + 4) = session_key;
            memcpy( lpResult2 + 8, lpResult, 4 * 5);
            HashData( lpResult2, 4 * 7, lpResult);
            *this << (u32)seed
                  << (u32)session_key
                  << *(u32 *)(lpResult + 0)
                  << *(u32 *)(lpResult + 4)
                  << *(u32 *)(lpResult + 8)
                  << *(u32 *)(lpResult + 12)
                  << *(u32 *)(lpResult + 16)
                  << username;
            sendpkt( 0x29ff);
          }
          break;
        #endif
      }
      break;
    case 0x00000002:
          *disp << "Error: Invalid CD Key returned." << endl;
          //input->update();
          netclose();
          break;
    case 0x00000003:
          *disp << "Error: CD Key is not for this application." << endl
                << "       Did you enter a StarCraft CD Key for a Warcraft setting?" << endl;
          //input->update();
          netclose();
          break;
    case 0x00000004:
          *disp << "Error: We got an error response. Strange, shutting down." << endl;
          //input->update();
          netclose();
          break;
    case 0x00000005:
          *disp << "Error: Your CD Key is currently in use." << endl;
          //input->update();
          netclose();
          break;
    default:
          *disp << "Error: We got an unknown response. Strange, shutting down." << endl;
          //input->update();
          netclose();
          break;
    }

  #ifdef DEBUGBOT
    *disp << "DEBUGBOT: Bot::pkt_36 has exited." << endl;
    //input->update();
  #endif

  return( 0);
}


// 0000   FF 3A 08 00 00 00 00 00
int Bot::pkt_3a( int pkt_len, char *pkt_buf) {

	switch( *(u32 *)(pkt_buf + 4)) {
		case 0:
      #ifdef DEBUGBOT
        *disp << "Info:  [0x3aff] Username & Password OK" << endl
             << "       Sending [0x0bff] Channel request for D2XP" << endl
             << "       Sending [0x0aff] Character registration" << endl
             << "       Sending [0x0cff] Channel join" << endl;
        //input->update();
      #endif
      break;
		default:
      *disp << "Info:  [0x3aff] Username & Password" << endl
           << "Error: Did *NOT* receive OK. Closing connection." << endl;
      //input->update();
      setActive( 0);
      netclose();
      return( -1);
	}

	*this << (u32)getClientType();
	sendpkt( 0x0bff);

	char buf[ 1024];
	sprintf( buf, ",%s", nick);
	*this << nick
	     << buf;
	sendpkt( 0x0aff);

	*this << (u32)1
	      << "Diablo II";
	sendpkt( 0x0cff);

  return( 0);
}


//===
// Todo: What if the remote server is hostile?
int Bot::pkt_50( int pkt_len, char *pkt_buf) {
	
	//===
	// Get the packet variables.
		session_key = *(u32 *)(pkt_buf + 8);
		session_num = *(u32 *)(pkt_buf + 12);

		int hash_mpq = 0;
		char *hash_equ = (pkt_buf + strlen( (pkt_buf + 0x18)) + 0x19);

		{
			char *tmp = strchr( (pkt_buf + 0x18), '.');
			if (tmp)
				hash_mpq = atoi( tmp - 1);
		}

		// *disp << "Info:  [0x50ff] session_num: " << session_num << endl
		//       << "       session_key: " << session_key << endl
		//       << "       hash_mpq:    " << hash_mpq << endl
		//       << "       hash_equ:    " << hash_equ << endl;

	//===
	// Decode the cdkey.
		u32 a, b, c;
		if (DecodeCDKey( cdkey, &a, &b, &c)) {
			*disp << "Error: Unable to decode cdkey" << endl;
			*disp << "Info:  Disabled bot to avoid ip ban." << endl;
			setActive( 0);
			netclose();
			return -1;
		}

	//===
	// Parse the hashes
		Obj *objHash = globals->db->getObj("hash");
		if (!objHash) {
			objHash = new Obj("hash");
			globals->db->append( objHash);
		}
		
		Obj *objClient = NULL;
		u32 result;

		switch( getClientType()) {
			case CLIENT_STAR:
				objClient = objHash->getObj("star");
				break;
			case CLIENT_SEXP:
				objClient = objHash->getObj("sexp");
				break;
			case CLIENT_D2XP:
				objClient = objHash->getObj("d2xp");
				break;
		}

		if (!objClient) {
			*disp << "Error: Could not find hash files, or did not recognize the client." << endl;
			*disp << "       Did you net set them yet?" << endl;
			*disp << "Info:  Disabled bot to avoid IP ban." << endl;
			setActive( 0);
			netclose();
			return -1;
		}
				
		char *f1 = objClient->getVar("exe");
		char *f2 = objClient->getVar("dll");
		char *f3 = objClient->getVar("snp");
					
		if (!f1 || (!f2 || !f3)) {
			*disp << "Error: All three hash files are not set. Did you not set them yet?" << endl;
			*disp << "Info:  Disabled bot to avoid IP ban." << endl;
			setActive( 0);
			netclose();
			return -1;
		}

	//===
	// Do the actual hashes
		VerCheck vercheck;
				
		switch( vercheck.checkRevision( hash_equ, hash_mpq, &result, f1, f2, f3)) {
			case 0:
				break;
			case -1:
				*disp << "Error: Invalid parameters passed to revision check" << endl;
				*disp << "Info:  Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
			case -2:
				*disp << "Error:  We were unable to find the hash files." << endl;
				*disp << "        Please verify the hash files below are correct:" << endl;
				*disp << "File:   " << f1 << endl;
				*disp << "File:   " << f2 << endl;
				*disp << "File:   " << f3 << endl;
				*disp << "Info:   Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
			default:
				*disp << "Error: Received an unknown result from checkRevision" << endl;
				*disp << "Info:   Disabled bot to avoid IP ban." << endl;
				setActive( 0);
				netclose();
				return -1;
		}

	u32 seed1 = rand();

	switch (getClientType()) {
		case CLIENT_STAR:
			*this << seed1
			      << (u32)0x010000900
			      << result
			      << (u32)1
			      << (u32)0
			      << (u32)0x0d
			      << (u32)1
			      << b
			      << (u32)0;
			break;
		case CLIENT_SEXP:
			*this << seed1
			      << (u32)0x01000903
            << result
            << (u32)1
            << (u32)0
            << (u32)0x0d
            << (u32)1
            << b
            << (u32)0;
			break;
		case CLIENT_D2XP:
			*this << seed1
			      << (u32)0x01000900
			      << result
			      << (u32)2
			      << (u32)0
			      << (u32)0x10
			      << (u32)0x06
			      << b
			      << (u32)0;
			break;
		//case CLIENT_D2DV:
		//	*this << seed1
      //      << (u32)0x010000900
      //      << result
      //      << (u32)1
      //      << (u32)0
      //      << (u32)0x10
      //      << (u32)6
      //      << b
      //      << (u32)0;
		//	break;
	}

	u32 hash[5];
	u32 tmp[6];
	tmp[0] = seed1;
	tmp[1] = session_key;
	tmp[2] = a;
	tmp[3] = b;
	tmp[4] = 0;
	tmp[5] = c;
	HashData( tmp, 6*4, hash);
  
	*this << hash[0] << hash[1] << hash[2] << hash[3] << hash[4];

	switch( getClientType()) {
		case CLIENT_D2XP:
			{
				//===
				// Decode the second cdkey.
					u32 a, b, c;
					if (DecodeCDKey( cdkey2, &a, &b, &c)) {
						*disp << "Error: Unable to decode cdkey2" << endl;
						*disp << "Info:  Disabled bot to avoid ip ban." << endl;
						setActive( 0);
						netclose();
						return -1;
					}

				u32 hash[5];
				u32 tmp[6];
				tmp[0] = seed1;
				tmp[1] = session_key;
				tmp[2] = a;
				tmp[3] = b;
				tmp[4] = 0;
				tmp[5] = c;
				HashData( tmp, 6*4, hash);

				*this << (u32)0x10
				      << (u32)0x0a
			         << b
			         << (u32)0
			         << hash[0] << hash[1] << hash[2] << hash[3] << hash[4];
			} break;
		default:
			break;
	}

	switch( getClientType()) {
		case CLIENT_STAR:
			*this << "starcraft.exe 02/21/02 21:48:42 1083392";
			break;
		case CLIENT_SEXP:
			*this << "starcraft.exe 10/31/02 19:23:40 1083392";
			break;
		case CLIENT_D2DV:
			*this << "Game.exe 11/30/01 03:59:46 444579";
			break;
		case CLIENT_D2XP:
			*this << "Game.exe 11/30/01 05:00:18 448675";
			break;
	}

  *this << getRegister();
  sendpkt( 0x51ff);
        
  return( 0);
}


// 0000  ff 51 09 00 00 00 00 00 - 00
int Bot::pkt_51( int pkt_len, char *pkt_buf) {
	switch( *(u32 *)(pkt_buf + 4)) {
		case 0:
			#ifdef DEBUGBOT
				*disp << "Info:  [0x51ff] CDKeys & Client Revision OK" << endl
				      << "       Sending [0x33ff] File request: bnserver-D2DV.ini" << endl;
			#endif

			//===
			// We should be able to safely ignore this packet.
			//switch (getClientType()) {
			//	case CLIENT_D2XP:
			//	case CLIENT_D2XP:
      	//		*this << (u32)0x80000004 // 0x80 for "NEW INFO" ? File download request number
      	//		      << (u32)0
      	//		      << "bnserver-D2DV.ini";
      	//		sendpkt( 0x33ff);
      	//		break;
      	//	default:
      	//		break;
      	//}

			switch( getClientType()) {
        case CLIENT_STAR:
        case CLIENT_SEXP:
          sendpkt( 0x2dff);
			{
		if (!plug) {
			char *tmp2 = "tenb";
			*this << *(u32 *)tmp2;
			sendpkt( 0x14ff);
		}
	}
          break;
        case CLIENT_D2DV:
        case CLIENT_D2XP:
          {
            #ifdef DEBUGBOT
            *disp << "       " << CWHITE << " Sending [0x3aff] Username & Password" << endl;
            //input->update();
            #endif

            char *_username = getName();
            char _password[256];

            strcpy( _password, password);

	    char lpResult[ 1024], lpResult2[ 1024];
	    HashData( _password, strlen( _password), lpResult);
	    u32 seed = rand();

	    *(u32 *)(lpResult2 + 0) = seed;
	    *(u32 *)(lpResult2 + 4) = session_key;
	    memcpy( lpResult2 + 8, lpResult, 4 * 5);
	    HashData( lpResult2, 4 * 7, lpResult);
            *this << (u32)seed
                  << (u32)session_key
                  << *(u32 *)(lpResult + 0)
                  << *(u32 *)(lpResult + 4)
                  << *(u32 *)(lpResult + 8)
                  << *(u32 *)(lpResult + 12)
                  << *(u32 *)(lpResult + 16)
                  << _username;
            sendpkt( 0x3aff);
          } break;
      }

      break;
    case 0x100:
      *disp << "Error: [0x51ff] CDKeys & Client Revision" << endl
            << "       It appears we need to update." << endl;
      //input->update();
		setActive( 0);
      netclose();
      break;
    case 0x101:
      *disp << "Error: [0x51ff] CDKeys & Client Revision" << endl
            << "       It appears we have the wrong version." << endl;
		setActive( 0);
      //input->update();
      netclose();
      #ifdef DEBUGBOT
        exit( -1);
      #endif
      break;
    case 0x200:
      *disp << "Error: [0x51ff] CDKeys & Client Revision" << endl
            << "       Is our cdkey in use?" << endl;
      //input->update();
		setActive( 0);
      netclose();
      #ifdef DEBUGBOT
        exit( -1);
      #endif
      break;
    default:
      *disp << "Info:  [0x51ff] CDKeys & Client Revision" << endl
           << "Error: Did *NOT* receive OK. Closing connection." << endl;
      //input->update();
		setActive( 0);
      netclose();
      #ifdef DEBUGBOT
        exit( -1);
      #endif
  }
  return( 0);
}


int Bot::pkt_handler( int pkt_len, char *pkt_buf) {
	debug(("Bot::pkt_handler()"));
	#ifdef DEBUG
		printf("  pkt_len => %d, pkt_buf[1] => 0x%.2x\n", pkt_len, pkt_buf[1]);
	#endif

	if (objbot)
		if (objbot->getVar("debug")) {
			disp->hexdump( pkt_len, pkt_buf);
		}

	//===
	// Todo: Add an option to log this to a file.
	//#ifdef DEBUGPKT
	//	*disp << "Debug: Bot::pkt_handler was called" << endl;
	//	disp->hexdump( pkt_len, pkt_buf);
	//	//input->update();
	//#endif

	switch( pkt_buf[1]) {
		case 0x00: pkt_00( pkt_len, pkt_buf); break;
		case 0x04: pkt_04( pkt_len, pkt_buf); break;
		case 0x05: pkt_05( pkt_len, pkt_buf); break;
		case 0x06: pkt_06( pkt_len, pkt_buf); break;
		case 0x07: pkt_07( pkt_len, pkt_buf); break;
		case 0x0a: pkt_0a( pkt_len, pkt_buf); break;
		case 0x0b: pkt_0b( pkt_len, pkt_buf); break;
		case 0x0c: pkt_0c( pkt_len, pkt_buf); break;
		case 0x0f: pkt_0f( pkt_len, pkt_buf); break;
		case 0x13: pkt_13( pkt_len, pkt_buf); break;
		case 0x15: pkt_15( pkt_len, pkt_buf); break;
		case 0x19: pkt_19( pkt_len, pkt_buf); break;
		case 0x1d: pkt_1d( pkt_len, pkt_buf); break;
		case 0x25: pkt_25( pkt_len, pkt_buf); break;
		case 0x26: pkt_26( pkt_len, pkt_buf); break;
		case 0x29: pkt_29( pkt_len, pkt_buf); break;
		case 0x2a: pkt_2a( pkt_len, pkt_buf); break;
		case 0x2d: pkt_2d( pkt_len, pkt_buf); break;
		case 0x30: pkt_30( pkt_len, pkt_buf); break;
		case 0x33: pkt_33( pkt_len, pkt_buf); break;
		case 0x36: pkt_36( pkt_len, pkt_buf); break;
		case 0x3a: pkt_3a( pkt_len, pkt_buf); break;
		case 0x50: pkt_50( pkt_len, pkt_buf); break;
		case 0x51: pkt_51( pkt_len, pkt_buf); break;
		default:
			*disp << CBWHITE << "Info:  " << CBCYAN << getName() << CWHITE << " has received an unknown packet from the server." << endl;
			disp->hexdump( pkt_len, pkt_buf);
			netclose();
			break;
	}

	debug(("Bot::~pkt_handler()"));
	return( 0);
}

int Bot::sendReqProfile( char *name) {
  char buf[ 1024];

  if (getfd() == -1) return( -1);
  //if (!profile_lastval) return( -1);
  //if (!profile_lasttime) return( -1);

    //char fuckyou[] = {
    //                                                  0x70, 0x72, 0x6F,   //Gay'n'Angry!.pro
    //  0x66, 0x69, 0x6C, 0x65, 0x5C, 0x73, 0x65, 0x78, 0x00, 0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65,   //file\sex.profile
    //  0x5C, 0x61, 0x67, 0x65, 0x00, 0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65, 0x5C, 0x6C, 0x6F, 0x63,   //\age.profile\loc
    //  0x61, 0x74, 0x69, 0x6F, 0x6E, 0x00, 0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65, 0x5C, 0x64, 0x65,   //ation.profile\de
    //  0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6F, 0x6E, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64,   //scription.Record
    //  0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x77, 0x69, 0x6E, 0x73, 0x00, 0x52, 0x65, 0x63,   //\W2BN\0\wins.Rec
    //  0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x6C, 0x6F, 0x73, 0x73, 0x65,   //ord\W2BN\0\losse
    //  0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C,   //s.Record\W2BN\0\
    //  0x64, 0x69, 0x73, 0x63, 0x6F, 0x6E, 0x6E, 0x65, 0x63, 0x74, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F,   //disconnects.Reco
    //  0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67,   //rd\W2BN\0\last g
    //  0x61, 0x6D, 0x65, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C,   //ame.Record\W2BN\
    //  0x30, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x20, 0x72, 0x65, 0x73, 0x75,   //0\last game resu
    //  0x6C, 0x74, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31,   //lt.Record\W2BN\1
    //  0x5C, 0x77, 0x69, 0x6E, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42,   //\wins.Record\W2B
    //  0x4E, 0x5C, 0x31, 0x5C, 0x6C, 0x6F, 0x73, 0x73, 0x65, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72,   //N\1\losses.Recor
    //  0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x64, 0x69, 0x73, 0x63, 0x6F, 0x6E, 0x6E,   //d\W2BN\1\disconn
    //  0x65, 0x63, 0x74, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E,   //ects.Record\W2BN
    //  0x5C, 0x31, 0x5C, 0x72, 0x61, 0x74, 0x69, 0x6E, 0x67, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64,   //\1\rating.Record
    //  0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x68, 0x69, 0x67, 0x68, 0x20, 0x72, 0x61, 0x74,   //\W2BN\1\high rat
    //  0x69, 0x6E, 0x67, 0x00, 0x44, 0x79, 0x6E, 0x4B, 0x65, 0x79, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C,   //ing.DynKey\W2BN\
    //  0x31, 0x5C, 0x72, 0x61, 0x6E, 0x6B, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32,   //1\rank.Record\W2
    //  0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x00, 0x52,   //BN\1\last game.R
    //  0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x6C, 0x61, 0x73,   //ecord\W2BN\1\las
    //  0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x20, 0x72, 0x65, 0x73, 0x75, 0x6C, 0x74, 0x00, 0x52, 0x65,   //t game result.Re
    //  0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x77, 0x69, 0x6E, 0x73,   //cord\W2BN\3\wins
    //  0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x6C,   //.Record\W2BN\3\l
    //  0x6F, 0x73, 0x73, 0x65, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42,   //osses.Record\W2B
    //  0x4E, 0x5C, 0x33, 0x5C, 0x64, 0x69, 0x73, 0x63, 0x6F, 0x6E, 0x6E, 0x65, 0x63, 0x74, 0x73, 0x00,   //N\3\disconnects.
    //  0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x72, 0x61,   //Record\W2BN\3\ra
    //  0x74, 0x69, 0x6E, 0x67, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E,   //ting.Record\W2BN
    //  0x5C, 0x33, 0x5C, 0x68, 0x69, 0x67, 0x68, 0x20, 0x72, 0x61, 0x74, 0x69, 0x6E, 0x67, 0x00, 0x44,   //\3\high rating.D
    //  0x79, 0x6E, 0x4B, 0x65, 0x79, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x72, 0x61, 0x6E,   //ynKey\W2BN\3\ran
    //  0x6B, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C,   //k.Record\W2BN\3\
    //  0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64,   //last game.Record
    //  0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D,   //\W2BN\3\last gam
    //  0x65, 0x20, 0x72, 0x65, 0x73, 0x75, 0x6C, 0x74, 0x00, 0x00                     //e result..
    //};
   char fuckyou[] = {
     //0xFF, 0x26, 0x46, 0x02, 0x01, 0x00, 0x00, 0x00, 0x1A, 0x00, 0x00, 0x00, 0x55, 0x81, 0x73, 0x1A,  //  .&F.........U.s. < 0000   
     //0x61, 0x72, 0x69, 0x61, 0x39, 0x38, 0x31, 0x36, 0x00, 
     0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65,  //  aria9816.profile < 0010   
     0x5C, 0x73, 0x65, 0x78, 0x00, 0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65, 0x5C, 0x61, 0x67, 0x65,  //  \sex.profile\age < 0020   
     0x00, 0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65, 0x5C, 0x6C, 0x6F, 0x63, 0x61, 0x74, 0x69, 0x6F,  //  .profile\locatio < 0030   
     0x6E, 0x00, 0x70, 0x72, 0x6F, 0x66, 0x69, 0x6C, 0x65, 0x5C, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69,  //  n.profile\descri < 0040   
     0x70, 0x74, 0x69, 0x6F, 0x6E, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42,  //  ption.Record\W2B < 0050   
     0x4E, 0x5C, 0x30, 0x5C, 0x77, 0x69, 0x6E, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C,  //  N\0\wins.Record\ < 0060   
     0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x6C, 0x6F, 0x73, 0x73, 0x65, 0x73, 0x00, 0x52, 0x65,  //  W2BN\0\losses.Re < 0070   
     0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x64, 0x69, 0x73, 0x63,  //  cord\W2BN\0\disc < 0080   
     0x6F, 0x6E, 0x6E, 0x65, 0x63, 0x74, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57,  //  onnects.Record\W < 0090   
     0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x00,  //  2BN\0\last game. < 00A0   
     0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x30, 0x5C, 0x6C, 0x61,  //  Record\W2BN\0\la < 00B0   
     0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x20, 0x72, 0x65, 0x73, 0x75, 0x6C, 0x74, 0x00, 0x52,  //  st game result.R < 00C0   
     0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x77, 0x69, 0x6E,  //  ecord\W2BN\1\win < 00D0   
     0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C,  //  s.Record\W2BN\1\ < 00E0   
     0x6C, 0x6F, 0x73, 0x73, 0x65, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32,  //  losses.Record\W2 < 00F0   
     0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x64, 0x69, 0x73, 0x63, 0x6F, 0x6E, 0x6E, 0x65, 0x63, 0x74, 0x73,  //  BN\1\disconnects < 0100   
     0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x72,  //  .Record\W2BN\1\r < 0110   
     0x61, 0x74, 0x69, 0x6E, 0x67, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42,  //  ating.Record\W2B < 0120   
     0x4E, 0x5C, 0x31, 0x5C, 0x68, 0x69, 0x67, 0x68, 0x20, 0x72, 0x61, 0x74, 0x69, 0x6E, 0x67, 0x00,  //  N\1\high rating. < 0130   
     0x44, 0x79, 0x6E, 0x4B, 0x65, 0x79, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x72, 0x61,  //  DynKey\W2BN\1\ra < 0140   
     0x6E, 0x6B, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31,  //  nk.Record\W2BN\1 < 0150   
     0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72,  //  \last game.Recor < 0160   
     0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x31, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61,  //  d\W2BN\1\last ga < 0170   
     0x6D, 0x65, 0x20, 0x72, 0x65, 0x73, 0x75, 0x6C, 0x74, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64,  //  me result.Record < 0180   
     0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x77, 0x69, 0x6E, 0x73, 0x00, 0x52, 0x65, 0x63,  //  \W2BN\3\wins.Rec < 0190   
     0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x6C, 0x6F, 0x73, 0x73, 0x65,  //  ord\W2BN\3\losse < 01A0   
     0x73, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C,  //  s.Record\W2BN\3\ < 01B0   
     0x64, 0x69, 0x73, 0x63, 0x6F, 0x6E, 0x6E, 0x65, 0x63, 0x74, 0x73, 0x00, 0x52, 0x65, 0x63, 0x6F,  //  disconnects.Reco < 01C0   
     0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x72, 0x61, 0x74, 0x69, 0x6E, 0x67,  //  rd\W2BN\3\rating < 01D0   
     0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x68,  //  .Record\W2BN\3\h < 01E0   
     0x69, 0x67, 0x68, 0x20, 0x72, 0x61, 0x74, 0x69, 0x6E, 0x67, 0x00, 0x44, 0x79, 0x6E, 0x4B, 0x65,  //  igh rating.DynKe < 01F0   
     0x79, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x72, 0x61, 0x6E, 0x6B, 0x00, 0x52, 0x65,  //  y\W2BN\3\rank.Re < 0200   
     0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42, 0x4E, 0x5C, 0x33, 0x5C, 0x6C, 0x61, 0x73, 0x74,  //  cord\W2BN\3\last < 0210   
     0x20, 0x67, 0x61, 0x6D, 0x65, 0x00, 0x52, 0x65, 0x63, 0x6F, 0x72, 0x64, 0x5C, 0x57, 0x32, 0x42,  //   game.Record\W2B < 0220   
     0x4E, 0x5C, 0x33, 0x5C, 0x6C, 0x61, 0x73, 0x74, 0x20, 0x67, 0x61, 0x6D, 0x65, 0x20, 0x72, 0x65,  //  N\3\last game re < 0230   
     0x73, 0x75, 0x6C, 0x74, 0x00, 0x00                                                               //  sult..           < 0240   
  };

    // *(u16 *)(buf) = 0x26ff;
    // *(u16 *)(buf + 2) = 0x11 + strlen( name) + sizeof( fuckyou);
    // *(u32 *)(buf + 4) = 1;
    // *(u32 *)(buf + 8) = 1; //0x1A;
    // *(u32 *)(buf + 12) = rand(); //(u32)((time(0) - profile_lasttime) * 1000 + profile_lastval);
    // strcpy( buf + 0x10, name);
    // memcpy( buf + 0x11 + strlen( name), fuckyou, sizeof( fuckyou));    
    // disp->hexdump( *(u16 *)(buf + 2), buf);    
    // rawsend( *(u16 *)(buf + 2), buf);

  *this << (u32)1
       << (u32)6 // one object and name is included
       << (u32)rand()
       << name
       << "profile\\sex"
       << "profile\\age"
       << "profile\\location"
       << "profile\\description"
       << "profile\\publicrsaencryptkey"
       << "";
  sendpkt( 0x26ff);

  return( 0);
}


int Bot::setName( const char *_username) {
  if (!_username) return( -1);
  strncpy( username, _username, sizeof( username) - 1);
  proxy->setName( username);
  return( 0);
}


int Bot::setPasswd( const char *_password) {
  if (!_password) return( -1);
  strncpy( password, _password, sizeof( password) - 1);
  return( 0);
}


int Bot::setServer( const char *_server) {
  if (!_server) return( -1);
  strncpy( server, _server, sizeof( server) - 1);
  proxy->setIP( server);
  return( 0);
}


int Bot::setHomeChannel( const char *_homechannel) {
  if (!_homechannel) return( -1);
  strncpy( homechannel, _homechannel, sizeof( homechannel) -1);
  return( 0);
}


int Bot::setCDKey( const char *_cdkey) {
  if (!_cdkey) return( -1);
  strncpy( cdkey, _cdkey, sizeof( cdkey) - 1);

  int len = 0; char *tmp = cdkey;
  while (*tmp) {
    if (*tmp != '-')
      len++;
    tmp++;
  }
  
  switch( len) {
    case 13: 
      if (clientType == -1)
        clientType = CLIENT_STAR; 
      break;
    case 16: 
      if (clientType == -1)
        clientType = CLIENT_W2BN;
      break;
//    default:
//      *disp << CBRED << "Error: " << CBWHITE << "Your CD-Key has an invalid length." << endl;
//      //input->clear();
//      return( -1);
  }

  return( 0);
}

int Bot::setCDKey2( const char *_cdkey) {
  if (!_cdkey) return( -1);

  strncpy( cdkey2, _cdkey, sizeof( cdkey) - 1);
  return( 0);
}


int Bot::setNick( const char *_nick) {
  if (!_nick) return( -1);

  strncpy( nick, _nick, sizeof( nick) - 1);
  return( 0);
}


int Bot::setRegister( const char *_registered) {
  if (!_registered) return( -1);
  strncpy( registered, _registered, sizeof( registered) - 1);
  return( 0);
}


int Bot::setCommandSet( const char *_cmdset) {
  if (!_cmdset) return( -1);
  strncpy( commandset, _cmdset, sizeof( commandset) - 1);
  return( 0);
}

int Bot::setSpawn( int _spawn) {
  spawn = _spawn ? 1 : 0;
  return( 0);
}

int Bot::setBind( const char *_bind) {
  if (!_bind) return( -1);
  strncpy( bindaddy, _bind, sizeof( bindaddy) -1);
  return( 0);
}

int Bot::getDisplay( void) {
  return( display);
}

int Bot::setDisplay( const char *_display) {
  if (!_display) return( -1);
  display = atoi( _display);
  if (display < 0) display = 0;
  if (display > 1) display = 1;

  disp->focus();

  return( 0);
}

int Bot::setSocks4_Server( const char *_server) {
  if (!_server) return( -1);
  strncpy( socks4_server, _server, sizeof( socks4_server) - 1);
  return( 0);
}

int Bot::setSocks4_Port( const char *_port) {
  if (!_port) return( -1);
  socks4_port = atoi( _port);
  return( 0);
}

int Bot::setSocks4_UserID( const char *_userid) {
  if (!_userid) return( -1);
  strncpy( socks4_userid, _userid, sizeof( socks4_userid) - 1);
  return( 0);
}

char *Bot::getName( void) {
  return( username);
}


char *Bot::getPasswd( void) {
  return( password);
}


char *Bot::getServer( void) {
  return( server);
}


char *Bot::getHomeChannel( void) {
  return( homechannel);
}


char *Bot::getCDKey( void) {
  return( cdkey);
}

char *Bot::getCDKey2( void) {
  return( cdkey2);
}

char *Bot::getRegister( void) {
  return( registered);
}

char *Bot::getCommandSet( void) {
	static char *missing = "Default";

	if (!commandset[0])
		return missing;

	return( commandset);
}

char *Bot::getCurChannel( void) {
  return( curchannel);
}

int Bot::getSpawn( void) {
  return( spawn);
}

int Bot::netclose( void) {
  *disp << "Info:  " << getName() << " has closed connection." << endl;
  //input->update();

  return( Network::netclose());
}

int Bot::enqueue( int lvl, char *str, ...) {
  va_list args; char buf[BUFSIZE];
  
  va_start( args, str);
  #ifdef WIN32
    vsprintf( buf, str, args);
  #else
    vsnprintf( buf, BUFSIZE, str, args);
  #endif
  va_end( args);

  return( queue->enqueue( lvl, "%s", buf));
}

int Bot::setLagSpoof( const char *_txt) {
  if (!_txt) return( -1);
  lag_spoof = atoi( _txt);
  return( 0);
}

CList *Bot::getCList( void) {
  return( clist);
}

u32 Bot::getClientType( void) {
  return( clientType);
}


int Bot::setIdle( int t, char *msg) {
  cmdIdle_d = t;

  if (!t) return( 0);

  #ifdef WIN32
    if (cmdIdle_d < 60) cmdIdle_d = 60;
  #else
    if (cmdIdle_d < 15)  cmdIdle_d = 15;
  #endif

  strncpy( cmdIdle_msg, msg, sizeof( cmdIdle_msg) - 1);

  return( 0);
}

int Bot::setMode( int _mode) {
  cmdMode = _mode;
}

int Bot::getMode( void) {
  return( cmdMode);
}

int Bot::setCommand( Command *_command) {
  command = _command;
  return( 0);
}

int Bot::focus( void) {
  disp->focus();
}

Proxy *Bot::getProxy( void) {
  return( proxy);
}

int Bot::getQuoteStatus( void) {
  return( quoteStatus);
}

void Bot::setQuoteStatus( int _quoteStatus) {
  quoteStatus = _quoteStatus;
}

void Bot::loadQuotes( char *_filename) {
  FILE *fd = fopen( _filename, "r");
  if (!fd) return;

  char buf[ 1024];
  while (!feof( fd)) {
    fgets( buf, sizeof( buf), fd);
    if (!feof( fd)) {
      if (char *t = strchr( buf, '\r')) *t = 0;
      if (char *t = strchr( buf, '\n')) *t = 0;

      // *disp << "Quote: " << buf << endl;
      // //input->update();
      
      sQuotes *tmp = new sQuotes;
      tmp->data = new char[ strlen( buf) + 1];
      strcpy( tmp->data, buf);
      tmp->next = firstQuote;
      firstQuote = tmp;
      numQuotes++;
    }
  }
}

void Bot::checkQuotes( void) {
  if (!quoteStatus) return;
  if (!numQuotes) return;

  if ((time(0) - lastQuote) > quoteStatus) {
    int i = rand() % numQuotes;
    sQuotes *tmp = firstQuote;
    while (i--)
      tmp = tmp->next;
    enqueue( 7, "%s", tmp->data);
    lastQuote = time( 0);
  }
}

int Bot::setClient( const char *_client) {
  if (!_client) return( -1);
  // trim( _client);

  clientType = CLIENT_STAR;

  if (!strcasecmp( _client, "war2")) { clientType = CLIENT_W2BN; return( 0); }
  if (!strcasecmp( _client, "w2bn")) { clientType = CLIENT_W2BN; return( 0); }

  if (!strcasecmp( _client, "star")) { clientType = CLIENT_STAR; return( 0); }
  if (!strcasecmp( _client, "sexp")) { clientType = CLIENT_SEXP; return( 0); }
  if (!strcasecmp( _client, "jstr")) { clientType = CLIENT_JSTR; return( 0); }

  if (!strcasecmp( _client, "d2dv")) { clientType = CLIENT_D2DV; return( 0); }
  if (!strcasecmp( _client, "d2xp")) { clientType = CLIENT_D2XP; return( 0); }

  return( -1);
}

void Bot::delqueue( void) {
  queue->delqueue();
}

int Bot::isActive( void) {
	return active;
}

void Bot::setActive( int active) {
	Bot::active = active;
}

int Bot::handler( void) {
	if (!isActive()) {
		if (getfd() != -1)
			netclose();
		return 0;
	}
	return Network::handler();
}

int Bot::selectWrite( void) {
	if (!active) {
		if (getfd() != -1)
			return 1;
		return 0;
	}
	return Network::selectWrite();
}

void Bot::setPlug( int _plug) {
	plug = _plug;
}

void Bot::lock( void) {
	pthread_mutex_lock( &mutex);
}

void Bot::unlock( void) {
	pthread_mutex_unlock( &mutex);
}


void Bot::getPKey( const char *buf) {
	char *tmp = new char[ strlen( buf) + 1];
	strcpy( tmp, buf);

	lock();
	pkey->push_back( tmp);
	unlock();
}

void Bot::checkPKey( void) {
	char *tmp = NULL;
	lock();
	if (!pkey->empty()) {
		tmp = pkey->front();
		pkey->pop_front();
	}
	unlock();
	if (tmp) {
		char *t2 = gettermn( tmp, 2);
		char *t1 = gettermn( tmp, 1);

		if (t1 && t2) {
			*this << (u32)1
			      << (u32)2 // name + one object
			      << (u32)rand()
			      << t1
			      << t2
			      << "";
			this->sendpkt( 0x26ff);
		}	
		delete tmp;
	}
}

void Bot::getProfile( const char *buf) {
	char *tmp = new char[ strlen( buf) + 1];
	strcpy( tmp, buf);

	lock();
	profile->push_back( tmp);
	unlock();
}

void Bot::checkProfile( void) {
	char *tmp = NULL;
	lock();
	if (!profile->empty()) {
		tmp = profile->front();
		profile->pop_front();
	}
	unlock();
	if (tmp) {
		char *t1 = gettermn( tmp, 1);

		if (t1) {
			u32 rnd = rand();
			std::string name;
			name.assign( t1);
			lock();
			(*profileMap)[rnd] = name;
			unlock();

			*this << (u32)1
			    << (u32)5 // one object and name is included
			    << rnd
			    << t1
			    << "profile\\sex"
			    << "profile\\age"
			    << "profile\\location"
			    << "profile\\description"
			    << "";
			sendpkt( 0x26ff);
		}
		delete tmp;
	}
}

//===
// Calls the given dynamic handler for this bot's command handler, provided it exists.
int Bot::dynHandler( char *handler, Obj *obj_spkr, char *msg) {
	//*disp << "DEBUG: Bot::dynHandler calling handler " << handler << endl;

	if (Command *cmd = commandlist.getCommand( getCommandSet())) {
		Obj *dyncmd = globals->db->getObj("dyncmd")->getObj( getCommandSet() );
		if (!dyncmd) {
			*disp << "Warning: We found a command group, but we did not find commandset object \"" << getCommandSet() << "\"" << endl;
			return -1;
		}
	
		dyncmd = dyncmd->getObj( handler);
		if (!dyncmd)
			return 0;

		cmd->dynHandler( this, dyncmd, obj_spkr, msg, 0);

		return 0;
	} else {
		*disp << "Warning: We could not find the commandset \"" << getCommandSet() << "\"" << endl;
		return -1;
	}
}

void Bot::setObj( Obj *obj) {
	objbot = obj;
}
