#ifndef BOT_H
#define BOT_H

#include "types.h"

#ifdef WIN32
  #include <stdio.h>
#else
  #include <time.h>
  #include <sys/times.h>
#endif
#include <stdlib.h>

#include "db/obj.h"
#include "input.h"
#include "window.h"
#include "network.h"
#include "config.h"
#include "enqueue.h"
#include "mylib.h"
#include "clist.h"
#include "cuser.h"
#include "display.h"
#include "proxy.h"

#include <string>
#include <list>
#include <map>

class CList;
class Window;
class Command;
class Enqueue;
class Proxy;
class Display;
class Input;

void hexdump(int b, char *buffer, FILE *where, int in);

class Bot : public Network {
public:
	Input *input;

  //#if defined(DISP_GTK) || defined(DISP_W32)
  //  Window *disp;
  //#else
    Display *disp;
  //#endif

	int active;

private:
	int dynHandler( char *handler, Obj *obj_spkr, char *msg);

  Proxy *proxy;
  CList *clist;

  int lastlag;
  Command *command;
  // Window *window;
  
  char username[33];
  char password[33];
  char server[128];
  char cdkey[20];
  char cdkey2[20];
  char nick[33];
  char registered[33];
  char commandset[33];
  char curchannel[33];
  char bindaddy[ 128];



  char socks4_server[128];
  u16  socks4_port;
  char socks4_userid[33];

  int  lag_spoof;
	int plug;


  int  spawn, display;

  char homechannel[ 32];

  time_t lastconnect_t;
  u32 session_num, session_key;

  // === === === ===

  time_t lastadd_time, lastidle_time;
  u32 lastadd_num;


  char name[33];

  int filter;
  
  // In order to ask for a profile - we have-to keep track of the time. blah.
  // You do get k-lined for fucking this up. I'm not sure how to determine
  // The very first value yet. Quite irritating. So,
  // you can profile - if we have a "last" profile value.
  // So - in order to profile - you gotta client the bot to start. :(

    u32    profile_lastval;
    time_t profile_lasttime;

  // So we don't flood off - we need to keep track of when we last said something. >;-)
    time_t msg_lasttime;

    clock_t latency;

  // Variables for clients. WC2/SC/etc
    u32    clientType;
  
  // Variables for commands.
    int    cmdIdle_d;
    time_t cmdIdle_t;
    char   cmdIdle_msg[ 256];

    int    cmdMode;

  // Other crapish
    time_t lastping;

protected:
  int pkt_00( int, char *);
  int pkt_04( int, char *);
  int pkt_05( int, char *);
  int pkt_06( int, char *);
  int pkt_07( int, char *);
  int pkt_0a( int, char *);
  int pkt_0b( int, char *);
  int pkt_0c( int, char *);
  int pkt_0f( int, char *);

    int pkt_0f_01( int, char *);
    int pkt_0f_02( int, char *);
    int pkt_0f_03( int, char *);
    int pkt_0f_04( int, char *);
    int pkt_0f_05( int, char *);
    int pkt_0f_06( int, char *);
    int pkt_0f_07( int, char *);
    int pkt_0f_09( int, char *);
    int pkt_0f_0A( int, char *);
    int pkt_0f_12( int, char *);
    int pkt_0f_13( int, char *);
    int pkt_0f_17( int, char *);

  int pkt_13( int, char *);
  int pkt_15( int, char *);
  int pkt_19( int, char *);
  int pkt_1d( int, char *);
  int pkt_25( int, char *);
  int pkt_26( int, char *);
  int pkt_29( int, char *);
  int pkt_2a( int, char *);
  int pkt_2d( int, char *);
  int pkt_30( int, char *);
  int pkt_33( int, char *);
  int pkt_36( int, char *);
  int pkt_3a( int, char *);
  int pkt_50( int, char *);
  int pkt_51( int, char *);
public:
  Enqueue *queue;  

  Bot( void);
  ~Bot( void);

  void clear( void);
  
	//===
	// Network Overrides
		int handler( void);
		int selectWrite( void);

  int pkt_send( int, char *);
  int pkt_handler( int, char *);

  int checkAdds( void);
  int checkOps( void);
  int checkHomeChannel( void);
  int checkIdle( void);

  int setName( const char *_username);
  int setPasswd( const char *_password);
  int setServer( const char *_server);
  int setCDKey( const char *_cdkey);
  int setNick( const char *_nick);
  int setCDKey2( const char *_cdkey);
  int setClient( const char *_client);
  int setHomeChannel( const char *_homechannel);
  int setRegister( const char *_register);
  int setCommandSet( const char *_cmdset);
  int setSpawn( int _spawn);
  int setBind( const char *_bind);
  int setDisplay( const char *_display);
  int setLagSpoof( const char *_txt);
  int setIdle( int, char *);
  int setCommand( Command *_command);

	//===
	// This needs to be in the obj at some point.
		void setPlug( int _plug);

  int setSocks4_Server( const char *_server);
  int setSocks4_Port( const char *_port);
  int setSocks4_UserID( const char *_userid);
  
  char *getName( void);
  char *getPasswd( void);
  char *getServer( void);
  char *getHomeChannel( void);
  char *getCDKey( void);
  char *getCDKey2( void);
  char *getRegister( void);
  char *getCommandSet( void);
  char *getCurChannel( void);
  int  getSpawn( void);
  CList *getCList( void);
  u32  getClientType( void);

  int setMode( int _mode);
  int getMode( void);
  int getDisplay( void);


  // Quotes
    private:
      struct sQuotes {
        struct sQuotes *next;
        char *data;
      } *firstQuote;
      int    numQuotes, quoteStatus;
      time_t lastQuote;
      void   checkQuotes( void);
    public:
      void   loadQuotes( char *_filename);
      int    getQuoteStatus( void);
      void   setQuoteStatus( int _quoteStatus);



void showProfile( const char *txt, const char *msg);
// Smile
  void idle( void);

  int netclose( void);

	int isActive( void);
	void setActive( int active);

  int sendReqProfile( char *name);

  int enqueue( int lvl, char *str, ...);
  void delqueue( void);
  int pkt_connected( void);

  int focus( void);

  Proxy *getProxy( void);

private:
	pthread_mutex_t mutex;
	std::map <u32,std::string> *profileMap;
	std::list<char *> *pkey;
	std::list<char *> *profile;
public:
	//===
	// Cheap method for looking up dynamic keys.
		void getPKey( const char *key);
		void checkPKey( void);

		void getProfile( const char *user);
		void checkProfile( void);

	//===
	// Prevent race conditions.
		void lock( void);
		void unlock( void);

	//===
	// Variables
		void setObj( Obj *);
		Obj *objbot;
};

#endif
