// This file has been modified for psuedo-release... >;-P

#ifdef WIN32
  #include <io.h>
  #include <winsock2.h>
#else
  #include <sys/types.h>
  #include <sys/socket.h>
#endif
#include <time.h>
#include <string.h>
#include <stdlib.h>

#include "tools/build.h"
//#include "display.h"
#include "mylib.h"
//#include "input.h"
#include "cas.h"
#include "botlist.h"
#include "config.h"
#include "vercheck.h"
#include "sendcdkeycheck.h"
#include "globals.h"

//extern Display *disp;
//extern Input *input;
extern BotList botlist;

//#ifdef FAKECAS
//  extern VerCheck *vercheck[3];
//#endif

Cas::Cas( void) {
  last_t = 0;
  port = 6142 + (time(0) % 3);
  ready = 0;
}


Cas::~Cas( void) {
}


int Cas::idle( void) {
  #ifndef FAKECAS
    if (getfd() != -1)
      return( -1);

    if ((time( 0) - last_t) < 2)
      return( -1);

    last_t = time( 0);

    //#ifdef DEBUGCAS
    //  disp->clrline();
    //  *disp << CBYELLOW << "Sys:   " << CBWHITE << "Connecting to CAS server:" << port << CWHITE << endl;
    //  //input->update();
    //#endif

    char buf[ 256];
    *buf = 0;
    // Back in the CAS days, this got rid of a lot of hexers from noticing
    // it had-to connect to a server to handle all the auth. This saved a
    // lot of questions, which get most irritating. >;-) There is no
    // longer a CAS now of course, but most of the code is still here.
    strcat( buf, "?");
    strcat( buf, ".");
    strcat( buf, "??");
    strcat( buf, ".");
    strcat( buf, "??");
    strcat( buf, ".");
    strcat( buf, "?");
    strcat( buf, "?");
  
    if (netopen( buf, port, 0, 0, 0));
    port++;
    if (port > 6146)
      port = 6142;

  #endif
  return( 0);
}

int Cas::pkt_00( int pkt_len, char *pkt_buf) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Received a null packet." << endl;
  //  //input->update();
  //#endif
  return( 0);
}

int Cas::pkt_01( int pkt_len, char *pkt_buf) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Received a init packet." << endl;
  //  disp->hexdump( pkt_len, pkt_buf);
  //  //input->update();
  //#endif
  
  if (pkt_len != 0x0C) {
    //disp->clrline();
    //*disp << "Error: Received an invalid init packet from CAS server." << endl;
    //input->update();
    netclose();
    globals->done++;
  }

  setCrypt( *(u32 *)(pkt_buf + 8), *(u32 *)(pkt_buf + 4));
  ready++;
  
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Set up crypt mode, sending build packet." << endl;
  //  //input->update();
  //#endif

  *this << (u32)1
        << (u32)BUILD;
  sendpkt( 0x01ff);

  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: All done with the init." << endl;
  //  //input->update();
  //#endif

  return( 0);
}

int Cas::pkt_02( int pkt_len, char *pkt_buf) {
  //disp->clrline();
  //*disp << CWHITE  << "[" << CBBLUE << printTime() << CWHITE << "] ";
  //*disp << CBWHITE << "*** " << CBYELLOW << "CAS" << CBWHITE << ": " << CBRED << (pkt_buf + 4) << CWHITE << endl;
  //input->update();
  return( 0);
}

int Cas::pkt_03( int pkt_len, char *pkt_buf) {
  sBotList *tmp = botlist.first;
  while (tmp) {
    if (tmp->data)
      if (tmp->data->getfd() != -1) {
        *this << (u32)tmp->data->getfd()
              << (u32)0 // Todo: Time bot has been online.
              << tmp->data->getName()
              << tmp->data->getServer()
              << tmp->data->getCurChannel();
        sendpkt( 0x03ff);
      }
    tmp = tmp->next;
  }
  return( 0);
}

int Cas::pkt_04( int pkt_len, char *pkt_buf) {
  globals->done++;
  
  return( 0);
}

int Cas::pkt_05( int pkt_len, char *pkt_buf) {
  sBotList *tmp = botlist.first;
  while (tmp) {
    if (tmp->data)
      tmp->data->netclose();
    tmp = tmp->next;
  }

  return( 0);
}

int Cas::pkt_06( int pkt_len, char *pkt_buf) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Received a raw packet send req" << endl;
  //  disp->hexdump( pkt_len - 8, pkt_buf + 8);
  //  //input->update();
  //#endif

  send( *(u32 *)(pkt_buf + 4), pkt_buf + 8, pkt_len - 8, 0);
  
  return( 0);
}

int Cas::pkt_handler( int pkt_len, char *pkt_buf) {
  switch (*(u16 *)(pkt_buf)) {
    case 0x00ff:   return( pkt_00( pkt_len, pkt_buf));  // NULL/Keepalive
    case 0x01ff:   return( pkt_01( pkt_len, pkt_buf));  // Server Seed
    case 0x02ff:   return( pkt_02( pkt_len, pkt_buf));  // Text Message
    case 0x03ff:   return( pkt_03( pkt_len, pkt_buf));  // Who is Online ?
    case 0x04ff:   return( pkt_04( pkt_len, pkt_buf));  // Quit
    case 0x05ff:   return( pkt_05( pkt_len, pkt_buf));  // Disconnect All Bots
    case 0x06ff:   return( pkt_06( pkt_len, pkt_buf));  // Send raw packet

    //#ifdef DEBUGCAS
    //default:     disp->clrline();
    //             *disp << "Debug: Received an unknown packet from the CAS server." << endl;
    //             disp->hexdump( pkt_len, pkt_buf);
    //             //input->update();
    //#endif
  }
  return( 0);
}

int Cas::SendCheckRevWar2( Bot *bot, char *authequ, char *mpq) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Sending a warcraft revision check." << endl;
  //  //input->update();
  //#endif

  #ifndef FAKECAS
    *this << (u32)bot->getfd()
          << authequ
          << mpq;
    sendpkt( 0x07ff);
  return( 0);
  #else
    u32 revisionhash = 0;
//    if (vercheck[0]->checkrev( authequ, mpq, &revisionhash)) {
//      //disp->clrline();
//      //*disp << "Info: Client revision check failed. Exiting." << endl;
//      globals->done++;
//      //input->update();
//      return( 0);
//    }

    char *war2 = "Warcraft II BNE.exe 05/15/01 20:53:20 712704";
    int len = 4 + 4 + 4 * 4 + strlen( war2) + 1;

    *bot << (u32)0x49583836 << (u32)0x5732424e << (u32)0x4f // ..E.68XINB2WO...
         << (u32)0x02000200
         << revisionhash << war2;
    bot->sendpkt( 0x07ff);

    return( 0);
  #endif
}

int Cas::SendCheckRevStar( Bot *bot, char *authequ, char *mpq) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Sending a starcraft revision check." << endl;
  //  //input->update();
  //#endif

  #ifndef FAKECAS
    *this << (u32)bot->getfd()
          << authequ
          << mpq;
    sendpkt( 0x09ff);
    return( 0);
  #else
    u32 revisionhash = 0;
    if (vercheck[1]->checkrev( authequ, mpq, &revisionhash)) {
      //disp->clrline();
      //*disp << "Info: Client revision check failed. Exiting." << endl;
      globals->done++;
      //input->update();
      return( 0);
    }

    char *war2 = "starcraft.exe 05/19/01 02:28:24 1082880";
    int len = 4 + 4 + 4 * 4 + strlen( war2) + 1;

    // starcraftj.exe 11\/04\/01 19:46:34 1323008 
    *bot << (u32)0x49583836 << (u32)0x53544152 << (u32)0xc3
         << (u32)0x0100080B
         << revisionhash << war2;
    bot->sendpkt( 0x07ff);

    return( 0);
  #endif
}

int Cas::SendCheckRevSCJap( Bot *bot, char *authequ, char *mpq) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Sending a SCJap revision check." << endl;
  //  //input->update();
  //#endif

  #ifndef FAKECAS
    I HAVE NOT DONE THIS PART YET!!!

    *this << (u32)bot->getfd()
          << authequ
          << mpq;
    sendpkt( 0x09ff);
    return( 0);
  #else
    u32 revisionhash = 0;
    if (vercheck[2]->checkrev( authequ, mpq, &revisionhash)) {
      //disp->clrline();
      //*disp << "Info: Client revision check failed. Exiting." << endl;
      globals->done++;
      //input->update();
      return( 0);
    }

    char *war2 = "starcraftj.exe 09/23/01 22:07:56 1323008";
    int len = 4 + 4 + 4 * 4 + strlen( war2) + 1;

    *bot << (u32)0x49583836 << (u32)0x4a535452 << (u32)0xa9
         << (u32)0x01000000
         << revisionhash << war2;
    bot->sendpkt( 0x07ff);

    return( 0);
  #endif
}

int Cas::SendCDKeyWar2( Bot *bot, char *cdkey, u32 session_key, char *reg, u32 rnd, u32 spawn) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Sending a warcraft cdkey." << endl;
  //  //input->update();
  //#endif

  #ifndef FAKECAS
    *this << (u32)bot->getfd()
          << session_key
          << rnd
          << spawn
          << cdkey
          << reg;
    sendpkt( 0x08ff);
    return( 0);
  #else
    char *tmp = SendCDKeyCheck( cdkey, session_key, reg, rnd, spawn);
    bot->rawsend( 48 + strlen( reg) + 1, tmp);
    return( 0);
  #endif
}

int Cas::SendCDKeyStar( Bot *bot, char *cdkey, u32 session_key, char *reg, u32 rnd, u32 spawn) {
  //#ifdef DEBUGCAS
  //  disp->clrline();
  //  *disp << "DEBUGCAS: Sending a starcraft cdkey." << endl;
  //  //input->update();
  //#endif

  #ifndef FAKECAS
    *this << (u32)bot->getfd()
          << session_key
          << rnd
          << spawn
          << cdkey
          << reg;
    sendpkt( 0x0Aff);
    return( 0);
  #else
    char *tmp = SendCDKeyCheck( cdkey, session_key, reg, rnd, spawn);
    bot->rawsend( 48 + strlen( reg) + 1, tmp);
    return( 0);
  #endif
}

int Cas::netclose( void) {
  #ifndef FAKECAS
    ready = 0;

    return( Network::netclose());
  #endif
}

int Cas::isReady( void) {
  #ifdef FAKECAS
    return( 1);
  #else
    if (getfd() == -1)
      return( 0);
    return( ready);
  #endif
}
