#include <string.h>
//#include "display.h"
#include "config.h"
#include "input.h"
#include "mylib.h"
#include "clist.h"

//extern Display *disp;
//extern Input *input;

CList::CList( Bot *_parent) {
  first = 0;
  parent = _parent;
  bzero( channame, sizeof( channame));
}

CList::~CList( void) {
  clear();
}


void CList::clear( void) {
  while (first) {
    sCList *tmp = first->next;

    delete first->data;
    delete first;

    first = tmp;
  }
}


int CList::addUser( CUser *_user) {
  sCList *tmp = new sCList;

  tmp->next = first;
  tmp->data = _user;

  first = tmp;

  return( 0);
}

int CList::delUser( char *_username) {
  sCList *tmp = first;

  if (!tmp) return( -1);  
  if (!strcasecmp( tmp->data->getName(), _username)) {
    first = tmp->next;
    delete tmp->data;
    delete tmp;
    return( 0);
  }
  
  while (tmp) {
    if (tmp->next)
      if (!strcasecmp( tmp->next->data->getName(), _username)) {
        sCList *tmp2 = tmp->next;
        tmp->next = tmp2->next;

        delete tmp2->data;
        delete tmp2;

        return( 0);
      }
    tmp = tmp->next;
  }

  return( -1);
}


int CList::delUser( CUser *_user) {
  sCList *tmp = first;

  if (!first)
    return( -1);

  if (first->data == _user) {
    first = first->next;
    delete tmp->data;
    delete tmp;
    return( 0);
  }

  while (tmp) {
    if (tmp->next)
      if (tmp->next->data == _user) {
        sCList *tmp2 = tmp->next;
        tmp->next = tmp2->next;

        delete tmp2->data;
        delete tmp2;

        return( 0);
      }
    tmp = tmp->next;
  }
  return( -1);
}


CUser *CList::getFirst( void) {
  if (first)
    return( first->data);
  return( 0);
}


CUser *CList::getUser( char *_username) {
  sCList *tmp = first;

  while (tmp) {
    if (!strcasecmp( tmp->data->getName(), _username))
      return( tmp->data);

    tmp = tmp->next;
  }
  return( 0);
}


int CList::getSize( void) {
  sCList *tmp = first;
  int size = 0;

  while (tmp) {
    size++;
    tmp = tmp->next;
  }

  return( size);
}


int CList::setChannel( char *_channel) {
  if (!_channel) return( -1);
  strncpy( channame, _channel, sizeof( channame) - 1);
  return( 0);
}

int CList::showUsers( Display *disp) {
	sCList *tmp = first;

	*disp << CBWHITE << "Channel List " << CBCYAN << "[" << CBGREEN << channame << CBCYAN << "]" << CWHITE << endl;
	while (tmp) {

    *disp << "   " << CBPURPLE << tmp->data->getName();
    for (int i = strlen( tmp->data->getName()); i < 20; i++)
      *disp << " ";

    *disp << CBWHITE << "[" << CBCYAN  << tmp->data->getLatency() << CBGREEN << "ms" << CBWHITE << "]  "
         << CBWHITE << "[" << CBGREEN << tmp->data->getProduct() << CBWHITE << "]  "
         << CBWHITE << "[" << CBGREEN << tmp->data->getFlags() << CBWHITE << "]"
         << CWHITE << endl;

    tmp = tmp->next;
  }

  return( 0);
}

