#include "config.h"

#ifdef WIN32
  #include <windows.h>  
#endif

#include <string>
#include <stdarg.h>
#include <stdlib.h>
#include "tools/build.h"
#include "display.h"
#include "command.h"
//#include "input.h"
#include "mylib.h"
#include "ctype.h"
#include "bot.h"
//#include "vars.h"
#include "botlist.h"

#include "globals.h"

extern BotList botlist;
extern Display *disp;
//extern Input *input;
//extern Vars vars;

int parseMsg( char *buf, Obj *obj_spkr, char *variable, char *text, int clienttype);

//===
// Todo: Remember to disable this :)
void log( char *str, ...) {
	va_list args; char buf[BUFSIZE];
  
	va_start( args, str);
	#ifdef WIN32
		vsprintf( buf, str, args);
	#else
		vsnprintf( buf, BUFSIZE, str, args);
	#endif
	va_end( args);
	buf[ sizeof( buf) - 1] = '\0';
	
	fprintf( stderr, "%s", buf);
}

Command::Command( void) {
  bzero( name, sizeof( name));
  bzero( database, sizeof( database));

  userlist = new UserList;
  tagban = new TagBan;
  //dyncmd = new DynCmd;
}

Command::~Command( void) {
  if (userlist) delete userlist;
  if (tagban)   delete tagban;
  //if (dyncmd)   delete dyncmd;
}

//=== MFT
//int Command::setTagBans( char *_file) {
//  FILE *fd = fopen( _file, "r");
//  if (!fd) {
//    *disp << "Error: Unable to open the file \"" << _file << "\" for tagban list." << endl;
//    return -1;
//  }
//
//  char buf[ 1024];
//  while (!feof( fd)) {
//    fgets( buf, sizeof( buf), fd);
//    if (feof(fd)) break;
//    trim( buf);
//    if (strlen( buf))
//      tagban->tagAdd( buf);
//  }
//
//  fclose( fd);
//  return 0;
//}

int Command::handleCommand( Bot *bot, char *username, char *msg, int priv) {
	if (!username || !msg) return( -1);

	//===
	// Get initial variables. If there is no user object, then create it.
		Obj *userdb = globals->userdb->getObj("userdb");
		if (!userdb) {
			userdb = new Obj("userdb");
			globals->userdb->append( userdb);	
		}
		Obj *vars = globals->db->getObj("vars");
		Obj *obj_spkr = userdb->getObj( username);

		if (!obj_spkr) {
			obj_spkr = new Obj( username);
			userdb->append( obj_spkr);
		}
  
	//=== Todo: Make this appear in the config file!
	//#ifdef DEBUGDSBOT
	//  if (strstr( msg, "thinks") && strstr( msg, "is annoying - don't you?")) {
	//    //char buf[ 1024];
	//    //sprintf( buf, "/kick %s Auto-kick. Please turn off that idle.", _username);
	//    bot->enqueue( 4, "/kick %s Auto-kick. Please turn off that idle.", _username);
	//    return( 0);
	//  }
	//#endif

// FIXME: Perhaps we should add this in to the dynamic commands.
//===
// Is the user yelling in the channel?
//		if (char *tmp = vars->getVar("kick_on_yell\0___")) {
//			if (atoi( tmp)) {
//				if (strlen( msg) > 10) {
//					int up = 0;
//					char *tmp = msg;
//					while (*tmp) {
//						if ((*tmp >= 'A') && (*tmp <= 'Z'))
//							up++;
//						tmp++;
//					}
//					if (((up * 100) / strlen(msg)) > 70) {
//						char *tmp = vars->getVar("kick_on_yell_msg");
//						if (!tmp)
//							tmp = "/kick %u Auto-kick. No yelling in the channel plz.\0__________________________________________________________________________________________________________________________________________________________________________________________________________";
//						char buf[256];
//						
//						if (parseMsg( buf, obj_spkr, tmp, msg, bot->getClientType()))
//							bot->enqueue( 4, "%s", buf);
//
//						return 0;
//					}
//				}
//      	}
//		}

	//===
	// MFT
	// User *user = userlist->getUser( _username);

	//===
	// MFT
	// Make sure bot_master has full access.
	// if (char *tmp = vars.getVar( "bot_master"))
	// if (!strcasecmp( _username, tmp)) {
	//   if (!user) {
	//     user = new User( userlist);
	//     user->setName( tmp);
	//    userlist->add( user);
	//   }
	//   user->setAccess( 255);
	// }

	//===
	// Ok, is this a command?
		char buf[ 256];
		strncpy( buf, msg, sizeof( buf) - 1);
		buf[ sizeof( buf) - 1] = '\0';

		char *tmp = gettermn( buf, 1);
		if (!tmp)
			return( 0);

		char *trigger = vars->getVar("bot_trigger");
		if (!trigger)
			trigger = "!\0______________";

		if (strncasecmp( buf, trigger, strlen( trigger)))
			return( 0);

		tmp += strlen( trigger);

	//===
	// Check the commands
   // char buf[ 1024];
   // strcpy( buf, msg);
   // char *tmp = gettermn( buf, 1);
   // if (!tmp) return( -1);
   //
   // char *trigger = vars.getVar("bot_trigger");
   // if (trigger && *trigger)
   //   if (strncmp( tmp, trigger, strlen( trigger))) {
   //     char buf[ 1024];
   //     strcpy( buf, msg);
   //     char *term2 = gettermn( buf, 2);
   //     char *term1 = gettermn( buf, 1);
   //     if (term2)
   //       dyncmd->handle( bot, _username, term1, msg + (term2 - buf));
   //     else
   //       dyncmd->handle( bot, _username, term1, 0);
   //     return( 0);
   //   }
	//
   // if (trigger)
   //   tmp += strlen( trigger);

//=== Todo
//    // Dual Level Commands
//    if (!strcmp( tmp, "cmd\0           ")) return( cmdCmd( bot, user, msg, priv));
//    if (!strcmp( tmp, "quote\0         ")) return( cmdQuote( bot, user, msg, priv));
//
//    // Single Level Commands
//    if (!strcmp( tmp, "add\0           ")) return( cmdAddUser( bot, user, msg, priv));
//    if (!strcmp( tmp, "adduser\0       ")) return( cmdAddUser( bot, user, msg, priv));
//    if (!strcmp( tmp, "del\0           ")) return( cmdDelUser( bot, user, msg, priv));
//    if (!strcmp( tmp, "delqueue\0      ")) return( cmdShutup( bot, user, msg, priv));
//    if (!strcmp( tmp, "deluser\0       ")) return( cmdDelUser( bot, user, msg, priv));
//    if (!strcmp( tmp, "designate\0     ")) return( cmdDesignate( bot, user, msg, priv));
//    if (!strcmp( tmp, "giveops\0       ")) return( cmdGiveOps( bot, user, msg, priv));
//    // if (!strcmp( tmp, "hide\0          ")) return( cmdHide( bot, user, msg, priv));
//    if (!strcmp( tmp, "idle\0          ")) return( cmdSetIdle( bot, user, msg, priv));
//    if (!strcmp( tmp, "join\0          ")) return( cmdJoin( bot, user, msg, priv));
//    if (!strcmp( tmp, "joinhome\0      ")) return( cmdJoinHome( bot, user, msg, priv));
//    if (!strcmp( tmp, "kill\0          ")) return( cmdDelUser( bot, user, msg, priv));
//    if (!strcmp( tmp, "killuser\0      ")) return( cmdDelUser( bot, user, msg, priv));
//    if (!strcmp( tmp, "mode\0          ")) return( cmdMode( bot, user, msg, priv));
//    if (!strcmp( tmp, "os\0            ")) return( cmdOS( bot, user, msg, priv));
//    if (!strcmp( tmp, "osinfo\0        ")) return( cmdOS( bot, user, msg, priv));
//    if (!strcmp( tmp, "pban\0          ")) return( cmdShitAdd( bot, user, msg, priv));
//    if (!strcmp( tmp, "profile\0       ")) return( cmdProfile( bot, user, msg, priv));
//    if (!strcmp( tmp, "protect\0       ")) return( cmdProtect( bot, user, msg, priv));
//    if (!strcmp( tmp, "rejoin\0        ")) return( cmdRejoin( bot, user, msg, priv));
//    if (!strcmp( tmp, "safeadd\0       ")) return( cmdSafeAdd( bot, user, msg, priv));
//    if (!strcmp( tmp, "safedel\0       ")) return( cmdSafeDel( bot, user, msg, priv));
//    if (!strcmp( tmp, "shitadd\0       ")) return( cmdShitAdd( bot, user, msg, priv));
//    if (!strcmp( tmp, "shitdel\0       ")) return( cmdShitDel( bot, user, msg, priv));
//    if (!strcmp( tmp, "setidle\0       ")) return( cmdSetIdle( bot, user, msg, priv));
//    if (!strcmp( tmp, "shitlist\0      ")) return( cmdShitList( bot, user, msg, priv));
//    // if (!strcmp( tmp, "show\0          ")) return( cmdShow( bot, user, msg, priv));
//    if (!strcmp( tmp, "sethome\0       ")) return( cmdSetHome( bot, user, msg, priv));
//    if (!strcmp( tmp, "setserver\0     ")) return( cmdSetServer( bot, user, msg, priv));
//    if (!strcmp( tmp, "settrigger\0    ")) return( cmdSetTrigger( bot, user, msg, priv));
//    if (!strcmp( tmp, "server\0        ")) return( cmdServer( bot, user, msg, priv));
//    if (!strcmp( tmp, "setidle\0       ")) return( cmdSetIdle( bot, user, msg, priv));
//    if (!strcmp( tmp, "shutup\0        ")) return( cmdShutup( bot, user, msg, priv));
//    if (!strcmp( tmp, "stats\0         ")) return( cmdStats( bot, user, msg, priv));
//    if (!strcmp( tmp, "status\0        ")) return( cmdStats( bot, user, msg, priv));
//    if (!strcmp( tmp, "tagadd\0        ")) return( cmdTagAdd( bot, user, msg, priv));
//    if (!strcmp( tmp, "tagban\0        ")) return( cmdTagAdd( bot, user, msg, priv));
//    if (!strcmp( tmp, "tagbans\0       ")) return( cmdTagBans( bot, user, msg, priv));
//    if (!strcmp( tmp, "tagdel\0        ")) return( cmdTagDel( bot, user, msg, priv));
//    if (!strcmp( tmp, "tagkill\0       ")) return( cmdTagDel( bot, user, msg, priv));
//    if (!strcmp( tmp, "taglist\0       ")) return( cmdTagBans( bot, user, msg, priv));
//    if (!strcmp( tmp, "tagshow\0       ")) return( cmdTagBans( bot, user, msg, priv));
//    if (!strcmp( tmp, "trigger\0       ")) return( cmdSetTrigger( bot, user, msg, priv));
//    if (!strcmp( tmp, "unignore\0      ")) return( cmdUnIgnore( bot, user, msg, priv));
//    if (!strcmp( tmp, "unprotect\0     ")) return( cmdUnProtect( bot, user, msg, priv));
//    if (!strcmp( tmp, "unsquelch\0     ")) return( cmdUnIgnore( bot, user, msg, priv));
//    if (!strcmp( tmp, "uptime\0        ")) return( cmdUpTime( bot, user, msg, priv));

	//===
	// Handle the dynamic commands.
		if (!strchr( tmp, '_')) {
			Obj *dynset = globals->db->getObj("dyncmd")->getObj( bot->getCommandSet());
			if (dynset) {
				//*(bot->disp) << "DEBUG: Command dynset found our set" << endl;
				Obj *dyncmd = dynset->getObj( tmp);
				if (dyncmd) {
					// *(bot->disp) << "Info: Calling dynamic handler for " << tmp << endl;
					dynHandler( bot, dyncmd, obj_spkr, msg, 0);
					return 0;
				}
			} else {
				*(bot->disp) << "Error: Command was unable to locate the command set." << endl;
			}
		}

	//===
	// Handle the commands.
		if (!strcmp( tmp, "chattr\0        ")) return( cmdSetFlags(  bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "find\0          ")) return( cmdInfo(      bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "flags\0         ")) return( cmdInfo(      bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "info\0          ")) return( cmdInfo(      bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "resign\0        ")) return( cmdResign(    bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "setflags\0      ")) return( cmdSetFlags(  bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "setglobal\0     ")) return( cmdSetGlobal( bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "setvar\0        ")) return( cmdSetVar(    bot, obj_spkr, msg, priv));
		if (!strcmp( tmp, "whois\0         ")) return( cmdInfo(      bot, obj_spkr, msg, priv));

	return(0);
}

int Command::setName( char *_name) {
  if (!_name) return( -1);
  strncpy( name, _name, sizeof( name) - 1);
  return( 0);
}

int Command::setDatabase( char *_database) {
  if (!_database) return( -1);
  strncpy( database, _database, sizeof( database) - 1);

  if (userlist) delete userlist;
  userlist = new UserList;
  userlist->setDatabase( database);
  
  return( 0);
}

char *Command::getName( void) {
  return( name);
}

int Command::addHandler( Bot *bot) {
  bot->setCommand( this);
  return( Enqueue::addHandler( bot));
}

// *** COMMENTS HERE DESTROYED >;-P
// *** shh :)

int Command::cmdAddUser( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 50) return( 0);

  char *tmp2 = gettermn( msg, 3);
  char *tmp = gettermn( msg, 2);

  if (!tmp) return( 0);
  if (!tmp2) return( 0);

  User *_user = userlist->getUser( tmp);
  if (!_user) {
    _user = new User( userlist);
    _user->setName( tmp);
    userlist->add( _user);
  }

  char buf[ 1024];

  if (user->getAccess() < _user->getAccess()) {
    //sprintf( buf, "User %s has higher access", _user->getName());
    bot->enqueue( 4, "User %s has higher access", _user->getName());
    return( 0);
  }
      
  if (atoi( tmp2) >= user->getAccess()) {
    bot->enqueue( 4, "You do not have access to do that");
    return( 0);
  }

  _user->setAccess( atoi(tmp2));
  if (priv)
    sprintf( buf, "/msg %s User %s is set to %d.", user->getName(), _user->getName(), _user->getAccess());
  else
    sprintf( buf, "User %s is set to %d.", _user->getName(), _user->getAccess());
  bot->enqueue( 6, "%s", buf);
  
  return( 0);
}

int Command::cmdChattr( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdDelUser( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdDesignate( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 90) return( 0);

  char *term2 = gettermn( msg, 2);
  if (!term2) return( 0);

  char buf[ 1024];
  sprintf( buf, "/designate %s", term2);
  bot->enqueue( 2, "/designate %s", term2);

  return( 0);
}

int Command::cmdGiveOps( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdHide( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 100) return( 0);

  bot->setDisplay( "0");
}

int Command::cmdIdle( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdInfo( Bot *bot, Obj *obj_spkr, char *msg, int priv) {
	//===
	// Do they have access?
		char *flags = obj_spkr->getVar("flags");
		if (!flags || !strchr( flags, 'V'))
			return 0;

	//===
	// Load the user account.
		char *user = gettermn( msg, 2);
		if (!user) return( 0);
		Obj *obj_user = globals->userdb->getObj("userdb")->getObj( user);

	//===
	// 2) Do they exist?
		if (!obj_user) {
			// Todo: if (parseMsg( buf, obj_spkr, "/msg %u User
			enqueue( 6, "/msg %s User %s was not found.", obj_spkr->getName(), user);
			return 0;
		}

	//===
	// 3) Show the user all sorts of information.
		char *flags2 = obj_user->getVar("flags");
		if (!flags2) {
			// Todo: if (parseMsg( buf, obj_spkr, "/msg %u User
			enqueue( 6, "/msg %s User %s has no flags.", obj_spkr->getName(), user);
			return 0;
		}

		if (priv)
			enqueue( 5, "/msg %s Flags: %s", obj_spkr->getName(), flags2);
		else
			bot->enqueue( 5, "Flags: %s", flags2);

  return( 0);
}

int Command::cmdJoin( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 90) return( 0);

  char buf[ 1024];
  strcpy( buf, msg);
  char *tmp = gettermn( buf, 2);
  if (!tmp) return( 0);

  bot->setHomeChannel( msg + (tmp - buf));

  return( 0);
}

int Command::cmdJoinHome( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdMode( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 30) return( 0);

  char buf[ 1024];
  char *tmp = gettermn( msg, 2);

  if (!tmp) {
    switch( bot->getMode()) {
      case 0: sprintf( buf, "Mode is normal"); break;
      case 1: sprintf( buf, "Mode is lockdown"); break;
      default: sprintf( buf, "Mode is unknown"); break;
    }
    bot->enqueue( 4, buf);
    return( 0);
  }

  if (user->getAccess() < 80) return( 0);

  if (!strcmp( tmp, "lockdown")) {
    //sprintf( buf, "Mode changed to lockdown.");
    bot->enqueue( 4, "Mode changed to lockdown.");
    bot->setMode( 1);
          
    struct sCList *tmp = bot->getCList()->first;
    while (tmp) {
      user = userlist->getUser( tmp->data->getName());
      if (!user) {
        //sprintf( buf, "/ban %s (CHANNEL LOCKDOWN)", tmp->data);
        bot->enqueue( 4, "/ban %s (CHANNEL LOCKDOWN)", tmp->data);
      } else {
        if (user->getAccess() < 20) {
          //sprintf( buf, "/ban %s (CHANNEL LOCKDOWN)", tmp->data);
          bot->enqueue( 4, "/ban %s (CHANNEL LOCKDOWN)", tmp->data);
        }
      }
      tmp = tmp->next;
    }
    return( 0);
  }

  if (!strcmp( tmp, "normal")) {
    //sprintf( buf, "Mode changed to normal.");
    bot->enqueue( 4, "Mode changed to normal.");
    bot->setMode( 0);
    return( 0);
  }
    
  return( 0);
}

int Command::cmdOS( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 30) return 0;

  #ifdef WIN32
    char os[32];

    OSVERSIONINFO VerInfo;
    VerInfo.dwOSVersionInfoSize = sizeof( OSVERSIONINFO);
    GetVersionEx(&VerInfo);
    
    if (VerInfo.dwPlatformId == 2) { // VER_PLATFORM_WIN32_NT) {
      if (VerInfo.dwMajorVersion>=5) {
        if (VerInfo.dwBuildNumber<=2195)
          strcpy( os, "Win2k");
        else
          strcpy( os, "WinXP");
      } else
        strcpy( os, "WinNT");
    } else
      if (VerInfo.dwPlatformId == 1) { // VER_PLATFORM_W32_WINDOWS) {
        if (VerInfo.dwMinorVersion<10)
          strcpy( os, "Win95");
        else
          if (VerInfo.dwMinorVersion<90) {
            if ((VerInfo.dwBuildNumber&0xffff) < 2222)
              strcpy( os, "Win98");
            else
              strcpy( os, "Win98r2");
          } else
            strcpy( os, "WinME");
      } else {
        if (VerInfo.dwPlatformId == 1)
          strcpy( os, "Win32");
        else
          strcpy( os, "Unknown");
      }

    char buf[ 1024];
    sprintf( buf, "OS: %s (build %d)", os, VerInfo.dwBuildNumber & 0xFFFF);
    enqueue( 5, "%s", buf);

  #endif

  return( 0);
}

int Command::cmdProtect( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdProfile( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 40) return( 0);

//  << (u32)1
//  << (u32)4
//  << "profile\sex",
//  << "profile\age",
//  << "profile\location",
//  "profile\description",
//  ""
//
//  bot->enqueue( 5, "And now for something completly different");

  return( 0);
}

int Command::cmdQuote( Bot *bot, User *user, char *msg, int priv) {
  char buf[ 1024];

  if (!user) return( 0);
  if (user->getAccess() < 80) return( 0);

  strcpy( buf, msg);
  char *term2 = gettermn( buf, 2);
  if (!term2) {
    int i = bot->getQuoteStatus();
    if (!i)
      bot->enqueue( 4, "Quotes are off");
    else {
      //char buf[ 1024];
      //sprintf( buf, "Quotes are at %d seconds.", i);
      bot->enqueue( 4, "Quotes are at %d seconds.", i);
    }
    return( 0);
  }

  if (!strcasecmp( term2, "on")) {
    bot->setQuoteStatus( 300);
    bot->enqueue( 4, "Quotes now on");
    return( 0);
  }

  if (!strcasecmp( term2, "off")) {
    bot->setQuoteStatus( 0);
    bot->enqueue( 4, "Quotes now off");
    return( 0);
  }

  int i = atoi( term2);
  if (i >= 5) {
    //char buf[ 1024];
    //sprintf( buf, "Quotes set to %d seconds.", i);
    bot->setQuoteStatus( i);
    bot->enqueue( 4, "Quotes set to %d seconds.", i);
    return( 0);
  }

  bot->enqueue( 4, "Unknown quote cmd");
  return( 0);
}

// This is intentionally not coded for an instant rejoin. Take a look at
// the actual code for instant rejoining. This happens in the idle
// state. There is no reason for an "instant" rejoin here, after all
// anyone with !rejoin access should be trusted.
int Command::cmdRejoin( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 90) return( 0);

  char buf[ 1024];

  char *tmp = gettermn( msg, 2);
  int n = 1;
  if (tmp)
    n = atoi( tmp);
  if (n < 1) n = 1;
  if (n > 255) n = 255;

  strcpy( buf, bot->getCurChannel());
  for (int i = 0; i < n; i++) {
    bot->enqueue( 5, "/join The Void");
    bot->enqueue( 5, "/join %s", buf);
  }
  return( 0);
}

int Command::cmdResign( Bot *bot, Obj *obj_spkr, char *msg, int priv) {
	char *flags = obj_spkr->getVar("flags");
	if (!flags || !strchr( flags, 'O'))
		return 0;

	bot->enqueue( 2, "/resign");

	return( 0);
}

int Command::cmdSetFlags( Bot *bot, Obj *obj_spkr, char *msg, int priv) {
	if (!obj_spkr) return 0;
	
	char *spkr_flags = obj_spkr->getVar("flags");
	if (!spkr_flags || !strchr( spkr_flags, 'O')) return 0;

	char *flags = gettermn( msg, 3);
	char *user = gettermn( msg, 2);
		
	if (!flags || !user)
		return 0;

	//===   
	// 1) Get the user. If the user doesn't exist. Create it.  
		Obj *db = globals->userdb->getObj("userdb");
		Obj *obj_user = db->getObj( user);
		if (!obj_user) {
			obj_user = new Obj( user);
			db->append( obj_user);
		}

	//===
	// 2) Get the flags.
		char *userflags = obj_user->getVar("flags");
		char buf[ 256];
		bzero( buf, sizeof( buf));
		if (userflags)
			strncpy( buf, userflags, sizeof( buf) - 1);
		
	//===
	// 3) Parse the new flags.
		int add = 1;
		while (*flags) {
			if (*flags == '-') add = 0;
			if (*flags == '+') add = 1;
			
			char ch = toupper(*flags);
			if ( (ch >= 'A') && (ch <= 'Z') ) {
				if (!add) {
					char *tmp = strchr( buf, ch);
					if (tmp)
						memmove( tmp, tmp + 1, strlen( tmp + 1) + 1);
				} else {
					char *tmp = strchr( buf, ch);
					if (!tmp) {
						char tmp[2];
						tmp[0] = ch;
						tmp[1] = 0;
						strcat( buf, tmp);
					}
				}
			}
			
			flags++;
		}

	//===
	// 4) Save the changes
		obj_user->setVar("flags", buf);

	return( 0);
}

int Command::cmdSetGlobal( Bot *bot, Obj *obj_spkr, char *msg, int priv) {
	if (!obj_spkr) return 0;
	
	char *spkr_flags = obj_spkr->getVar("flags");
	if (!spkr_flags || !strchr( spkr_flags, 'O')) return 0;

	char *value   = gettermnz( msg, 3);
	char *varname = gettermn( msg, 2);
		
	if (!varname || !value)
		return 0;

	globals->db->getObj("vars")->setVar( varname, value);

	return( 0);
}

int Command::cmdSetVar( Bot *bot, Obj *obj_spkr, char *msg, int priv) {
	if (!obj_spkr) return 0;
	
	char *spkr_flags = obj_spkr->getVar("flags");
	if (!spkr_flags || !strchr( spkr_flags, 'O')) return 0;

	char *value    = gettermnz( msg, 4);
	char *varname  = gettermn( msg, 3);
	char *username = gettermn( msg, 2);
		
	if (!username)
		return 0;

	Obj *obj_user = globals->userdb->getObj("userdb")->getObj( username);
	if (!obj_user)
		return 0;

	obj_user->setVar( varname, value);

	return( 0);
}

int Command::cmdSetHome( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdSetIdle( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 70) return( 0);
  
  char buf[ 1024];
  strcpy( buf, msg);
  
  char *b = gettermn( buf, 3);
  char *a = gettermn( msg, 2);
  
  if (!b || !a) {
    if (priv) {
      sprintf( buf, "/msg %s Need a time and a message.", user->getName());
      enqueue( 5, "%s", buf);
    } else
      bot->enqueue( 5, "Need a time and a message.");
    return( 0);
  }

  bot->setIdle( atoi( a), msg + (b - buf));
  if (priv) {
    sprintf( buf, "/msg %s Idle changed.", user->getName());
    enqueue( 5, "%s", buf);
  } else
    bot->enqueue( 5, "Idle changed.");
  
  return( 0);
}

int Command::cmdSetServer( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 90) return( 0);
  
  char *tmp = gettermn( msg, 2);
  if (!tmp) return( 0);
  
  bot->setServer( tmp);

  return( 0);
}

//int Command::cmdSetTrigger( Bot *bot, User *user, char *msg, int priv) {
//  if (!user) return( 0);
//  if (user->getAccess() < 90) return( 0);
//
//  char *tmp = gettermn( msg, 2);
//  if (!tmp) return( 0);
//
//  //vars.setVar( "bot_trigger", tmp);
//
//  char buf[ 1024];
//  if (priv) {
//    sprintf( buf, "/msg %s Trigger changed to %s", user->getName(), tmp);
//    enqueue( 4, "%s", buf);
//  } else {
//    //sprintf( buf, "Trigger changed to %s", tmp);
//    bot->enqueue( 4, "Trigger changed to %s", tmp);
//  }
//
//  return( 0);
//}

int Command::cmdServer( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 50) return( 0);
  
  char buf[ 1024];
  if (priv) {
    sprintf( buf, "/msg %s Server: %s", user->getName(), bot->getServer());
    enqueue( 5, "%s", buf);
  } else {
    //sprintf( buf, "Server: %s", bot->getServer());
    bot->enqueue( 5, "Server: %s", bot->getServer());
  }
    
  return( 0);
}

int Command::cmdShitAdd( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 70) return( 0);
  
  char buf[ 1024];
  strcpy( buf, msg);
  
  char *term3 = gettermn( buf, 3);
  char *term2 = gettermn( msg, 2);
  
  if (!term2) {
    if (priv) {
      sprintf( buf, "/msg %s We need a user to shitlist", user->getName());
      enqueue( 4, "%s", buf);
    } else
      bot->enqueue( 4, "We need a user to shitlist");
    return( 0);
  }
  
  User *_user = userlist->getUser( term2);
  if (!_user) {
    _user = new User( userlist);
    _user->setName( term2);
    userlist->add( _user);
  }
  
  _user->setFlags( _user->getFlags() | 1);
  
  if (term3)
    _user->setBanMessage( msg + (term3 - buf));
        
  //sprintf( buf, "/ban %s %s", _user->getName(), _user->getBanMessage());
  bot->enqueue( 1, "/ban %s %s", _user->getName(), _user->getBanMessage());

  if (priv) {
    sprintf( buf, "/msg %s pban added for %s", user->getName(), _user->getName());
    enqueue( 4, "%s", buf);
  } else {
    //sprintf( buf, "pban added for %s", _user->getName());
    bot->enqueue( 4, "pban added for %s", _user->getName());
  }

  return( 0);
}

int Command::cmdStats( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 30) return( 0);

  int t = time(0) - bot->getCTime();
  int days = t / (3600*24); t -= days * 3600 * 24;
  int hours = t / (3600);   t -= hours * 3600;
  int mins = t / 60;        t -= mins * 60;
  int secs = t;

  char buf[ 1024];
  if (priv) {
    sprintf( buf, "/msg %s Online: %dd %.2d:%.2d:%.2d  Recv: %d  Send: %d", user->getName(), days, hours, mins, secs, bot->getCountRecv(), bot->getCountSend());
    enqueue( 6, "%s", buf);
  } else {
    sprintf( buf, "Online: %dd %.2d:%.2d:%.2d  Recv: %d  Send: %d", days, hours, mins, secs, bot->getCountRecv(), bot->getCountSend());
    bot->enqueue( 6, "%s", buf);
  }

  return( 0);
}

int Command::cmdShow( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 100) return( 0);

  bot->setDisplay( "1");
}

int Command::cmdShitList( Bot *bot, User *user, char *msg, int priv) {
  return( 0);
}

int Command::cmdShutup( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 80) return( 0);

  bot->delqueue();

  return( 0);
}

int Command::cmdTagAdd( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 80) return( 0);

  char *term2 = gettermn( msg, 2);
  if (!term2) return( 0);

  char buf[ 1024];
  if (tagban->tagAdd( term2)) {
    if (priv) {
      sprintf( buf, "/msg %s Unable to add tag %s", user->getName(), term2);
      enqueue( 3, "%s", buf);
    } else {
      //sprintf( buf, "Unable to add tag %s", term2);
      bot->enqueue( 3, "Unable to add tag %s", term2);
    }
    return( 0);
  }

  if (priv) {
    sprintf( buf, "/msg %s Tagban added: %s", user->getName(), term2);
    enqueue( 3, "%s", buf);
  } else {
    //sprintf( buf, "Tagban added: %s", term2);
    bot->enqueue( 3, "Tagban added: %s", term2);
  }

  struct sCList *tmp = bot->getCList()->first;
  while (tmp) {
    user = userlist->getUser( tmp->data->getName());
    if (!user || (user->getAccess() < 20))
      if (tagban->isBanned( tmp->data->getName())) {
        //sprintf( buf, "/ban %s (TAGBAN)", tmp->data->getName());
        bot->enqueue( 2, "/ban %s (TAGBAN)", tmp->data->getName());
      }

    tmp = tmp->next;
  }

  return( 0);
}

int Command::cmdTagBans( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 30) return( 0);

  tagban->tagShow( bot->queue);

  return( 0);
}

int Command::cmdTagDel( Bot *bot, User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 80) return( 0);

  char *term2 = gettermn( msg, 2);
  if (!term2) return( 0);

  char buf[ 1024];
  if (tagban->tagDel( term2)) {
    if (priv) {
      sprintf( buf, "/msg %s Tag %s was not found", user->getName(), term2);
      enqueue( 3, "%s", buf);
    } else {
      //sprintf( buf, "Tag %s was not found", term2);
      bot->enqueue( 3, "Tag %s was not found", term2);
    }
    return( 0);
  }

  if (priv) {
    sprintf( buf, "/msg %s Tag %s deleted", user->getName(), term2);
    enqueue( 3, "%s", buf);
  } else {
    //sprintf( buf, "Tag %s deleted", term2);
    bot->enqueue( 3, "Tag %s deleted", term2);
  }

  return( 0);
}

int Command::cmdUpTime( Bot *bot,  User *user, char *msg, int priv) {
  if (!user) return( 0);
  if (user->getAccess() < 20) return( 0);

  char buf[ 1024];

  #ifndef WIN32
    int t = time(0) - bot->getCTime();
    int days = t / (3600*24); t -= days * 3600 * 24;
    int hours = t / (3600);   t -= hours * 3600;
    int mins = t / 60;        t -= mins * 60;
    int secs = t;

    if ( priv) {
      sprintf( buf, "/msg %s Uptime: %s. Online: %d days, %.2d:%.2d:%.2d.", user->getName(), GetUptime(), days, hours, mins, secs);
      enqueue( 6, "%s", buf);
    } else {
      sprintf( buf, "Uptime: %s. Online: %d days, %.2d:%.2d:%.2d.", GetUptime(), days, hours, mins, secs);
      bot->enqueue( 6, "%s", buf);
    }

  #else
    // TODO: Make this work.
    int ticks = GetTickCount();
    int secs = ticks / 1000;
    int mins = secs / 60;
    int hours = mins / 60;
    int days = hours / 24;

    secs = secs - 60 * mins;
    mins = mins - 60 * hours;
    hours = hours - 24 * days;

    if (priv) {
      sprintf( buf, "/msg %s Uptime: %d days, %.2d:%.2d:%.2d.", user->getName(), days, hours, mins, secs);
      enqueue( 6, "%s", buf);
    } else {
      sprintf( buf, "Uptime: %d days, %.2d:%.2d:%.2d.", days, hours, mins, secs);
      bot->enqueue( 6, "%s", buf);
    }
  #endif
  
  return( 0);
}

int Command::cmdUnProtect( Bot *bot,  User *user, char *msg, int priv) {
  return( 0);
}

TagBan *Command::getTagBan( void) {
  return( tagban);
}

int Command::dynHandler( Bot *bot, Obj *dyncmd, Obj *obj_spkr, char *msg2, int depth) {
	char buf[1]; buf[0] = '\0';
	if (!msg2)
		msg2 = buf;

	if (depth >= 25) {
		log("Error on command: %s\nDepth exceeded 25 levels deep\n", msg2);
		return -1;
	}
	
	sLList *i = dyncmd->objFirst;
	while (i) {
		if (!i->obj->name) {
			i = i->next;
			continue;
		}

		char cmd[ 512];
		if (i->obj->cdata)
			strncpy( cmd, i->obj->cdata, sizeof( cmd) - 1);
		else
			cmd[0] = '\0';
		cmd[sizeof( cmd) - 1] = '\0';
		
		//*(bot->disp) << "DEBUG: Command::dynHandler is handling " << cmd << endl;


		char msg[ 256];
		strncpy( msg, msg2, sizeof( msg) - 1);
		msg[sizeof( msg) - 1] = '\0';

		int found = 0;
		
		//===
		// join (channel)
		//- This bot joins a channel
			if (!strcasecmp( i->obj->name, "&join")) { found++;
				char *cmd_chan = cmd;

				char buf[256];
				if (!parseMsg( buf, obj_spkr, cmd_chan, msg2, bot->getClientType())) {
					log("Error on command: %s\nUnable to parse message\n", msg2);
					return -1;
				}
				
				bot->setHomeChannel( buf);
			}
			
		//===
		// mjoin (channel)
		//- All bots in related command set join channel
			if (!strcasecmp( i->obj->name, "&mjoin")) { found++;
				char *cmd_chan = cmd;

				char buf[256];
				if (!parseMsg( buf, obj_spkr, cmd_chan, msg2, bot->getClientType())) {
					log("Error on command: %s\nUnable to parse message\n", msg2);
					return -1;
				}
				
				char *bot_cmd = bot->getCommandSet();
				if (bot_cmd) {
					//===
					// Traverse all bots. If they have the same commandset, then
					// set the home channel.
					sBotList *tmp = botlist.first;
					while (tmp) {
						if (char *tmp2 = tmp->data->getCommandSet()) {
							if (!strcasecmp( tmp2, bot_cmd))
								tmp->data->setHomeChannel( buf);
						}
						tmp = tmp->next;
					}
				}
			}
			
		//===
		// setflags (flags)
			if (!strcasecmp( i->obj->name, "&setflags")) { found++;
				fprintf( stderr, "DEBUG: &setflags was called\n");

				char *cmd_flags = gettermn( cmd, 1);
				if (!cmd_flags) {
					log("Error on command %s\nNo flags passed to setflags\n", msg2);
					return -1;
				}

				char tmp[ 256];
				if (!parseMsg( tmp, obj_spkr, cmd_flags, msg2, bot->getClientType())) {
					log("Error on command: %s\nUnable to parse message\n", msg2);
					return -1;
				}
				
				const char *flags = tmp;
				
				//===
				// 2) Get the flags.
					Obj *obj_user = obj_spkr;
					char *userflags = obj_user->getVar("flags");
					char buf[ 256];
					bzero( buf, sizeof( buf));
					if (userflags)
						strncpy( buf, userflags, sizeof( buf) - 1);
		
				//===
				// 3) Parse the new flags.
					int add = 1;
					while (*flags) {
						if (*flags == '-') add = 0;
						if (*flags == '+') add = 1;
						
						char ch = toupper(*flags);
						if ( (ch >= 'A') && (ch <= 'Z') ) {
							if (!add) {
								char *tmp = strchr( buf, ch);
								if (tmp)
									memmove( tmp, tmp + 1, strlen( tmp + 1) + 1);
							} else {
								char *tmp = strchr( buf, ch);
								if (!tmp) {
									char tmp[2];
									tmp[0] = ch;
									tmp[1] = 0;
									strcat( buf, tmp);
								}
							}
						}
			
						flags++;
					}

				//===
				// 4) Save the changes
					fprintf( stderr, "DEBUG: &setflags is setting flags to %s\n", buf);
					obj_user->setVar("flags", buf);

			}
		
		//===
		// reqflag (flags) (function)
			if (!strcasecmp( i->obj->name, "&reqflag")) { found++;
				
				char *cmd_fn = gettermn( cmd, 2);
				char *cmd_flags = gettermn( cmd, 1);
				if (!cmd_flags) {
					log("Error on command: %s\nNo flags passed to reqflag\n", msg2);
					return -1;
				}
				
				char *user_flags = obj_spkr->getVar("flags");
				for (char *i = cmd_flags; *i; i++) {
					if (!user_flags || !strchr( user_flags, toupper(*i))) {
						if (cmd_fn)
							return dynFn( bot, cmd_fn, obj_spkr, msg2, ++depth);
						return 0;
					}
				}
			}
			
		// requserflag (user) (flags) (function)
			if (!strcasecmp( i->obj->name, "&requserflag")) { found++;
				//===
				// Grab the vars
					char *cmd_fn    = gettermn( cmd, 3);
					char *cmd_flags = gettermn( cmd, 2);
					char *cmd_user  = gettermn( cmd, 1);

					if (!cmd_flags) {
						log("Error on command: %s\nToo few perameters\n", msg2);
						return -1;
					}
				
					char buf[256];
					if (!parseMsg( buf, obj_spkr, cmd_user, msg2, bot->getClientType())) {
						log("Error on command: %s\nUnable to parse message\n", msg2);
						return -1;
					}
				
					cmd_user = buf;
					
				//===
				// Get the user.
					Obj *obj_user = globals->userdb->getObj("userdb")->getObj( cmd_user);
					if (!obj_user)
						if (cmd_fn)
								return dynFn( bot, cmd_fn, obj_user, msg2, ++depth);

				//===
				// Verify the flags
					char *user_flags = obj_user->getVar("flags");
					for (char *i = cmd_flags; *i; i++)
						if (!user_flags || !strchr( user_flags, toupper(*i)))
							return dynFn( bot, cmd_fn, obj_user, msg2, ++depth);
			}

		// quit (exit code)
			if (!strcasecmp( i->obj->name, "&quit")) { found++;
				#ifdef DISP_GTK
					gtk_main_quit();
				#endif
	
				#ifdef WIN32
					PostQuitMessage( 0);
				#endif
	
				globals->done++;
			}

		// say (message)
			if (!strcasecmp( i->obj->name, "&say")) { found++;
				if (i->obj->cdata) {
					char buf[256];
					if (parseMsg( buf, obj_spkr, i->obj->cdata, msg2, bot->getClientType())) {
						bot->enqueue( 4, "%s", buf);
					} else
						log("Error on command: %s\nUnable to parse user message\n", msg2);
				}
			}
			
		// esay (message)
			if (!strcasecmp( i->obj->name, "&esay")) { found++;
				if (i->obj->cdata) {
					char buf[256];
					if (parseMsg( buf, obj_spkr, i->obj->cdata, msg2, bot->getClientType())) {
						enqueue( 4, "%s", buf);
					} else
						log("Error on command: %s\nUnable to parse user message\n", msg2);
				}
			}
			
		// sayn (priority) (message)
			if (!strcasecmp( i->obj->name, "&sayn")) { found++;
				if (i->obj->cdata) {
					char buf[256];
					strncpy( buf, i->obj->cdata, sizeof( buf) - 1);
					buf[ sizeof( buf) - 1] = 0;
					
					char *t2 = gettermnz( buf, 2);
					char *t1 = gettermn( buf, 1);
					
					if (t1 && t2) {
						char buf[256];
						if (parseMsg( buf, obj_spkr, t2, msg2, bot->getClientType())) {
							//log("We are about to enqueue the message\n");
							bot->enqueue( atoi( t1), "%s", buf);
							//log("We successfully enqueued the message :D\n");
						} else
							log("Error on command: %s\nUnable to parse user message\n", msg2);
					} else {
						log("Error on command: %s\nToo few parameters to sayn\n", msg2);
						return -1;
					}
				}
			}
			
		// esayn (priority) (message)
			if (!strcasecmp( i->obj->name, "&esayn")) { found++;
				if (i->obj->cdata) {
					char buf[256];
					strncpy( buf, i->obj->cdata, sizeof( buf) - 1);
					buf[ sizeof( buf) - 1] = 0;
					
					char *t2 = gettermnz( buf, 2);
					char *t1 = gettermn( buf, 1);
					
					if (t1 && t2) {
						char buf[256];
						if (parseMsg( buf, obj_spkr, t2, msg2, bot->getClientType())) {
							//log("We are about to enqueue the message\n");
							enqueue( atoi( t1), "%s", buf);
							//log("We successfully enqueued the message :D\n");
						} else
							log("Error on command: %s\nUnable to parse user message\n", msg2);
					} else {
						log("Error on command: %s\nToo few parameters to sayn\n", msg2);
						return -1;
					}
				}
			}
			
		// foreach (function)
		//   Calls the function for each user that is in the channel, with the user in the channel as %u/%n.
			if (!strcasecmp( i->obj->name, "&foreach")) { found++;
				char buf[256];
				strncpy( buf, i->obj->cdata, sizeof( buf) - 1);
				buf[ sizeof( buf) - 1] = 0;
				if (char *fn = gettermn( buf, 1)) {
					struct sCList *first = bot->getCList()->first;
					while (first) {
						CUser *cuser = first->data;
						Obj *obj_user = globals->userdb->getObj("userdb")->getObj( cuser->getName());
						if (!obj_user) {
							obj_user = new Obj( cuser->getName());
							globals->userdb->getObj("userdb")->append( obj_user);
						}
						dynFn( bot, fn, obj_user, msg2, ++depth);
						first = first->next;
					}
				} else {
					log("Error on command: %d\nMissing function\n", msg2);
				}
			}
		
		// print (message)
			if (!strcasecmp( i->obj->name, "&print")) { found++;
				if (i->obj->cdata) {
					char buf[256];
					strncpy( buf, i->obj->cdata, sizeof( buf) - 1);
					buf[ sizeof( buf) - 1] = 0;
					
					if (parseMsg( buf, obj_spkr, i->obj->cdata, msg2, bot->getClientType())) {
						*bot->disp << buf << endl;
						//input->update();
					} else {
						log("Error on command: %s\nUnable to parse print string\n", msg2);
						return -1;
					}
				}
			}
			
		// reconnect
			if (!strcasecmp( i->obj->name, "&reconnect")) { found++;
				bot->netclose();
			}
			
		// mreconnect
			if (!strcasecmp( i->obj->name, "&mreconnect")) { found++;
				char *bot_cmd = bot->getCommandSet();
				if (bot_cmd) {
					//===
					// Traverse all bots. If they have the same commandset, then
					// set the home channel.
					sBotList *tmp = botlist.first;
					while (tmp) {
						if (char *tmp2 = tmp->data->getCommandSet()) {
							if (!strcasecmp( tmp2, bot_cmd))
								tmp->data->netclose();
						}
						tmp = tmp->next;
					}
				}
			}
			
		// save
			if (!strcasecmp( i->obj->name, "&save")) { found++;
				globals->db->save("nconfig.txt");
				globals->userdb->save("userdb.txt");
			}

		// tagadd (list) (tagname) (reason)
			if (!strcasecmp( i->obj->name, "&tagadd")) { found++;
				if (i->obj->cdata) {
					//===
					// Parse the variables.
						char buf[ 256];
						strncpy( buf, i->obj->cdata, sizeof( buf));
						buf[ sizeof( buf) - 1] = 0;
				
						char *arg_reason  = gettermnz( buf, 3);
						char *arg_tagname = gettermn( buf, 2);
						char *arg_list    = gettermn( buf, 1);
				
						if (!arg_tagname) {
							log("Error on command: %s\nToo few parameters\n", msg2);
							return -1;
						}
					
						char buf2[ 256];
						if (!parseMsg( buf2, obj_spkr, arg_tagname, msg2, bot->getClientType())) {
							log("Error on command: %s\nUnable to parse the tagname\n", msg2);
							return -1;
						}
					
						char buf3[ 256];
					
						if (arg_reason)
							parseMsg( buf3, obj_spkr, arg_reason, msg2, bot->getClientType());
						
						arg_tagname = buf2;
						arg_reason = buf3;
				
					//===
					// Ok, let's find the requested list.
						Obj *tagban = globals->db->getObj( arg_list);
						if (!tagban) {
							tagban = new Obj( arg_list);
							globals->db->append( tagban);
						}
				
					//===
					// Set the tag.
						tagban->setVar( arg_tagname, arg_reason);
				}
			}
			
		// tagmatch (list) (tomatch) (fn)
			if (!strcasecmp( i->obj->name, "&tagmatch")) { found++;
					//===
					// Parse the variables.
						char buf[ 256];
						strncpy( buf, i->obj->cdata, sizeof( buf));
						buf[ sizeof( buf) - 1] = 0;
				
						char *arg_fn      = gettermn( buf, 3);
						char *arg_tagname = gettermn( buf, 2);
						char *arg_list    = gettermn( buf, 1);
				
						if (!arg_tagname) {
							log("Error on command: %s\nToo few parameters\n", msg2);
							return -1;
						}
					
						char buf2[ 256];
						if (!parseMsg( buf2, obj_spkr, arg_tagname, msg2, bot->getClientType())) {
							log("Error on command: %s\nUnable to parse the tagname\n", msg2);
							return -1;
						}
					
						arg_tagname = buf2;
				
					//===
					// Ok, let's find the requested list.
						Obj *tagban = globals->db->getObj( arg_list);
						if (!tagban) {
							tagban = new Obj( arg_list);
							globals->db->append( tagban);
						}
				
					//===
					// Search all the tags to see if we have a match.
					// If we do not, then call the function or return.
						sLList *i = tagban->objFirst;
						int match = 0;
						while (i) {
							if (!i->obj->name) {
								i = i->next;
								continue;
							}
							
							//===
							// Does it match?
							if (i->obj->cdata) {
								//fprintf( stderr, "TAGDEBUG: \"%s\" vs \"%s\"\n", i->obj->getName(), arg_tagname);
								if (Command::tagban->tagCmp( i->obj->getName(), arg_tagname)) {
									match++;
									break;
								}
							}
							
							i = i->next;
						}

					//===
					// If we don't match, call the function or return.
						if (!match)
							return dynFn( bot, arg_fn, obj_spkr, msg2, depth);
			}
			
			
		// tagdel (list) (tagname)
			if (!strcasecmp( i->obj->name, "&tagdel")) { found++;
				//===
				// Parse the variables.
					char buf[ 256];
					strncpy( buf, i->obj->cdata, sizeof( buf));
					buf[ sizeof( buf) - 1] = 0;
				
					char *arg_tagname = gettermn( buf, 2);
					char *arg_list    = gettermn( buf, 1);
				
					if (!arg_tagname) {
						log("Error on command: %s\nToo few parameters\n", msg2);
						return -1;
					}
					
					char buf2[ 256];
					if (!parseMsg( buf2, obj_spkr, arg_tagname, msg2, bot->getClientType())) {
						log("Error on command: %s\nUnable to parse the tagname\n", msg2);
						return -1;
					}
					
					arg_tagname = buf2;
				
				//===
				// Ok, let's find the requested list.
					Obj *tagban = globals->db->getObj( arg_list);
					if (!tagban) {
						tagban = new Obj( arg_list);
						globals->db->append( tagban);
					}
				
				//===
				// Search all the tags to see if we have a match.
				// If we do not, then call the function or return.
					Obj *tmp = tagban->getObj( arg_tagname);
					if (tmp)
						tagban->delObj( tmp);
			}
		

		// meshowfile (username) (priority) (filename)
			if (!strcasecmp( i->obj->name, "&meshowfile")) { found++;
				if (i->obj->cdata) {
					char buf[256];
					strncpy( buf, i->obj->cdata, sizeof( buf) - 1);
					buf[ sizeof( buf) - 1] = 0;
				
					char *filename = gettermn( buf, 3);
					char *priority = gettermn( buf, 2);
					char *username = gettermn( buf, 1);
					
					if (filename) {
						char buf[ 256];
						if (parseMsg( buf, obj_spkr, username, msg2, bot->getClientType())) {
							//===
							// Open the file, and enqueue all of it :)
							FILE *fd = fopen( filename, "r");
							if (fd) {
								char rbuf[ 256];
								while (fgets( rbuf, sizeof( rbuf), fd)) {
									if (char *tmp = strchr( rbuf, '\r')) *tmp = 0;
									if (char *tmp = strchr( rbuf, '\n')) *tmp = 0;
								
									enqueue( atoi( priority), "/msg %s %s", buf, rbuf);
								}
								fclose( fd);
							}
						} else {
							log("Error on command: %s\nUnable to parse username\n", msg2);
							return -1;
						}
					} else {
						log("Error on command: %s\nMissing parameters.\n", msg2);
						return -1;
					}
				}
			}

		//===
		// Perhaps this is a function call?
			if (!found) {
				char *t2 = gettermn( cmd, 2);
				char *t1 = gettermn( cmd, 1);
				
				if (t1 && t2)
					if (!strcmp( t2, "()"))
						return dynFn( bot, t1, obj_spkr, msg2, depth + 1);
					else {
						log("Error on command: %s\nUnknown command '%s'\n", msg2, t1);
						return -1;
					}
			}

		i = i->next;
	}
	//*(bot->disp) << "DEBUG: Command::dynHandler is returning" << endl;
	return 0;
}

int Command::dynFn( Bot *bot, char *fn, Obj *obj_spkr, char *msg, int depth) {
	if (!fn)
		return -1;

	Obj *dynset = globals->db->getObj("dyncmd")->getObj( bot->getCommandSet());
	if (!dynset) {
		if (msg) {
			log("Error: On command %s\nUnable to find commandset '%s'\n", msg, bot->getCommandSet());
		} else {
			log("Error: Unable to find commandset '%s'\n", bot->getCommandSet());
		}
		return -1;
	}
	Obj *dyncmd = dynset->getObj( fn);
	if (!dyncmd) {
		if (msg) {
			log("Error: On command: %s\nFunction %s was not found\n", msg, fn);
		} else {
			log("Error: Function %s was not found\n", fn);
		}
		return -1;
	}
	return dynHandler( bot, dyncmd, obj_spkr, msg, depth);
}
