#ifndef COMMAND_H
#define COMMAND_H

#include "db/obj.h"
#include "enqueue.h"
#include "userlist.h"
#include "bot.h"
#include "tagban.h"
#include "dyncmd.h"

class Bot;

class Command : public Enqueue {
  char name[33];
  char database[ 257];

  TagBan *tagban;
public:
  DynCmd *dyncmd;
  UserList *userlist;

  Command( void);
  ~Command( void);

  int setTagBans( char *_file);
  int handleCommand( Bot *bot, char *_username, char *_command, int priv);

  int setName( char *_name);
  int setDatabase( char *_database);
  char *getName( void);
  int addHandler( Bot *bot);

  TagBan *getTagBan( void);

  int cmdAddUser( Bot *bot, User *user, char *msg, int priv);
  int cmdChattr( Bot *bot, User *user, char *msg, int priv);
  int cmdCmd( Bot *bot, User *user, char *msg, int priv);
  int cmdDelUser( Bot *bot, User *user, char *msg, int priv);
  int cmdDesignate( Bot *bot, User *user, char *msg, int priv);
  int cmdHide( Bot *bot, User *user, char *msg, int priv);
  int cmdIdle( Bot *bot, User *user, char *msg, int priv);
  int cmdGiveOps( Bot *bot, User *user, char *msg, int priv);
  int cmdJoin( Bot *bot, User *user, char *msg, int priv);
  int cmdJoinHome( Bot *bot, User *user, char *msg, int priv);
  int cmdMode( Bot *bot, User *user, char *msg, int priv);
  int cmdOS( Bot *bot, User *user, char *msg, int priv);
  int cmdProfile( Bot *bot, User *user, char *msg, int priv);
  int cmdProtect( Bot *bot, User *user, char *msg, int priv);
  int cmdQuote( Bot *bot, User *user, char *msg, int priv);
  int cmdRejoin( Bot *bot, User *user, char *msg, int priv);
  int cmdSetHome( Bot *bot, User *user, char *msg, int priv);
  int cmdSetIdle( Bot *bot, User *user, char *msg, int priv);
  int cmdSetServer( Bot *bot, User *user, char *msg, int priv);
//  int cmdSetTrigger( Bot *bot, User *user, char *msg, int priv);
  int cmdServer( Bot *bot, User *user, char *msg, int priv);
  int cmdShow( Bot *bot, User *user, char *msg, int priv);
  int cmdShitAdd( Bot *bot, User *user, char *msg, int priv);
  int cmdShitDel( Bot *bot, User *user, char *msg, int priv);
  int cmdShitList( Bot *bot, User *user, char *msg, int priv);
  int cmdShutup( Bot *bot, User *user, char *msg, int priv);
  int cmdStats( Bot *bot, User *user, char *msg, int priv);
  int cmdTagAdd( Bot *bot, User *user, char *msg, int priv);
  int cmdTagBans( Bot *bot, User *user, char *msg, int priv);
  int cmdTagDel( Bot *bot, User *user, char *msg, int priv);
  int cmdUnProtect( Bot *bot,  User *user, char *msg, int priv);
  int cmdUpTime( Bot *bot, User *user, char *msg, int priv);

	int cmdInfo(      Bot *, Obj *, char *, int);
	int cmdReconnect( Bot *, Obj *, char *, int);
	int cmdResign(    Bot *, Obj *, char *, int);
	int cmdSetFlags(  Bot *, Obj *, char *, int);
	int cmdSetGlobal( Bot *, Obj *, char *, int);
	int cmdSetVar(    Bot *, Obj *, char *, int);
	int cmdVer(       Bot *, Obj *, char *, int);

	int dynHandler( Bot *bot, Obj *dyncmd, Obj *obj_spkr, char *msg, int depth);
	int dynFn( Bot *bot, char *fn, Obj *obj_spkr, char *msg, int depth);
};

#endif
