#include <string.h>
#include "commandlist.h"
#include "display.h"

extern Display disp;

CommandList::CommandList( void) {
  first = 0;
}

CommandList::~CommandList( void) {
  struct sCommandList *tmp = first;

  while (first) {
    if (first->data)
      delete first->data;
    tmp = first;
    first = tmp->next;
    delete tmp;
  }
}

void CommandList::add( Command *data) {
  struct sCommandList *tmp;

  tmp = new sCommandList;
  if (!tmp) {
    delete data;
    return;
  }

  tmp->data = data;
  tmp->next = first;

  first = tmp;
}

void CommandList::remove( Command *data) {
  sCommandList *tmp = first;

  if (!tmp) return;

  if (tmp->data == data) {
    delete tmp->data;
    first = tmp->next;
    delete tmp;
    return;
  }

  for (;;) {
    if (tmp->next)
      if (tmp->next->data == data) {
        delete tmp->next->data;
        sCommandList *tmp2 = tmp->next;
        tmp->next = tmp->next->next;
        delete tmp2;
        break;
      }
    else
      break;
    tmp = tmp->next;
  }
}

Command *CommandList::getFirst( void) {
  if (!first)
    return( 0);
  return( first->data);
}

Command *CommandList::getCommand( char *name) {
  sCommandList *tmp = first;

  //disp << "Debug: CommandList::getCommand was called for " << name << endl;
  while (tmp) {
    if (!strcmp( name, tmp->data->getName()))
      return( tmp->data);
    tmp = tmp->next;
  }
  //disp << "       CommandList::getCommand did not find " << name << endl;
  return( 0);
}
