#ifndef CONFIG2_H
#define CONFIG2_H

#ifndef OS_STRING
#	define OS_STRING "unknown"
#endif

#ifdef OS_FREEBSD
#	define _BSD_
#	define OS_BSD
#endif

#ifdef OS_LINUX
#	define _LINUX_
#endif

#ifdef OS_WIN32
#	define _WIN32_
# define sleep(x) Sleep(x * 1000)
#	define usleep(x) Sleep( x / 1000)
#endif

#define DEBUG

#ifdef DEBUG
#	define debug(x) { printf( "Debug: "); printf x; printf( "\n"); fflush( stdout); }
#else
#	define debug(x) // Debug: x
#endif

  //#define DISP_CON
  // both for new gui
  // #define DISP_W32
  // #define DISP_GTK

  //===
  // zDSBot3 auto features.
  #if defined(OS_BSD) || defined(OS_LINUX)
  #  define FEATURE_JSTR
  #endif
  #if defined(OS_WIN32) && ! defined(DISP_GTK)
  #  define WIN32_NATIVE
  #endif

  // I really liked the CAS server. :(
  #define FAKECAS

  // THIS STOPS THE IDLE LOOP!!!
  // #define DEBUGHALT

  //#define DEBUGVER
  // *** Normal debugging
  //#define DEBUGDYNCMD
  //#define DEBUGUSERLIST
  //#define DEBUGPROXY
  //#define DEBUGCFG
  //#define DEBUGDSBOT  
  //#define DEBUGCAS  
  //#define DEBUGPKT  
  //#define DEBUGBOT  
  //#define DEBUGNET
  //#define DEBUGNET2  

  // *** Debugging hell
  //#define DEBUGMAIN

  #ifdef WIN32
    #define GUI
  #endif
  
  #ifdef DISP_GTK
    #define GUI
  #endif

  #ifdef WIN32
    #define WM_NETEVENT WM_USER+0x1998
    #define WM_JOIN     WM_USER+0x1999
  #endif

	#include "types.h"

  #define CBLACK   (char)0   // "\033[0;30m"
  #define CRED     (char)1   // "\033[0;31m"
  #define CGREEN   (char)2   // "\033[0;32m"
  #define CBROWN   (char)3   // "\033[0;33m"
  #define CBLUE    (char)4   // "\033[0;34m"
  #define CPURPLE  (char)5   // "\033[0;35m"
  #define CCYAN    (char)6   // "\033[0;36m"
  #define CWHITE   (char)7   // "\033[0;37m"
  #define CBGRAY   (char)8   // "\033[1;30m"
  #define CBRED    (char)12  // "\033[1;31m"
  #define CBGREEN  (char)10  // "\033[1;32m"
  #define CBYELLOW (char)14  // "\033[1;33m"
  #define CBBLUE   (char)9   // "\033[1;34m"
  #define CBPURPLE (char)13  // "\033[1;35m"
  #define CBCYAN   (char)11  // "\033[1;36m"
  #define CBWHITE  (char)15  // "\033[0;1m"

  const u32 CLIENT_CHAT = 0x43484154;
  const u32 CLIENT_W2BN = 0x5732424e;
  const u32 CLIENT_WAR3 = 0x57415233;
  const u32 CLIENT_STAR = 0x53544152;
  const u32 CLIENT_SSHR = 0x53534852;
  const u32 CLIENT_SEXP = 0x53455850;
  const u32 CLIENT_DSHR = 0x44534852;
  const u32 CLIENT_DRTL = 0x4452544c;
  const u32 CLIENT_D2DV = 0x44324456;
  const u32 CLIENT_D2XP = 0x44325850;
  const u32 CLIENT_JSTR = 0x4a535452;

#endif
