#include "dhandle.h"

DHandle::DHandle( void) {
	Bot *bot = NULL;
	curcolor = 7;
}

DHandle::~DHandle( void) {
}

void DHandle::onHandler( void) {
	if (!bot) {
		//fprintf( stderr, "DHandle::onHandler called w/ a NULL bot\n");
		//fflush( stderr);
		return;
	}
	
	Display *disp = bot->disp;

	if (!disp) {
		//fprintf( stderr, "dhandle::onhandler warning - disp is null!\n");
		//fflush( stderr);
		return;
	}

	std::queue <sEvents *> Q;

	//===
	// Dequeue, and queue to avoid locking other threads.
		disp->lock();
		if (disp->dispQ) {
			int n = 0;
			while (!disp->dispQ->empty()) {
				Q.push( disp->dispQ->front());
				disp->dispQ->pop();

				//===
				// Keep any display from hogging up all of the time.
				if (++n > 250)
					break;
			}
		}
		disp->unlock();

	//===
	// Now handle the events in our own time. :)
		if (!Q.empty()) {
			onFreeze();
			while (!Q.empty()) {
				sEvents *tmp = Q.front();
				Q.pop();

				//fprintf(stderr, "dhandle::onHandler has an event type: %d\n", tmp->eventtype);
				//fflush( stderr);

				switch( tmp->eventtype) {
					case EVENT_CLS:
						onCls();
						break;
					case EVENT_STRING:
						{
							char *start = (char *)tmp->data;
							char *loc = (char *)tmp->data;

							while (*loc) {
								if (*(unsigned char *)loc <= 16) {
									char ch = *loc;
									*loc = 0;
									onText( start, curcolor);
									if (ch == 16)
										onText("\n", curcolor);
									else
									curcolor = ch;
									start = loc + 1;
								}
								loc++;
							}
							if (*start)
								onText( start, curcolor);
							delete (char *)tmp->data;
						} break;
					default:
						break;
				}

				delete tmp;
			}
			onThaw();
		}

}

void DHandle::onText( char *txt, int color) {
}

void DHandle::onCls( void) {
}

void DHandle::onFreeze( void) {
}

void DHandle::onThaw( void) {
}

