#include <unistd.h>
#include <string.h>
#include "Images/icons_alizee.xpm"
#include "Images/icons_diablo2.xpm"
#include "Images/icons_jsc.xpm"
#include "Images/icons_sware.xpm"
#include "Images/icons_bliz.xpm"
#include "Images/icons_diablosw.xpm"
#include "Images/icons_sc.xpm"
#include "Images/icons_war2.xpm"
#include "Images/icons_chat.xpm"
#include "Images/icons_gavel.xpm"
#include "Images/icons_starx.xpm"
#include "Images/icons_war3.xpm"
#include "Images/stock_clear.xpm"
#include "Images/stock_colorselector.xpm"
#include "Images/stock_properties.xpm"
#include "Images/stock_text_bold.xpm"
#include "../../../src/globals.h"
#include "wnddisp.h"
#include "support.h"

extern Globals *globals;

gboolean on_wndDisp_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data) {
  return FALSE;
}

void on_wndDisp_destroy( GtkObject *object, gpointer user_data) {
}

//===
// Gtk called us, don't lock.
void on_btnClear_clicked( GtkButton *button, gpointer user_data) {
	gtk_editable_delete_text( (GtkEditable *)((WndDisp *)user_data)->text1, 0, -1);

	// Set the background to black again, just in case.
	GdkColor	black = { 0, 0, 0, 0x100 };
	gdk_window_set_background(GTK_TEXT( ((WndDisp *)user_data)->text1 )->text_area, &black);
}

void on_btnProp_clicked( GtkButton *button, gpointer user_data) {
}

void on_btnUnk_clicked( GtkButton *button, gpointer user_data) {
}

void on_btnFont_clicked( GtkButton *button, gpointer user_data) {
}

void on_checkbutton1_toggled( GtkToggleButton *togglebutton, gpointer user_data) {
}

void on_clist1_select_row( GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
}

void on_dispalt_entry1_activate( GtkEditable *editable, gpointer user_data) {
  ((WndDisp *)user_data)->handleInput( editable);
}


//===
// In the creation process we will generally add a callback to
// actually create the display to ensure it is ran in the
// display thread. This actually does the gtk work.
// Note: This is always ran from the Display thread.
void WndDisp::create( void) {
	debug(("WndDisp::create was called"));
	debug(("WndDisp::create is gonna lock the thread, this will freeze"));
	gdk_threads_enter();
	debug(("WndDisp::create you don't see this right? see it froze"));

	tooltips = gtk_tooltips_new ();

	wnddisp = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wnddisp), "wnddisp", wnddisp);
	gtk_window_set_title (GTK_WINDOW (wnddisp), "Prolix - Public Chat");
	gtk_window_set_default_size (GTK_WINDOW (wnddisp), 500, 200);

	vbox1 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox1);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "vbox1", vbox1,
	                         (GtkDestroyNotify) gtk_widget_unref);
 	gtk_widget_show (vbox1);
 	gtk_container_add (GTK_CONTAINER (wnddisp), vbox1);

	hpaned1 = gtk_hpaned_new ();
	gtk_widget_ref (hpaned1);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "hpaned1", hpaned1,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hpaned1);
	gtk_box_pack_start (GTK_BOX (vbox1), hpaned1, TRUE, TRUE, 0);
	gtk_paned_set_position (GTK_PANED (hpaned1), 300);

	vbox2 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox2);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "vbox2", vbox2,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (vbox2);
	gtk_paned_pack1 (GTK_PANED (hpaned1), vbox2, FALSE, TRUE);

	frame5 = gtk_frame_new (NULL);
	gtk_widget_ref (frame5);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "frame5", frame5,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frame5);
	gtk_box_pack_start (GTK_BOX (vbox2), frame5, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (frame5), 2);

	scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_ref (scrolledwindow2);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "scrolledwindow2", scrolledwindow2,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (scrolledwindow2);
	gtk_container_add (GTK_CONTAINER (frame5), scrolledwindow2);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	GdkColor	black = { 0, 0, 0, 0x100 };
	GdkColormap   *cmap = gdk_colormap_get_system();
	gdk_colormap_alloc_color(cmap, &black, FALSE, TRUE);

	//font = gdk_font_load("-adobe-courier-bold-r-normal-*-*-100-*-*-m-*-*-*");
	font = gdk_font_load("-cronyx-courier-bold-r-normal-*-*-100-*-*-m-*-koi8-r");

	text1 = gtk_text_new (NULL, NULL);
	gtk_widget_ref (text1);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (text1);
	gtk_container_add (GTK_CONTAINER (scrolledwindow2), text1);

	vbox3 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox3);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "vbox3", vbox3,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (vbox3);
	gtk_paned_pack2 (GTK_PANED (hpaned1), vbox3, TRUE, TRUE);

	vbox4 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox4);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "vbox4", vbox4,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (vbox4);
	gtk_box_pack_start (GTK_BOX (vbox3), vbox4, TRUE, TRUE, 0);

	frame7 = gtk_frame_new (NULL);
	gtk_widget_ref (frame7);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "frame7", frame7,
 	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frame7);
	gtk_box_pack_start (GTK_BOX (vbox4), frame7, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame7), hbox1);

  toolbar2 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_ref (toolbar2);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "toolbar2", toolbar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar2);
  gtk_box_pack_start (GTK_BOX (hbox1), toolbar2, FALSE, FALSE, 0);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (wnddisp, GNOME_STOCK_PIXMAP_CLEAR);
  tmp_toolbar_icon = create_xpm(wnddisp, stock_clear_xpm);
  btnClear = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                "Clear The Chat Window.", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnClear);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "btnClear", btnClear,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnClear);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (wnddisp, GNOME_STOCK_PIXMAP_PROPERTIES);
  tmp_toolbar_icon = create_xpm(wnddisp, stock_properties_xpm);
  btnProp = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                "Bot Properties.", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnProp);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "btnProp", btnProp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnProp);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (wnddisp, GNOME_STOCK_PIXMAP_COLORSELECTOR);
  tmp_toolbar_icon = create_xpm(wnddisp, stock_colorselector_xpm);
  btnUnk = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                "Perhaps Color Scheme. Sure makes for a cool icon though. >;-)", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnUnk);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "btnUnk", btnUnk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnUnk);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (wnddisp, GNOME_STOCK_PIXMAP_TEXT_BOLD);
  tmp_toolbar_icon = create_xpm(wnddisp, stock_text_bold_xpm);
  btnFont = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "button6",
                                "Change Font.", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnFont);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "btnFont", btnFont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnFont);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, TRUE, 2);

  checkbutton1 = gtk_check_button_new_with_label ("Popup");
  gtk_widget_ref (checkbutton1);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "checkbutton1", checkbutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton1);
  gtk_box_pack_start (GTK_BOX (hbox1), checkbutton1, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, checkbutton1, "Show Private Messages in a Popup", NULL);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_ref (frame6);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox4), frame6, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame6), 2);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (frame6), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

	//===
	// blah @ enum problems
	// gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow3)->hscrollbar), GTK_POLICY_AUTOMATIC);
	// gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow3)->vscrollbar), GTK_POLICY_AUTOMATIC);

	clist1 = gtk_clist_new (3);
	gtk_widget_ref (clist1);
	gtk_object_set_data_full (GTK_OBJECT (wnddisp), "clist1", clist1,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (clist1);
	gtk_container_add (GTK_CONTAINER (scrolledwindow3), clist1);
	gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 28);
	gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 90);
	gtk_clist_set_column_width (GTK_CLIST (clist1), 2, 20);

	gtk_clist_set_column_max_width( GTK_CLIST (clist1), 0, 28);
	gtk_clist_set_column_max_width( GTK_CLIST (clist1), 2, 20);

	//gtk_clist_set_column_auto_resize( GTK_CLIST (clist1), 0, 1);
	//gtk_clist_set_column_auto_resize( GTK_CLIST (clist1), 1, 1);
	//gtk_clist_set_column_auto_resize( GTK_CLIST (clist1), 2, 1);

	gtk_clist_column_titles_hide (GTK_CLIST (clist1));

	label6 = gtk_label_new ("label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label6);

  label7 = gtk_label_new ("label7");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label7);

  label8 = gtk_label_new ("label8");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 2, label8);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (wnddisp), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_container_add (GTK_CONTAINER (frame1), entry1);
  gtk_entry_set_text (GTK_ENTRY (entry1), "");

  gtk_signal_connect (GTK_OBJECT (wnddisp), "delete_event",
                      GTK_SIGNAL_FUNC (on_wndDisp_delete_event),
                      this);
  gtk_signal_connect (GTK_OBJECT (wnddisp), "destroy",
                      GTK_SIGNAL_FUNC (on_wndDisp_destroy),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnClear), "clicked",
                      GTK_SIGNAL_FUNC (on_btnClear_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnProp), "clicked",
                      GTK_SIGNAL_FUNC (on_btnProp_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnUnk), "clicked",
                      GTK_SIGNAL_FUNC (on_btnUnk_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnFont), "clicked",
                      GTK_SIGNAL_FUNC (on_btnFont_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (checkbutton1), "toggled",
                      GTK_SIGNAL_FUNC (on_checkbutton1_toggled),
                      this);
  gtk_signal_connect (GTK_OBJECT (clist1), "select_row",
                      GTK_SIGNAL_FUNC (on_clist1_select_row),
                      this);
  gtk_signal_connect (GTK_OBJECT (entry1), "activate",
                      GTK_SIGNAL_FUNC (on_dispalt_entry1_activate),
                      this);

  gtk_object_set_data (GTK_OBJECT (wnddisp), "tooltips", tooltips);

  gtk_widget_show( wnddisp);

  gdk_window_set_background(GTK_TEXT(text1)->text_area, &black);

  GdkColormap *colormap = gtk_widget_get_colormap( wnddisp);
  if (colormap == NULL)
    g_error("Couldn't create replacement colormap.");

  pixmap[ 0] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 0], NULL, alizee_xpm);
  pixmap[ 1] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 1], NULL, bliz_xpm);
  pixmap[ 2] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 2], NULL, chat_xpm);
  pixmap[ 3] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 3], NULL, diablo2_xpm);
  pixmap[ 4] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 4], NULL, diablosw_xpm);
  pixmap[ 5] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 5], NULL, gavel_xpm);
  pixmap[ 6] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 6], NULL, jsc_xpm);
  pixmap[ 7] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 7], NULL, sc_xpm);
  pixmap[ 8] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 8], NULL, starx_xpm);
  pixmap[ 9] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 9], NULL, sware_xpm);
  pixmap[10] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[10], NULL, war2_xpm);
  pixmap[11] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[11], NULL, war3_xpm);

	active = 1;

	gdk_threads_leave();
	debug(("WndDisp::create is returning"));
}

//===
// Callback ran in the display thread.
void wndDisp_create( void *data) {
	debug(("WndDisp::wnddisp_create was called, calling WndDisp::create"));
	((WndDisp *)data)->create();
	debug(("WndDisp::wnddisp_create is returning"));
}


//===
// This could be called from a couple different threads.
// Generally either the root, config, or display thread.
// In any case, add a callback to ensure we are called
// from the display thread.
WndDisp::WndDisp( void) {
	debug(("WndDisp::WndDisp was called, adding callback handler"));
	active = 0;
	debug(("WndDisp::WndDisp globals              is 0x%x", globals));
	debug(("WndDisp::WndDisp is sleeping for a second :)"));
	sleep( 1);
	debug(("WndDisp::WndDisp is gonna display globals->thread_disp"));
	debug(("WndDisp::WndDisp globals->thread_disp is 0x%x", globals->thread_disp));
	sleep( 1);

	globals->thread_disp->addCallback( wndDisp_create, this);
	debug(("WndDisp::WndDisp is returning"));
}

WndDisp::~WndDisp( void) {
}


void WndDisp::handle( void) {
	/*
	static int colors2[16][3] = {
		{      0,      0,      0 }, //  0 BLACK ?!
		{ 0xA000,      0,      0 }, //  1 Red
		{      0, 0xA000,      0 }, //  2 Green
		{      0,      0,      0 }, //  3 Brown
		{      0,      0, 0xA000 }, //  4 Blue
		{ 0xA000,      0, 0xA000 }, //  5 Purple
		{      0, 0xA000, 0xA000 }, //  6 Cyan
		{ 0xC000, 0xC000, 0xC000 }, //  7 White
		{ 0x8000, 0x8000, 0x8000 }, //  8 Gray
		{ 0x0000, 0x0000, 0xFFFF }, //  9 Blue
		{      0, 0xFFFF,      0 }, // 10 Green
		{ 0xFFFF, 0xFFFF,      0 }, // 11 Yellow
		{ 0xFFFF,      0,      0 }, // 12 Red
		{ 0xFFFF,      0, 0xFFFF }, // 13 Purple
		{      0, 0xFFFF, 0xFFFF }, // 14 Cyan
		{ 0xFFFF, 0xFFFF, 0xFFFF }  // 15 White
	};
	*/
  // These dark colors are driving me nutso, let's force them to be bright >;-)
  static int colors[16][3] = {
    {      0,      0,      0 }, //  0 BLACK ?!
    { 0xEEEE,      0,      0 }, //  1 Red
    {      0, 0xEEEE,      0 }, //  2 Green
    {      0,      0,      0 }, //  3 Brown
    {      0,      0, 0xEEEE }, //  4 Blue
    { 0xEEEE,      0, 0xEEEE }, //  5 Purple
    {      0, 0xEEEE, 0xEEEE }, //  6 Cyan
    { 0xEEEE, 0xEEEE, 0xEEEE }, //  7 White
    { 0xCCCC, 0xCCCC, 0xCCCC }, //  8 Gray
    { 0x0000, 0x0000, 0xFFFF }, //  9 Blue
    {      0, 0xFFFF,      0 }, // 10 Green
    { 0xFFFF, 0xFFFF,      0 }, // 11 Yellow
    { 0xFFFF,      0,      0 }, // 12 Red
    { 0xFFFF,      0, 0xFFFF }, // 13 Purple
    {      0, 0xFFFF, 0xFFFF }, // 14 Cyan
    { 0xFFFF, 0xFFFF, 0xFFFF }  // 15 White
  };

	if (!active)
		return;
		
  for (;;) {
    sDisp *tmp = NULL;
    pthread_mutex_lock( &mutex_data);
    tmp = first;
    if (first) {
      first = first->next;
      if (!first)
        last = NULL;
    }
    pthread_mutex_unlock( &mutex_data);
    if (!tmp) break;
    
    GdkColor bgcol, fgcol;
    bgcol.red   = colors[(tmp->color & 0xf0) >> 4][0];
    bgcol.green = colors[(tmp->color & 0xf0) >> 4][1];
    bgcol.blue  = colors[(tmp->color & 0xf0) >> 4][2];
    fgcol.red   = colors[tmp->color & 0xf][0];
    fgcol.green = colors[tmp->color & 0xf][1];
    fgcol.blue  = colors[tmp->color & 0xf][2];

    gdk_threads_enter();
    gtk_text_insert( GTK_TEXT( text1), font, &fgcol, &bgcol, tmp->data, -1);
    gdk_threads_leave();

    delete tmp->data;
    delete tmp;
  }
}

//===
// Don't lock the thread! Gtk called us!
void WndDisp::handleInput( GtkEditable *editable) {
	if (!active)
		return;

  char *cmd = gtk_entry_get_text( GTK_ENTRY(editable));

  if (cmd)
    if (!handleCmd( cmd))
      addmsg( cmd);

	gtk_entry_set_text( GTK_ENTRY(editable), "");

}

int WndDisp::handleCmd( char *cmd) {
	if (!active)
		return 0;

  int ret = 0;

  if (!strcasecmp( cmd, "/help")) {
    *this << CBWHITE << "*** " << CBGREEN << "Help:" << endl;
    ret++;
  }

  if (!strcasecmp( cmd, "/quit")) {
    gtk_main_quit();
    ret++;
  }
  
  return( ret + Disp::handleCmd( cmd));
}

//===
// Todo: This needs to be queue'd and handled in the display thread.
int WndDisp::addUser( char *name, u32 flags, u32 client, u32 latency) {
	if (!active)
		return -1;
		
  char **buf = new char *[3];
  buf[0] = new char[ 1];
  *buf[0] = '\0';

  buf[1] = new char[ strlen( name) + 1];
  strcpy(buf[1], name);

  buf[2] = new char[ 13];
  sprintf( buf[2], "%dms", latency);

  gdk_threads_enter();
  int i = gtk_clist_append( (GtkCList *)clist1, buf);
  
  //===
  // Todo:
  //   For "user-specific" icons, we need a good way to allow the
  //   user/bot to pass them. This should also be moved into some
  //   sort of a BST.
  if (!strcasecmp( name, "Alizee")) gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 0], mask[ 0]);
  else if (flags & 1) gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 1], mask[1]);
  else if (flags & 2) gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 5], mask[5]);
  else
    switch( client) {
      case CLIENT_CHAT: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 2], mask[ 2]); break;
      case CLIENT_W2BN: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[10], mask[10]); break;
      case CLIENT_STAR: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 7], mask[ 7]); break;
      case CLIENT_SEXP: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 8], mask[ 8]); break;
      case CLIENT_SSHR: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 9], mask[ 9]); break;
      case CLIENT_DSHR: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 4], mask[ 4]); break;
      case CLIENT_DRTL: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 4], mask[ 4]); break;
      case CLIENT_D2DV: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 3], mask[ 3]); break;
      case CLIENT_D2XP: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 3], mask[ 3]); break;
      case CLIENT_JSTR: gtk_clist_set_pixmap( (GtkCList *)clist1, i, 0, pixmap[ 6], mask[ 6]); break;
    }

  gdk_threads_leave();
  return -1;
}

//===
// Todo: This needs to be queue'd and handled in the gtk thread.
int WndDisp::updateUser( char *name, u32 flags, u32 client, u32 latency) {
	if (!active)
		return -1;

  char *text; int i = 0;
  gdk_threads_enter();
  while (gtk_clist_get_text( (GtkCList *)clist1, i, 1, &text)) {
    if (!strcasecmp( text, name)) {
      gtk_clist_get_text( (GtkCList *)clist1, i, 2, &text);
      sprintf( text, "%dms", latency);
      gtk_clist_set_text( (GtkCList *)clist1, i, 2, text);
      gdk_threads_leave();
      return 0;
    }
    i++;
  }
  gdk_threads_leave();
  return -1;
}

//===
// Todo: This needs to be queue'd and handled in the gtk thread.
int WndDisp::delUser( char *name) {
	if (!active)
		return -1;
		
  char *text; int i = 0;
  gdk_threads_enter();
  while (gtk_clist_get_text( (GtkCList *)clist1, i, 1, &text)) {
    if (!strcasecmp( text, name)) {
      gtk_clist_remove ( (GtkCList *)clist1, i);
      gdk_threads_leave();
      return 0;
    }
    i++;
  }
  gdk_threads_leave();
  return -1;
}

//===
// Todo: This needs to be queue'd and handled in the gtk thread.
void WndDisp::setChan( char *_name) {
	if (!active)
		return;
		
  Disp::setChan( _name);

  // updateTitle();

  gdk_threads_enter();
  gtk_clist_clear( (GtkCList *)clist1);
  gdk_threads_leave();
}
