#ifndef WNDDISP_H
#define WNDDISP_H

#include <gtk/gtk.h>
#include "../../../src/display/disp.h"
#include "../../../src/types.h"

class WndDisp : public Disp {
private:
	int active;
public:
  GdkPixmap *pixmap[12];
  GdkBitmap *mask[12];

  GtkWidget *wnddisp;
  GtkWidget *vbox1;
  GtkWidget *hpaned1;
  GtkWidget *vbox2;
  GtkWidget *frame5;
  GtkWidget *scrolledwindow2;
  GtkWidget *text1;
  GtkWidget *vbox3;
  GtkWidget *vbox4;
  GtkWidget *frame7;
  GtkWidget *hbox1;
  GtkWidget *toolbar2;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *btnClear;
  GtkWidget *btnProp;
  GtkWidget *btnUnk;
  GtkWidget *btnFont;
  GtkWidget *vseparator1;
  GtkWidget *checkbutton1;
  GtkWidget *frame6;
  GtkWidget *scrolledwindow3;
  GtkWidget *clist1;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *frame1;
  GtkWidget *entry1;
  GtkTooltips *tooltips;
  GdkFont   *font;

  WndDisp( void);
  ~WndDisp( void);

	//===
	// In the creation process we will generally add a callback to
	// actually create the display to ensure it is ran in the
	// display thread. This actually does the gtk work.
		void create( void);

  int addUser( char *name, u32 flags, u32 client, u32 latency);
  int updateUser( char *name, u32 flags, u32 client, u32 latency);
  int delUser( char *name);
  void setChan( char *);

  WndDisp& operator<<( char *msg) { Disp::operator<<( msg); return *this; }
  WndDisp& operator<<( char ch)   { Disp::operator<<( ch);  return *this; }
  WndDisp& operator<<( int i)     { Disp::operator<<( i);   return *this; }
  WndDisp& operator<<(Disp & (*func)(Disp &str)) {
    return (WndDisp&)((*func)(*this));
  }

  int show( void);
  int hide( void);

  void handleInput( GtkEditable *editable);
  int  handleCmd( char *cmd);
  void handle( void);
};

#endif
