//=============================================================================
//= zDSBot3 by Eurijk!
//=   Hmmm, so I like this comment style or not...? Heh, I changed style
//=   to something similar in http://prolix.sourceforge.net/ <shrugs>

#include "config.h"

#include <time.h>
#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include "display.h"

#include "globals.h"

Display::Display( void) {
	init();
}

Display::Display( int _background) {
	init();
}

void Display::init( void) {
	dispQ = new std::queue< sEvents *>;
	pthread_mutex_init( & display_lock, 0);

	MAXENQUEUE = 10000;

	Obj *obj = globals->db->getObj("vars");
	char *tmp = obj->getVar("maxenqueue");
	if (!tmp) {
		obj->setVar("maxenqueue", "10000");
	}

	if (tmp)
		MAXENQUEUE = atoi( tmp);
	
	if (MAXENQUEUE < 1)
		MAXENQUEUE = 1;
}

Display::~Display( void) {
	lock();
	while (!dispQ->empty()) {
		sEvents *tmp = dispQ->front();
		dispQ->pop();
		if (tmp)
			dispose( tmp);
	}
	delete dispQ;
	dispQ = NULL;
	unlock();
}


void Display::cls( void) {
	struct sEvents *tmp = new sEvents;
	tmp->eventtype = EVENT_CLS;
	tmp->data = 0;

	lock();
	dispQ->push( tmp); 
	unlock();
	
	return;
}

// MFT
//void Display::clrline( void) {
//}

void Display::print( char *str, ... ) {
	va_list args; char buf[BUFSIZE];
  
	va_start( args, str);
	#ifdef WIN32
		vsprintf( buf, str, args);
	#else
		vsnprintf( buf, BUFSIZE, str, args);
	#endif
	va_end( args);

	char *start = buf, *cur = buf;
	while (*cur) {
		if (*cur < 17) {
			char ch = *cur;
			*cur = 0;
			*this << start;
			start = cur + 1;
			*this << ch;
		}
		cur++;
	}
	
	*this << start;
}

//MFT
//void Display::thetime( void) {
//	struct tm *t; time_t p;
//
//	p = time( NULL);
//	t = localtime( &p);
//
//	print( "%.02d:%.02d:%.02d", t->tm_hour, t->tm_min, t->tm_sec);
//}

Display &Display::operator<<( const char *text) {
	if (!text || (!*text))
		return *this;

	struct sEvents *tmp = new sEvents;
	struct sEvents *tmp2 = NULL;

	tmp->eventtype = EVENT_STRING;
	tmp->data = new char[strlen( text) + 1];
	strcpy( (char *)tmp->data, text);

	lock();
	if (dispQ->size() > MAXENQUEUE) {
		tmp2 = dispQ->front();
		dispQ->pop();
	}
	dispQ->push( tmp);
	unlock();

	if (tmp2)
		dispose( tmp2);

	return *this;
}

Display &Display::operator<<( char ch) {
	struct sEvents *tmp  = new sEvents;
	struct sEvents *tmp2 = NULL;

	tmp->eventtype = EVENT_STRING;
	tmp->data = new char[2];
	((char *)tmp->data)[0] = ch;
	((char *)tmp->data)[1] = 0;

	lock();
	if (dispQ->size() > MAXENQUEUE) {
		tmp2 = dispQ->front();
		dispQ->pop();
	}
	dispQ->push( tmp);
	unlock();

	if (tmp2)
		dispose( tmp2);

	return *this;
}

void Display::dispose( sEvents *event) {
	switch( event->eventtype) {
		case EVENT_STRING:
			delete (char *)event->data;
			break;
		default:
			break;
	}
	delete event;
}

Display &Display::operator<<( int i) {
  print( "%d", i);
  return *this;
}

Display &Display::operator<<( unsigned int i) {
  print( "%u", i);
  return *this;
}

void Display::hexdump( int len, char *buf) {
	char mybuf[ 256];

	int i, offset, stop; unsigned char *p;
 
	for (offset = 0; offset < len; offset += 16) {
 
		// Offset
			sprintf( mybuf, "  %04X   ", offset);
			*this << mybuf;
 
		// Adjust start
			p = (unsigned char *)&buf[offset];
			stop = ((offset + 16) > len) ? len - offset : 16;
 
		// Drop numbers
			for (i = 0; i < stop; i++) {
				if (i == 8)
					*this << "- ";
				sprintf( mybuf, "%02X ", p[i]);
				*this << mybuf;
			}
 
		// Fill
			while (i < 16) {
				if (i++ == 8)
					*this << "- ";
				*this << "   ";
			}
 
		// Space
			*this << "  ";

		// Drop characters
		    for (i = 0; i < stop; i++) 
				if (isgraph(p[i])) {
					sprintf( mybuf, "%c", p[i]);
					*this << mybuf;
				} else {
					if (p[i] == ' ')
						*this << " ";
					else
					*this << ".";
				}

		// Finish
			*this << endl;
	}
}

void Display::setBanner( char *left, char *right) {
  if (background) return;

  #ifdef _DOS_
    window( 1, 1, 80, 50);
  
    textbackground( 1);
    *this << left;

    int len = strlen( right);
    for (;(wherex() < (80 - len));)
      *this << " ";

    gotoxy( 80 - len, 1);
    *this << right << " ";

    window( 1, 2, 80, 50);
    textbackground( 0);
    gotoxy( 1, 1);
  #endif
}

void Display::addUser( char *username, int latency, u32 client, u32 flags) {
}

void Display::delUser( char *username) {
}

void Display::clearUsers( void) {
}

void Display::focus( void) {
}

void Display::lock( void) {
	pthread_mutex_lock( &display_lock);
}

void Display::unlock( void) {
	pthread_mutex_unlock( &display_lock);
}
