#ifndef DISPLAY_H
#define DISPLAY_H

#include "types.h"
#include "config.h"
#include <pthread.h>
#include <queue>

#ifndef BUFSIZE
  #define BUFSIZE 4096
#endif

#ifndef endl
  #define endl (char)16
#endif

#define EVENT_CLS    1
#define EVENT_STRING 2

struct sEvents {
	int eventtype;
	void *data;
};

class Display {
private:
	int MAXENQUEUE;
	int enterstate;

	//MFT
	//int curcolor;

	void dispose( sEvents *);

public:
	pthread_mutex_t display_lock;

	std::queue< sEvents *> *dispQ;
	int background;

	Display( void);
	Display( int _display);
	Display( char *banner);
	~Display( void);

	virtual void cls( void);
	//MFT
	//void clrline( void);
	virtual void print( char *str, ... );

	//MFT
	//void thetime( void);

	void hexdump( int len, char *buf);

    Display& operator<<( const char *text);
    Display& operator<<( char ch);
    Display& operator<<( int i);
    Display& operator<<( unsigned int i);

    void setBanner( char *left, char *right);

    virtual void addUser( char *username, int latency, u32 client, u32 flags);
    virtual void delUser( char *username);

    void clearUsers( void);
    void focus( void);

	//===
	// Available in all threads.
		void lock( void);
		void unlock( void);

private:
	void init( void);
};

#endif
