static unsigned char des_pc2row(int byte1, int bit1, int byte2, int bit2, int byte3, int bit3, int byte4, int bit4, int byte5, int bit5, int byte6, int bit6, unsigned char *main_key)
{
  return (unsigned char)((((main_key[byte1] >> bit1) & 1) << 5) +
         (((main_key[byte2] >> bit2) & 1) << 4) +
         (((main_key[byte3] >> bit3) & 1) << 3) +
         (((main_key[byte4] >> bit4) & 1) << 2) +
         (((main_key[byte5] >> bit5) & 1) << 1) +
         (((main_key[byte6] >> bit6) & 1)));
}

static void des_prow(int byte1, int bit1, int byte2, int bit2, int byte3, int bit3, int byte4, int bit4, int value, unsigned char *block)
{
  block[byte1] |= ((value >> 3) & 1) << bit1;
  block[byte2] |= ((value >> 2) & 1) << bit2;
  block[byte3] |= ((value >> 1) & 1) << bit3;
  block[byte4] |= ((value     ) & 1) << bit4;
}

unsigned char *des(unsigned char input[8], unsigned char des_key[7], int encrypt)
{
  static unsigned char sbox1[] =
      { 0xE, 0x0, 0x4, 0xF, 0xD, 0x7, 0x1, 0x4, 0x2, 0xE, 0xF, 0x2, 0xB, 0xD, 0x8, 0x1,
        0x3, 0xA, 0xA, 0x6, 0x6, 0xC, 0xC, 0xB, 0x5, 0x9, 0x9, 0x5, 0x0, 0x3, 0x7, 0x8,
        0x4, 0xF, 0x1, 0xC, 0xE, 0x8, 0x8, 0x2, 0xD, 0x4, 0x6, 0x9, 0x2, 0x1, 0xB, 0x7,
        0xF, 0x5, 0xC, 0xB, 0x9, 0x3, 0x7, 0xE, 0x3, 0xA, 0xA, 0x0, 0x5, 0x6, 0x0, 0xD };
  static unsigned char sbox2[] =
      { 0xF, 0x3, 0x1, 0xd, 0x8, 0x4, 0xe, 0x7, 0x6, 0xf, 0xb, 0x2, 0x3, 0x8, 0x4, 0xe,
        0x9, 0xc, 0x7, 0x0, 0x2, 0x1, 0xd, 0xa, 0xc, 0x6, 0x0, 0x9, 0x5, 0xb, 0xa, 0x5,
        0x0, 0xd, 0xe, 0x8, 0x7, 0xa, 0xb, 0x1, 0xa, 0x3, 0x4, 0xf, 0xd, 0x4, 0x1, 0x2,
        0x5, 0xb, 0x8, 0x6, 0xc, 0x7, 0x6, 0xc, 0x9, 0x0, 0x3, 0x5, 0x2, 0xe, 0xf, 0x9 };
  static unsigned char sbox3[] =
      { 0xa, 0xd, 0x0, 0x7, 0x9, 0x0, 0xe, 0x9, 0x6, 0x3, 0x3, 0x4, 0xf, 0x6, 0x5, 0xa,
        0x1, 0x2, 0xd, 0x8, 0xc, 0x5, 0x7, 0xe, 0xb, 0xc, 0x4, 0xb, 0x2, 0xf, 0x8, 0x1,
        0xd, 0x1, 0x6, 0xa, 0x4, 0xd, 0x9, 0x0, 0x8, 0x6, 0xf, 0x9, 0x3, 0x8, 0x0, 0x7,
        0xb, 0x4, 0x1, 0xf, 0x2, 0xe, 0xc, 0x3, 0x5, 0xb, 0xa, 0x5, 0xe, 0x2, 0x7, 0xc };
  static unsigned char sbox4[] =
      { 0x7, 0xd, 0xd, 0x8, 0xe, 0xb, 0x3, 0x5, 0x0, 0x6, 0x6, 0xf, 0x9, 0x0, 0xa, 0x3,
        0x1, 0x4, 0x2, 0x7, 0x8, 0x2, 0x5, 0xc, 0xb, 0x1, 0xc, 0xa, 0x4, 0xe, 0xf, 0x9,
        0xa, 0x3, 0x6, 0xf, 0x9, 0x0, 0x0, 0x6, 0xc, 0xa, 0xb, 0x1, 0x7, 0xd, 0xd, 0x8,
        0xf, 0x9, 0x1, 0x4, 0x3, 0x5, 0xe, 0xb, 0x5, 0xc, 0x2, 0x7, 0x8, 0x2, 0x4, 0xe };
  static unsigned char sbox5[] =
      { 0x2, 0xe, 0xc, 0xb, 0x4, 0x2, 0x1, 0xc, 0x7, 0x4, 0xa, 0x7, 0xb, 0xd, 0x6, 0x1,
        0x8, 0x5, 0x5, 0x0, 0x3, 0xf, 0xf, 0xa, 0xd, 0x3, 0x0, 0x9, 0xe, 0x8, 0x9, 0x6,
        0x4, 0xb, 0x2, 0x8, 0x1, 0xc, 0xb, 0x7, 0xa, 0x1, 0xd, 0xe, 0x7, 0x2, 0x8, 0xd,
        0xf, 0x6, 0x9, 0xf, 0xc, 0x0, 0x5, 0x9, 0x6, 0xa, 0x3, 0x4, 0x0, 0x5, 0xe, 0x3 };
  static unsigned char sbox6[] =
      { 0xc, 0xa, 0x1, 0xf, 0xa, 0x4, 0xf, 0x2, 0x9, 0x7, 0x2, 0xc, 0x6, 0x9, 0x8, 0x5,
        0x0, 0x6, 0xd, 0x1, 0x3, 0xd, 0x4, 0xe, 0xe, 0x0, 0x7, 0xb, 0x5, 0x3, 0xb, 0x8,
        0x9, 0x4, 0xe, 0x3, 0xf, 0x2, 0x5, 0xc, 0x2, 0x9, 0x8, 0x5, 0xc, 0xf, 0x3, 0xa,
        0x7, 0xb, 0x0, 0xe, 0x4, 0x1, 0xa, 0x7, 0x1, 0x6, 0xd, 0x0, 0xb, 0x8, 0x6, 0xd };
  static unsigned char sbox7[] =
      { 0x4, 0xd, 0xb, 0x0, 0x2, 0xb, 0xe, 0x7, 0xf, 0x4, 0x0, 0x9, 0x8, 0x1, 0xd, 0xa,
        0x3, 0xe, 0xc, 0x3, 0x9, 0x5, 0x7, 0xc, 0x5, 0x2, 0xa, 0xf, 0x6, 0x8, 0x1, 0x6,
        0x1, 0x6, 0x4, 0xb, 0xb, 0xd, 0xd, 0x8, 0xc, 0x1, 0x3, 0x4, 0x7, 0xa, 0xe, 0x7,
        0xa, 0x9, 0xf, 0x5, 0x6, 0x0, 0x8, 0xf, 0x0, 0xe, 0x5, 0x2, 0x9, 0x3, 0x2, 0xc };
  static unsigned char sbox8[] =
      { 0xd, 0x1, 0x2, 0xf, 0x8, 0xd, 0x4, 0x8, 0x6, 0xa, 0xf, 0x3, 0xb, 0x7, 0x1, 0x4,
        0xa, 0xc, 0x9, 0x5, 0x3, 0x6, 0xe, 0xb, 0x5, 0x0, 0x0, 0xe, 0xc, 0x9, 0x7, 0x2,
        0x7, 0x2, 0xb, 0x1, 0x4, 0xe, 0x1, 0x7, 0x9, 0x4, 0xc, 0xa, 0xe, 0x8, 0x2, 0xd,
        0x0, 0xf, 0x6, 0xc, 0xa, 0x9, 0xd, 0x0, 0xf, 0x3, 0x3, 0x5, 0x5, 0x6, 0x8, 0xb };
        
  static unsigned char shift[] = { 1,1,2,2,2,2,2,2,1,2,2,2,2,2,2,1 };
  unsigned char *output = input, sub6[8], block[4];
  int i, j, carry, value, round;

  
  for (round = 0; round <= 15; round++)
  {
    /* Shift main key (if operating in "encrypt" mode) */
  
    if (encrypt)
      for (i = 1; i<= shift[round]; i++)
      {
        carry = 0;
        for (j=6; j>=0; j--)
        {
          value = des_key[j] >> 7;
          des_key[j] = (unsigned char)(((des_key[j] << 1) + carry) & 0xff);
          carry = value;
        }
        if (des_key[3] & 0x10)
          des_key[6] |= 1;
        des_key[3] &= 0xef;
        des_key[3] |= carry << 4;
      }
  
    /* Permuted Choice 2 */
  
    sub6[0] = des_pc2row(1,2, 2,7, 1,5, 2,0, 0,7, 0,3, des_key);
    sub6[1] = des_pc2row(0,5, 3,4, 1,1, 0,2, 2,3, 1,6, des_key);
    sub6[2] = des_pc2row(2,1, 2,5, 1,4, 0,4, 3,6, 0,0, des_key);
    sub6[3] = des_pc2row(1,0, 0,1, 3,5, 2,4, 1,3, 0,6, des_key);
    sub6[4] = des_pc2row(5,7, 6,4, 3,1, 4,3, 5,1, 6,1, des_key);
    sub6[5] = des_pc2row(3,2, 4,0, 6,5, 5,3, 4,7, 5,0, des_key);
    sub6[6] = des_pc2row(5,4, 6,7, 4,1, 6,0, 4,6, 6,3, des_key);
    sub6[7] = des_pc2row(5,2, 5,6, 6,6, 4,4, 3,3, 3,0, des_key);
    
    /* DES Round [E-Bit, S-Box lookup, P Permutation] */
  
    for (i=0; i<=3; i++)
      block[i] = 0x00;

    /* E-Bit row 1: R[32], R[1..5], P Permutation: [2.7], [3.7], [3.1], [4.1] */
  
    value = ((output[7] & 1) << 5) + ((output[4] >> 3) & 0x1f);
    value = sbox1[(value ^ sub6[0]) & 0x3f];
    des_prow(1,7, 2,7, 2,1, 3,1, value, block);
    
    /* E-Bit row 2: R[4..9],        P Permutation: [2.3], [4.4], [1.6], [3.6] */
  
    value = ((output[4] & 0x1f) << 1) + ((output[5] >> 7) & 1);
    value = sbox2[(value ^ sub6[1]) & 0x3f];
    des_prow(1,3, 3,4, 0,6, 2,6, value, block);
  
    /* E-Bit row 3: R[8..13],       P Permutation: [3.0], [2.0], [4.2], [1.2] */
  
    value = ((output[4] & 1) << 5) + ((output[5] >> 3) & 0x1f);
    value = sbox3[(value ^ sub6[2]) & 0x3f];
    des_prow(2,0, 1,0, 3,2, 0,2, value, block);
  
    /* E-Bit row 4: R[12..17],      P Permutation: [4.6], [3.4], [2.6], [1.7] */
  
    value = ((output[5] & 0x1f) << 1) + ((output[6] >> 7) & 1);
    value = sbox4[(value ^ sub6[3]) & 0x3f];
    des_prow(3,6, 2,4, 1,6, 0,7, value, block);
  
    /* E-Bit row 5: R[16..21],      P Permutation: [1.0], [2.2], [4.7], [1.5] */
  
    value = ((output[5] & 1) << 5) + ((output[6] >> 3) & 0x1f);
    value = sbox5[(value ^ sub6[4]) & 0x3f];
    des_prow(0,0, 1,2, 3,7, 0,5, value, block);
  
    /* E-Bit row 6: R[20..25],      P Permutation: [1.4], [4.3], [2.5], [3.5] */
  
    value = ((output[6] & 0x1f) << 1) + ((output[7] >> 7) & 1);
    value = sbox6[(value ^ sub6[5]) & 0x3f];
    des_prow(0,4, 3,3, 1,5, 2,5, value, block);
  
    /* E-Bit row 7: R[24..29],      P Permutation: [4.0], [2.4], [3.2], [1.1] */
  
    value = ((output[6] & 1) << 5) + ((output[7] >> 3) & 0x1f);
    value = sbox7[(value ^ sub6[6]) & 0x3f];
    des_prow(3,0, 1,4, 2,2, 0,1, value, block);
  
    /* E-Bit row 8: R[28..32], R[1],P Permutation: [1.3], [4.5], [2.1], [3.3] */
  
    value = ((output[7] & 0x1f) << 1) + ((output[4] >> 7) & 1);
    value = sbox8[(value ^ sub6[7]) & 0x3f];
    des_prow(0,3, 3,5, 1,1, 2,3, value, block);
    
    for (i=0; i<=3; i++)
      block[i] ^= output[i];
  
    for (i=0; i<=3; i++)
      output[i] = output[i+4];
  
    for (i=0; i<=3; i++)
      output[i+4] = block[i];

    /* Shift main key (if operating in "decrypt" mode) */
  
    if (!encrypt)
      for (i = 1; i<= shift[15-round]; i++)
      {
        carry = 0;
        for (j=0; j<=6; j++)
        {
          value = des_key[j] & 1;
          des_key[j] = (unsigned char)(((des_key[j] >> 1) + carry) & 0xff);
          carry = value << 7;
        }
        if (des_key[3] & 0x08)
          des_key[0] |= 0x80;
        des_key[3] &= 0xf7;
        des_key[3] |= carry >> 4;
      }
  }
  
  /* Swap halves */
  
  for (i=0; i<=3; i++)
    block[i] = output[i];
  for (i=0; i<=3; i++)
    output[i] = output[i+4];
  for (i=0; i<=3; i++)
    output[i+4] = block[i];
  return output;
}

