// Encryption.h: interface for the Encryption class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENCRYPTION_H__B692D4F1_4898_4C12_9351_5B26BB51B005__INCLUDED_)
#define AFX_ENCRYPTION_H__B692D4F1_4898_4C12_9351_5B26BB51B005__INCLUDED_

#include "rsa/rsa.hpp"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <map>
#include <string>
#include "pubkey.h"
#include "deskey.h"
#include "rsa/vlong.hpp"	// Added by ClassView

#pragma warning(disable:4786)

class Encryption  
{
public:
	static std::string hex(const std::string &data);
	static std::string encrypttext(const std::string &txt, const PubKey &target);
	static bool importpublic(const std::string &rdata, public_key &key);
	static bool importpublic(const std::string &rdata, PubKey &key);
	static bool BERGetInteger(std::string &data, vlong& n);
	static int BERGetLength(std::string& data);
	static bool importprivate(const std::string& data, private_key& key);
	bool importprivate(const std::string& data);
	private_key ownkey;
	Encryption();
	virtual ~Encryption();
	typedef std::multimap<unsigned, PubKey> KeyRing;
	KeyRing keyring;
	typedef std::multimap<unsigned, DesKey> DesKeys;
	DesKeys deskeys;
	enum resulttype {
		DES		= 0x00010000, 
		RSA		= 0x00020000, 
		SIGNED	= 0x00040000, 
		KEY		= 0x00100000, 
		TEXT	= 0x00200000, 
		CRYPTOERROR	= 0xFFFF, 
		BADVERSION	= 0x0001, 
		NOKEY		= 0x0002, 
		UNSUPPORTED	= 0x0004, 
		BADLENGTH	= 0x0008, 
		UNKNOWNERROR= 0x8000, 
		CRYPTOOK	= 0x0000
	};
	enum { 
		DESDECRYPTED = DES, 
		RSADECRYPTED = RSA, 
		CRYPTOVERSION = 0xe0
	};
	int process(const std::string &encrypted, const std::string &user, std::string &result, PubKey *&signer);
	static std::string xbase64(const std::string &data);
	static std::string xdebase64(const std::string &data);
	static std::string dehex(const std::string &data);
	static std::string encrypttext(const std::string &txt, const DesKey &target);
	static std::string encryptkey(const DesKey & key, const PubKey & target);
};

#endif // !defined(AFX_ENCRYPTION_H__B692D4F1_4898_4C12_9351_5B26BB51B005__INCLUDED_)
