// PubKey.cpp: implementation of the PubKey class.
//
//////////////////////////////////////////////////////////////////////

#include "pubkey.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PubKey::PubKey()
{

}

PubKey::~PubKey()
{

}

PubKey::PubKey(const PubKey & other) : owner(other.owner)
{
	key = other.key;
}

bool PubKey::encrypt(const std::string &data, std::string &result) const
{
	if(data.length() > 123)
		return false;
	result = std::string("\x00\x00\x00\x00", 4);
	result.reserve(128);
	result += char(data.length());
	result += data;
	result.resize(128, 0);
	vlong plain;
	plain.load(result.c_str(), 128);	
	vlong cipher = key.encrypt(plain);
	char buffer[165];
	int len = cipher.save(buffer, 165);
	if(len < 128) {
		memmove(buffer+128-len, buffer, len);
		memset(buffer, 0, 128-len);
	}
	result = std::string(buffer, 128);
	return true;
}

bool PubKey::decrypt(const std::string &data, std::string &result, const private_key & pkey)
{
	if(data.length() != 128)
		return false;
	vlong cipher;
	cipher.load(data.c_str(), 128);	
	vlong plain = pkey.decrypt(cipher);
	char buffer[164];
	int len = plain.save(buffer, 164);
	if(len < 128) {
		memmove(buffer+128-len, buffer, len);
		memset(buffer, 0, 128-len);
	}
	if(memcmp(buffer, "\x0\x0\x0\x0", 4) || (unsigned char)buffer[4] > 123)
		return false;
	result = std::string(buffer + 5, (unsigned char)buffer[4]);
	return true;
}
