#ifndef ENQUEUE_H
#define ENQUEUE_H

#include <pthread.h>
#include "bot.h"

class Bot;

#define ENQUEUE_LEVELS 8
	// Level 0: /ban
	// Level 1: /kick /unban
	// Level 2: Local commands
	// Level 3: A queued non-queued message. >;-)
	//          Things that need to be responsive.
	// Level 5: 
	// Level 6: Non-authorized users commands.
	//          !help, !version, etc...
	// Level 7: Non-queued messages. Example would be
	//          a channel welcome message. It is not
	//          important if we actually welcome them.
	//          If we are busy - why waste the time?

#define ENQUEUE_DEPTH 2000
	// I don't see why we would want to enqueue more then
	// 2000 lines. It would be too laggy anyhow.

struct sMessage {
	int lvl;
	char *buf;
};

struct sQueue {
	struct sQueue *next;
	char *buf;
};

struct sHandlers {
	struct sHandlers *next;
	Bot    *bot;
};

class Enqueue {
private:
	struct sQueue *first[ ENQUEUE_LEVELS - 1];
	struct sQueue *last[ ENQUEUE_LEVELS - 1];
	int depth[ ENQUEUE_LEVELS - 1];

	int deQueue( struct sMessage *);
	int enQueue( struct sMessage *);

	pthread_mutex_t enqueue_mutex;

public:
	struct sHandlers *handlers;

	Enqueue( void);
	~Enqueue( void);

	virtual int addHandler( Bot *bot);
	int deleteHandler( Bot *bot);

	int delqueue( void);
	int enqueue( int lvl, char *str, ...);

	int idle( void);
};

#endif
