#include "config.h"

#ifdef DISP_GTK
  #include <gtk/gtk.h>
  // #include <gnome.h>
  #include "logo1.xpm"
#endif

#include "gtk_about.h"
#include "support.h"

#ifdef DISP_GTK
void gtk_about_on_destroy( GtkButton *button, gpointer user_data) {
  delete (Gtk_About *)user_data;
}

void gtk_about_on_button1_clicked( GtkButton *button, gpointer user_data) {
  gtk_object_destroy( (GtkObject *)((Gtk_About *)user_data)->dialog1);
  // delete (Gtk_About *)user_data;
}
#endif

Gtk_About::Gtk_About( Gtk_Main *_parent) {
  parent = _parent;
  #ifdef WIN32
    return;
  #endif

  #ifdef DISP_GTK
  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "zDSBot3 - About");
  gtk_window_set_default_size (GTK_WINDOW (dialog1), 183, 161);
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  //
  {
    GdkBitmap *mask;
    GdkColormap *colormap = gtk_widget_get_colormap ( (GtkWidget *)dialog1);
    GdkPixmap *gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d( NULL, colormap, &mask,NULL,logo1_xpm);
    pixmap1 = gtk_pixmap_new( gdkpixmap, mask);
    gdk_pixmap_unref( gdkpixmap); 
    gdk_bitmap_unref( mask);
  }
  //
  // pixmap1 = // create_pixmap (dialog1, "logo1.xpm");

  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), pixmap1, TRUE, TRUE, 2);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  // button1 = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  button1 = gtk_button_new_with_label( "Sweet!");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (dialog1), "destroy",
                      GTK_SIGNAL_FUNC (gtk_about_on_destroy),
                      this);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (gtk_about_on_button1_clicked),
                      this);


  gtk_widget_show ( dialog1);
  #endif
}

Gtk_About::~Gtk_About( void) {
  parent->gtk_about = 0;
}

void Gtk_About::focus( void) {
  #ifdef DISP_GTK
    gtk_window_activate_focus( (GtkWindow *)dialog1);
  #endif
}
