#include "config.h"
#ifdef DISP_GTK
  #include <gtk/gtk.h>
  //#include <gnome.h>
#endif

#include "gtk_log.h"
#include "support.h"

#ifdef DISP_GTK
void gtk_log_on_destroy( GtkButton *button, gpointer user_data) {
  delete (Gtk_Log *)user_data;
}

void gtk_log_on_button1_clicked( GtkButton *button, gpointer user_data) {
  gtk_object_destroy( (GtkObject *)((Gtk_Log *)user_data)->window1);
}
#endif

Gtk_Log::Gtk_Log( Gtk_Main *_parent) {
  parent = _parent;

  #ifdef DISP_GTK
  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "zDSBot3 - Log - by Eurijk!");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), text1);

  button1 = gtk_button_new_with_label ("Close");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (vbox1), button1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (window1), "destroy",
                      GTK_SIGNAL_FUNC (gtk_log_on_destroy),
                      this);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (gtk_log_on_button1_clicked),
                      this);


  gtk_widget_show ( window1);
  #endif
}

Gtk_Log::~Gtk_Log( void) {
  parent->gtk_log = 0;
}

void Gtk_Log::focus( void) {
  #ifdef DISP_GTK
  gtk_window_activate_focus( (GtkWindow *)window1);
  #endif
}
