#include "config.h"

#ifdef DISP_GTK
  #include <gtk/gtk.h>
#endif
#include <string.h>
#include "gtk_main.h"
// #include "gtk_about.h"
#include "wndabout.h"
#include "gtk_userlist.h"
#include "gtk_log.h"
#include "botlist.h"
#include "display.h"
#include "globals.h"
#include "tools/build.h"

extern BotList botlist;
extern Display *disp;

#ifdef DISP_GTK
  void on_main_on_destroy_event( GtkButton *button, gpointer user_data) {
    gtk_main_quit();
    globals->done++;
  }

  void gtk_main_ctree_select_row( GtkCTree *ctree, GList *node, gint column, gpointer user_data) {

//    sBotList *tmp = botlist.first;
//    while (tmp) {
//      if (tmp->data)
//        if (tmp->data->getProxy()->getNode() == (GtkCTreeNode *)node)
//          tmp->data->focus();
//      tmp = tmp->next;
//    }
  
  }

  void gtk_main_on_button1_clicked( GtkButton *button, gpointer user_data) {
  }

  void gtk_main_on_button3_clicked( GtkButton *button, gpointer user_data) {
    if (!((Gtk_Main *)user_data)->gtk_userlist)
      ((Gtk_Main *)user_data)->gtk_userlist = new Gtk_UserList( (Gtk_Main *)user_data);
    else
      ((Gtk_Main *)user_data)->gtk_userlist->focus();
  }

  void gtk_main_on_button5_clicked( GtkButton *button, gpointer user_data) {
    if (!((Gtk_Main *)user_data)->gtk_log)
      ((Gtk_Main *)user_data)->gtk_log = new Gtk_Log( (Gtk_Main *)user_data);
    else
      ((Gtk_Main *)user_data)->gtk_log->focus();
  }

  // If they wanna make 293874923874 of em, let em
  void gtk_main_on_button6_clicked( GtkButton *button, gpointer user_data) {
    new WndAbout();
    //if (!((Gtk_Main *)user_data)->gtk_about)
    //  ((Gtk_Main *)user_data)->gtk_about = new Gtk_About( (Gtk_Main *)user_data);
    //else
    //  ((Gtk_Main *)user_data)->gtk_about->focus();
  }
#endif

Gtk_Main::Gtk_Main( void) {
  proxylist = new ProxyList( this);

  #ifdef DISP_GTK
    gtk_userlist = 0;
    gtk_about = 0;
    gtk_log = 0;

    window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
    char buf[ 256];
    sprintf( buf, "zDSBot3 (build %d) - by Eurijk!", BUILD);
    gtk_window_set_title (GTK_WINDOW (window1), buf);
    gtk_window_set_default_size( (GtkWindow *)window1, 600, 250);

    vbox1 = gtk_vbox_new (FALSE, 0);
    gtk_widget_ref (vbox1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (vbox1);
    gtk_container_add (GTK_CONTAINER (window1), vbox1);

    toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
    gtk_widget_ref (toolbar1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "toolbar1", toolbar1,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (toolbar1);
    gtk_box_pack_start (GTK_BOX (vbox1), toolbar1, FALSE, FALSE, 0);

    toolbar3 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
    gtk_widget_ref (toolbar3);
    gtk_object_set_data_full (GTK_OBJECT (window1), "toolbar3", toolbar3,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (toolbar3);
    gtk_box_pack_start (GTK_BOX (vbox1), toolbar3, FALSE, FALSE, 0);

    button3 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                  GTK_TOOLBAR_CHILD_BUTTON,
                                  0,
                                  "UserDB",
                                  0, 0, 
                                  0, 0, 0);
      gtk_widget_ref (button3);
    gtk_object_set_data_full (GTK_OBJECT (window1), "button3", button3,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (button3);
  
    button4 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                  GTK_TOOLBAR_CHILD_BUTTON,
                                  0,
                                  "Proxies",
                                  0, 0,  
                                  0, 0, 0);
    gtk_widget_ref (button4);
    gtk_object_set_data_full (GTK_OBJECT (window1), "button4", button4,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (button4);
  
    button5 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                  GTK_TOOLBAR_CHILD_BUTTON,
                                  0,
                                  "Log",
                                  0, 0,
                                  0, 0, 0);
    gtk_widget_ref (button5);
    gtk_object_set_data_full (GTK_OBJECT (window1), "button5", button5,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (button5);
  
    button6 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                  GTK_TOOLBAR_CHILD_BUTTON,
                                  0,
                                  "About",
                                  0, 0,
                                  0, 0, 0);
    gtk_widget_ref (button6);
    gtk_object_set_data_full (GTK_OBJECT (window1), "button6", button5,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (button6);


    vbox3 = gtk_vbox_new (FALSE, 0);
    gtk_widget_ref (vbox3);
    gtk_object_set_data_full (GTK_OBJECT (window1), "vbox3", vbox3,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (vbox3);
    gtk_box_pack_start (GTK_BOX (vbox1), vbox3, TRUE, TRUE, 0);
  
    scrolledwindow1 = gtk_scrolled_window_new (0, 0);
    gtk_widget_ref (scrolledwindow1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (scrolledwindow1);
    gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow1, TRUE, TRUE, 0);
  
    ctree1 = gtk_ctree_new (6, 0);
    gtk_widget_ref (ctree1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "ctree1", ctree1,
                              (GtkDestroyNotify) gtk_widget_unref);  
    gtk_widget_show (ctree1);
    gtk_container_add (GTK_CONTAINER (scrolledwindow1), ctree1);
    gtk_clist_set_column_width (GTK_CLIST (ctree1), 0, 80);
    gtk_clist_set_column_width (GTK_CLIST (ctree1), 1, 80);
    gtk_clist_set_column_width (GTK_CLIST (ctree1), 2, 80);
    gtk_clist_set_column_width (GTK_CLIST (ctree1), 3, 80);
    gtk_clist_set_column_width (GTK_CLIST (ctree1), 4, 80);
    gtk_clist_set_column_width (GTK_CLIST (ctree1), 5, 80);
    gtk_clist_column_titles_show (GTK_CLIST (ctree1));
  
    label7 = gtk_label_new ("Bot");
    gtk_widget_ref (label7);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label7", label7,
                              (GtkDestroyNotify) gtk_widget_unref);  
    gtk_widget_show (label7);
    gtk_clist_set_column_widget (GTK_CLIST (ctree1), 0, label7);
    gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

    label8 = gtk_label_new ("Channel");
    gtk_widget_ref (label8);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);  
    gtk_widget_show (label8);
    gtk_clist_set_column_widget (GTK_CLIST (ctree1), 1, label8);
    gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);

    label9 = gtk_label_new ("Server");
    gtk_widget_ref (label9);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);  
    gtk_widget_show (label9);
    gtk_clist_set_column_widget (GTK_CLIST (ctree1), 2, label9);
    gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);

    label10 = gtk_label_new ("Uptime");
    gtk_widget_ref (label10);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label10);
    gtk_clist_set_column_widget (GTK_CLIST (ctree1), 3, label10);

    label11 = gtk_label_new ("Recv");
    gtk_widget_ref (label11);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label11", label11,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label11);
    gtk_clist_set_column_widget (GTK_CLIST (ctree1), 4, label11);
  
    label12 = gtk_label_new ("Send");
    gtk_widget_ref (label12);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label12", label12,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label12);
    gtk_clist_set_column_widget (GTK_CLIST (ctree1), 5, label12);
  
    //button1 = gtk_button_new_with_label ("Add Bot");
    //gtk_widget_ref (button1);
    //gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
    //                          (GtkDestroyNotify) gtk_widget_unref);
    //gtk_widget_show (button1);
    //gtk_box_pack_start (GTK_BOX (vbox3), button1, FALSE, FALSE, 0);
    //button2 = gtk_button_new_with_label ("Del Bot");
    //gtk_widget_ref (button2);
    //gtk_object_set_data_full (GTK_OBJECT (window1), "button2", button2,
    //                          (GtkDestroyNotify) gtk_widget_unref);
    //gtk_widget_show (button2);
    //gtk_box_pack_start (GTK_BOX (vbox3), button2, FALSE, FALSE, 0);
  
    gtk_signal_connect (GTK_OBJECT (window1), "destroy",
                        GTK_SIGNAL_FUNC (on_main_on_destroy_event),
                        NULL);
  
    //gtk_signal_connect (GTK_OBJECT (button1), "clicked",
    //                    GTK_SIGNAL_FUNC (gtk_main_on_button1_clicked),
    //                    this);
    gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                        GTK_SIGNAL_FUNC (gtk_main_on_button3_clicked),
                        this);
  
    gtk_signal_connect (GTK_OBJECT (button5), "clicked",
                        GTK_SIGNAL_FUNC (gtk_main_on_button5_clicked),
                        this);
  
    gtk_signal_connect (GTK_OBJECT (button6), "clicked",
                        GTK_SIGNAL_FUNC (gtk_main_on_button6_clicked),
                        this);
  
    gtk_signal_connect (GTK_OBJECT(ctree1), "tree-select-row",
  		      GTK_SIGNAL_FUNC(gtk_main_ctree_select_row),
  		      this);
  
  
  
    gtk_widget_show (window1);
  #endif
}

Gtk_Main::~Gtk_Main( void) {
  #ifdef DISP_GTK
    // if (gtk_about) delete gtk_about;
    if (gtk_userlist) delete gtk_userlist;
    // gtk_object_destroy( (GtkObject *)window1);
  #endif

  delete proxylist;
}

ProxyList *Gtk_Main::getProxyList( void) {
  return( proxylist);
}

#ifdef DISP_GTK
  GtkCTree *Gtk_Main::getCTree( void) {
    return( (GtkCTree *)ctree1);
  }
#endif

void Gtk_Main::idle( void) {
  time_t tmp = time( 0);

  if (!(tmp - tv))
    return;
  tv = tmp;

  proxylist->idle();
}
