#include "config.h"

#ifdef DISP_GTK
  #include <gtk/gtk.h>
#endif

#include "gtk_profile.h"
#include "support.h"

#ifdef DISP_GTK
void gtk_profile_on_destroy( GtkButton *button, gpointer user_data) {
  delete (Gtk_Profile *)user_data;
}

void gtk_profile_on_button1_clicked( GtkButton *button, gpointer user_data) {
  gtk_object_destroy( (GtkObject *)((Gtk_Profile *)user_data)->wndProfile);
}
#endif

Gtk_Profile::Gtk_Profile( char *username, char *sex, char *age, char *loc, char *desc) {
  // parent = _parent;

  #ifdef DISP_GTK
		wndProfile = gtk_window_new (GTK_WINDOW_DIALOG);
		gtk_object_set_data (GTK_OBJECT (wndProfile), "wndProfile", wndProfile);
		gtk_container_set_border_width (GTK_CONTAINER (wndProfile), 2);
		gtk_window_set_title (GTK_WINDOW (wndProfile), "zDSBot3 - Profile");

		vbox2 = gtk_vbox_new (FALSE, 0);
		gtk_widget_ref (vbox2);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (vbox2);
		gtk_container_add (GTK_CONTAINER (wndProfile), vbox2);

		frame2 = gtk_frame_new (NULL);
		gtk_widget_ref (frame2);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (frame2);
		gtk_box_pack_start (GTK_BOX (vbox2), frame2, FALSE, TRUE, 0);
		gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);

		szName = gtk_label_new ( username);
		gtk_widget_ref (szName);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "szName", szName,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (szName);
		gtk_container_add (GTK_CONTAINER (frame2), szName);

		vbox3 = gtk_vbox_new (FALSE, 0);
		gtk_widget_ref (vbox3);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (vbox3);
		gtk_box_pack_start (GTK_BOX (vbox2), vbox3, TRUE, TRUE, 0);

		frame1 = gtk_frame_new (NULL);
		gtk_widget_ref (frame1);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (frame1);
		gtk_box_pack_start (GTK_BOX (vbox3), frame1, TRUE, TRUE, 0);
		gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

		table1 = gtk_table_new (4, 2, FALSE);
		gtk_widget_ref (table1);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (table1);
		gtk_container_add (GTK_CONTAINER (frame1), table1);

		label1 = gtk_label_new ("Sex:");
		gtk_widget_ref (label1);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (label1);
		gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
		gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);
		gtk_misc_set_padding (GTK_MISC (label1), 2, 2);

		label2 = gtk_label_new ("Age:");
		gtk_widget_ref (label2);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (label2);
		gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
		gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);
		gtk_misc_set_padding (GTK_MISC (label2), 2, 2);

		label3 = gtk_label_new ("Location:");
		gtk_widget_ref (label3);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (label3);
		gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
		gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);
		gtk_misc_set_padding (GTK_MISC (label3), 2, 2);

		label4 = gtk_label_new ("Desc:");
		gtk_widget_ref (label4);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (label4);
		gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
		gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);
		gtk_misc_set_padding (GTK_MISC (label4), 2, 2);

		scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
		gtk_widget_ref (scrolledwindow2);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (scrolledwindow2);
		gtk_table_attach (GTK_TABLE (table1), scrolledwindow2, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
		gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

		szLocation = gtk_text_new (NULL, NULL);
		gtk_text_insert( (GtkText *)szLocation, NULL, NULL, NULL, loc, strlen( loc));
		gtk_widget_ref (szLocation);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "szLocation", szLocation,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (szLocation);
		gtk_container_add (GTK_CONTAINER (scrolledwindow2), szLocation);

		scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
		gtk_widget_ref (scrolledwindow3);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_table_attach (GTK_TABLE (table1), scrolledwindow3, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	szAge = gtk_text_new (NULL, NULL);
	gtk_text_insert( (GtkText *)szAge, NULL, NULL, NULL, age, strlen( age));
	gtk_widget_ref (szAge);
	gtk_object_set_data_full (GTK_OBJECT (wndProfile), "szAge", szAge,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (szAge);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), szAge);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (wndProfile), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_table_attach (GTK_TABLE (table1), scrolledwindow4, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	szSex = gtk_text_new (NULL, NULL);
	gtk_text_insert( (GtkText *)szSex, NULL, NULL, NULL, sex, strlen( sex));
  gtk_widget_ref (szSex);
  gtk_object_set_data_full (GTK_OBJECT (wndProfile), "szSex", szSex,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (szSex);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), szSex);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (wndProfile), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_table_attach (GTK_TABLE (table1), scrolledwindow1, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

		szDesc = gtk_text_new (NULL, NULL);
		gtk_text_insert( (GtkText *)szDesc, NULL, NULL, NULL, desc, strlen( desc));
		gtk_widget_ref (szDesc);
		gtk_object_set_data_full (GTK_OBJECT (wndProfile), "szDesc", szDesc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (szDesc);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), szDesc);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (wndProfile), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox3), hseparator1, FALSE, TRUE, 2);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (wndProfile), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox2), hbuttonbox1, FALSE, TRUE, 2);

  bnSweet = gtk_button_new_with_label ("Sweet!");
  gtk_widget_ref (bnSweet);
  gtk_object_set_data_full (GTK_OBJECT (wndProfile), "bnSweet", bnSweet,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bnSweet);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), bnSweet);
  GTK_WIDGET_SET_FLAGS (bnSweet, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (hbuttonbox1), "button_press_event",
                      GTK_SIGNAL_FUNC (gtk_profile_on_button1_clicked),
                      this);

  gtk_signal_connect (GTK_OBJECT (wndProfile), "destroy",
                      GTK_SIGNAL_FUNC (gtk_profile_on_destroy),
                      this);
  
	gtk_widget_show ( wndProfile);
  #endif
}

Gtk_Profile::~Gtk_Profile( void) {
	//parent->gtk_about = 0;
}

void Gtk_Profile::focus( void) {
  #ifdef DISP_GTK
    gtk_window_activate_focus( (GtkWindow *)wndProfile);
  #endif
}
