#include "config.h"
#ifdef DISP_GTK
  #include <gtk/gtk.h>
  //#include <gnome.h>
#endif

#include "gtk_userlist.h"
#include "userlist.h"
#include "commandlist.h"
#include "display.h"
#include "user.h"

extern Display *disp;
extern CommandList commandlist;

#ifdef DISP_GTK
  void gtk_userlist_on_destroy( GtkButton *button, gpointer user_data) {
    delete (Gtk_UserList *)user_data;
  }

void gtk_userlist_on_select_row(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data) {
  Gtk_UserList *gtk_userlist = (Gtk_UserList *)user_data;

  gchar *username;
  gtk_clist_get_text( clist, row, 0, &username);
  if (!username) return;

  UserList *tmp = commandlist.getFirst()->userlist;
  if (!tmp) return;

  User *user = tmp->getUser( username);
  if (!user) return;

  gtk_entry_set_text( (GtkEntry *)gtk_userlist->entry3, (gchar *)user->getName());
  char buf[ 1024];
  sprintf( buf, "%d", user->getAccess()); gtk_entry_set_text( (GtkEntry *)gtk_userlist->entry4, (gchar *)buf);
  sprintf( buf, "%d", user->getFlags());  gtk_entry_set_text( (GtkEntry *)gtk_userlist->entry5, (gchar *)buf);

}
#endif

Gtk_UserList::Gtk_UserList( Gtk_Main *_parent) {
  parent = _parent;

  #ifdef DISP_GTK
  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "zDSBot3 - UserDB - by Eurijk!");
  gtk_window_set_default_size (GTK_WINDOW (window1), 478, 300);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_ref (hpaned1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hpaned1", hpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hpaned1);
  gtk_container_add (GTK_CONTAINER (window1), hpaned1);
  gtk_paned_set_position (GTK_PANED (hpaned1), 271);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_paned_pack1 (GTK_PANED (hpaned1), vbox2, FALSE, TRUE);

  table3 = gtk_table_new (5, 2, FALSE);
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_box_pack_start (GTK_BOX (vbox2), table3, FALSE, TRUE, 2);

  label17 = gtk_label_new ("Access:");
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_table_attach (GTK_TABLE (table3), label17, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label17), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label17), 2, 0);

  label18 = gtk_label_new ("Flags:");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_table_attach (GTK_TABLE (table3), label18, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label18), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label18), 2, 0);

  label19 = gtk_label_new ("Lastseen:");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_table_attach (GTK_TABLE (table3), label19, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label19), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label19), 2, 0);

  label20 = gtk_label_new ("Lastchan:");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_table_attach (GTK_TABLE (table3), label20, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label20), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label20), 2, 0);

  entry3 = gtk_entry_new ();
  gtk_widget_ref (entry3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry3", entry3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry3);
  gtk_table_attach (GTK_TABLE (table3), entry3, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  entry4 = gtk_entry_new ();
  gtk_widget_ref (entry4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry4", entry4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry4);
  gtk_table_attach (GTK_TABLE (table3), entry4, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  entry5 = gtk_entry_new ();
  gtk_widget_ref (entry5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry5", entry5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry5);
  gtk_table_attach (GTK_TABLE (table3), entry5, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  entry6 = gtk_entry_new ();
  gtk_widget_ref (entry6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry6", entry6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry6);
  gtk_table_attach (GTK_TABLE (table3), entry6, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  entry7 = gtk_entry_new ();
  gtk_widget_ref (entry7);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry7", entry7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry7);
  gtk_table_attach (GTK_TABLE (table3), entry7, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  label16 = gtk_label_new ("Username:");
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_table_attach (GTK_TABLE (table3), label16, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label16), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label16), 2, 0);

  label15 = gtk_label_new ("Last Message:");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (vbox2), label15, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), vbox3, FALSE, FALSE, 2);

  entry8 = gtk_entry_new ();
  gtk_widget_ref (entry8);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry8", entry8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry8);
  gtk_box_pack_start (GTK_BOX (vbox3), entry8, FALSE, FALSE, 2);

  label21 = gtk_label_new ("Shitlist Message:");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (vbox3), label21, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);

  entry9 = gtk_entry_new ();
  gtk_widget_ref (entry9);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry9", entry9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry9);
  gtk_box_pack_start (GTK_BOX (vbox3), entry9, FALSE, FALSE, 2);

  label14 = gtk_label_new ("User Info:");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_box_pack_start (GTK_BOX (vbox2), label14, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label14), GTK_JUSTIFY_LEFT);

  scrolledwindow2 = gtk_scrolled_window_new (0, 0);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow2, TRUE, TRUE, 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  text1 = gtk_text_new ( 0, 0);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), text1);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);   
  gtk_box_pack_start (GTK_BOX (vbox2), hbox1, FALSE, TRUE, 0);

  button3 = // gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
            gtk_button_new_with_label ("Apply");
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_box_pack_start (GTK_BOX (hbox1), button3, FALSE, TRUE, 0); 

  button4 = // gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
            gtk_button_new_with_label("Cancel");
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  gtk_box_pack_start (GTK_BOX (hbox1), button4, FALSE, TRUE, 0); 

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_paned_pack2 (GTK_PANED (hpaned1), vbox1, TRUE, TRUE);

  scrolledwindow1 = gtk_scrolled_window_new ( 0, 0);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 2);

  clist1 = gtk_clist_new (2);
  gtk_widget_ref (clist1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "clist1", clist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist1);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist1));

  label1 = gtk_label_new ("Username");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label1);

  label2 = gtk_label_new ("Access");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label2);

  button1 = gtk_button_new_with_label ("Add User");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (vbox1), button1, FALSE, FALSE, 2);

  button2 = gtk_button_new_with_label ("Delete User");
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_box_pack_start (GTK_BOX (vbox1), button2, FALSE, FALSE, 2);

  gtk_signal_connect (GTK_OBJECT (window1), "destroy",
                      GTK_SIGNAL_FUNC (gtk_userlist_on_destroy),
                      this);

  gtk_signal_connect (GTK_OBJECT (clist1), "select_row",
                      GTK_SIGNAL_FUNC (gtk_userlist_on_select_row),
                      this);

  gtk_widget_show( window1);

  #endif
  showUsers();

}

Gtk_UserList::~Gtk_UserList( void) {
  parent->gtk_userlist = 0;
  #ifdef DISP_GTK
    gtk_object_destroy( (GtkObject *)window1);
  #endif
}


void Gtk_UserList::showUsers( void) {
  if (!commandlist.getFirst()) {
    #ifdef DEBUGUSERLIST
      *disp << "DEBUGUSERLIST: commandlist.getFirst returned NULL" << endl;
    #endif
    return;
  }

  #ifdef DISP_GTK
  sUserList *tmp = commandlist.getFirst()->userlist->first;

  while (tmp) {
    if (tmp->data) {
      char *text[] = { "erm1", "erm2"};
      gint row = gtk_clist_append( (GtkCList *)clist1, text);
      gtk_clist_set_text( (GtkCList *)clist1, row, 0, tmp->data->getName());
      char buf[ 32];
      sprintf( buf, "%d", tmp->data->getAccess());
      gtk_clist_set_text( (GtkCList *)clist1, row, 1, buf);
    }
    tmp = tmp->next;
  }
  #endif
}


void Gtk_UserList::focus( void) {
  #ifdef DISP_GTK
    gtk_window_activate_focus( (GtkWindow *)window1);
  #endif
}
