//= zDSBot3 by Eurijk! blah blah blah >;-)

#ifdef WIN32
  // #include <conio.h>
  #include <io.h>
  #include <stdio.h>
  #include <windows.h>

  extern HWND hEnter;
#else
  #include <signal.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <termios.h>
  #include <unistd.h>
  #include <stdarg.h>
  // #include <iostream.h>
#endif

#include <iostream> // just for debug

#include "input.h"
#include "display.h"
#include "config.h"

extern Display *disp;
extern void kbd_handler( void);

Input::Input( int _background, void (fnct)(), void (fnct_tab)()) {
  background = _background;

  #ifndef WIN32
  #ifndef DISP_GTK
    if (!background) {
      {
        struct termios new_settings;
        tcgetattr(0,&savedtty);
        new_settings = savedtty;
        new_settings.c_lflag &= (~ECHO);
        new_settings.c_lflag &= (~ICANON);
        new_settings.c_cc[VTIME] = 0;
        new_settings.c_cc[VMIN] = 1;
        tcsetattr(0,TCSANOW,&new_settings);
      }

    }
  #endif
  #endif

  buf[0] = 0;
  handler_fnct = fnct;
  tab_fnct = fnct_tab;
  prompt = 0;
}


Input::~Input() {
  if (background)
    return;

  #ifndef WIN32
    #ifndef DISP_GTK
      tcsetattr(0, 0, &savedtty);
    #endif
  #endif
}


void Input::echo_on( void) {
  if (background)
    return;

  #ifndef WIN32
  #ifndef DISP_GTK
    struct termios attr;
  
    if (tcgetattr(STDIN_FILENO, &attr) != 0) return;
    attr.c_lflag |= ECHO;
    tcsetattr(STDIN_FILENO,TCSANOW,&attr);
  #endif
  #endif
}


void Input::echo_off( void) {
  if (background)
    return;

  #ifndef WIN32
  #ifndef DISP_GTK
    struct termios attr;

    if (tcgetattr(STDIN_FILENO, &attr) != 0) return;
    attr.c_lflag &= ~(ECHO);
    tcsetattr(STDIN_FILENO,TCSAFLUSH,&attr);
  #endif
  #endif
}


void Input::clear( void) {
  buf[0] = 0; // I think I like *buf = 0; better
}

void Input::handler( void) {
  char tmp[ 1024*16], *tmp2 = tmp;
  char ch; static int i = 0;

  #ifndef WIN32_NATIVE
    int n = read( 0, tmp, sizeof( tmp));
    if (n <= 0) return;
  #else
    int n = 0;

    GetWindowText( hEnter, buf, sizeof( buf) - 1);
    SetWindowText( hEnter, "");
    (handler_fnct)();
    return;
  #endif

  #ifndef WIN32_NATIVE
  while (n) {
    switch( ch = *tmp2++) { // getchar()) {
    #ifndef WIN32
      case '\n':
    #else
      case 13:
    #endif
        (handler_fnct)();
        i ^= i;
        break;
      case 0: // lamepoints++;
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
      case 27: break;
      case 7:
      case 9:
        if (tab_fnct)
          (tab_fnct)();
        break;
      case 8:
      case 127:
        if (i) {
          i--;
          buf[i] = 0;
          #ifdef WIN32_NATIVE
            gotoxy( wherex() - 1, wherey());
            *disp << " ";
            gotoxy( wherex() - 1, wherey());
          #else
            *disp << (char)27 << "[1D "
                 << (char)27 << "[1D";
          #endif
        }
        break;
      default:
        buf[i] = ch;
        if (i < BUFSIZE) i++;
        buf[i] = 0;
        *disp << ch;
    }
    n--;
  }
  #endif
}

char *Input::getbuf( void) {
  return( buf);
}


void Input::setbuf( char *msg) {
  strcpy( buf, msg);

  kbd_handler();
}

// TODO: Fix this !!!
void Input::update( void) {
  #ifndef DISP_GTK
    #ifndef WIN32_NATIVE
      disp->clrline();

      if (prompt)
        *disp << prompt;

      *disp << CBWHITE << "> "
            << CWHITE << getbuf();
    #endif
  #endif
}

void Input::setPrompt( char *buf) {
  prompt = buf;
}
