//=============================================================================
//= zDSBot3 - Eurijk!

#ifndef INPUT_H
#define INPUT_H

#ifndef BUFSIZE
  #define BUFSIZE 4096
#endif

#ifdef WIN32
#else
  #include <termios.h>
  #include <unistd.h>
#endif

class Input {
  private:
    int background;
  #ifndef WIN32
    struct termios savedtty;
  #endif
    void restoretty(void);
    void (*handler_fnct)();
    void (*tab_fnct)();

    char buf[BUFSIZE];
    char *prompt;
  protected:
    void echo_on( void);
    void echo_off( void);
  public:
    Input( int _background, void (fnct)(), void (fnct_tab)());
    ~Input();

    void clear();
    char *getbuf();
    void handler();
    void update();
    void setPrompt( char *buf);
    void setbuf( char *msg);
} ;

#endif
