#include "config.h"

#ifdef DISP_GTK
  #include <gtk/gtk.h>
#endif

#include "config.h"

#ifdef DISP_OPENGL
	#include "OpenGL/tgl.h"
#endif

#ifdef WIN32
  #include <io.h>
  #include <windows.h>
  #include <winsock.h>
  #include <time.h>
  #include <conio.h>
  #include <map.h>
#else
  #ifdef _LINUX_
    #include <netinet/in.h>
  #endif
  #include <sys/stat.h>
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <sys/time.h>
  #include <stdlib.h>
  #include <signal.h>
  #include <unistd.h>
  #include <stdio.h>
  #include <fcntl.h>
#endif

// #include <iostream>
#include <string.h>
#include <stdlib.h>


#include "tools/build.h"
#include "commandlist.h"
#include "display.h"
#include "botlist.h"
#include "bot.h"
#include "enqueue.h"
#include "input.h"
//#include "vars.h"
#include "mylib.h"
//#include "cas.h"
// #include "gtk_main.h"
#include "vercheck.h"

#include "globals.h"

//===
// Global variables!
	Globals *globals;
	CommandList commandlist;

struct Config {
  char *cmd;
  int  (*handler)( char *);
};

void sig_handler( int signum);

time_t LASTBOT = 0;

int a = 0;
#ifdef WIN32_NATIVE
  HBRUSH     g_hbrBackground = CreateSolidBrush(RGB(0, 0, 0));
  HWND hEdit = 0, hEnter = 0;
  HFONT font;
#endif
#ifdef WIN32
  const char g_szClassName[] = "zDSBot3";
  HWND mainWnd;
  HINSTANCE hInstance;
#endif

void kbd_handler( void);
void tab_handler( void);

//Input *input;
//Display *disp;
//#ifdef DISP_GTK
//  Gtk_Main *gtkmain;
//#endif

BotList botlist;
//Vars vars;
Enqueue enqueue;
//Cas cas;

sBotList *bot_current;

char *Encrypt(char *source) {
  static char dest[ 1024]; //char *dest = new char[256];M
        int pos = 1;
        dest[0] = strlen(source) + 64;
	int i;

        for(i = 0; i < (int)strlen(source); i++) {
                int tmp = rand() % 20 + 1;
		dest[pos++] = tmp + 100;
                dest[pos++] = (source[i] ^ tmp) + 63;
        }
	for(i = pos; i < 220; i++)
	        dest[i] = rand() % 180 + 60;
	dest[i] = 0;
	return dest;
}

int initvars( void) {
  //*disp << CBWHITE << "Info:  " << CWHITE << "Initing vars" << endl;
  bot_current = 0;

//  vars.setVar( "war2_exe",      "Binaries/war2/Warcraft II BNE.exe");
//  vars.setVar( "war2_snp",      "Binaries/war2/battle.snp");
//  vars.setVar( "war2_dll",      "Binaries/war2/storm.dll");
//
//  /vars.setVar( "star_exe",      "Binaries/star/starcraft.exe");
// / vars.setVar( "star_snp",      "Binaries/star/battle.snp");
// / vars.setVar( "star_dll",      "Binaries/star/storm.dll");
//
//  vars.setVar( "jstr_exe",      "Binaries/jstr/StarCraftJ.exe");
//  vars.setVar( "jstr_snp",      "Binaries/jstr/battle.snp");
//  vars.setVar( "jstr_dll",      "Binaries/jstr/storm.dll");
//
//  vars.setVar( "d2dv_exe",      "Binaries/d2dv/Game.exe");
//  vars.setVar( "d2dv_d2c",      "Binaries/d2dv/d2client.dll");
//  vars.setVar( "d2dv_bnc",      "Binaries/d2dv/bnclient.dll");
//
//  vars.setVar( "d2xp_exe",      "Binaries/d2xp/Game.exe");
//  vars.setVar( "d2xp_d2c",      "Binaries/d2xp/D2Client.dll");
//  vars.setVar( "d2xp_bnc",      "Binaries/d2xp/Bnclient.dll");

//  vars.setVar( "auto_rejoin",   "1");
//  vars.setVar( "auto_welcome",  "0");
//  vars.setVar( "beep_onjoin",   "1");
//  vars.setVar( "beep_onpriv",   "1");
//
//  vars.setVar( "bot_master",      "Eurijk!");
//  vars.setVar( "bot_trigger",     ".");
//  vars.setVar( "reconnect_delay", "3");
//
//  vars.setVar( "cmd_profile",   "0");
//
//  vars.setVar( "debug_idle",    "0");
//  vars.setVar( "debug_verbose", "0");
//
//  vars.setVar( "use_delay",     "1");
//  vars.setVar( "show_bots",     "0");
//  vars.setVar( "show_idles",    "0");
//  vars.setVar( "show_joins",    "1");
//
//  vars.setVar( "rejoin_pause",  "2");
//
//  vars.setVar( "kick_on_yell",  "0");

  // *disp << CBWHITE << "Info:  " << CWHITE << "Ready for connections." << endl;
  //*disp << CBWHITE << "Info:  " << "Type /set to see a list of variables." << endl;

  //*disp << CBWHITE << "Info:  " << CWHITE << "Reading config file" << endl;
  //if (readconfig()) {
  ////  *disp << CBWHITE << "Warning: " << CBRED << "Unable to read config file \"" << configfile << "\"" << endl;
  //}

  // Now we need to assign all the command queue's.
  {
    sBotList *tmp = botlist.first;
    while (tmp) {
      Command *cmd = commandlist.getCommand( tmp->data->getCommandSet());
      if (cmd)
        cmd->addHandler( tmp->data);
      tmp = tmp->next;
    }
  }
  return( 0);
}

int banner( void) {
//	#ifndef WIN32
//		#ifndef DISP_GTK
//    *disp << "\033[0m\033[0;0H\033[2J"
//         << "zDSBot3! - build number " << BUILD << " - by Eurijk!" << endl;
//  	#endif
//  #endif
//
//  char build[ 256];
//  sprintf( build, "(build %d)\0_____", BUILD);
  // disp->setBanner(" zDSBot3! by \017E\016urijk\014!\007\0_______________", build);

  return( 0);
}

void sig_handler( int signum) {
  static int forcequit = 0;

  switch( signum) {
    case 13:
      //disp->clrline();
      //*disp << "Info:  SIGPIPE was received. Ignoring." << endl;
      //input->update();
      break;
    default:
      //*disp << "Info:  Signal " << signum << " was received. Exiting." << endl;
      if (forcequit) {
        //*disp << "Info:  A second signal has been received. Forcing exit." << endl;
        exit( 1);
      }
      forcequit++;
      globals->done++;
  }
}

void tab_handler( void) {
  if (!bot_current)
    bot_current = botlist.first;
  else {
    if (bot_current->next)
      bot_current = bot_current->next;
    else
      bot_current = botlist.first;
  }

  //if (bot_current)
  //  input->setPrompt( bot_current->data->getName());

  //disp->clrline();
  //input->update();
}

void kbd_handler( void) {
/*
	static int ENC_MODE = 0;
	static char *gmsg = 0;

  char buf[ 1024];
  // *disp << endl;

  if (!strcmp( input->getbuf(), "/quit")) {
    globals->done++;
    input->clear();

    #ifdef DISP_GTK
      gtk_main_quit();
    #endif

    return;
  }

  if (!strcmp( input->getbuf(), "/status")) {
    sBotList *tmp = botlist.first;
    input->clear();
    *disp << endl;
    while (tmp) {
      *disp << "Bot:             " << tmp->data->getName() << endl
            << "  Password:      " << tmp->data->getPasswd() << endl
            << "  Server:        " << tmp->data->getServer() << endl
            << "  Home Channel:  " << tmp->data->getHomeChannel() << endl
            << "  CD Key:        " << tmp->data->getCDKey() << endl
            << "  Registered:    " << tmp->data->getRegister() << endl
            << "  Command Set:   " << tmp->data->getCommandSet() << endl
            << "  Spawn:         " << tmp->data->getSpawn() << endl;
      tmp = tmp->next;
    }

    input->update();
    return;
  }

	if (!strcmp( input->getbuf(), "/ver") || !strcmp( input->getbuf(), "/version")) {
		input->clear();
		*disp << endl
		      << CBWHITE << "zDSBot3! - (build \0__________" << BUILD << ")\0_____________" << CWHITE << endl;
		input->update();
		return;
	}

	if (!strcmp( input->getbuf(), "/info")) {
		input->clear();
		*disp << endl
		      << CBWHITE << "| Botname          | Server           | Channel          | Uptime            |" << CWHITE << endl;
		sBotList *tmp = botlist.first;
		while (tmp) {
			if (tmp->data) {
				char buf[256];
				Bot *bot = tmp->data;

				int t = time(0) - bot->getCTime();
				int days = t / (3600*24); t -= days * 3600 * 24;
				int hours = t / (3600);   t -= hours * 3600;
				int mins = t / 60;        t -= mins * 60;   
				int secs = t;
				
				sprintf( buf, "| %16s | %16s | %16s | %.2d days, %.2d:%.2d:%.2d |",
					bot->getName(),
					bot->getServer(),
					bot->getCurChannel(),
					days, hours, mins, secs);

				*disp << buf << endl;
                              
			}
			tmp = tmp->next;
		}
		input->update();
		return;
	}

	if (!strcmp( input->getbuf(), "/botnet")) {
		input->clear();
		*disp << "=== BotNet Stats ===" << endl
		      << "= Server: Disabled" << endl
		      << "=         0 clients" << endl
		      << "= Client: Not connected to any servers" << endl;
		input->update();
		return;
	}

	if (!strncmp( input->getbuf(), "/gmsg ", 6)) {
		input->clear();
		char *tmp = input->getbuf() + 6;

		if (gmsg) {
			delete gmsg;
			gmsg = NULL;
		}
			
		gmsg = new char[ strlen( tmp) + 1];
		strcpy( gmsg, tmp);
		*disp << endl
		      << CBWHITE << "gmsg mode enabled (/msg " << gmsg << ")" << CWHITE << endl;
		      
		input->update();
		return;
	}
	
	if (!strcmp( input->getbuf(), "/gmsg")) {
		input->clear();
		*disp << endl
		      << CBWHITE << "gmsg mode disabled" << CWHITE << endl;
		if (gmsg)
			delete gmsg;
		gmsg = 0;
		input->update();
		return;
	}

  if (!strncmp( input->getbuf(), "/profile ", 9)) {
    input->clear();
    disp->clrline();
    if (bot_current && *bot_current->data->getName())
      if (bot_current->data->sendReqProfile( input->getbuf() + 9))
        *disp << "Error: Unable to send profile request" << endl;
      else
        *disp << "Info:  Profile request sent." << endl;
    input->update();
    return;
  }

	// MFT
  //if (!strncmp( input->getbuf(), "/set ", 5)) {
  //  char *tmp = strstr( input->getbuf() + 5, " ");
  //  if (!tmp) {
  //    *disp << "Error: You must pass a variable and a value for /set to set. >;-)" << endl;
  //    input->clear();
  //    input->update();
  //    return;
  //  }
  //  *(tmp++) = '\0';
  //  vars.setVar( input->getbuf() + 5, tmp);
  //  input->clear();
  //  input->update();
  //  return;
  //}

  if (!strncmp( input->getbuf(), "/h ", 3)) {
    char buf[ 1024]; char *tmp2 = buf + 1;
    char *tmp = input->getbuf() + 3;
    buf[0] = 0xA3;
    while (*tmp) {
      sprintf( tmp2, "%.2x", *tmp);
      tmp2 += 2;
      tmp++;
    }
    *tmp2 = 0;

    if (bot_current && *bot_current->data->getName())
      bot_current->data->enqueue( 0, "%s", buf);
    else
      enqueue.enqueue( 0, "%s", buf);

    input->clear();
    input->update();
    return;
  }

  if (!strncmp( input->getbuf(), "/ev ", 4)) {
    char buf[ 1024];
    buf[0] = '';
    strcpy( buf + 1, Encrypt( input->getbuf() + 4));

    if (bot_current && *bot_current->data->getName())
      bot_current->data->enqueue( 0, "%s", buf);
    else
      enqueue.enqueue( 0, "%s", buf);
    input->clear();
    input->update();
    return;
  }

	// MFT
  //if (!strcmp( input->getbuf(), "/set")) {
  //  vars.showVars( disp, input);
  //  input->clear();
  //  input->update();
  //  return;
  //}

	char *tmp = input->getbuf();
	for (;tmp;) {
		char *tmp2 = strchr( tmp, 0x0A);

		if (tmp2)
			*tmp2 = 0;

		if (gmsg) {
			//printf("\033[160D\033[1A");
			char buf[512];
			sprintf( buf, "/msg %s %s", gmsg, tmp);
			enqueue.enqueue( 3, "%s", buf);
		} else {
			switch( ENC_MODE) {
				case 3:
					if (bot_current && *bot_current->data->getName())
						bot_current->data->enqueue( 0, "%s", (char *)zenc_Encrypt( (unsigned char *)tmp));
					else   
						enqueue.enqueue( 0, "%s", (char *)zenc_Encrypt( (unsigned char *)tmp));
					break;
				case 0:
					if (bot_current && *bot_current->data->getName())
						bot_current->data->enqueue( 3, "%s", tmp);
					else
						enqueue.enqueue( 3, "%s", tmp);
						break;
			}
		}
    
		if (!tmp2)
			tmp = 0;
		else
			tmp = tmp2 + 1;
	}

	input->clear();
	input->update();
*/
}


//Display *getDisp( void) {
//  return disp;
//}

int usage( void) {
  printf("Usage:\n"
         "  -h or --help        For help\n"
         "  -b or --background  For no forcing to a terminal.\n"
         "                      In later versions this may change\n"
         "                      to daemon form.\n");
  globals->done++;
  return( 0);
}

//===
// Program start.
#ifndef WIN32
int main( int argc, char **argv) {
#else
int nCmdShow;
int APIENTRY WinMain(HINSTANCE _hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam,int yhgtbfkm) {
  nCmdShow = yhgtbfkm;
#endif

	//===
	// Allocate globals, and load data.
		globals = new Globals();


	//===
	//
  #ifdef WIN32
    hInstance = _hInstance;

    WSADATA W;

    WSAStartup( 0x101, &W);
  #else
    #ifndef DISP_GTK
      // TODO: Did this work heh? >;-)
      if (signal (SIGINT, sig_handler) == SIG_IGN) signal (SIGINT, SIG_IGN);
      if (signal (SIGPIPE, sig_handler) == SIG_IGN) signal (SIGPIPE, SIG_IGN);
    #endif
  #endif

	debug(("main - done w/ signals"));

  int background = 0;
  
	#ifndef WIN32
		srandom( time( 0));
	#endif

	//strcpy( configfile, "config.txt");
	//#ifndef WIN32
	//	argv++;
	//	while (argc > 1) {
	//		if (!strcmp( *argv, "-h"))           usage();
	//		if (!strcmp( *argv, "--help"))       usage();
	//		if (!strcmp( *argv, "-b"))           background = 1;
	//		if (!strcmp( *argv, "--background")) background = 1;
	//		if (!strcmp( *argv, "-c"))           { strcpy( configfile, *++argv); argc--; }
	//		if (!strcmp( *argv, "--config"))     { strcpy( configfile, *++argv); argc--; }
	//		argv++;
	//		argc--;
	//	}
	//#endif
	//
	//if (globals->done)
	//	return( 0);
	//
	//debug("main - done w/ args");
	//
	//disp = new Display( background);
	//
	// debug("main - done w/ display");
	// input = new Input( background, kbd_handler, tab_handler);

//	debug("main - done w/ new disp/input");
//
//  #ifndef WIN32
//    if (background) {
//      switch( fork()) {
//        case -1:
//          std::cerr << "Error: Unable to fork.\n";
//          _exit( -1);
//        case 0:
//          break;
//        default:
//          std::cerr << "zDSBot3 wanders off to the background.\n";
//          _exit( 0);
//      }
//
//      if (setsid() == -1)
//        std::cerr << "Error: Unable to setsid - ignoring\n";
//
  //    switch( fork()) {
  //      case -1:
  //        std::cerr << "Error: Unable to fork again. Ignoring.\n";
  //        break;
  //      case 0:
  //        //std::cerr << "Info: second fork successful\n";
  //        break;
  //      default:
  //        //std::cerr << "Info: dropping parent from second fork\n";
  //        _exit( 0);
  //    }
  //  }
  //#endif

  //if (banner())
  //	return( -1);

  //#ifdef DISP_GTK
  //  gtkmain = new Gtk_Main();
  //#endif

  //#ifdef WIN32_NATIVE
  //  if (!LoadLibrary("RICHED32.DLL")) {
  //    MessageBox(NULL, "Error loading RICHED32.DLL", "Error", MB_OK);
  //    return( -1);
  //  }
  //#endif

	debug(("main - starting w32 extentions"));

  if (initvars()) return( -1);

	debug(("main - done w/ initvars"));

	#ifndef WIN32
		if (background) {
      	//chdir("/");
      	umask( 0);
      	//close( 0); close( 1); close( 2);
		}
	#endif

	//===
	// Allocate the threads.
		#ifdef DISP_GTK
			globals->tgtk = new TGtk();
		#endif
		#ifdef DISP_OPENGL
			TGl *tgl = new TGl();
		#endif

		globals->tio = new TIO();

	//===
	// Wait for the threads to terminate.
		#ifdef DISP_GTK
			globals->tgtk->join();
		#endif
		globals->tio->join();

	//===
	// Save and delete globals.
		delete globals;

	return( 0);
}
