#include "mnumain.h"
#ifdef DISP_GTK

MnuMain::MnuMain( void) {
  mnuMain = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (mnuMain), "mnuMain", mnuMain);
  mnuMain_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (mnuMain));

  display1 = gtk_menu_item_new_with_label ("Display");
  gtk_widget_ref (display1);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "display1", display1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (display1);
  gtk_container_add (GTK_CONTAINER (mnuMain), display1);

  separator2 = gtk_menu_item_new ();
  gtk_widget_ref (separator2);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "separator2", separator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator2);
  gtk_container_add (GTK_CONTAINER (mnuMain), separator2);
  gtk_widget_set_sensitive (separator2, FALSE);

  reconnect2 = gtk_menu_item_new_with_label ("Reconnect");
  gtk_widget_ref (reconnect2);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "reconnect2", reconnect2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reconnect2);
  gtk_container_add (GTK_CONTAINER (mnuMain), reconnect2);

  active1 = gtk_check_menu_item_new_with_label ("Active");
  gtk_widget_ref (active1);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "active1", active1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (active1);
  gtk_container_add (GTK_CONTAINER (mnuMain), active1);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (active1), TRUE);
  gtk_check_menu_item_set_show_toggle (GTK_CHECK_MENU_ITEM (active1), TRUE);

  properties1 = gtk_menu_item_new_with_label ("Properties");
  gtk_widget_ref (properties1);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "properties1", properties1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (properties1);
  gtk_container_add (GTK_CONTAINER (mnuMain), properties1);

  separator4 = gtk_menu_item_new ();
  gtk_widget_ref (separator4);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "separator4", separator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator4);
  gtk_container_add (GTK_CONTAINER (mnuMain), separator4);
  gtk_widget_set_sensitive (separator4, FALSE);

  delete1 = gtk_menu_item_new_with_label ("Delete");
  gtk_widget_ref (delete1);
  gtk_object_set_data_full (GTK_OBJECT (mnuMain), "delete1", delete1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete1);
  gtk_container_add (GTK_CONTAINER (mnuMain), delete1);

  gtk_signal_connect (GTK_OBJECT (display1), "activate",
                      GTK_SIGNAL_FUNC (on_display1_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (reconnect2), "activate",
                      GTK_SIGNAL_FUNC (on_reconnect2_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (active1), "activate",
                      GTK_SIGNAL_FUNC (on_active1_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (properties1), "activate",
                      GTK_SIGNAL_FUNC (on_properties1_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (delete1), "activate",
                      GTK_SIGNAL_FUNC (on_delete1_activate),
                      this);
}

#endif
