//=============================================================================
//= zDSBot by Eurijk!                                                         =

#include "config.h"

#ifdef _WIN32
  #include <io.h>
  #include <winsock2.h>
  #include "mylib.h"
#else
  #include <unistd.h>
  #include <sys/socket.h>

  //===
  // For nagle on linux.
    #define TCP_NODELAY 1

  #include <arpa/inet.h>
  #include <netinet/in.h>
  #include <netdb.h>
  #include <sys/time.h>
  #include <fcntl.h>
  #include <errno.h>
#endif

#include "mylib.h"

#ifdef DEBUGNET
   #include <stdio.h>
#endif

#include <string.h>
#include <time.h>

//#include "display.h"
//#include "input.h"
#include "network.h"

#ifdef WIN32
  extern HWND mainWnd;
#endif

//extern Display *disp;
//extern Input *input;
//#ifdef DISP_GTK
//  extern int callback( gpointer data, gint source, GdkInputCondition condition );
//#endif

Network::Network( void) {
  fd = -1;

  pkt_loc = 4;
  bzero( pkt_buf, sizeof( pkt_buf));

  bzero( pre_buf, sizeof( pre_buf));
  pre_len = 0;

  crypt = 0;

  proxystate = 0;
  contime = 0;
  is_connected = 0;

  counter_recv = counter_send = 0;
  bzero( rawserver, sizeof( rawserver));
  bzero( username, sizeof( username));

  //#ifdef DISP_GTK
  //  gtk_readfd = gtk_writefd = gtk_exceptfd = 0;
  //#endif
}


Network::~Network( void) {
  if (fd != -1)
    netclose();
}


int Network::netopen(char *addr, u16 port, char *paddr, u16 pport, char *_username, char *vhost) {
  struct sockaddr_in sock; struct hostent *he;
  struct sockaddr_in psock;
 
  crypt = proxystate = 0;
  strcpy( rawserver, addr);
  strcpy( username, _username);

  if (fd != -1)
    netclose();

  if (paddr && *paddr)
    proxystate = 1;

  bzero(&sock, sizeof(struct sockaddr_in));
  if (proxystate) {
    if ((sock.sin_addr.s_addr = inet_addr(paddr)) == -1) {
      he = gethostbyname(paddr);
      if (he == NULL) return(-1);
      sock.sin_addr = *((struct in_addr *)he->h_addr);
    }
    sock.sin_port = htons( pport);
  } else {
    if ((sock.sin_addr.s_addr = inet_addr(addr)) == -1) {
      he = gethostbyname(addr);
      if (he == NULL) return(-1);
      sock.sin_addr = *((struct in_addr *)he->h_addr);
    }
    sock.sin_port = htons( port);
  }
  sock.sin_family = AF_INET;

  fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (fd == -1)
    return( -1);
 
  //===
  // Turn off nagle.
    {
      int disable = 1;
      int status = setsockopt( fd, IPPROTO_TCP, TCP_NODELAY, (char *) &disable, sizeof(int));
    }

  if (vhost && *vhost) {
    //disp->clrline();
    //*disp << CBWHITE << "Info: " << CWHITE << "Binding to " << CBBLUE << vhost << endl;
    //input->update();

    struct sockaddr_in sz;
    bzero( &sz, sizeof(struct sockaddr_in));
    
    if ((sz.sin_addr.s_addr = inet_addr(vhost)) == -1) {
      he = gethostbyname(vhost);
      if (he == NULL) return(-1);
      sz.sin_addr = *((struct in_addr *)he->h_addr);
    }
    sz.sin_family = AF_INET;
    if (bind( fd, (struct sockaddr *)&sz, sizeof( sz)) == -1) {
      //disp->clrline();
      //*disp << CBRED << "Error: " << CBWHITE << "Unable to bind to " << CBBLUE << vhost << endl;
      //input->update();
      close( fd);
      fd = -1;
      return( -1);
    }   
  }

  //#ifdef WIN32
  //  #ifdef DEBUGNET
  //    *disp << "DEBUGNET: Setting socket for non-blocking connect." << endl;
  //  #endif
  //  WSAAsyncSelect( fd, mainWnd, WM_NETEVENT, FD_CLOSE | FD_READ | FD_CONNECT);
  //  #ifdef DEBUGNET
  //    *disp << "DEBUGNET: Socket set for non-blocing connect." << endl;
  //  #endif
  //#endif

  #if defined(OS_BSD) || defined(OS_LINUX)
    int flags = fcntl(fd, F_GETFL, 0);
    if(fcntl(fd, F_SETFL, flags | O_NONBLOCK) == -1) {
      close( fd);
      return( -1);
    }
  #endif

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Connecting to " << inet_ntoa(sock.sin_addr) << ":" << port << endl;
  //  //input->update();
  //#endif

  int n = connect(fd, (struct sockaddr *)&sock, sizeof(struct sockaddr));
  #if defined(OS_BSD) || defined(OS_LINUX)
    fcntl(fd, F_SETFL, flags);
  #endif

  if (!n) {
    pkt_connected();
    is_connected = 2; // 2 means, we are connected
  } else
    #ifndef WIN32
      switch( errno) {
        case EINPROGRESS:
          is_connected = 1; // 1 means we are connecting
          break;
        default:
          netclose();
          return( -1);
      }
    #else
      is_connected = 1; // 1 means we are connecting
    #endif  

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Connect returned " << n << endl;
  //  if (n) perror( "DEBUGNET");
  //  //input->update();
  //#endif

  return( 0);
}


int Network::netclose( void) {
  crypt = 0; contime = 0;
  counter_recv = counter_send = 0;
  is_connected = 0;

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: A request has been made to close the socket." << endl;
  //  //input->update();
  //#endif

  if (fd != -1) {
    #ifdef WIN32
      int sanity = 0; char ch;
      for (;;) {
        while (closesocket( fd)) {
          if (sanity++ > 16) break;
        }
				#ifdef OS_LINUX
	        int n = recv( fd, &ch, 1, MSG_NOSIGNAL);
	      #else
	        int n = recv( fd, &ch, 1, 0);
	      #endif
        if (n == -1)
          break;
        //disp->clrline();
        //*disp << "Error: Windows is refusing to close the socket." << endl;
        //input->update();
        if (sanity++ > 32) break;
      }
    #else
      close( fd);
    #endif

  }

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Socket is now closed." << endl;
  //  //input->update();
  //#endif

	fd = -1;

	return( -1);
}


int Network::rawsend( int len, char *buf) {
	if (fd == -1)
		return( 0);

	#ifdef DEBUGNET
		fprintf( stdout, "Network::rawsend( len=>%d )\n", len);
		hexdump( len, buf, stdout);
	#endif

	#ifdef OS_LINUX
		int n = send( fd, buf, len, MSG_NOSIGNAL);
	#else
		int n = send( fd, buf, len, 0);
	#endif
	
	if (n != len) {
		netclose();
		return( 0);
	}

	counter_send += n;
	return( 0);
}


int Network::sendpktdebug2( u16 type) {
  //disp->clrline();
  //*disp << "Info:  Setting packet type length to " << pkt_loc << endl;
  //disp->hexdump( pkt_loc, pkt_buf);
  //input->update();

  return( sendpkt( type));
}


int Network::sendpktdebug( u16 type) {
  *(u16 *)(pkt_buf) = type;
  *(u16 *)(pkt_buf + 2) = pkt_loc;

  //disp->clrline();
  //*disp << "Info:  Setting packet type length to " << pkt_loc << endl;
  //disp->hexdump( pkt_loc, pkt_buf);
  //input->update();

  pkt_loc = 4;
  return( 0);
}


int Network::sendpkt( u16 type) {

	if (fd == -1)
		return( -1);

	*(u16 *)(pkt_buf) = type;
	*(u16 *)(pkt_buf + 2) = pkt_loc;


	#ifdef DEBUGNET
		fprintf( stderr, "Network::sendpkt\n");
		hexdump( pkt_loc, pkt_buf, stderr);
	#endif
	
	#ifdef OS_LINUX
		int n = send( fd, pkt_buf, pkt_loc, MSG_NOSIGNAL);
	#else
		int n = send( fd, pkt_buf, pkt_loc, 0);
	#endif
		
	if (n != pkt_loc) {
		netclose();
		return( -1);
	}

	counter_send += n;

	pkt_loc = 4;
	return( n);
}


int Network::getfd( void) {
  return( fd);
}


int Network::setfd( int _fd) {
  fd = _fd;
  return( 0);
}


int Network::handler( void) {
  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "Debug: Network::handler was called." << endl;
  //  //input->update();
  //#endif

  if (fd == -1) {
    //#ifdef DEBUGNET
    //  disp->clrline();
    //  *disp << "DEBUGNET: Network::handler was called with a already closed fd." << endl;
    //  //input->update();
    //#endif
    return( fd);
  }

  // TODO - How often are we calling this ?!
  #ifndef WIN32
    int flags = fcntl(fd, F_GETFL, 0);
    fcntl(fd, F_SETFL, flags | O_NONBLOCK);
  #endif

	#ifdef OS_LINUX
	  int n = recv( fd, pre_buf + pre_len, 8192 - pre_len, MSG_NOSIGNAL);
	#else
	  int n = recv( fd, pre_buf + pre_len, 8192 - pre_len, 0);
	#endif

	#ifdef DEBUG
		if (n >= 0) {
			fprintf( stdout, "Network::handler recv\n");
			hexdump( n, pre_buf + pre_len, stdout);
		}
	#endif

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Network::handler recv returned " << n << endl;
  //  #ifdef DEBUGNET2
  //    disp->hexdump( n, pre_buf + pre_len);
  //  #endif
  //  input->update();
  //#endif  

  #ifndef WIN32
    fcntl(fd, F_SETFL, flags);
  #endif

  #ifndef WIN32
    if (n <= 0)
      switch( errno) {
        case EAGAIN:
          //#ifdef DEBUGNET
          //  *disp << "DEBUGNET: Non-blocking eagain thingy." << endl;
          //#endif
          return( 0);
        case EBADF:
          //#ifdef DEBUGNET
          //  *disp << "DEBUGNET: Bad file descriptor received." << endl;
          //#endif
          return( netclose());
        default:
          return( netclose());
      }
  #endif

  counter_recv += n;
  
  if (n <= 0) {
    netclose();
    //#ifdef DEBUGNET
    //  disp->clrline();
    //  *disp << "DEBUGNET: Network::handler is returning with a newly closed fd." << endl;
    //  //input->update();
    //#endif
    return( -1);
  }

  // TODO: fix for 1 byte packets
  if (proxystate == 1) {
    switch( *(pre_buf + pre_len + 1)) {
      case 90: //disp->clrline();
               //*disp << "SOCKS4: Request granted." << endl;
               //input->update();
               proxystate = 0;
               pkt_connected();
               break;
      case 91: //disp->clrline();
               //*disp << "SOCKS4: Error! Request rejected or failed." << endl;
               //input->update();
               netclose();
               break;
      case 92: //disp->clrline();
               //*disp << "SOCKS4: Error! Request rejected because SOCKS server cannot connect" << endl
               //      << "        to identd on the client. (Install identd)" << endl;
               //input->update();
               netclose();
               break;
      case 93: //disp->clrline();
               //*disp << "SOCKS4: Error! Request rejected because the client program and" << endl
               //      << "        identd report different user-ids." << endl;
               //input->update();
               netclose();
               break;
      default: //disp->clrline();
               //*disp << "SOCKS4: Error! Unknown value returned from SOCKS server. Are you sure" << endl
               //      << "        this is a socks server?" << endl;
               //input->update();
               netclose();
               break;
    }
    return( 0);
  }  

  //if (crypt)
  //  for (int i = 0; i < n; i ++)
  //    *(pre_buf + pre_len + i) ^= psuedo_recv.getNext();
  
  pre_len += n;
  if (pre_len >= 8192) pre_len = 0;

  while (pre_len >= 4) {
    int i = 0;
    for (;(pre_buf[i] != -1) && (i < pre_len); i++) ;

    if (i) {
      pre_len -= i;
      memmove( pre_buf, pre_buf + i, pre_len);
    }
    
    if ((pre_buf[0] == -1) && (*(u16 *)(pre_buf + 2) <= pre_len)) {
      pkt_handler( *(u16 *)(pre_buf + 2), pre_buf);
      pre_len -= *(u16 *)(pre_buf + 2);
      memmove( pre_buf, pre_buf + *(u16 *)(pre_buf + 2), pre_len);
    } else
      break;
  }

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Network::handler is returning." << endl;
  //  //input->update();
  //#endif

  return( 0);
}


Network &Network::operator<<( char *buf) {
	if (fd == -1)
		return *this;

  int i = strlen( buf);
  strcpy( pkt_buf + pkt_loc, buf);
  pkt_loc += i + 1;
  return *this;
}


Network &Network::operator<<( u8 i) {
	if (fd == -1)
		return *this;

  *(u8 *)(pkt_buf + pkt_loc) = i;
  pkt_loc += sizeof( u8);
  return *this;
}


Network &Network::operator<<( u16 i) {
	if (fd == -1)
		return *this;

  *(u16 *)(pkt_buf + pkt_loc) = i;
  pkt_loc += sizeof( u16);
  return *this;
}


Network &Network::operator<<( u32 i) {
	if (fd == -1)
		return *this;

  *(u32 *)(pkt_buf + pkt_loc) = i;
  pkt_loc += sizeof( u32);
  return *this;
}


int Network::rawAdd( int len, char *buf) {
  memcpy( pkt_buf + pkt_loc, buf, len);
  pkt_loc += len;
  return( 0);
}



int Network::pkt_handler( int len, char *buf) {
  //#ifdef DEBUGNET2
  //  disp->clrline();
  //  *disp << "Debug: Network::pkt_handler was called" << endl;
  //  disp->hexdump( len, buf);
  //  //input->update();
  ///#endif

  return( 0);
}


int Network::setCrypt( int seed_recv, int seed_send) {
  //psuedo_recv.init( seed_recv);
  //psuedo_send.init( seed_send);
  crypt = 1;
  return( 0);
}


time_t Network::getCTime( void) {
  return( contime);
}


int Network::getproxystate( void) {
  return( proxystate);
}


int Network::setproxystate( int _state) {
  proxystate = _state;
  return( 0);
}


int Network::getCrypt( void) {
  return( crypt);
}

time_t Network::getUpTime( void) {
	if (fd == -1)
		return( 0);

	return( time( 0) - contime);
}

u32 Network::getCountRecv( void) {
  return( counter_recv);
}

u32 Network::getCountSend( void) {
  return( counter_send);
}

int Network::pkt_connected( void) {
  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Network::pkt_connected was called" << endl;
  //  //input->update();
  //#endif

  is_connected = 2;
  //#ifdef DISP_GTK
  //  if (gtk_writefd)  gtk_input_remove( gtk_writefd);
  //#endif

  if (proxystate == 1) {
    //#ifdef DEBUGNET
    //  disp->clrline();
    //  *disp << CBWHITE << "DEBUGNET: Sending proxy connect req." << endl;
    //  //input->update();
    //#endif
      struct sockaddr_in psock; struct hostent *he;

      bzero(&psock, sizeof(struct sockaddr_in));
      if ((psock.sin_addr.s_addr = inet_addr(rawserver)) == -1) {
        he = gethostbyname(rawserver);
            if (he == NULL) {
              //*disp << CBWHITE << "Error: " << CBRED << "Unable to resolve " << CBBLUE << rawserver << endl;
              netclose();
              return(-1);
            }
            psock.sin_addr = *((struct in_addr *)he->h_addr);
          }
  
          char buf[ 256];
          *(u16 *)(buf + 0) = 0x0104;
          *(u16 *)(buf + 2) = htons( 6112);
          *(u32 *)(buf + 4) = psock.sin_addr.s_addr;
          strcpy( buf + 8, username);
  
          //#ifdef DEBUGNET
          //  *disp << "DEBUGNET: Sending..." << endl;
          //  disp->hexdump( 9 + strlen( username), buf);
          //  //input->update();
          //#endif
  
          rawsend( 9 + strlen( username), buf);
    
    return( -1);
  }

  // Start the connected time now.
  contime = time(0);

  //#ifdef DEBUGNET
  //  disp->clrline();
  //  *disp << "DEBUGNET: Network::pkt_connected is returning" << endl;
  //  //input->update();
  //#endif
  return( 0);
}

int Network::selectWrite( void) {
  return( is_connected);
}
