/* From what I can tell... -Eurijk!
 *   D2Exp code by Denumber1Ace
 *   CD-Key Algorithm source code was by YobGuls (yobguls@yobguls.2ndmail.com) 2001
 *   SHA-1 routines came from the bnetd project by Ross Combs
 *   Please see original source for more author information.
 */

// For debug
// #include <iostream.h>

#ifdef WIN32
  #include <windows.h>
#else
  #include <string.h>
  #include <stdlib.h>
  #include <stdio.h>
  #include <ctype.h>
#endif
#include <ctype.h>
#include "sendcdkeycheck.h"
#include "vercheck.h"
#include "mylib.h"

extern VerCheck *vercheck[4];

static char codevalues[256] = {
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0x00, 0xff, 0x01, 0xff, 0x02, 0x03, 0x04, 0x05, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ..2.4.6789...... 
  0xff, 0xff, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0xff, 0x0D, 0x0E, 0xff, 0x0F, 0x10, 0xff, // ..BCDEFGH.JK.MN.
  0x11, 0xff, 0x12, 0xff, 0x13, 0xff, 0x14, 0x15, 0x16, 0xff, 0x17, 0xff, 0xff, 0xff, 0xff, 0xff, // P.R.T.VWX.Z.....
  0xff, 0xff, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0xff, 0x0D, 0x0E, 0xff, 0x0F, 0x10, 0xff, // ..bcdefgh.jk.mn.
  0x11, 0xff, 0x12, 0xff, 0x13, 0xff, 0x14, 0x15, 0x16, 0xff, 0x17, 0xff, 0xff, 0xff, 0xff, 0xff, // p.r.t.vwx.z.....
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, // ................
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff  // ................
};

//#ifdef WIN32
//  void HashData(LPVOID lpSource, int nLength, LPVOID lpResult) {
//    BYTE bBuffer[1024];
//    int i;
//    DWORD a, b, c, d, e, g;
//
//    ZeroMemory(bBuffer, 1024);
//    CopyMemory(bBuffer, lpSource, nLength);
//    DWORD *lpdwBuffer = (LPDWORD) bBuffer;
//#else
  void HashData( void *lpSource, int nLength, void *lpResult) {
    u8 bBuffer[1024];
    int i;
    u32 a, b, c, d, e, g;

    bzero(bBuffer, 1024);
    memcpy(bBuffer, lpSource, nLength);
    u32 *lpdwBuffer = (u32 *)bBuffer;
//#endif  

  for (i=0; i<64; i++)
    lpdwBuffer[i+16] = ROL(1, (lpdwBuffer[i] ^ lpdwBuffer[i+8] ^ lpdwBuffer[i+2] ^ lpdwBuffer[i+13]) % 32);

  a = 0x67452301lu;
  b = 0xefcdab89lu;
  c = 0x98badcfelu;
  d = 0x10325476lu;
  e = 0xc3d2e1f0lu;

  for (i = 0; i < (20 * 1); i++) {
    g = lpdwBuffer[i] + ROL(a,5) + e + ((b & c) | (~b & d)) + 0x5a827999lu;
    e = d;
    d = c;
    c = ROL(b,30);
    b = a;
    a = g;
  }
  for (; i < (20 * 2); i++) {
    g = (d ^ c ^ b) + e + ROL(g,5) + lpdwBuffer[i] + 0x6ed9eba1lu;
    e = d;
    d = c;
    c = ROL(b,30);
    b = a;
    a = g;
  }
  for (; i < (20 * 3); i++) {
    g = lpdwBuffer[i] + ROL(g,5) + e + ((c & b) | (d & c) | (d & b)) - 0x70e44324lu;
    e = d;
    d = c;
    c = ROL(b,30);
    b = a;
    a = g;
  }
  for (; i < (20 * 4); i++) {
    g = (d ^ c ^ b) + e + ROL(g,5) + lpdwBuffer[i] - 0x359d3e2alu;
    e = d;
    d = c;
    c = ROL(b,30);
    b = a;
    a = g;
  }

  //#ifdef WIN32
  //  lpdwBuffer = (LPDWORD)lpResult;
  //#else
    lpdwBuffer = (u32 *)lpResult;
  //#endif
  
  lpdwBuffer[0] = 0x67452301lu + g;
  lpdwBuffer[1] = 0xefcdab89lu + b;
  lpdwBuffer[2] = 0x98badcfelu + c;
  lpdwBuffer[3] = 0x10325476lu + d;
  lpdwBuffer[4] = 0xc3d2e1f0lu + e;

  return;
}


// #ifndef WIN32
// char *SendCDKeyCheckD2Exp( char *lpszCDKey, char *key2, u32 dwServerHashKey,
//                         char *lpszUserName, u32 timestamp, 
//                         char *lpszValueString, char *lpszMpqFileName) {
//     u32 *lpdwBuffer;
//     static char bBuffer[ 1024];
//     u32  dwBuffer[256], dwProductId, dwValue1, dwValue2, dwHashKey;
//     u16  wLength,wLength1;
//     int  i,n;
// 
//     bBuffer[0] = 0xFF; bBuffer[1] = 0x51; // 0x42;
// 
//     lpdwBuffer = (u32 *)&bBuffer[4];
//     if (DecodeCDKey(lpszCDKey, &dwProductId, &dwValue1, &dwValue2))
//       return( 0);
// 
//   int length = strlen(lpszCDKey);
//   int keylength = 0;
// 
//   for (i = 0; i < length; i++) {
//     if (lpszCDKey[i] != '-')
//       keylength++;
//   }
// 
//   #ifdef WIN32
//     dwHashKey = GetTickCount();
//   #else
//     dwHashKey = timestamp; // 0x12345678; // rand();
//   #endif
// 
//   dwBuffer[0] = dwHashKey;
//   dwBuffer[1] = dwServerHashKey;
//   dwBuffer[2] = dwProductId;
//   dwBuffer[3] = dwValue1;
//   dwBuffer[4] = 0;
//   dwBuffer[5] = dwValue2;
// 
//   HashData( dwBuffer, 24, &lpdwBuffer[7+2]);
// 
//   #ifdef WIN32
//     lpdwBuffer = (LPDWORD) lpdwBuffer;
//   #else
//     lpdwBuffer = (u32 *)lpdwBuffer;
//   #endif
// 
//   lpdwBuffer[0] = dwHashKey;
//   lpdwBuffer[1] = 0x01000900; // Version 00 09 00 01
// 
//   u32 revisionhash;
//   vercheck[3]->checkrev( lpszValueString, lpszMpqFileName, &revisionhash);
// 
//   //CheckRevision( "D2Exp/Game.exe",
//   //               "D2Exp/Bnclient.dll",
//   //               "D2Exp/D2Client.dll",
//   //                lpszValueString, lpszMpqFileName,
//   //
//   //               &revisionhash);
// 
//   lpdwBuffer[2] = revisionhash; // Checksum !?!?!?
// 
//   lpdwBuffer[1+2] = 2;
//   lpdwBuffer[2+2] = 0;
//   lpdwBuffer[3+2] = keylength;   // 0x10
//   lpdwBuffer[4+2] = dwProductId; // 0x06
//   lpdwBuffer[5+2] = dwValue1;
//   lpdwBuffer[6+2] = 0;
// 
// 
//   // Do the second CD key
//     if (DecodeCDKey( key2, &dwProductId, &dwValue1, &dwValue2))
//       return( 0);
// 
//     dwBuffer[0] = dwHashKey;
//     dwBuffer[1] = dwServerHashKey;
//     dwBuffer[2] = dwProductId;
//     dwBuffer[3] = dwValue1;
//     dwBuffer[4] = 0;
//     dwBuffer[5] = dwValue2;
// 
//     HashData( dwBuffer, 24, &lpdwBuffer[16+2]);
//     lpdwBuffer[12+2] = keylength;
//     lpdwBuffer[13+2] = dwProductId;
//     lpdwBuffer[14+2] = dwValue1;
//     lpdwBuffer[15+2] = 0;
// 
//     //lpdwBuffer[21] = 0xee8de4d5; // 64bit dos timestamp?
//     //lpdwBuffer[22] = 0x604f8adc; //
//     char *filethingy = "Game.exe 08/31/01 22:40:58 428163";
//     strcpy( (char *) &lpdwBuffer[23], filethingy);
//     strcpy( (char *) &lpdwBuffer[23] + strlen( filethingy) + 1, lpszUserName);
// 
//   wLength = 0x58 + strlen( filethingy) + 1 + 8 + strlen(lpszUserName) + 1;
// 
//   #ifdef WIN32
//     *(WORD *) &bBuffer[2] = wLength;
//   #else
//     *(u16 *)(bBuffer + 2) = wLength;
//   #endif
// 
//   return bBuffer;
// }
// #endif
// 
 //#ifdef WIN32
 //  char * __stdcall SendCDKeyCheck(LPCTSTR lpszCDKey, DWORD dwServerHashKey, LPCTSTR lpszUserName) {
 //    DWORD * lpdwBuffer;
 //    char bBuffer[ 1024];
 //    DWORD dwBuffer[256], dwProductId, dwValue1, dwValue2, dwHashKey;
 //    WORD wLength,wLength1;
 //    int i,n;
 //#else
   // char *SendCDKeyCheck( char *lpszCDKey, char *key2, u32 dwServerHashKey, char *lpszUserName, u32 timestamp) {
   char *SendCDKeyCheck( char *lpszCDKey, u32 dwServerHashKey, char *lpszUserName, u32 timestamp, u32 spawn) {
     u32 *lpdwBuffer;
     static char bBuffer[ 1024];
     u32  dwBuffer[256], dwProductId, dwValue1, dwValue2, dwHashKey;
     u16  wLength,wLength1;
     int  i,n;
 //#endif
 
     //cout << "Info:  SendCDKeyCheck has been called" << endl
     //     << "       lpszCDKey is:       " << lpszCDKey << endl
     //     << "       dwServerHashKey is: " << hex << dwServerHashKey << dec << endl
     //     << "       lpszUserName is:    " << lpszUserName << endl
     //     << "       timestamp is:       " << hex << timestamp << dec << endl;
     //{
     //  char TMP[ 1024];
     //  sprintf( TMP, "User: %s  CDKey: %s", lpszUserName, lpszCDKey);
     //  log2( TMP);
     //}
 
 
     bBuffer[0] = 0xFF; bBuffer[1] = 0x36;
 
     lpdwBuffer = (u32 *)&bBuffer[4];
     if (DecodeCDKey(lpszCDKey, &dwProductId, &dwValue1, &dwValue2))
       return( 0);
 
   int length = strlen(lpszCDKey);
   int keylength = 0;
 
   for (i = 0; i < length; i++) {
     if (lpszCDKey[i] != '-')
       keylength++;
   }
 
   #ifdef WIN32
     dwHashKey = GetTickCount();
   #else
     dwHashKey = timestamp; // 0x12345678; // rand();
   #endif
 
   dwBuffer[0] = dwHashKey;
   dwBuffer[1] = dwServerHashKey;
   dwBuffer[2] = dwProductId;
   dwBuffer[3] = dwValue1;
   //dwBuffer[4] = 0x4f;
   dwBuffer[4] = dwValue2;
 
   HashData( dwBuffer, 20, &lpdwBuffer[6]);
 
   //#ifdef WIN32
   //  lpdwBuffer = (LPDWORD) lpdwBuffer;
   //#else
     lpdwBuffer = (u32 *)lpdwBuffer;
   //#endif
 
 //  lpdwBuffer[0] = dwHashKey;
 //  lpdwBuffer[1] = 2;
 //  lpdwBuffer[2] = 0;
   lpdwBuffer[0] = spawn;
   lpdwBuffer[1] = keylength;
   lpdwBuffer[2] = dwProductId;
   lpdwBuffer[3] = dwValue1;
   lpdwBuffer[4] = dwServerHashKey;
   lpdwBuffer[5] = dwHashKey;
 
 //  // Do the second CD key
 //    if (DecodeCDKey( key2, &dwProductId, &dwValue1, &dwValue2))
 //      return( 0);
 //
 //    dwBuffer[0] = dwHashKey;
 //    dwBuffer[1] = dwServerHashKey;
 //    dwBuffer[2] = dwProductId;
 //    dwBuffer[3] = dwValue1;
 //    dwBuffer[4] = 0;
 //    dwBuffer[5] = dwValue2;
 //
 //    HashData( dwBuffer, 24, &lpdwBuffer[16]);
 //
 //    lpdwBuffer[12] = keylength;
 //    lpdwBuffer[13] = dwProductId;
 //    lpdwBuffer[14] = dwValue1;
 //    lpdwBuffer[15] = 0;
 
 
   strcpy((char *) &lpdwBuffer[11], lpszUserName);
 
   wLength = 0x30 + strlen(lpszUserName) + 1;
 
   #ifdef WIN32
     *(WORD *) &bBuffer[2] = wLength;
   #else
     *(u16 *)(bBuffer + 2) = wLength;
   #endif
 
   //for (n = 0; n <= wLength; n++) {
   //  // Why the malloc? >;-)
   //  // b = (char *)malloc(2 * n + 1);
   //  b = new char[ 2 * n + 1];
   //
   //  for (i = 0; i < n; i++) {
   //    b[i * 2] = "0123456789ABCDEF"[(bBuffer[i] & 0xF0) >> 4];
   //    b[i * 2 + 1] = "0123456789ABCDEF"[bBuffer[i] & 0x0F]; 
   //  }
   //}
 
   //b[n * 2 - 2] = '0';
   //b[n * 2 - 1] = '0';
   //b[n * 2 ] = '\0';
 
   //send(hSocket, bBuffer, wLength, 0);
 
   //return b;
   return bBuffer;
 }


int DecodeCDKey( char *lpszCDKey, u32 *lpdwProductId, u32 *lpdwValue1, u32 * lpdwValue2) {
  char key[1024], value[1024];
  int i, length, keylength;
  int bValid;

  length = strlen(lpszCDKey);
  keylength = 0;
   
  for (i = 0; i < length; i++)
    if (lpszCDKey[i] != '-') {
      key[keylength] = lpszCDKey[i];
      keylength++;
    }

  if (keylength == 13)
    bValid = DecodeStarcraftKey(key);
  else if (keylength == 16)
    bValid = DecodeD2Key(key);
  else
    return( -1);
  
  strncpy(value, key, 2);
  value[2] = '\0';
  sscanf(value, "%X", lpdwProductId);

  if (keylength == 16) {
    strncpy(value, &key[2], 6);
    value[6] = '\0';
    sscanf(value, "%X", lpdwValue1);

    strcpy(value, &key[8]);
    value[8] = '\0';
    sscanf(value, "%X", lpdwValue2);
  } else if (keylength == 13) {
    strncpy(value, &key[2], 7);
    value[7] = '\0';
    sscanf(value, "%ld", lpdwValue1);

    strncpy(value, &key[9], 3);
    value[3] = '\0';
    sscanf(value, "%ld", lpdwValue2);
  }      
  return bValid;
}

int DecodeStarcraftKey( char *key) {
  u32 r, n, n2, v, v2, keyvalue;
  char c1, c2, c;
  int bValid;
  int i;

  v = 3;
  for (i = 0; i < 12; i++) {
    c = key[i];
    n = Get_Num_Value(c);
    n2 = v * 2;
    n ^= n2;
    v += n;
  }

  v %= 10;
  if (Get_Hex_Value(v) == key[12])
    bValid = 0;
  else
    bValid = -1;

  v = 194;
  for (i = 11; v >= 7, i >= 0; i--) {
    c = key[i];
    n = v / 12;
    n2 = v % 12;
    v -= 17;
    c2 = key[n2];
    key[i] = c2;
    key[n2] = c;
  }

  v2 = 0x13AC9741;
  for (i = 11; i >= 0; i--) {
    c = toupper(key[i]);
    key[i] = c;
    if (c <= '7') {
      v = v2;
      c2 = v & 0xFF;
      c2 &= 7;
      c2 ^= c;
      v >>= 3;
      key[i] = c2;
      v2 = v;
    } else if (c < 'A') {
      c2 = (u8) i;
      c2 &= 1;
      c2 ^= c;
      key[i] = c2;
    }
  }
  return bValid;
}

int DecodeD2Key( char *key) {
   u32 n2, v, v2;
   u8 c1, c2, c;
   int bValid;

   u32 r = 1, keyvalue = 0;
   for (int i = 0; i < 16; i += 2) {
      u32 n = (u32)codevalues[key[i+1]] + (u32)codevalues[key[i]] * (u32)24;

      if (n >= 0x100) {
        n -= 0x100;
        keyvalue += r;
      }

      key[i] = Get_Hex_Value(n >> 4);
      key[i+1] = Get_Hex_Value(n);

      r <<= 1;
   }

   v = 3;
   for (int i = 0; i < 16; i++) {
      c = key[i];
      u32 n = Get_Num_Value(c);
      n2 = v * 2;
      n ^= n2;
      v += n;
   }

   v &= 0xFF;
   if (v == keyvalue) {
      bValid = 0;
   } else {
      bValid = -1;
   }

   for (int i = 15; i >= 0; i--) {
      c = key[i];
      u32 n = (i > 8) ? (i - 9) : (0xF - (8 - i));
      n &= 0xF;
      c2 = key[n];
      key[i] = c2;
      key[n] = c;
   }

   v2 = 0x13AC9741;
   for (int i = 15; i >= 0; i--) {
      c = toupper(key[i]);
      key[i] = c;
      if (c <= '7') {
         v = v2;
         c2 = v & 0xFF;
         c2 &= 7;
         c2 ^= c;
         v >>= 3;
         key[i] = c2;
         v2 = v;
      } else if (c < 'A') {
         c2 = (u8) i;
         c2 &= 1;
         c2 ^= c;
         key[i] = c2;
      }
   }

   return bValid;
}

char Get_Hex_Value( u32 v) {
  v &= 0xF;
  if (v < 10)
    return (v + 0x30);
  else
    return (v + 0x37);
}

int Get_Num_Value( char c) {
  c = toupper(c);
  if (isdigit(c))
    return (c - 0x30);
  else
    return (c - 0x37);
}
