#include <string.h>
#include <ctype.h>
#include "tagban.h"
#include "mylib.h"

TagBan::TagBan( void) {
  first = 0;
}

TagBan::~TagBan( void) {
  clear();
}

void TagBan::clear( void) {
  while (first) {
    sTagBan *tmp = first->next;
    if (first->data)
      delete first->data;
    delete first;
    
    first = tmp;
  }
}


// Returns true on a match
int TagBan::tagCmp( char *wildcard, char *msg) {
  int wild = 0;
 
  while (*wildcard && *msg) {
    if (wild) {
      if (tolower(*wildcard) == tolower(*msg)) {
        if (tagCmp( wildcard - 1, ++msg))
          return( 1);
        wild = 0;
        wildcard++;
      } else
        msg++;
    } else {
      if (*wildcard == '*') {
        wildcard++;
        wild = 1;
      } else {
        if (tolower(*wildcard) != tolower(*msg))
          return( 0);
        wildcard++;
        msg++;
      }
    }
  }
 
  if (*msg && wild)
    return( 1);
 
  if (*wildcard || *msg)
    return( 0);
 
  return( 1);
}

int TagBan::exist( char *msg) {
  sTagBan *tmp = first;

  while (tmp) {
    if (tmp->data)
      if (!strcasecmp( tmp->data, msg))
        return( 1);
    tmp = tmp->next;
  }

  return( 0);
}

int TagBan::tagAdd( char *msg) {
  if (exist( msg)) return( -1);

  sTagBan *tmp = new sTagBan;

  tmp->next = first;
  tmp->data = new char[ strlen( msg) + 1];
  strcpy( tmp->data, msg);

  first = tmp;

  return( 0);
}

int TagBan::tagDel( char *msg) {
  if (!first) return( -1);

  if (!strcasecmp( first->data, msg)) {
    sTagBan *tmp = first->next;
    delete first->data;
    delete first;
    first = tmp;
    return( 0);
  }

  sTagBan *tmp = first;

  while (tmp->next) {
    if (tmp->next->data)
      if (!strcasecmp( tmp->next->data, msg)) {
        sTagBan *tmp2 = tmp->next;

        tmp->next = tmp2->next;

        delete tmp2->data;
        delete tmp2;

        return( 0);
      }
    tmp = tmp->next;
  }

  return( -1);
}

int TagBan::tagShow( Enqueue *enqueue) {
  char buf[ 1024];
  bzero( buf, sizeof( buf));

  if (!first) {
    enqueue->enqueue( 4, "TagBans: There are no tagbans");
    return( 0);
  }

  sTagBan *tmp = first;
  int num = 0;
  while (tmp) {
    if (!num)
      strcpy( buf, "TagBans: ");

    if (tmp->data) {
      strncat( buf, tmp->data, sizeof( buf) - 1);
      strncat( buf, " ", sizeof( buf) - 1);
      num++;
    }    

    if (num == 5) {
      enqueue->enqueue( 4, buf);
      num = 0;
    }
    tmp = tmp->next;
  }

  if (num)
    enqueue->enqueue( 4, buf);

  return( 0);
}

int TagBan::isBanned( char *msg) {
  sTagBan *tmp = first;

  while (tmp) {
    if (tmp->data)
      if (tagCmp( tmp->data, msg))
        return( 1);
    tmp = tmp->next;
  }
  return( 0);
}
