#include "config.h"

#ifdef WIN32
  #include <io.h>
  #include <windows.h>
  #include <winsock.h>
  #include <time.h>
  #include <conio.h>
  #include <map.h>
#endif

#include "tio.h"
#include "botlist.h"
#include "commandlist.h"
//#include "cas.h"
#include "enqueue.h"
#include "commandlist.h"
#include "vars.h"

class BotList;
class Vars;

extern BotList botlist;
extern Vars vars;
extern Enqueue enqueue;
//extern Cas cas;
extern CommandList commandlist;

TIO::TIO( void) {
}

TIO::~TIO( void) {
}

void TIO::instance( void) {
	//===
	// Select on all the file descriptors.
	for (;!globals->done;) {
		//===
		// Setup vars for select.
			int max = 0; fd_set rfds, wfds, efds;
			FD_ZERO( &rfds); FD_ZERO( &wfds); FD_ZERO( &efds);
			struct timeval tv;

			tv.tv_sec = 0;
			tv.tv_usec = 200000;
		
		//===
		// Listen on all the bots.
		{
			debug(("TIO::instance is adding the listen"));
			sBotList *tmp = botlist.first;
			while (tmp) {
				int fd = tmp->data->getfd();
				if (fd != -1) {
					FD_SET( fd, &rfds);
					if (tmp->data->selectWrite() == 1)
						FD_SET( fd, &wfds);
					FD_SET( fd, &efds);
	
					if ( fd > max)
						max = fd;
				}
				tmp = tmp->next;
			}
		}

		//===
		// BugFix: Win32 select on no args, appears to run 100% cpu
			debug(("TIO::instance is selecting"));
			int n = 0;
			if (max == 0)
				sleep( 1);
			else
				n = select( max + 1, &rfds, &wfds, &efds, &tv);
			debug(("TIO::instance is done selecting"));

		//===
		// Handle the bots.
			if (n) {
				debug(("TIO::instance is handling the bots"));
				sBotList *tmp = botlist.first;
				while (tmp) {
					int fd = tmp->data->getfd();
					if (fd != -1) {
						if (FD_ISSET( fd, &rfds) || FD_ISSET( fd, &efds))
							tmp->data->handler();
								
						if (FD_ISSET( fd, &wfds)) {
							debug(("TIO::instance is calling pkt_connected"));
							tmp->data->pkt_connected();
							debug(("TIO::instance is done calling pkt_connected"));
						}

						debug(("TIO::instance is testing between the two bloody }'s"));
					}
					debug(("TIO::instance tmp = tmp->next"));
					tmp = tmp->next;
					debug(("TIO::instance is done w/ tmp = tmp->next"));
				}
			}

		//===
		// Calling idle
			debug(("TIO::instance idle()"));
			idle();
			debug(("TIO::instance ~idle()"));
	}
}

void TIO::idle( void) {

	debug(("TIO::idle is idling the bots"));
	sBotList *tmp = botlist.first;
	while (tmp) {
		if (tmp->data)
			tmp->data->idle();
		tmp = tmp->next;
	}

	debug(("TIO::idle is idling the command list"));
	sCommandList *tmp2 = commandlist.first;
	while (tmp2) {
		if (tmp2->data)
			tmp2->data->idle();
		tmp2 = tmp2->next;
	}

	debug(("TIO::idle is idling the enqueue"));
	enqueue.idle();

	return;
}
