#include <string.h>
#include "mylib.h"
#include "user.h"

User::User( UserList *_parent) {
  parent = _parent;

  bzero( name, sizeof( name));
  access = flags = 0;
  bzero( banmessage, sizeof( banmessage));
  offset = 0;
}

User::~User( void) {
}

int User::setName( char *_name) {
  if (!_name) return( -1);
  strncpy( name, _name, sizeof( name) - 1);

  parent->saveUser( this);
  return( 0);
}

int User::setOffset( u32 _offset) {
  offset = _offset;
  return( 0);
}

int User::setAccess( int _access) {
  access = _access;
  if (access < 0) access = 0;
  if (access > 255) access = 255;

  parent->saveUser( this);
  return( 0);
}

int User::setFlags( int _flags) {
  flags = _flags;

  parent->saveUser( this);
  return( 0);
}

int User::setBanMessage( char *_message) {
  if (!_message) return( -1);
  strncpy( banmessage, _message, sizeof( banmessage) - 1);

  parent->saveUser( this);
  return( 0);
}

u32 User::getOffset( void) {
  return( offset);
}

char *User::getName( void) {
  return( name);
}

int User::getAccess( void) {
  return( access);
}

int User::getFlags( void) {
  return( flags);
}

char *User::getBanMessage( void) {
  return( banmessage);
}
