#ifdef WIN32
  #include <windows.h>
  #include <io.h>
#else
  #include <unistd.h>                       
#endif

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
//#include "display.h"
//#include "input.h"
#include "config.h"
#include "mylib.h"

//extern Display *disp;
//extern Input *input;
                     
#include "userlist.h"

UserList::UserList( void) {
  fd = -1;
  first = 0;
  save = 0;
}

UserList::~UserList( void) {
  struct sUserList *tmp = first;

  while (first) {
    if (first->data)
      delete first->data;
    tmp = first;
    first = tmp->next;
    delete tmp;
  }

  if (fd != -1)
    close( fd);
}

void UserList::add( User *data) {
  struct sUserList *tmp;

  tmp = new sUserList;
  if (!tmp) {
    delete data;
    return;
  }

  tmp->data = data;
  tmp->next = first;

  first = tmp;
}

void UserList::remove( User *data) {
  sUserList *tmp = first;

  if (!tmp) return;

  if (tmp->data == data) {
    delete tmp->data;
    first = tmp->next;
    delete tmp;
    return;
  }

  for (;;) {
    if (tmp->next)
      if (tmp->next->data == data) {
        delete tmp->next->data;
        sUserList *tmp2 = tmp->next;
        tmp->next = tmp->next->next;
        delete tmp2;
        break;
      }
    else
      break;
    tmp = tmp->next;
  }
}

User *UserList::getFirst( void) {
  if (!first)
    return( 0);
  return( first->data);
}

User *UserList::getUser( char *name) {
  sUserList *tmp = first;
  while (tmp) {
    if (tmp->data)
      if (!strcasecmp( tmp->data->getName(), name))
        return( tmp->data);
    tmp = tmp->next;
  }
  return( 0);
}

int UserList::setDatabase( char *filename) {
  char buf[ 32 + 4 + 4 + 128]; char ch = -1;

  fd = open( filename, O_CREAT | O_RDWR, S_IRUSR | S_IWUSR);
  if (fd == -1) {
    //disp->clrline();
    //*disp << "ERROR: Unable to load the database " << filename << endl;
    //input->update();
    return( -1);
  }
  
  int size = lseek( fd, 0, SEEK_END);
  if (!size)
    write( fd, &ch, 1);
    
  lseek( fd, 1, SEEK_SET);

  save = 0;
  while (read( fd, buf, sizeof( buf)) == sizeof( buf)) {
    u32 offset = lseek( fd, 0, SEEK_CUR) - sizeof( buf);
    User *user = new User( this);
    user->setOffset( offset);

    user->setName( buf);
    user->setAccess( *(u32 *)(buf + 32));
    user->setFlags( *(u32 *)(buf + 36));
    user->setBanMessage( buf + 40);
    add( user);

    #ifdef DEBUGUSERLIST
      disp->clrline();
      *disp << "DEBUGUSERLIST: ADDED USER " << buf << "===============" << endl;
      //input->update();
      disp->clrline();
      *disp << "DEBUGUSERLIST: ADDED USER sanity check" << buf << "===============" << endl;
      //input->update();
    #endif
  }
  save++;

  return( 0);
}

int UserList::saveUser( User *user) {
  if (fd == -1) return( -1);
  if (!save)    return( -1);
  if (!user)    return( -1);

  #ifdef DEBUGUSERLIST
    disp->clrline();
    *disp << "DEBUGUSERLIST: Saving " << user->getName() << " at offset " << user->getOffset() << endl;
    //input->update();
  #endif

  u32 offset = user->getOffset();
  if (!offset) {
    offset = lseek( fd, 0, SEEK_END);
    offset = (offset + 1) / (32 + 4 + 4 + 128);
    offset = offset * (32 + 4 + 4 + 128) + 1;
    user->setOffset( offset);
  }

  lseek( fd, offset, SEEK_SET);
  write( fd, user->getName(), 32);

  int i;
  i = user->getAccess(); write( fd, &i, 4);
  i = user->getFlags();  write( fd, &i, 4);

  write( fd, user->getBanMessage(), 128);

  return( 0);
}
