// Todo:
//   Probably should have some credits and clean this up, etc etc
//   Yobguls did the public disasm->c of this. Skywing did some crc
//   stuff, etc etc. I made a port to unix, but blah blah. >;-)

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>

#ifndef WIN32
  #include <unistd.h>
#else
  #include <windows.h>
  #include <io.h>
#endif

//#include "display.h"
//#include "input.h"
#include "vercheck.h"
#include "globals.h"

//extern Display *disp;
//extern Input *input;

/* These are special keys that vary depending upon which DLL it is that you're using
 * They're used to initialize the first variable (A) as part of the checksum algorithm */
/* Thanks to Skywing for the additional checksum keys */
//u32 dwMpqChecksumKeys[] = {
//  0xE7F4CB62, 0xF6A14FFC, 0xAA5504AF,
//  0x871FCDC2, 0x11BF6A18, 0xC57292E6,
//  0x7927D27E, 0x2FEC8733
//};
u32 mpqCrc[] = {
	0xE7F4CB62, 0xF6A14FFC, 0xAA5504AF,
	0x871FCDC2, 0x11BF6A18, 0xC57292E6,
	0x7927D27E, 0x2FEC8733
};


/* The unix atol didn't work, because the input is unsigned */
u32 uatol( char *s) {
  u32 a = 0;

  if (!s) return( a);

  while (*s && isdigit(*s)) {
    if (a) a *= 10;
    a += *s++ - '0';
  }

  return( a);
}

VerCheck::VerCheck( void) {
}

VerCheck::~VerCheck( void) {
}

// Generally ran from the auth thread.
//  0 - Ok
// -1 - Invalid Parameters
// -2 - Unable to open hash files
int VerCheck::checkRevision( char *equ, int mpq, u32 *var, char *f1, char *f2, char *f3) {
	debug(("VerCheck::checkRevision was called"));
	if (mpq < 0 || mpq >= (int)sizeof(mpqCrc)) return -1;
	int nvar = 0, nhash = 0; int vars[ 16];

	//===
	// Early Debugging
	//#ifdef DEBUG
	//	*globals->mylog << "VerCheck::checkRevision( " << (int)client << ", " << equ << ", " << mpq
	//	                << ", " << (int)var << ", " << f1 << ", " << f2 << ", " << f3 << ")" << endl;
	//#endif

  //===
  // Equ: A=3066839436 B=1452667226 C=775240323 4 A=A^S B=B^C C=C^A A=A-B
  // vars[0] is 3066839436
  // vars[1] is 1452667226
  // vars[2] is 775240323
	debug(("VerCheck::checkRevision phase 1"));
  while (*equ) {
    if (isalpha(*equ))
      nvar = (int)(toupper(*equ) - 'A');
    else {
      nhash = (int)(*equ - '0');
      if (*(++equ))
        equ++;
      else {
			//*globals->mylog << "VerCheck::checkRevision error. Invalid server EQU." << endl;
			return( -1);
		}
      if (nhash & 0xfffffff0) {
			//*globals->mylog << "VerCheck::checkRevision error. nhash in server EQU" << endl;
      	return -1;
      }
      break;
    }

    if (*++equ == '=')
      equ++;

    vars[ nvar] = uatol(equ);
    equ = strchr( equ, ' ');
    if (!equ++) {
		//*globals->mylog << "VerCheck::checkRevision error. Missing space in server EQU" << endl;
    	return -1;
    }
  }

  //===
  // nvars[0] = A A ^ S
  // nvars[1] = B B ^ S
  // nvars[2] = C C ^ S
  // nvars[3] = A A - S
	debug(("VerCheck::checkRevision phase 2"));
  int len = strlen( equ);
  int nvars[nhash][4];
  for (int i = 0; i < nhash; i++, equ++) {
    if (len < 5) {
		//*globals->mylog << "VerCheck::checkRevision error. Length to small on server EQU" << endl;
    	return -1;
    }
    for (int o = 0; o < 4; o++ ? equ++ : (++equ)++)
      if (o == 2)
        nvars[i][o] = *equ;
      else {
        nvars[i][o] = *equ == 'S' ? (nhash - 1) : (toupper(*equ) - 'A');
        if (nvars[i][o] > nhash) {
			//*globals->mylog << "VerCheck::checkRevision error. nvars[i][o] > nhash" << endl;
        	return -1;
        }
      }

    len -= 5;
  }

	//===
	// Early debugging
	// printf("NumHash: %d\n", nhash);
	// for (int i = 0; i < (nhash-1); i++)
	//   printf("vars[%d] is %u\n", i, vars[i]);
	// 
	// for (int i = 0; i < nhash; i++)
	//   for (int o = 0; o < 4; o++)
	//     printf("nvars[%d][%d] is set to %u\n", i, o, nvars[i][o]);
	debug(("VerCheck::checkRevision phase 3"));

  vars[0] ^= mpqCrc[mpq];

  //===
  // Open the hash files, in reality all hash files will be opened already
  // and we will call something else, but that's for another day.
	debug(("VerCheck::checkRevision phase 4"));
  char *files[3];
  files[0] = f1;
  files[1] = f2;
  files[2] = f3;

  //char *files[3] = { "./Binaries/war2/Warcraft II BNE.exe",
  //                   "./Binaries/war2/storm.dll",
  //                   "./Binaries/war2/battle.snp"
  //                 };
	debug(("VerCheck::checkRevision phase 5"));
  int size[3];
  char *data[3];
	#ifdef WIN32
		HANDLE fd[3];
		HANDLE fdmap[3];
	#endif
  for (int i = 0; i < 3; i++) {
		#ifdef WIN32
			// HANDLE fd, fdmap;
			fd[i] = CreateFile( files[i], GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			if (fd[i] == (HANDLE)INVALID_HANDLE_VALUE) {
				//*globals->mylog << "VerCheck::checkRevision error. Unable to open \"" << files[i] << "\"" << endl;
				return -1;
			}
			fdmap[i] = CreateFileMapping( fd[i], NULL, PAGE_READONLY, 0, 0, NULL);
			
			size[i] = GetFileSize( fd[i], NULL);
			data[i] = (char *)MapViewOfFile( fdmap[i], FILE_MAP_READ, 0, 0, 0);

			//===
			// Todo: These need to be freed :)
		#else
	    int fd = open(files[i], O_RDONLY);
			if (!fd) {
				//*globals->mylog << "VerCheck::checkRevision error. Unable to open \"" << files[i] << "\"" << endl;
    		return -1;
    	}
			size[i] = lseek( fd, 0, SEEK_END);
			data[i] = new char[ size[i]];
			// printf("Opened %s is %d bytes\n", files[i], size[i]);

			lseek( fd, 0, SEEK_SET);
			int tmp = size[i];
			char *tbuf = data[i];
			while (tmp > 0) {
				int n = read( fd, tbuf, 4096);
				if (n > 0) {
					tbuf += n;
					tmp -= n;
				}
				//printf("%d bytes left\n", tmp);
			}

			//printf("Closing file %s", files[i]);
			close( fd);
		#endif
  }

  //===
  // Todo: This *seriously* *needs* to be unrolled.
	debug(("VerCheck::checkRevision phase 6"));
  for (int i = 0; i < (nhash-1); i++) {
    int *buf = (int *)data[i];
    int len = size[i];
    len &= 0xfffffc00;
    len /= 4;

    for (int j = 0; j < len; j++) {
      vars[3] = buf[j];
      for (int k = 0; k < nhash; k++)
        switch(nvars[k][2]) {
          case '+': vars[nvars[k][0]] = vars[nvars[k][1]] + vars[nvars[k][3]]; break;
          case '-': vars[nvars[k][0]] = vars[nvars[k][1]] - vars[nvars[k][3]]; break;
          case '^': vars[nvars[k][0]] = vars[nvars[k][1]] ^ vars[nvars[k][3]]; break;
        }
    }
  }

	debug(("VerCheck::checkRevision phase 7"));
	#ifndef WIN32
		for (int i = 0; i < 3; i++)
			delete data[i];
	#endif

	#ifdef WIN32
		for (int i = 0; i < 3; i++) {
			UnmapViewOfFile( data[i]);			
			CloseHandle( fdmap[i]);
			CloseHandle( fd[i]);
		}
	#endif


	*var = vars[2];

	//*globals->mylog << "VerCheck::checkRevision all went well returning 0" << endl;
	debug(("VerCheck is done"));
	return( 0);
}

//===
// Old stuff
// 
// VerCheck::VerCheck( void) {
// 	//char *file1, char *file2, char *file3) {
// 	//for (int i = 0; i < VERCHECK_NFILES; i++) {
//     // bzero( files[i].name, VERCHECK_MAXLEN);
//    // files[i].size = 0;
//    // files[i].data = NULL;
//   //}
// 
//   //load( 0, file1);
//   //load( 1, file2);
//   //load( 2, file3);
// }
// 
// VerCheck::~VerCheck( void) {
// 	//for (int i = 0; i < VERCHECK_NFILES; i++)
// 	// if (files[i].data)
// 	//   delete files[i].data;
// }
// 
// int VerCheck::checkrev( char *value, char *filename, u32 *mevar) {
//   #ifdef DEBUGVER
//     disp->clrline();
//     *disp << "Debug: VerCheck::checkrev was called" << endl
//          << "       " << value << endl
//          << "       " << filename << endl; 
//     input->update();
//   #endif
// 
//   char *s = strchr( filename, '.');
//   if (!s) return( -1);
// 
//   int nHashFile = (int) (*(s - 1) - '0');
//   if (nHashFile > 7 || nHashFile < 0)
//     return( -1);
// 
//   u32 dwMpqKey = dwMpqChecksumKeys[nHashFile];
//   s = value;
//   
//   int nVariable, nHashOperations;
//   u32 dwVariables[4];
//   
//   while (*s) {
//     if (isalpha(*s))
//       nVariable = (int) (toupper(*s) - 'A');
//     else {
//       nHashOperations = (int) (*s - '0');
//       s = strchr(s, ' ');
//       if (!s) return( -1);
//       s++;
//       break;
//     }
//       
//     if (*(++s) == '=')
//       s++;
// 
//     dwVariables[ nVariable] = uatol(s);
//     s = strchr(s, ' ');
//     if (!s) return( -1);
//     
//     s++;
//   }
//   
//   char cOperations[16];
//   int nVariable1[16], nVariable2[16], nVariable3[16];
//   for (int i = 0; i < nHashOperations; i++) {
//     if (!isalpha(*s)) return( -1);
//     
//     nVariable1[i] = (int) (toupper(*s) - 'A');
//     if (*(++s) == '=')
//       s++;
//       
//     if (toupper(*s) == 'S')
//       nVariable2[i] = 3;
//     else
//       nVariable2[i] = (int) (toupper(*s) - 'A');
//     
//     cOperations[i] = *(++s);
//     s++;
//     
//     if (toupper(*s) == 'S')
//       nVariable3[i] = 3;
//     else
//       nVariable3[i] = (int) (toupper(*s) - 'A');
//     
//     s = strchr(s, ' ');
//     if (!s)
//       break;
//     s++;
//   }
// 
//   dwVariables[0] ^= dwMpqKey;
// 
//   int i, j, k;
//   for (int i = 0; i < 3; i++) {
//     //disp.clrline();
//     //disp << "Debug: files[" << i << "].data is " << endl //<< (int)files[i].data << endl
//     //     << "       size is " << (int)files[i].size << endl;
//     //input.update();
//         
//     int *lpdwBuffer = (int *)files[i].data;
//     if (!lpdwBuffer)
//       return( -1);
// 
//     int dwSize = files[i].size;
//     
//     dwSize &= 0xfffffc00;
//     
//     for (j = 0; j < (dwSize / 4); j++) {
//       dwVariables[3] = lpdwBuffer[j];
//       //if (j < 100)
//       //  *disp << i << " " << j << dwVariables[3] << endl;
//       for (k = 0; k < nHashOperations; k++) {
//         switch (cOperations[k]) {
//           case '+':
//             dwVariables[nVariable1[k]] = dwVariables[nVariable2[k]] +
//                                          dwVariables[nVariable3[k]];
//             break;
//           case '-':
//             dwVariables[nVariable1[k]] = dwVariables[nVariable2[k]] -
//                                          dwVariables[nVariable3[k]];
//             break;
//           case '^':
//             dwVariables[nVariable1[k]] = dwVariables[nVariable2[k]] ^
//                                          dwVariables[nVariable3[k]];
//             break;
//           default:
//             return( -1);
//         }
//       }
//       // disp << "Debug: j: " << j << ", k: " << k << endl;
//     }
//   }
// 
//   //disp.clrline();
//   //disp << "Debug: VerCheck::checkrev is leaving" << endl;
//   //input.update();
// 
//   *mevar = dwVariables[2];
//   //disp->clrline();
//   //*disp << "Returning: " << dwVariables[2] << endl;
//   //input->update();
//   return( 0);
// }
// 
// int VerCheck::load( int num, char *filename) {
//   // WINBLOWS IS GAY
//   #ifdef WIN32
//     HANDLE fd, fdmap;
//     fd = CreateFile( filename, GENERIC_READ,
//                      FILE_SHARE_READ, NULL, OPEN_EXISTING,
//                      FILE_ATTRIBUTE_NORMAL, NULL);
//     if (fd == (HANDLE)INVALID_HANDLE_VALUE) {
//       char buf[ 1024];
//       sprintf(buf, "Error: Unable to open %s. You need to copy over the exe/dll/snp and files. Look at the config file to specify these.", filename);
// 
//       MessageBox(NULL, buf, "Error!", MB_ICONEXCLAMATION | MB_OK);
//       globals->done++;
//       return( -1);
//     }
// 
//     fdmap = CreateFileMapping( fd, NULL, PAGE_READONLY, 0, 0, NULL);
// 
//     files[ num].size = GetFileSize( fd, NULL);
//     files[ num].data = (char *)MapViewOfFile( fdmap, FILE_MAP_READ, 0, 0, 0);
// 
//   #else
//     // strncpy( files[ num].name, filename, VERCHECK_MAXLEN - 1);  
//     // disp << "Debug: VerCheck::load( " << num << ", " << filename << ");" << endl;
// 
//     int fd = open( filename, O_RDONLY);
//     if (fd == -1) {
//       //disp->clrline();
//       //*disp << "Error: Unable to open " << filename << endl;
//       //input->update();
//       globals->done++;
//       return( -1);
//     }
// 
//     files[ num].size = lseek( fd, 0, SEEK_END);
//     lseek( fd, 0, SEEK_SET);
// 
//     if (files[ num].data)
//       delete files[ num].data;
// 
//     files[ num].data = new char[ files[ num].size];
// 
//     int tmp = files[ num].size;
//     char *tbuf = files[ num].data;
//   
//     // FixMe: Code this correctly...
//     while (tmp > 0) {
//       int n = read( fd, tbuf, 4096);
//       if (n > 0) {
//         tbuf += n;
//         tmp -= n;
//       }
//     }
//   
//     close( fd);
//     //disp << "Debug: VerCheck::load read " << (int)files[ num].size << " bytes." << endl;
//   #endif
// 
//   return( 0);
// }
