
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "config.h"
#include "window.h"
#include "tools/build.h"
#include "input.h"
#include "mylib.h"
#include "bot.h"
#include "vars.h"
#include "globals.h"

#ifdef DISP_GTK
#  include "support.h"
#  include "wndfont.h"
#  include "Images/icons_alizee.xpm"
#  include "Images/icons_diablo2.xpm"
#  include "Images/icons_jsc.xpm"
#  include "Images/icons_sware.xpm"
#  include "Images/icons_bliz.xpm"
#  include "Images/icons_diablosw.xpm"
#  include "Images/icons_sc.xpm"
#  include "Images/icons_war2.xpm"
#  include "Images/icons_chat.xpm"
#  include "Images/icons_gavel.xpm"
#  include "Images/icons_starx.xpm"
#  include "Images/icons_war3.xpm"
#  include "Images/stock_clear.xpm"
#  include "Images/stock_colorselector.xpm"
#  include "Images/stock_properties.xpm"
#  include "Images/stock_text_bold.xpm"

gboolean on_wndDisp_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data) {
  return FALSE;
}

void on_wndDisp_destroy( GtkObject *object, gpointer user_data) {
}

//===
// Gtk called us, don't lock.
void on_btnClear_clicked( GtkButton *button, gpointer user_data) {
	//gtk_text_thaw( GTK_TEXT( ((Window *)user_data)->text1));
	//gtk_editable_delete_text( (GtkEditable *)((Window *)user_data)->text1, 0, -1);
	gtk_text_backward_delete(
		GTK_TEXT( ((Window *)user_data)->text1),
		gtk_text_get_length ( GTK_TEXT( ((Window *)user_data)->text1) )
	);

	((Window *)user_data)->buffer_enter = 0;

	//gtk_text_set_point( GTK_TEXT( ((Window *)user_data)->text1), 0);
	//gtk_text_freeze( GTK_TEXT( ((Window *)user_data)->text1));
}

void on_btnProp_clicked( GtkButton *button, gpointer user_data) {
}

void on_btnUnk_clicked( GtkButton *button, gpointer user_data) {
}

void on_btnFont_clicked( GtkButton *button, gpointer user_data) {
  new WndFont( (Window *)user_data);
}

void on_checkbutton1_toggled( GtkToggleButton *togglebutton, gpointer user_data) {
}

void on_clist1_select_row( GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
}

//void on_entry1_activate( GtkEditable *editable, gpointer user_data) {
//  ((WndDisp *)user_data)->handleInput( editable);
//}


#endif

#ifdef WIN32_NATIVE
  extern HINSTANCE hInstance;
  extern int nCmdShow;
  extern HFONT font;
#endif

extern Input *input;
extern Vars vars;

extern unsigned char *zenc_Encrypt( unsigned char *msg);
extern char *Encrypt(char *source);

#ifdef WIN32_NATIVE

// void Put( const char *format, ...);

// (INSERT REALLY NASTY WORDS HERE) MICROSOFT - YOU SUCK.
  Window *BOBBYBROWN;


void on_entry1_activate( Window *disp);

LRESULT CALLBACK window_proc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
  switch(msg) {
    case WM_CREATE:
      {
        // Window *window = (Window *)lParam;
        Window *window = BOBBYBROWN; // (Window *)GetWindowLong( hwnd, GWL_USERDATA);
        SetWindowLong( hwnd, GWL_USERDATA, (LONG)window);

        window->text1=CreateWindowEx( WS_EX_LEFT | WS_EX_LTRREADING | WS_EX_RIGHTSCROLLBAR,
                            "RichEdit",
                            "",
                            ES_READONLY | WS_VISIBLE | WS_CHILD | ES_LEFT | ES_MULTILINE | WS_VSCROLL | ES_AUTOVSCROLL,
                            0, 0,
                            0, 0,
                            hwnd, NULL, hInstance, NULL);
        SendMessage( window->text1, EM_SETBKGNDCOLOR, 0, RGB( 0, 0, 0));

        CHARFORMAT fmt;
        
        SendMessage( window->text1, EM_GETCHARFORMAT, 0, (LPARAM)&fmt);
        fmt.cbSize = sizeof( CHARFORMAT);
        fmt.dwMask = CFM_COLOR | CFM_BOLD;
        fmt.crTextColor = RGB( 255, 255, 255);
        SendMessage( window->text1, EM_SETCHARFORMAT, 0, (LPARAM)&fmt);

        SendMessage( window->text1, WM_SETFONT, (WPARAM)font, (LPARAM)TRUE);
        
        window->entry1 = CreateWindowEx( WS_EX_LEFT | WS_EX_LTRREADING,
                            "RichEdit",
                            "",
                            WS_VISIBLE | WS_CHILD | ES_LEFT | ES_AUTOHSCROLL | WS_BORDER | WS_THICKFRAME | ES_WANTRETURN  | WM_CHAR | WM_KEYDOWN | WM_KEYUP,
                            0, 0,
                            0, 0,
                            hwnd, NULL, hInstance, NULL);
        SendMessage( window->entry1, EM_SETEVENTMASK, 0, ENM_KEYEVENTS);

        window->clist = CreateWindowEx( 0, "listbox", "", 
                            WS_VSCROLL | WS_VISIBLE | WS_CHILD | LBS_EXTENDEDSEL | LBS_HASSTRINGS | LBS_SORT | LBS_NOINTEGRALHEIGHT | LBS_NOTIFY,
                            0, 0,
                            0, 0,
                            hwnd, NULL, hInstance, NULL);
        SendMessage( window->clist, WM_SETFONT, (WPARAM)font, (LPARAM)TRUE);
        SendMessage( window->clist, 0x0200, (WPARAM)1, (LPARAM)&(window->lvCol));
        //
        //SetFocus( window->text1);
      }
      break;
    case WM_SIZE:
      {
        Window *window = (Window *)GetWindowLong( hwnd, GWL_USERDATA);
        MoveWindow( window->text1,                     0,                 0, LOWORD(lParam) - 140, HIWORD(lParam)-24, TRUE);
        MoveWindow( window->entry1,                   -3, HIWORD(lParam)-24, LOWORD(lParam)+2*3,              24+5, TRUE);
        MoveWindow( window->clist,  LOWORD(lParam) - 140,                 0,                  140, HIWORD(lParam)-24, TRUE);
      }
      break;
    case WM_NOTIFY:
      {
        Window *window = (Window *)GetWindowLong( hwnd, GWL_USERDATA);
        MSGFILTER *mf = (MSGFILTER*)lParam;
        switch( mf->nmhdr.code) {
          case EN_MSGFILTER:
            if (mf->msg == WM_KEYUP && mf->wParam == VK_RETURN)
              on_entry1_activate( window);
            break;
        }
      }

    default:
      return DefWindowProc(hwnd, msg, wParam, lParam);
  }
}

#endif

#ifdef GUI
#ifdef DISP_GTK
  

  void window_on_window1_destroy( GtkEditable *editable, gpointer data) {
    ((Window *)data)->background = 1;
    //((Window *)data)->parent->setDisplay( "0");
  }

  void on_entry1_activate(GtkEditable *editable, gpointer user_data) {
    Window *disp = (Window *)user_data;
    Bot *bot = disp->parent;
#endif
#ifdef WIN32_NATIVE
  void on_entry1_activate( Window *disp) {
    Bot *bot = disp->parent;
#endif

    // input->setbuf( gtk_entry_get_text( GTK_ENTRY(editable)));
  #ifdef DISP_GTK
    char *command = gtk_entry_get_text( GTK_ENTRY(editable));
  #endif
  #ifdef WIN32_NATIVE
    char cmdbuf[ 1024];
    GetWindowText( disp->entry1, cmdbuf, sizeof( cmdbuf) - 1);
    char *command = cmdbuf;
  #endif

    if (!command) return;
    if (char *tmp = strchr( command, '\r')) *tmp = 0;
    if (char *tmp = strchr( command, '\n')) *tmp = 0;

    if (!strcmp( command, "/quit")) {
      globals->done++;
      #ifdef DISP_GTK
        gtk_main_quit();
      #endif
      disp->clear(); return;
    }
    if (!strcmp( command, "/status")) {
      *disp << "Bot:             " << bot->getName() << endl
            << "  Password:      " << bot->getPasswd() << endl
            << "  Server:        " << bot->getServer() << endl
            << "  Home Channel:  " << bot->getHomeChannel() << endl
            << "  CD Key:        " << bot->getCDKey() << endl
            << "  Registered:    " << bot->getRegister() << endl
            << "  Command Set:   " << bot->getCommandSet() << endl
            << "  Spawn:         " << bot->getSpawn() << endl;
      disp->clear(); return;
    }
    if (!strcmp( command, "/help")) {
      *disp << CBWHITE << "Help:" << endl << CBGREEN
            << "       /clear      - Clear the screen" << endl
            << "       /quit       - Quit" << endl
            << "       /e          - Encrypt using zEnc" << endl
            << "       /ev         - Encrypt using the vlbbot method" << endl
            << "       /h          - Encrypt using the hex method" << endl
            << "       /eon        - Sets crypt on" << endl
            << "       /eoff       - Sets crypt off" << endl
            << "       /set        - Shows the list of variables" << endl
            << "                   - Set's the list of variables" << endl
            << "       /status     - Shows some basic status info for each bot" << CWHITE << endl;
      disp->clear(); return;
    }

    if (!strncmp( command, "/profile ", 9)) {
      if (disp->parent->sendReqProfile( command + 9))
        *disp << "Error: Unable to send profile request" << endl;
      else
        *disp << "Info:  Profile request sent." << endl;
      disp->clear(); return;
    }

    if (!strncmp( command, "/join ", 6)) {
      disp->parent->setHomeChannel( command + 6);
      disp->clear(); return;
    }
    if (!strcmp( command, "/clear")) {
      disp->cls();
      disp->clear(); return;
    }
    if (!strcmp( command, "/set")) {
      vars.showVars( disp, 0);
      disp->clear(); return;
    }
    if (!strncmp( command, "/set ", 5)) {
      char *tmp = strstr( command + 5, " ");
      if (!tmp) {
        *disp << "Error: You must pass a variable and a value for /set to set. >;-)" << endl;
        disp->clear(); return;
      }
      *(tmp++) = '\0';
      vars.setVar( command + 5, tmp);
      disp->clear(); return;
    }
    if (!strncmp( command, "/h ", 3)) {
      char buf[ 1024]; char *tmp2 = buf + 1;
      char *tmp = command + 3;
      buf[0] = 0xA3;
      while (*tmp) {
        sprintf( tmp2, "%.2x", *tmp);
        tmp2 += 2;
        tmp++;
      }
      *tmp2 = 0;

      bot->enqueue( 0, "%s", buf);
      disp->clear(); return;
    }

    if (!strncmp( command, "/e ", 3)) {
      char buf[ 1024];
      strcpy( buf, (char *)zenc_Encrypt( (unsigned char *)(command + 3)));

      bot->enqueue( 0, "%s", buf);
      disp->clear(); return;
    }
    if (!strcmp( command, "/eoff")) {
      *disp << CBWHITE << "Info:  " << CWHITE << "Crypt set off" << endl;
      disp->ENC_MODE = 0;
      disp->clear(); return;
    }
    if (!strcmp( command, "/eon")) {
      *disp << CBWHITE << "Info:  " << CWHITE << "Crypt set on" << endl;
      disp->ENC_MODE = 3;
      disp->clear(); return;
    }
    if (!strncmp( command, "/ev ", 4)) {
      char buf[ 1024];
      buf[0] = '';
      strcpy( buf + 1, Encrypt( command + 4));

      bot->enqueue( 0, "%s", buf);
      disp->clear(); return;
    }
    if (!strcmp( command, "/set")) {
      vars.showVars( disp, NULL);
      disp->clear(); return;
    }

    switch( disp->ENC_MODE) {
      case 3:
        bot->enqueue( 0, "%s", (char *)zenc_Encrypt( (unsigned char *)command));
        break;
      case 0:
        bot->enqueue( 0, "%s", command);
        break;
    }

    disp->clear();
  }

#endif

Window::Window( Bot *_parent) {
  parent = _parent;
  ENC_MODE = 0;

  #ifdef WIN32_NATIVE
    window1 = 0;
    // cilist  = 0;
  #endif


  init();
}

Window::~Window( void) {
  //#if OS_WIN32_NATIVE
  //  if (cilist)
  //    delete cilist;
  //#endif
}

int Window::add( char *txt) {
  if (background)
    return( 0);

  #ifdef DISP_GTK
  
  GdkColor black;
  black.red = 0;
  black.green = 0;
  black.blue = 0;

  gtk_widget_realize (text1);
  if (buffer_enter) {
	if (frozen)
    gtk_text_thaw( GTK_TEXT( text1));

    gtk_text_insert( GTK_TEXT( text1), ourfont, &color, 0, "\n", -1);

	if (frozen)
    gtk_text_freeze( GTK_TEXT( text1));
    buffer_enter = 0;
  }
    
  if (txt[ strlen( txt) - 1] == '\n') {
    buffer_enter = 1;
    txt[ strlen( txt) - 1] = 0;
  }

  gtk_text_insert( GTK_TEXT( text1), ourfont, &color, 0, txt, -1);
  //gtk_text_insert( GTK_TEXT( text1), 0, &color, &black, txt, -1);
  //gtk_text_thaw (GTK_TEXT (text1));

  #endif
  return( 0);
}

int Window::setColor_( int curcolor) {
  #ifdef WIN32_NATIVE
  CHARFORMAT fmt;

  bzero( &fmt, sizeof( fmt));

  SendMessage( text1, EM_GETCHARFORMAT, 0, (LPARAM)&fmt);
  
  fmt.cbSize = sizeof( CHARFORMAT);
  fmt.dwMask = CFM_COLOR;
  
  switch( curcolor) {
    case 1:  fmt.crTextColor = RGB( 128,   0,   0); break;
    case 2:  fmt.crTextColor = RGB(   0, 128,   0); break;
    case 3:  fmt.crTextColor = RGB(   0,   0, 128); break;
    case 5:  fmt.crTextColor = RGB( 128,   0, 128); break;
    case 6:  fmt.crTextColor = RGB(   0, 128, 128); break;
    case 8:  fmt.crTextColor = RGB( 128, 128, 128); break;
    case 9:  fmt.crTextColor = RGB(   0,   0, 255); break;
    case 10: fmt.crTextColor = RGB(   0, 255,   0); break;
    case 11: fmt.crTextColor = RGB(   0, 255, 255); break;
    case 12: fmt.crTextColor = RGB( 255,   0,   0); break;
    case 13: fmt.crTextColor = RGB( 255,   0, 255); break;
    case 14: fmt.crTextColor = RGB( 255, 255,   0); break;
    case 15: fmt.crTextColor = RGB( 255, 255, 255); break;
    default: fmt.crTextColor = RGB( 192, 192, 192);
  }
  SendMessage( text1, EM_SETCHARFORMAT, 1, (LPARAM)&fmt);

  #endif
  return( 0);
}

void Window::print( char *str, ... ) {
  #ifdef WIN32_NATIVE
  // int curcolor; // static char curcolor = 7;

  if (!str) return;

  va_list args;
  char buf[ 8192];
  bzero( buf, sizeof( buf));

  va_start(args, str);
  _vsnprintf(buf, sizeof(buf), str, args);
  va_end(args);

  // Put( buf);

  char *start = buf, *tmp = buf;
  while (*tmp) {
    if (*tmp < 16) {
      char col = *tmp;
      *tmp = 0;

      SendMessage( text1, EM_SETSEL, 0x7FFFFFFF, 0x7FFFFFFF);
      setColor_( curcolor);
      SendMessage(text1, EM_REPLACESEL, 0, (LPARAM)(start));

      curcolor = col;
      start = tmp + 1;
    }

    if (*tmp == 16) {
      *tmp = 0;

      SendMessage(text1, EM_SETSEL, 0x7FFFFFFF, 0x7FFFFFFF);
      setColor_( curcolor);
      SendMessage(text1, EM_REPLACESEL, 0, (LPARAM)(start));      
      SendMessage(text1, EM_SETSEL, 0x7FFFFFFF, 0x7FFFFFFF);
      SendMessage(text1, EM_REPLACESEL, 0, (LPARAM)"\n");

      start = tmp + 1;
    }
    tmp++;
  }

  if (*start) {
    SendMessage(text1, EM_SETSEL, 0x7FFFFFFF, 0x7FFFFFFF);
    setColor_( curcolor);
    SendMessage(text1, EM_REPLACESEL, 0, (LPARAM)(start));
  }

  SendMessage(text1, EM_SCROLLCARET, 0, 0);

  #else

  va_list args; char buf[BUFSIZE];
  
  va_start( args, str);
  #ifdef WIN32
    vsprintf( buf, str, args);
  #else
    vsnprintf( buf, BUFSIZE, str, args);
  #endif
  va_end( args);
  
  #ifdef DISP_GTK
    add( buf);
  #else
    #ifdef WIN32_NATIVE
      add( buf);
    #else
      Display::print( "%s", buf);
    #endif
  #endif
  #endif
}

Window &Window::operator<<( char *text) {
  if (background)
    return( *this);

  if (!text)
    return *this;

	#ifdef DISP_GTK
		gtk_text_freeze( GTK_TEXT( text1)); frozen++;
	#endif

	while (*text) {
		*this << *text++;
	}

	#ifdef DISP_GTK
		gtk_text_thaw( GTK_TEXT( text1)); frozen--;
	#endif

  return *this;
}

Window &Window::operator<<( char ch) {
  if (background)
    return( *this);

  #ifdef DISP_GTK

  //static int colors[16][3] = {
  //  {      0,      0,      0 }, //  0 BLACK ?!
  //  { 0x8000,      0,      0 }, //  1 Red
  //  {      0, 0x8000,      0 }, //  2 Green
  //  {      0,      0,      0 }, //  3 Brown
  //  {      0,      0, 0x8000 }, //  4 Blue
  //  { 0x8000,      0, 0x8000 }, //  5 Purple
  //  {      0, 0x8000, 0x8000 }, //  6 Cyan
  //  { 0x2000, 0x2000, 0x2000 }, //  7 White
  //  { 0x6000, 0x6000, 0x6000 }, //  8 Gray
  //  { 0x2000, 0x2000, 0x8000 }, //  9 Blue
  //  { 0x2000, 0x8000, 0x2000 }, // 10 Green
  //  {      0, 0x4000, 0x4000 }, // 11 Cyan
  //  { 0x8000, 0x2000, 0x2000 }, // 12 Red
  //  { 0x4000,      0, 0x4000 }, // 13 Purple
  //  { 0x8000, 0x8000, 0x2000 }, // 14 Yellow
  //  { 0x0000, 0x0000, 0x0000 }  // 15 White
  //};
  static int colors[16][3] = {
    {      0,      0,      0 }, //  0 BLACK ?!
    { 0x8000,      0,      0 }, //  1 Red
    {      0, 0x8000,      0 }, //  2 Green
    {      0,      0,      0 }, //  3 Brown
    {      0,      0, 0x8000 }, //  4 Blue
    { 0x8000,      0, 0x8000 }, //  5 Purple
    {      0, 0x8000, 0x8000 }, //  6 Cyan
    { 0xC000, 0xC000, 0xC000 }, //  7 White
    { 0x8000, 0x8000, 0x8000 }, //  8 Gray
    { 0x0000, 0x0000, 0xFFFF }, //  9 Blue
    {      0, 0xFFFF,      0 }, // 10 Green
    {      0, 0xFFFF, 0xFFFF }, // 11 Cyan
    { 0xFFFF,      0,      0 }, // 12 Red
    { 0xFFFF,      0, 0xFFFF }, // 13 Purple
    { 0xFFFF, 0xFFFF,      0 }, // 14 Yellow
    { 0xFFFF, 0xFFFF, 0xFFFF }  // 15 White
  };

  if (ch < 16) {
    color.red   = colors[ch][0];
    color.green = colors[ch][1];
    color.blue  = colors[ch][2];
    return *this;
  }
  
  if (ch == 16) {
    print("\n");
    return *this;
  }

  print("%c", ch);
  return *this;

  #else
    print("%c", ch);
    return *this;
  #endif
}

Window &Window::operator<<( int i) {
  if (background)
    return *this;

  print( "%d", i);
  return *this;
}

Window &Window::operator<<( unsigned int i) {
  if (background)
    return *this;

  print( "%u", i);
  return *this;
}

void Window::cls( void) {
  if (background)
    return;

  #ifdef DISP_GTK
    gtk_text_backward_delete( GTK_TEXT( text1), gtk_text_get_length( GTK_TEXT( text1)));
    // gtk_entry_set_text( GTK_ENTRY( text1), "");
  #endif
}

void Window::clear( void) {
  if (background)
    return;

  #ifdef DISP_GTK
    //gtk_text_thaw( GTK_TEXT( text1));
    gtk_entry_set_text( GTK_ENTRY(entry1), "");
    //gtk_text_freeze( GTK_TEXT( text1));
  #endif
  #ifdef WIN32_NATIVE
    SetWindowText( entry1, "");
  #endif
}

void Window::addUser( char *username, int latency, u32 client, u32 flags) {
  if (background)
    return;

  if (!username)
    return;

  #ifdef WIN32_NATIVE
    // Icon := TIcon.Create;
    // Icon.LoadFromFile('ORANGE.ICO');
    // ListBox1.Items.AddObject('Orange', Icon);
    SendMessage( clist, LB_ADDSTRING, 0, (LPARAM)username);
  #endif

  #ifdef DISP_GTK
    char **buf = new char *[3];
    buf[0] = new char[ 1];
    *buf[0] = '\0';

    buf[1] = new char[ strlen( username) + 1];
    strcpy(buf[1], username);

    buf[2] = new char[ 13];
    sprintf( buf[2], "%dms", latency);

    // gdk_threads_enter();
    int i = gtk_clist_append( (GtkCList *)clist, buf);
  
    //===
    // Todo:
    //   For "user-specific" icons, we need a good way to allow the
    //   user/bot to pass them. This should also be moved into some
    //   sort of a BST.
    if (!strcasecmp( username, "Alizee")) gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 0], mask[ 0]);
    else if (flags & 1) gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 1], mask[1]);
    else if (flags & 2) gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 5], mask[5]);
    else
      switch( client) {
        case CLIENT_CHAT: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 2], mask[ 2]); break;
        case CLIENT_W2BN: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[10], mask[10]); break;
        case CLIENT_WAR3: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[11], mask[11]); break;
        case CLIENT_STAR: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 7], mask[ 7]); break;
        case CLIENT_SEXP: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 8], mask[ 8]); break;
        case CLIENT_SSHR: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 9], mask[ 9]); break;
        case CLIENT_DSHR: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 4], mask[ 4]); break;
        case CLIENT_DRTL: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 4], mask[ 4]); break;
        case CLIENT_D2DV: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 3], mask[ 3]); break;
        case CLIENT_D2XP: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 3], mask[ 3]); break;
        case CLIENT_JSTR: gtk_clist_set_pixmap( (GtkCList *)clist, i, 0, pixmap[ 6], mask[ 6]); break;
      }

    // gdk_threads_leave();

    //char **buf = new char *[2];
    //*buf = new char[ 64];
    //strcpy(*buf, username);
    //*(buf+1) = new char[64];
    //sprintf( *(buf + 1), "%dms", latency);
 
    //gtk_clist_append( (GtkCList *)clist, buf);

    //GdkColor black;

    //color.red = 0;
    //color.green = 0;
    //color.blue = 0;

    // gtk_clist_set_background( (GtkCList *)clist, ?, &black);

  #endif
}

void Window::delUser( char *username) {
  if (background)
    return;

  char *text;
  int i = 0;

  #ifdef WIN32_NATIVE
    int index = SendMessage( clist, LB_FINDSTRINGEXACT, 0, (LPARAM)username);
    SendMessage( clist, LB_DELETESTRING, index, 0);
  #endif

  #ifdef DISP_GTK
    while (gtk_clist_get_text( (GtkCList *)clist, i, 1, &text)) {
      if (!strcasecmp( text, username)) {
        gtk_clist_remove ( (GtkCList *)clist, i);
        return;
      }
      i++;
    }
  #endif
}

void Window::clearUsers( void) {
  if (background)
    return;

  #ifdef WIN32_NATIVE
    SendMessage( clist, LB_RESETCONTENT, 0, 0);
  #endif

  #ifdef DISP_GTK
    gtk_clist_clear( (GtkCList *)clist);
  #endif
}

void Window::focus( void) {
  if (background) {
    background = 0;
    init();
  }
}

void Window::init( void) {
	frozen = 0;
  buffer_enter = 0;
  curcolor = 7;

  if (!parent->getDisplay()) {
    background = 1;
    return;
  }

  //if (window1)
  //  return;

  // Main Window Box
    char verBuf[ 1024];

    #ifdef WIN32_NATIVE
      sprintf( verBuf, "zDSBot3 - (build %d [w32]) - by Eurijk!", BUILD);

      BOBBYBROWN = this;
      window1 = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        "Window",
        verBuf,
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 500, 220,
        NULL, NULL, hInstance, NULL);

      ShowWindow( window1, nCmdShow);
      UpdateWindow( window1);
    #endif
    #ifdef DISP_GTK
      tooltips = gtk_tooltips_new ();

      sprintf( verBuf, "zDSBot3 - (build %d [gtk]) - by Eurijk!", BUILD);

      // window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      // gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
      // gtk_widget_set_usize (window1, 400, 220);
      //gtk_window_set_title (GTK_WINDOW (window1), verBuf);

      window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_window_set_title (GTK_WINDOW (window1), verBuf);
      gtk_window_set_default_size (GTK_WINDOW (window1), 500, 200);

    #endif  



  #ifdef DISP_GTK
    //vbox1 = gtk_vbox_new (FALSE, 0);
    //gtk_widget_ref (vbox1);
    //gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1, (GtkDestroyNotify) gtk_widget_unref);
    //gtk_widget_show (vbox1);
    //gtk_container_add (GTK_CONTAINER (window1), vbox1);
    vbox1 = gtk_vbox_new (FALSE, 0);
    gtk_widget_ref (vbox1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (vbox1);
    gtk_container_add (GTK_CONTAINER (window1), vbox1);

    //hpaned1 = gtk_hpaned_new ();
    //gtk_widget_ref (hpaned1);   
    //gtk_object_set_data_full (GTK_OBJECT (window1), "hpaned1", hpaned1, (GtkDestroyNotify) gtk_widget_unref);
    //gtk_widget_show (hpaned1);
    //gtk_box_pack_start (GTK_BOX (vbox1), hpaned1, TRUE, TRUE, 0);
    //gtk_paned_set_position (GTK_PANED (hpaned1), 300);
    hpaned1 = gtk_hpaned_new ();
    gtk_widget_ref (hpaned1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "hpaned1", hpaned1,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (hpaned1);
    gtk_box_pack_start (GTK_BOX (vbox1), hpaned1, TRUE, TRUE, 0);
    gtk_paned_set_position (GTK_PANED (hpaned1), 300);

    vbox2 = gtk_vbox_new (FALSE, 0);
    gtk_widget_ref (vbox2);
    gtk_object_set_data_full (GTK_OBJECT (window1), "vbox2", vbox2,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (vbox2);
    gtk_paned_pack1 (GTK_PANED (hpaned1), vbox2, FALSE, TRUE);

    frame5 = gtk_frame_new (NULL);
    gtk_widget_ref (frame5);
    gtk_object_set_data_full (GTK_OBJECT (window1), "frame5", frame5,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (frame5);
    gtk_box_pack_start (GTK_BOX (vbox2), frame5, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (frame5), 2);

    //scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
    //gtk_widget_ref (scrolledwindow1);
    //gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
    //                        (GtkDestroyNotify) gtk_widget_unref);
    //gtk_widget_show (scrolledwindow1);
    //gtk_paned_pack1 (GTK_PANED (hpaned1), scrolledwindow1, FALSE, TRUE);
    //gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

    scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_ref (scrolledwindow2);
    gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow2", scrolledwindow2,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (scrolledwindow2);
    gtk_container_add (GTK_CONTAINER (frame5), scrolledwindow2);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);


    GdkColor    black = { 0, 0, 0, 0x100 };
    GdkColormap *cmap = gdk_colormap_get_system();
    gdk_colormap_alloc_color(cmap, &black, FALSE, TRUE);
  
    //ourfont = gdk_font_load("cronyx-courier-bold-r-normal-*-*-100-*-*-m-*-koi8-r");
	ourfont = gdk_font_load("-adobe-courier-bold-r-normal-*-*-120-*-*-m-*-iso8859-1");

    //text1 = gtk_text_new (NULL, NULL);
    //gtk_container_add (GTK_CONTAINER (scrolledwindow1), text1);
    //
    //gtk_widget_ref (text1);
    //gtk_object_set_data_full (GTK_OBJECT (window1), "text1", text1, (GtkDestroyNotify) gtk_widget_unref);
    //
    //gtk_widget_show (text1);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), text1);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_paned_pack2 (GTK_PANED (hpaned1), vbox3, TRUE, TRUE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), vbox4, TRUE, TRUE, 0);

  frame7 = gtk_frame_new (NULL);
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame7);
  gtk_box_pack_start (GTK_BOX (vbox4), frame7, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame7), hbox1);

  toolbar2 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_ref (toolbar2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "toolbar2", toolbar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar2);
  gtk_box_pack_start (GTK_BOX (hbox1), toolbar2, FALSE, FALSE, 0);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (window1, GNOME_STOCK_PIXMAP_CLEAR);
  tmp_toolbar_icon = create_xpm(window1, stock_clear_xpm);
  btnClear = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                "Clear The Chat Window.", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnClear);
  gtk_object_set_data_full (GTK_OBJECT (window1), "btnClear", btnClear,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnClear);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (window1, GNOME_STOCK_PIXMAP_PROPERTIES);
  tmp_toolbar_icon = create_xpm(window1, stock_properties_xpm);
  btnProp = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                "Bot Properties.", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnProp);
  gtk_object_set_data_full (GTK_OBJECT (window1), "btnProp", btnProp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnProp);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (window1, GNOME_STOCK_PIXMAP_COLORSELECTOR);
  tmp_toolbar_icon = create_xpm(window1, stock_colorselector_xpm);
  btnUnk = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                "Perhaps Color Scheme. Sure makes for a cool icon though. >;-)", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnUnk);
  gtk_object_set_data_full (GTK_OBJECT (window1), "btnUnk", btnUnk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnUnk);

  // tmp_toolbar_icon = gnome_stock_pixmap_widget (window1, GNOME_STOCK_PIXMAP_TEXT_BOLD);
  tmp_toolbar_icon = create_xpm(window1, stock_text_bold_xpm);
  btnFont = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "button6",
                                "Change Font.", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btnFont);
  gtk_object_set_data_full (GTK_OBJECT (window1), "btnFont", btnFont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnFont);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, TRUE, 2);

  checkbutton1 = gtk_check_button_new_with_label ("Popup");
  gtk_widget_ref (checkbutton1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "checkbutton1", checkbutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton1);
  gtk_box_pack_start (GTK_BOX (hbox1), checkbutton1, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, checkbutton1, "Show Private Messages in a Popup", NULL);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_ref (frame6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox4), frame6, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame6), 2);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (frame6), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  //===
  // blah @ enum problems
  // gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow3)->hscrollbar), GTK_POLICY_AUTOMATIC);
  // gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow3)->vscrollbar), GTK_POLICY_AUTOMATIC);

  //gchar *titles[2] = { "Username", "Latency" };
  //clist = gtk_clist_new_with_titles( 2, titles);
  // 
  ////list1 = gtk_list_new ();
  //gtk_widget_ref (clist); 
  //gtk_object_set_data_full (GTK_OBJECT (window1), "clist", clist,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  //
  //
  //gtk_widget_show (clist);
  //gtk_paned_pack2 (GTK_PANED (hpaned1), clist, TRUE, TRUE);
  //gtk_container_set_border_width (GTK_CONTAINER (clist), 2);
  //GTK_WIDGET_SET_FLAGS (clist, GTK_CAN_FOCUS);
  //
  //entry1 = gtk_entry_new ();
  //gtk_widget_ref (entry1);  
  //gtk_object_set_data_full (GTK_OBJECT (window1), "entry1", entry1,
  //                          (GtkDestroyNotify) gtk_widget_unref);  
  //gtk_widget_show (entry1);
  //gtk_box_pack_start (GTK_BOX (vbox1), entry1, FALSE, FALSE, 0);
  //gtk_widget_set_extension_events (entry1, GDK_EXTENSION_EVENTS_ALL);

  clist = gtk_clist_new (3);
  gtk_widget_ref (clist);
  gtk_object_set_data_full (GTK_OBJECT (window1), "clist", clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), clist);
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 28);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 90);
  gtk_clist_set_column_width (GTK_CLIST (clist), 2, 20);

  gtk_clist_set_column_max_width( GTK_CLIST (clist), 0, 28);
  gtk_clist_set_column_max_width( GTK_CLIST (clist), 2, 20);

  //gtk_clist_set_column_auto_resize( GTK_CLIST (clist), 0, 1);
  //gtk_clist_set_column_auto_resize( GTK_CLIST (clist), 1, 1);
  //gtk_clist_set_column_auto_resize( GTK_CLIST (clist), 2, 1);

  gtk_clist_column_titles_hide (GTK_CLIST (clist));

  label6 = gtk_label_new ("label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label6);

  label7 = gtk_label_new ("label7");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label7);

  label8 = gtk_label_new ("label8");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label8);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_container_add (GTK_CONTAINER (frame1), entry1);
  gtk_entry_set_text (GTK_ENTRY (entry1), "");


  gtk_signal_connect (GTK_OBJECT (window1), "destroy",
                      GTK_SIGNAL_FUNC (window_on_window1_destroy),
                      this);

  gtk_signal_connect (GTK_OBJECT (entry1), "activate",
                      GTK_SIGNAL_FUNC (on_entry1_activate),
                      this);
  //gtk_signal_connect (GTK_OBJECT (wnddisp), "delete_event",
  //                    GTK_SIGNAL_FUNC (on_wndDisp_delete_event),
  //                    this);
  //gtk_signal_connect (GTK_OBJECT (wnddisp), "destroy",
  //                    GTK_SIGNAL_FUNC (on_wndDisp_destroy),
  //                    this);
  gtk_signal_connect (GTK_OBJECT (btnClear), "clicked",
                      GTK_SIGNAL_FUNC (on_btnClear_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnProp), "clicked",
                      GTK_SIGNAL_FUNC (on_btnProp_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnUnk), "clicked",
                      GTK_SIGNAL_FUNC (on_btnUnk_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnFont), "clicked",
                      GTK_SIGNAL_FUNC (on_btnFont_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (checkbutton1), "toggled",
                      GTK_SIGNAL_FUNC (on_checkbutton1_toggled),
                      this);
  gtk_signal_connect (GTK_OBJECT (clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist1_select_row),
                      this);
  //gtk_signal_connect (GTK_OBJECT (entry1), "activate",
  //                    GTK_SIGNAL_FUNC (on_entry1_activate),
  //                    this);

  // ourfont = gdk_font_load("-adobe-courier-bold-r-normal-*-*-100-*-*-m-*-*-*");

  gtk_object_set_data (GTK_OBJECT (window1), "tooltips", tooltips);

  gtk_widget_show( window1);

  gdk_window_set_background(GTK_TEXT(text1)->text_area, &black);

  GdkColormap *colormap = gtk_widget_get_colormap( window1);
  if (colormap == NULL)
    g_error("Couldn't create replacement colormap.");

  pixmap[ 0] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 0], NULL, alizee_xpm);
  pixmap[ 1] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 1], NULL, bliz_xpm);
  pixmap[ 2] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 2], NULL, chat_xpm);
  pixmap[ 3] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 3], NULL, diablo2_xpm);
  pixmap[ 4] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 4], NULL, diablosw_xpm);
  pixmap[ 5] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 5], NULL, gavel_xpm);
  pixmap[ 6] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 6], NULL, jsc_xpm);
  pixmap[ 7] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 7], NULL, sc_xpm);
  pixmap[ 8] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 8], NULL, starx_xpm);
  pixmap[ 9] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[ 9], NULL, sware_xpm);
  pixmap[10] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[10], NULL, war2_xpm);
  pixmap[11] = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask[11], NULL, war3_xpm);

                        
  //gtk_widget_show ( window1);
  //gdk_window_set_background(GTK_TEXT(text1)->text_area, &black);

  // Now let's update the channellist.
  sCList *tmp = parent->getCList()->first;

  if (!tmp)
    return;

  while (tmp) {
    if (tmp->data)
      addUser( tmp->data->getName(), tmp->data->getLatency(), tmp->data->getProduct2(), tmp->data->getFlags());
    tmp = tmp->next;
  }

	//gtk_text_freeze( (GtkText *)text1);

  #endif
}
