#ifndef WINDOW_H
#define WINDOW_H

#include "config.h"
#include "display.h"
#include "bot.h"

class Bot;

#ifdef DISP_GTK
  #include <gtk/gtk.h>
#endif

#ifdef WIN32_NATIVE
  #include <windows.h>
  #include <richedit.h>
  // #include "win32/IconListBox.h"

  LRESULT CALLBACK window_proc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
#endif

struct LV_COLUMN {
  u32 imask;
  u32 fmt;
  u32 lx;
  u32 pszText;
  u32 cchTextMax;
  u32 iSubItem;
  u32 iImage;
  u32 iOrder;
};

class Window : public Display {
	int frozen;

  #ifdef DISP_GTK
    GdkPixmap *pixmap[12];
    GdkBitmap *mask[12];

    GtkWidget *window1;
    GtkWidget *vbox1;
    GtkWidget *hpaned1;
    GtkWidget *vbox2;
    GtkWidget *frame5;
    GtkWidget *scrolledwindow2;
    GtkWidget *vbox3;
    GtkWidget *vbox4;
    GtkWidget *frame7;
    GtkWidget *hbox1;
    GtkWidget *toolbar2;
    GtkWidget *tmp_toolbar_icon;
    GtkWidget *btnClear;
    GtkWidget *btnProp;
    GtkWidget *btnUnk;
    GtkWidget *btnFont;
    GtkWidget *vseparator1;
    GtkWidget *checkbutton1;
    GtkWidget *frame6;
    GtkWidget *scrolledwindow3;
    GtkWidget *clist;
    GtkWidget *label6;
    GtkWidget *label7;
    GtkWidget *label8;
    GtkWidget *frame1;
    GtkWidget *entry1;
    GtkTooltips *tooltips;
    //GdkFont   *font;
    //GtkWidget *window1;
    //GtkWidget *vbox1;
    //GtkWidget *hpaned1;
    //GtkWidget *scrolledwindow1;
    //GtkWidget *text1;
    //GtkWidget *clist;
    //GtkWidget *entry1;
    GdkColor color;
  #endif

  int curcolor;
public:
  int buffer_enter;

  #ifdef DISP_GTK
    GtkWidget *text1;
    GdkFont *ourfont;
  #endif

  #ifdef WIN32_NATIVE
    HWND      window1;
    HWND      text1;
    HWND      clist;
    HWND      entry1;
    LV_COLUMN lvCol;

    // CIconListBox *cilist;
  #endif

  int ENC_MODE;
  Bot *parent;

  Window( Bot *parent);
  ~Window( void);

  void print( char *str, ... );
  int add( char *txt);
  void clear( void);
  void cls( void);

  Window& operator<<( char *text);
  Window& operator<<( char ch);
  Window& operator<<( int i);
  Window& operator<<( unsigned int i);

  void addUser( char *username, int latency, u32 client, u32 flags);
  void delUser( char *username);
  void clearUsers( void);

  int  setColor_( int curcolor);

  void focus( void);
  void init( void);
};

#endif

