#include "mnumain.h"
#include "wndnewbot.h"
#include "wndchat.h"

#include "../botlist.h"
extern BotList botlist;

void on_activate1_activate( GtkMenuItem *menuitem, gpointer user_data) {
	sBotList *tmp = botlist.first; int row = 0;

	while (tmp) {
		if (row++ == ((MnuMain *)user_data)->row) {
			tmp->data->setActive( 1);
			return;
		}
		tmp = tmp->next;
	}
}

void on_disactivate1_activate( GtkMenuItem *menuitem, gpointer user_data) {
	sBotList *tmp = botlist.first; int row = 0;

	while (tmp) {
		if (row++ == ((MnuMain *)user_data)->row) {
			tmp->data->setActive( 0);
			return;
		}
		tmp = tmp->next;
	}
}

void on_properties1_activate( GtkMenuItem *menuitem, gpointer user_data) {
	sBotList *tmp = botlist.first; int row = 0;

	while (tmp) {
		if (row++ == ((MnuMain *)user_data)->row) {
			new WndNewBot( tmp->data);
			return;
		}
		tmp = tmp->next;
	}
}

void on_showbot1_activate( GtkMenuItem *menuitem, gpointer user_data) {
	sBotList *tmp = botlist.first; int row = 0;

	while (tmp) {
		if (row++ == ((MnuMain *)user_data)->row) {
			//===
			// Do a quick check to make sure we don't have a display already. :)
			for (std::list<WndChat *>::iterator i = ((MnuMain *)user_data)->wndmain->displist->begin(); i != ((MnuMain *)user_data)->wndmain->displist->end(); i++) {
				if ((*i)->bot == tmp->data)
					return;
			}

			((MnuMain *)user_data)->wndmain->displist->push_back( new WndChat( ((MnuMain *)user_data)->wndmain, tmp->data));
			return;
		}
		tmp = tmp->next;
	}
}

//===
// Don't threads_enter, we are called from gtk !!!
MnuMain::MnuMain( WndMain *wndmain, int _row) {
	MnuMain::wndmain = wndmain;
	row = _row;

  //gdk_threads_enter();
  mnumain = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (mnumain), "mnumain", mnumain);
  gtk_container_set_border_width (GTK_CONTAINER (mnumain), 2);
//GTK2 fixme
//  mnumain_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (mnumain));

  activate1 = gtk_menu_item_new_with_label ("Activate");
  gtk_widget_show (activate1);  
  gtk_container_add (GTK_CONTAINER (mnumain), activate1);

  disactivate1 = gtk_menu_item_new_with_label ("Disactivate");
  gtk_widget_show (disactivate1);
  gtk_container_add (GTK_CONTAINER (mnumain), disactivate1);

  properties1 = gtk_menu_item_new_with_label ("Properties");
  gtk_widget_show (properties1);
  gtk_container_add (GTK_CONTAINER (mnumain), properties1);
 
  showbot1 = gtk_menu_item_new_with_label ("Show Bot");
  gtk_widget_show (showbot1);
  gtk_container_add (GTK_CONTAINER (mnumain), showbot1);
 
  gtk_signal_connect (GTK_OBJECT (activate1), "activate",
                      GTK_SIGNAL_FUNC (on_activate1_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (disactivate1), "activate",
                      GTK_SIGNAL_FUNC (on_disactivate1_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (properties1), "activate",
                      GTK_SIGNAL_FUNC (on_properties1_activate),
                      this);
  gtk_signal_connect (GTK_OBJECT (showbot1), "activate",
                      GTK_SIGNAL_FUNC (on_showbot1_activate),
                      this);
  gtk_menu_popup( (GtkMenu *)mnumain, 0, 0, 0, 0, 0, 0);
  //gdk_threads_leave();
}

MnuMain::~MnuMain( void) {
}
