#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <gtk/gtk.h>
#include "support.h"

GtkWidget* lookup_widget( GtkWidget *widget, const gchar *widget_name) {
  GtkWidget *parent, *found_widget;

  for (;;) {
    if (GTK_IS_MENU (widget))
      parent = gtk_menu_get_attach_widget (GTK_MENU (widget));
    else
      parent = widget->parent;
    if (parent == NULL)
      break;
    widget = parent;
  }

  found_widget = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (widget), widget_name);

  if (!found_widget)
    g_warning ("Widget not found: %s", widget_name);

  return found_widget;
}

//GtkWidget* create_xpm( GtkWidget *widget, gchar **xpm) {
//  GtkWidget *pixmap;
//  GdkColormap *colormap;
//  GdkPixmap *gdkpixmap;
//  GdkBitmap *mask;
//  // gchar *pathname;
//
//  colormap = gtk_widget_get_colormap( widget);
//  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask, NULL, xpm);
//
//  if (gdkpixmap == NULL)
//    g_error ("Couldn't create replacement pixmap.");
//
//  pixmap = gtk_pixmap_new (gdkpixmap, mask);
//  gdk_pixmap_unref (gdkpixmap);
//  gdk_bitmap_unref (mask);
//  return pixmap;
//}
