#include "../tools/build.h"
#include <queue>
#include "wndchat.h"
#include "../bot.h"

void onWndChat_wndchat_unrealize( GtkWidget *widget, gpointer user_data) {
	((WndChat *)user_data)->wndmain->displist->remove( (WndChat *)user_data);
}

void onWndChat_entry13_activate( GtkEditable *editable, gpointer user_data) {
	const char *tmp = gtk_entry_get_text( (GtkEntry *)((WndChat *)user_data)->entry13);
	((WndChat *)user_data)->bot->input->handle( tmp);
	gtk_entry_set_text( (GtkEntry *)((WndChat *)user_data)->entry13, "");
}

WndChat::WndChat( WndMain *wndmain, Bot *_bot) {
	//if (!bot) {
	//	fprintf( stderr, "WndChat::WndChat was called w/ a NULL bot!\n");
	//	fflush( stderr);
	//}

	WndChat::wndmain = wndmain;
	DHandle::bot = _bot;

  wndchat = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (wndchat), "wndchat", wndchat);
  gtk_container_set_border_width (GTK_CONTAINER (wndchat), 2);
	char buf[ 256];
	sprintf( buf, "zDSBot3 (build %d) - Chat\0________________________________________________________________", BUILD);
  gtk_window_set_title (GTK_WINDOW (wndchat), buf);
  gtk_window_set_default_size (GTK_WINDOW (wndchat), 400, 250);
  gtk_window_set_policy (GTK_WINDOW (wndchat), TRUE, TRUE, FALSE);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (wndchat), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (wndchat), vbox11);

  frame15 = gtk_frame_new ( 0);
  gtk_widget_ref (frame15);
  gtk_object_set_data_full (GTK_OBJECT (wndchat), "frame15", frame15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame15);
  gtk_box_pack_start (GTK_BOX (vbox11), frame15, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame15), 2);

  scrolledwindow14 = gtk_scrolled_window_new (0, 0);
  gtk_widget_ref (scrolledwindow14);
  gtk_object_set_data_full (GTK_OBJECT (wndchat), "scrolledwindow14", scrolledwindow14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow14);
  gtk_container_add (GTK_CONTAINER (frame15), scrolledwindow14);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow14), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow14)->vscrollbar), GTK_UPDATE_DELAYED); //GTK_UPDATE_DISCONTINUOUS);

	GdkColor    black = { 0, 0, 0, 0x100 };
	GdkColormap *cmap = gdk_colormap_get_system();
	gdk_colormap_alloc_color(cmap, &black, FALSE, TRUE);

	//GTK1
	//  text7 = gtk_text_new ( 0, 0);
	//  gtk_widget_ref (text7);
	//  gtk_object_set_data_full (GTK_OBJECT (wndchat), "text7", text7,
	//                            (GtkDestroyNotify) gtk_widget_unref);
	//  gtk_widget_show (text7);
	//  gtk_container_add (GTK_CONTAINER (scrolledwindow14), text7);
	//GTK2
	text7 = gtk_text_view_new ();
  gtk_widget_ref (text7);
  gtk_object_set_data_full (GTK_OBJECT (wndchat), "text7", text7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text7);
  gtk_container_add (GTK_CONTAINER (scrolledwindow14), text7);
	gtk_text_view_set_wrap_mode( (GtkTextView *)text7, GTK_WRAP_WORD);

	{
		GtkWidget *view = text7;
	//	GtkTextBuffer *buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
	//	gtk_text_buffer_set_text (buffer, "Hello, this is some text", -1);

		char *myfont = "Courier 12";
		Obj *obj = globals->db->getObj("vars");
		if (obj) {
			char *tmp = obj->getVar("font");
			if (tmp)
				myfont = tmp;
		}

		PangoFontDescription *font_desc = pango_font_description_from_string(myfont);
		gtk_widget_modify_font (view, font_desc);
		pango_font_description_free (font_desc);

		GdkColor color;
		gdk_color_parse ("black", &color);
		gtk_widget_modify_base( view, GTK_STATE_NORMAL, &color);
		
		gtk_text_view_set_editable( GTK_TEXT_VIEW (view), 0);

	//	/* Change default color throughout the widget */
		gdk_color_parse ("white", &color);
		gtk_widget_modify_text (view, GTK_STATE_NORMAL, &color);
	//
	//	GtkTextTag *tag;
	//	  /* Change left margin throughout the widget */
	//	    gtk_text_view_set_left_margin (GTK_TEXT_VIEW (view), 30);
	//	    
	//GtkTextIter start, end;
  //tag = gtk_text_buffer_create_tag (buffer, "blue_foreground",
  //	   		            "foreground", "blue", NULL);  
  //	   		              gtk_text_buffer_get_iter_at_offset (buffer, &start,
	//7);
  //gtk_text_buffer_get_iter_at_offset (buffer, &end, 12);
  //  gtk_text_buffer_apply_tag (buffer, tag, &start, &end);
	}

  frame16 = gtk_frame_new ( 0);
  gtk_widget_ref (frame16);
  gtk_object_set_data_full (GTK_OBJECT (wndchat), "frame16", frame16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame16);
  gtk_box_pack_start (GTK_BOX (vbox11), frame16, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame16), 2);

  entry13 = gtk_entry_new ();
  gtk_widget_ref (entry13);
  gtk_object_set_data_full (GTK_OBJECT (wndchat), "entry13", entry13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry13);
  gtk_container_add (GTK_CONTAINER (frame16), entry13);

  gtk_signal_connect (GTK_OBJECT (wndchat), "unrealize",
                      GTK_SIGNAL_FUNC (onWndChat_wndchat_unrealize),
                      this);
  gtk_signal_connect (GTK_OBJECT (entry13), "activate",
                      GTK_SIGNAL_FUNC (onWndChat_entry13_activate),
                      this);

	// ourfont = gdk_font_load("-adobe-courier-bold-r-normal-*-*-100-*-*-m-*-iso8859-1");

	{
		const int colors[16][3] = {
			{      0,      0,      0 }, //  0 BLACK ?!
			{ 0x8000,      0,      0 }, //  1 Red
			{      0, 0x8000,      0 }, //  2 Green
			{      0,      0,      0 }, //  3 Brown
			{      0,      0, 0x8000 }, //  4 Blue
			{ 0x8000,      0, 0x8000 }, //  5 Purple
			{      0, 0x8000, 0x8000 }, //  6 Cyan
			{ 0xC000, 0xC000, 0xC000 }, //  7 White
			{ 0x8000, 0x8000, 0x8000 }, //  8 Gray
			{ 0x0000, 0x0000, 0xFFFF }, //  9 Blue
			{      0, 0xFFFF,      0 }, // 10 Green
			{      0, 0xFFFF, 0xFFFF }, // 11 Cyan
			{ 0xFFFF,      0,      0 }, // 12 Red
			{ 0xFFFF,      0, 0xFFFF }, // 13 Purple
			{ 0xFFFF, 0xFFFF,      0 }, // 14 Yellow
			{ 0xFFFF, 0xFFFF, 0xFFFF }  // 15 White
		};
		GtkTextBuffer *gtktextbuffer = gtk_text_view_get_buffer( (GtkTextView *)text7);
		GdkColor color;
		for (int i = 0; i <= 15; i++) {
			color.red = colors[i][0];
			color.green = colors[i][1];
			color.blue = colors[i][2];
			char buf[32];
			sprintf( buf, "f%x", i);
			gtk_text_buffer_create_tag (gtktextbuffer, buf, "foreground_gdk", &color, NULL);
		}
	}

	// gtk_text_buffer_create_tag (gtktextbuffer, "ff", "foreground", "blue", NULL);  
	// iter = NULL; MFT

	gtk_widget_show( wndchat);

//GTK2
//	gdk_window_set_background(GTK_TEXT(text7)->text_area, &black);
}

WndChat::~WndChat( void) {
}

//void WndChat::onHandler( void) {
//	std::queue <char *>Q;
//	char *tmp = NULL;
//
//	//===
//	// Now display it in our own sweet time.
//		if (!Q.empty()) {
//			gtk_text_freeze( GTK_TEXT( text7));
//			while (!Q.empty()) {
//				char *tmp = Q.front();
//				Q.pop();
//			
//				char *start = tmp;
//				char *loc = tmp;
//
//				while (*loc) {
//					if (*(unsigned char *)loc <= 16) {
//						char ch = *loc;
//						*loc = 0;
//						onText( start, curcolor);
//						if (ch == 16)
//							onText("\n", curcolor);
//						else
//							curcolor = ch;
//						start = loc + 1;
//					}
//					loc++;
//				}
//				if (*start)
//					onText( start, curcolor);
//				delete tmp;
//			}
//			gtk_text_thaw( GTK_TEXT( text7));
//		}
//}

void WndChat::onFreeze( void) {
	//GTK2
	//gtk_text_freeze( GTK_TEXT( text7));
}

void WndChat::onThaw( void) {
	//GTK2
	//gtk_text_thaw( GTK_TEXT( text7));	
}

void WndChat::onText( char *txt, int n) {
	//	GtkTextBuffer *gtktextbuffer = gtk_text_view_get_buffer( (GtkTextView *)text7);
	//	gtk_text_buffer_insert_at_cursor( gtktextbuffer, "\n", -1);
	//	gtk_text_buffer_get_iter_at_offset (gtktextbuffer, iter, 0);

	GtkTextBuffer *gtktextbuffer = gtk_text_view_get_buffer( (GtkTextView *)text7);
	GtkTextIter start, end;
	gtk_text_buffer_get_bounds (gtktextbuffer, &start, &end);

	//if (!iter)
	//	gtk_text_buffer_get_iter_at_offset (gtktextbuffer, iter, 0);

	static char *colors[] = {
		"f0",
		"f1",
		"f2",
		"f3",
		"f4",
		"f5",
		"f6",
		"f7",
		"f8",
		"f9",
		"fa",
		"fb",
		"fc",
		"fd",
		"fe",
		"ff",
	};


	if (*txt == '\n') {
		//===
		// If we are at the very bottom of the scroll window, then scroll.
		GtkAdjustment *adj = gtk_scrolled_window_get_vadjustment ( (GtkScrolledWindow *)scrolledwindow14);

		// Debugging to figure out how gtk does this. :)
		//fprintf( stderr, "WndChat::onText\n");
		//fprintf( stderr, "  lower -> %f\n", adj->lower);
		//fprintf( stderr, "  upper -> %f\n", adj->upper);
		//fprintf( stderr, "  value -> %f\n", adj->value);
		//fprintf( stderr, "  step  -> %f\n", adj->step_increment);
		//fprintf( stderr, "  page  -> %f\n", adj->page_increment);
		//fprintf( stderr, "  size  -> %f\n", adj->page_size);
		
		if ((adj->value + adj->step_increment + adj->page_size) >= adj->upper) {
			//GTK2
			//gtk_text_thaw( GTK_TEXT( text7));

			if (*txt)
				//gtk_text_buffer_insert_at_cursor( gtktextbuffer, txt, -1);
				gtk_text_buffer_insert_with_tags_by_name( gtktextbuffer, &end, txt, -1, colors[n], NULL);

			//gtk_text_insert( GTK_TEXT( text7), (GdkFont *)ourfont, (GdkColor *)0, (GdkColor *)0, txt, -1);
			//gtk_text_freeze( GTK_TEXT( text7));
		} else {
			//GTK2

			if (*txt)
				// gtk_text_buffer_insert_at_cursor( gtktextbuffer, txt, -1);
				gtk_text_buffer_insert_with_tags_by_name( gtktextbuffer, &end, txt, -1, colors[n], NULL);

			//gtk_text_insert( GTK_TEXT( text7), (GdkFont *)ourfont, (GdkColor *)0, (GdkColor *)0, txt, -1);
		}

		gtk_text_view_scroll_to_iter( (GtkTextView *)text7, &end, 0.0, 1, 0, 1.0);

		return;
	}

	//static int colors[16][3] = {
	//	{      0,      0,      0 }, //  0 BLACK ?!
	//	{ 0x8000,      0,      0 }, //  1 Red
	//	{      0, 0x8000,      0 }, //  2 Green
	//	{      0,      0,      0 }, //  3 Brown
	//	{      0,      0, 0x8000 }, //  4 Blue
	//	{ 0x8000,      0, 0x8000 }, //  5 Purple
	//	{      0, 0x8000, 0x8000 }, //  6 Cyan
	//	{ 0xC000, 0xC000, 0xC000 }, //  7 White
	//	{ 0x8000, 0x8000, 0x8000 }, //  8 Gray
	//	{ 0x0000, 0x0000, 0xFFFF }, //  9 Blue
	//	{      0, 0xFFFF,      0 }, // 10 Green
	//	{      0, 0xFFFF, 0xFFFF }, // 11 Cyan
	//	{ 0xFFFF,      0,      0 }, // 12 Red
	//	{ 0xFFFF,      0, 0xFFFF }, // 13 Purple
	//	{ 0xFFFF, 0xFFFF,      0 }, // 14 Yellow
	//	{ 0xFFFF, 0xFFFF, 0xFFFF }  // 15 White
	//};
	//
	//GdkColor black;
	//black.red   = colors[n][0];
	//black.green = colors[n][1];
	//black.blue  = colors[n][2];

	if (*txt)
		gtk_text_buffer_insert_with_tags_by_name( gtktextbuffer, &end, txt, -1, colors[n], NULL);

//g/boolean    gtk_text_view_scroll_to_iter    (GtkTextView *text_view,
///                                             GtkTextIter *iter,
//                                             gdouble within_margin,
//                                             gboolean use_align,
//                                             gdouble xalign,
//                                             gdouble yalign);
	//GTK1
	//gtk_text_insert( GTK_TEXT( text7), (GdkFont *)ourfont, (GdkColor *)&black, (GdkColor *)0, txt, -1);
	//GTK2
	//if (*txt)
	//	gtk_text_buffer_insert_at_cursor( gtktextbuffer, txt, -1);
}

void WndChat::onCls( void) {
	onThaw();

	GtkTextBuffer *gtktextbuffer = gtk_text_view_get_buffer( (GtkTextView *)text7);
	gtk_text_buffer_set_text( gtktextbuffer, "", -1);

	//GTK2
	//gtk_text_set_point( GTK_TEXT(text7), 0);
	//gtk_text_forward_delete(
	//	GTK_TEXT(text7), 
	//	gtk_text_get_length( GTK_TEXT(text7))
	//);
	//gtk_text_set_point( GTK_TEXT(text7), 0);	
	onFreeze();
}
