#include "../config.h"
#include <stdio.h>
#include "wndfile.h"
#include "wndalert.h"

#ifdef WIN32
#include <windows.h>

// struct win32_filtermap {
// 	int action;
// 	char *filter;
// };
// 
// static char *get_filters (int action) {
// 	int i;
// 	char *filter;
// 	static struct win32_filtermap map[] = {
// 		{SAVE_DATA, "gretl data files (*.dat)\0*.dat\0all files\0*\0"},
// 		{SAVE_GZDATA, "compressed data files (*.gz)\0*.gz\0all files\0*\0"},
// 		{SAVE_BIN1, "gretl data files (*.dat)\0*.dat\0all files\0*\0"},
// 		{SAVE_BIN2, "gretl data files (*.dat)\0*.dat\0all files\0*\0"},
// 		{SAVE_CMDS, "gretl command files (*.inp)\0*.inp\0all files\0*\0"},
// 		{SAVE_SCRIPT, "gretl script files (*.inp)\0*.inp\0all files\0*\0"},
// 		{SAVE_CONSOLE, "gretl command files (*.inp)\0*.inp\0all files\0*\0"},
// 		{SAVE_MODEL, "text files (*.txt)\0*.txt\0all files\0*\0"},
// 		{SAVE_SESSION, "session files (*.gretl)\0*.gretl\0all files\0*\0"},
// 		{SAVE_LAST_GRAPH, "all files\0*\0"},
// 		{SAVE_GP_CMDS, "gnuplot files (*.gp)\0*.gp\0all files\0*\0"},
// 		{EXPORT_CSV, "CSV files (*.csv)\0*.csv\0all files\0*\0"},
// 		{EXPORT_R, "GNU R files (*.R)\0*.R\0all files\0*\0"},
// 		{EXPORT_R_ALT, "GNU R files (*.R)\0*.R\0all files\0*\0"},
// 		{EXPORT_OCTAVE, "GNU Octave files (*.m)\0*.m\0all files\0*\0"},
// 		{SAVE_OUTPUT, "text files (*.txt)\0*.txt\0all files\0*\0"},
// 		{SAVE_TEX_TAB, "TeX files (*.tex)\0*.tex\0all files\0*\0"},
// 		{SAVE_TEX_EQ, "TeX files (*.tex)\0*.tex\0all files\0*\0"},
// 		{OPEN_DATA, "gretl data files (*.dat)\0*.dat*\0all files\0*\0"},
// 		{OPEN_SCRIPT, "gretl script files (*.inp)\0*.inp\0all files\0*\0"},
// 		{OPEN_SESSION, "session files (*.gretl)\0*.gretl\0all files\0*\0"},
// 		{OPEN_CSV,  "CSV files (*.csv)\0*.csv\0all files\0*\0"},
// 		{OPEN_BOX, "BOX data files (*.box)\0*.box\0all files\0*\0"}
// 	};
// 
// 	for (i=0; i< sizeof map/sizeof *map; i++) {
// 		if (action == map[i].action) {
// 			filter = map[i].filter;
// 			break;
// 		}
// 	}
// 		
// 	return filter;
// }

#endif

void onWndFile_fileselection1_unrealize( GtkWidget *widget, gpointer user_data) {
}


void onWndFile_ok_button1_clicked( GtkButton *button, gpointer user_data) {
	
	((WndFile *)user_data)->fn(
		0,
		(char *)gtk_file_selection_get_filename( (GtkFileSelection *) ((WndFile *)user_data)->wndfile ),
		((WndFile *)user_data)->data
	);
	gtk_widget_hide( ((WndFile *)user_data)->wndfile);
}


void onWndFile_cancel_button1_clicked( GtkButton *button, gpointer user_data) {
}

WndFile::WndFile( void (*fn)(int, const char *, void *), void *data) {
	WndFile::fn = fn;
	WndFile::data = data;

	#ifdef WIN32

		OPENFILENAME of;
		int retval;
		char fname[512];

		fname[0] = '\0';

		memset(&of, 0, sizeof( of));
		#ifdef OPENFILENAME_SIZE_VERSION_400
			of.lStructSize = OPENFILENAME_SIZE_VERSION_400;
		#else
			of.lStructSize = sizeof of;
		#endif
		of.hwndOwner = NULL;
		of.lpstrFilter = NULL; //get_filters(action);
		of.lpstrCustomFilter = NULL;
		of.nFilterIndex = 1;
		of.lpstrFile = fname;
		of.nMaxFile = sizeof fname;
		of.lpstrFileTitle = NULL;
		of.lpstrInitialDir = "."; //startdir;
		of.lpstrTitle = "Select file...";
		of.lpstrDefExt = NULL;
		of.Flags = OFN_HIDEREADONLY;

		retval = GetOpenFileName(&of);

		if (retval)
			fn( 0, fname, data);

	#else

		wndfile = gtk_file_selection_new ("Select File");
		gtk_object_set_data (GTK_OBJECT (wndfile), "wndfile", wndfile);
		gtk_container_set_border_width (GTK_CONTAINER (wndfile), 10);

		ok_button1 = GTK_FILE_SELECTION (wndfile)->ok_button;
		gtk_object_set_data (GTK_OBJECT (wndfile), "ok_button1", ok_button1);
		gtk_widget_show (ok_button1);
		GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

		cancel_button1 = GTK_FILE_SELECTION (wndfile)->cancel_button;
		gtk_object_set_data (GTK_OBJECT (wndfile), "cancel_button1", cancel_button1);
		gtk_widget_show (cancel_button1);
		GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

		gtk_signal_connect (GTK_OBJECT (wndfile), "unrealize",
                      GTK_SIGNAL_FUNC (onWndFile_fileselection1_unrealize),
                      this);
		gtk_signal_connect (GTK_OBJECT (ok_button1), "clicked",
                      GTK_SIGNAL_FUNC (onWndFile_ok_button1_clicked),
                      this);
		gtk_signal_connect (GTK_OBJECT (cancel_button1), "clicked",
                      GTK_SIGNAL_FUNC (onWndFile_cancel_button1_clicked),
                      this);

		gtk_widget_show( wndfile);

	#endif
}

WndFile::~WndFile( void) {
}
