#include <stdio.h>
#include <stdlib.h>
#include "../tools/build.h"
#include "../globals.h"
#include "config.h"
#include "wndhashedit.h"
#include "wndfile.h"

//===
// Initialize the allowed client types.
	const char *WndHash_clients[WNDHASH_CLIENTS] = {
		"W2BN", "STAR", "SEXP", "D2DV", "D2XP", "JSTR", "WAR3"
	};

void on_optionmenu4_activate( GtkMenuItem *widget, gchar *user_data) { //*string) {
	//fprintf( stderr, "WndHashEdit widget is 0x%.8x\n", widget); fflush( stderr);
	//
	//fprintf( stderr, "WndHashEdit optionmenu4       is 0x%.8x\n", ((WndHashEdit *)user_data)->optionmenu4     ); fflush( stderr);
	//fprintf( stderr, "WndHashEdit optionmenu4_menu  is 0x%.8x\n", ((WndHashEdit *)user_data)->optionmenu4_menu); fflush( stderr);
	//fprintf( stderr, "WndHashEdit glade_menuitem[0] is 0x%.8x\n", ((WndHashEdit *)user_data)->glade_menuitem[0]); fflush( stderr);

	for (int i = 0; i < WNDHASH_CLIENTS; i++) {
		if (widget == (GtkMenuItem *) ((WndHashEdit *)user_data)->glade_menuitem[i]) {
			//===
			// Get the "hash" objects from the database.
				Obj *objHash = globals->db->getObj("hash");
				if (!objHash) {
					objHash = new Obj("hash");
					globals->db->append( objHash);
				}
				
			//===
			// Search for the vars we are looking for
				Obj *objClient = objHash->getObj( WndHash_clients[i]);
				if (!objClient) {
					objClient = new Obj( WndHash_clients[i]);
					objHash->append( objClient);
				}
				
			//===
			// Search for the exe, snp, dll
				char *exe = objClient->getVar("exe");
				char *snp = objClient->getVar("snp");
				char *dll = objClient->getVar("dll");
				
				if (!exe) exe = "";
				if (!snp) snp = "";
				if (!dll) dll = "";
				
			//===
			// Set the fields.
				gtk_entry_set_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry10, exe);
				gtk_entry_set_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry11, snp);
				gtk_entry_set_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry12, dll);
		}
	}
}

void on_optionmenu4_save( GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	fprintf( stderr, "WndHashEdit widget is 0x%.8x\n", widget); fflush( stderr);

	fprintf( stderr, "WndHashEdit optionmenu4       is 0x%.8x\n", ((WndHashEdit *)user_data)->optionmenu4     ); fflush( stderr);
	fprintf( stderr, "WndHashEdit optionmenu4_menu  is 0x%.8x\n", ((WndHashEdit *)user_data)->optionmenu4_menu); fflush( stderr);
	fprintf( stderr, "WndHashEdit glade_menuitem[0] is 0x%.8x\n", ((WndHashEdit *)user_data)->glade_menuitem[0]); fflush( stderr);

	GtkWidget *active = gtk_menu_get_active( (GtkMenu *)((WndHashEdit *)user_data)->optionmenu4_menu);
	for (int i = 0; i < WNDHASH_CLIENTS; i++) {
		if ( ((WndHashEdit *)user_data)->glade_menuitem[i] == (GtkWidget *)active) {
			fprintf( stderr, "WndHashEdit found menu item %s\n", WndHash_clients[i]); fflush( stderr);

			//===
			// Get the "hash" objects from the database.
				Obj *objHash = globals->db->getObj("hash");
				if (!objHash) {
					objHash = new Obj("hash");
					globals->db->append( objHash);
				}
				
			//===
			// Search for the vars we are looking for
				Obj *objClient = objHash->getObj( WndHash_clients[i]);
				if (!objClient) {
					objClient = new Obj( WndHash_clients[i]);
					objHash->append( objClient);
				}
				
			//===
			// Get the exe, snp, dll
				const char *exe = gtk_entry_get_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry10);
				const char *snp = gtk_entry_get_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry11);
				const char *dll = gtk_entry_get_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry12);

			//===
			// Set the vars.
				objClient->setVar( "exe", exe);
				objClient->setVar( "snp", snp);
				objClient->setVar( "dll", dll);
		}
	}
}

void on_entry10_changed( GtkEditable *editable, gpointer user_data) {
}

void onWndHash_callback( int n, const char *buf, void *data) {
	switch( n) {
		case 0: // File selection
			gtk_entry_set_text( (GtkEntry *)data, buf);
			break;
		case 1: // Dialog destroyed
			break;
	}
}


//===
// Exe file
void on_button10_clicked( GtkButton *button, gpointer user_data) {
	new WndFile( onWndHash_callback, (void *)user_data);
}


void on_entry11_changed( GtkEditable *editable, gpointer user_data) {
}


void on_button11_clicked( GtkButton *button, gpointer user_data) {
	new WndFile( onWndHash_callback, (void *)user_data);
}

void on_entry12_changed( GtkEditable *editable, gpointer user_data) {
}


void on_button12_clicked( GtkButton *button, gpointer user_data) {
	new WndFile( onWndHash_callback, (void *)user_data);
}


//===
// Save the current hash.
void on_button4_clicked( GtkButton *button, gpointer user_data) {
	GtkWidget *active = gtk_menu_get_active( (GtkMenu *)((WndHashEdit *)user_data)->optionmenu4_menu);
	for (int i = 0; i < WNDHASH_CLIENTS; i++) {
		if ( ((WndHashEdit *)user_data)->glade_menuitem[i] == (GtkWidget *)active) {
			fprintf( stderr, "WndHashEdit found menu item %s\n", WndHash_clients[i]); fflush( stderr);

			//===
			// Get the "hash" objects from the database.
				Obj *objHash = globals->db->getObj("hash");
				if (!objHash) {
					objHash = new Obj("hash");
					globals->db->append( objHash);
				}
				
			//===
			// Search for the vars we are looking for
				Obj *objClient = objHash->getObj( WndHash_clients[i]);
				if (!objClient) {
					objClient = new Obj( WndHash_clients[i]);
					objHash->append( objClient);
				}
				
			//===
			// Get the exe, snp, dll
				const char *exe = gtk_entry_get_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry10);
				const char *snp = gtk_entry_get_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry11);
				const char *dll = gtk_entry_get_text( (GtkEntry *) ((WndHashEdit *)user_data)->entry12);

			//===
			// Set the vars.
				objClient->setVar( "exe", exe);
				objClient->setVar( "snp", snp);
				objClient->setVar( "dll", dll);
		}
	}

	gtk_widget_hide( ((WndHashEdit *)user_data)->wndhashedit);
}

WndHashEdit::WndHashEdit( void) {
  wndhashedit = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (wndhashedit), "wndhashedit", wndhashedit);
  gtk_container_set_border_width (GTK_CONTAINER (wndhashedit), 5);
  char buf[ 256];
  sprintf( buf, "zDSBot3 (build %d) - Hash Edit\0________________________________________________________________", BUILD);
  gtk_window_set_title (GTK_WINDOW (wndhashedit), buf);
  gtk_window_set_policy (GTK_WINDOW (wndhashedit), TRUE, TRUE, FALSE);

  #ifdef WIN32
    dialog_vbox2 = GTK_DIALOG (wndhashedit)->action_area;
  #else
    dialog_vbox2 = GTK_DIALOG (wndhashedit)->vbox;
  #endif
  gtk_object_set_data (GTK_OBJECT (wndhashedit), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), vbox2, TRUE, TRUE, 0);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox12, FALSE, TRUE, 0);

  label23 = gtk_label_new( "Client:");
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (hbox12), label23, FALSE, FALSE, 2);
  gtk_widget_set_usize (label23, 60, -2);

  optionmenu4 = gtk_option_menu_new ();
  gtk_widget_show (optionmenu4);
  gtk_box_pack_start (GTK_BOX (hbox12), optionmenu4, FALSE, FALSE, 2);
  optionmenu4_menu = gtk_menu_new ();
  
  //glade_menuitem = gtk_menu_item_new_with_label ("Chat Client");
  //gtk_widget_show (glade_menuitem);
  //gtk_menu_append (GTK_MENU (optionmenu4_menu), glade_menuitem);
  
	//===
	// Add the pull-down client select.
		for (int i = 0; i < WNDHASH_CLIENTS; i++) {
			glade_menuitem[i] = gtk_menu_item_new_with_label (WndHash_clients[i]);
			gtk_widget_show (glade_menuitem[i]);
			gtk_menu_append (GTK_MENU (optionmenu4_menu), glade_menuitem[i]);
		}

		gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu4), optionmenu4_menu);
		gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu4), WNDHASH_CLIENTS);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox2), hseparator2, TRUE, TRUE, 2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), vbox3, TRUE, TRUE, 0);

  hbox13 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox13, TRUE, TRUE, 0);

  label24 = gtk_label_new ("Exe");
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (hbox13), label24, FALSE, FALSE, 2);
  gtk_widget_set_usize (label24, 60, -2);

  entry10 = gtk_entry_new ();
  gtk_widget_show (entry10);
  gtk_box_pack_start (GTK_BOX (hbox13), entry10, TRUE, TRUE, 2);

  button10 = gtk_button_new_with_label ("Browse");
  gtk_widget_show (button10);
  gtk_box_pack_start (GTK_BOX (hbox13), button10, FALSE, FALSE, 2);

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox14, TRUE, TRUE, 0);

  label25 = gtk_label_new ("Snp/D2c");
  gtk_widget_show (label25);
  gtk_box_pack_start (GTK_BOX (hbox14), label25, FALSE, FALSE, 2);
  gtk_widget_set_usize (label25, 60, -2);

  entry11 = gtk_entry_new ();
  gtk_widget_show (entry11);
  gtk_box_pack_start (GTK_BOX (hbox14), entry11, TRUE, TRUE, 2);

  button11 = gtk_button_new_with_label ("Browse");
  gtk_widget_show (button11);
  gtk_box_pack_start (GTK_BOX (hbox14), button11, FALSE, FALSE, 2);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox15);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox15, TRUE, TRUE, 0);

  label26 = gtk_label_new ("Dll/Bnc");
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (hbox15), label26, FALSE, FALSE, 2);
  gtk_widget_set_usize (label26, 60, -2);

  entry12 = gtk_entry_new ();
  gtk_widget_show (entry12);
  gtk_box_pack_start (GTK_BOX (hbox15), entry12, TRUE, TRUE, 2);

  button12 = gtk_button_new_with_label ("Browse");
  gtk_widget_show (button12);
  gtk_box_pack_start (GTK_BOX (hbox15), button12, FALSE, FALSE, 2);

  dialog_action_area2 = GTK_DIALOG (wndhashedit)->action_area;
  gtk_object_set_data (GTK_OBJECT (wndhashedit), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), hbuttonbox2, TRUE, TRUE, 0);

  button4 = gtk_button_new_with_label ("Sweet!");
  gtk_widget_show (button4);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);

	for (int i = 0; i < WNDHASH_CLIENTS; i++)
		gtk_signal_connect(GTK_OBJECT( glade_menuitem[i]),
			"activate",
			GTK_SIGNAL_FUNC (on_optionmenu4_activate),
			this        //(GtkObject *)WndHash_clients[i]
		);

  //gtk_signal_connect (GTK_OBJECT (optionmenu4), "enter",
  //                    GTK_SIGNAL_FUNC (on_optionmenu4_save),
  //                    this);
  gtk_signal_connect (GTK_OBJECT (optionmenu4), "button_press_event",
                      GTK_SIGNAL_FUNC (on_optionmenu4_save),
                      this);
  //gtk_signal_connect (GTK_OBJECT (optionmenu4), "leave",
  //                    GTK_SIGNAL_FUNC (on_optionmenu4_activate),
  //                    this);
  //gtk_signal_connect (GTK_OBJECT (optionmenu4), "pressed",
  //                    GTK_SIGNAL_FUNC (on_optionmenu4_activate),
  //                    this);
  //gtk_signal_connect (GTK_OBJECT (optionmenu4), "released",
  //                    GTK_SIGNAL_FUNC (on_optionmenu4_activate),
  //                    this);
  gtk_signal_connect (GTK_OBJECT (entry10), "changed",
                      GTK_SIGNAL_FUNC (on_entry10_changed),
                      this);
  gtk_signal_connect (GTK_OBJECT (button10), "clicked",
                      GTK_SIGNAL_FUNC (on_button10_clicked),
                      entry10);
  gtk_signal_connect (GTK_OBJECT (entry11), "changed",
                      GTK_SIGNAL_FUNC (on_entry11_changed),
                      this);
  gtk_signal_connect (GTK_OBJECT (button11), "clicked",
                      GTK_SIGNAL_FUNC (on_button11_clicked),
                      entry11);
  gtk_signal_connect (GTK_OBJECT (entry12), "changed",
                      GTK_SIGNAL_FUNC (on_entry12_changed),
                      this);
  gtk_signal_connect (GTK_OBJECT (button12), "clicked",
                      GTK_SIGNAL_FUNC (on_button12_clicked),
                      entry12);
  gtk_signal_connect (GTK_OBJECT (button4), "clicked",
                      GTK_SIGNAL_FUNC (on_button4_clicked),
                      this);

	
	//===
	// Get the "hash" objects from the database.
		Obj *objHash = globals->db->getObj("hash");
		if (!objHash) {
			objHash = new Obj("hash");
			globals->db->append( objHash);
		}
				
	//===
	// Search for the vars we are looking for
		Obj *objClient = objHash->getObj( WndHash_clients[0]);
		if (!objClient) {
			objClient = new Obj( WndHash_clients[0]);
			objHash->append( objClient);
		}
				
	//===
	// Search for the exe, snp, dll
		char *exe = objClient->getVar("exe");
		char *snp = objClient->getVar("snp");
		char *dll = objClient->getVar("dll");
				
		if (!exe) exe = "";
		if (!snp) snp = "";
		if (!dll) dll = "";
				
	//===
	// Set the fields.
		gtk_entry_set_text( (GtkEntry *) entry10, exe);
		gtk_entry_set_text( (GtkEntry *) entry11, snp);
		gtk_entry_set_text( (GtkEntry *) entry12, dll);

  gtk_widget_show( wndhashedit);
}

WndHashEdit::~WndHashEdit( void) {
  gtk_widget_destroy( wndhashedit);
}
