#include <iostream> // delme
#include "../tools/build.h"
#include "config.h"
#include "wndmain.h"
#include "wndabout.h"
#include "wndnewbot.h"
#include "wndhashedit.h"
#include "wndmodules.h"
#include "wndquotes.h"
#include "../support.h"
#include "mnumain.h"
#include "wndscripts.h"
#include "wndusers.h"
#include "wndbnstatus.h"

#include "../globals.h"
//#include "../../../src/bot/botthread.h"
//#include "../../../src/bot/botlist.h"
//#include "../../../src/db/obj.h"

#include "Pixmaps/stock_new.xpm"
#include "Pixmaps/stock_properties.xpm"
#include "Pixmaps/stock_index.xpm"
#include "Pixmaps/stock_book_red.xpm"
#include "Pixmaps/stock_book_green.xpm"
#include "Pixmaps/stock_book_open2.xpm"
#include "Pixmaps/stock_exec.xpm"
#include "Pixmaps/stock_search.xpm"
#include "Pixmaps/stock_menu_about.xpm"
#include "Pixmaps/stock_preferences.xpm"
#include "Pixmaps/stock_convert.xpm"
#include "Pixmaps/stock_save.xpm"

#include "../botlist.h"
extern BotList botlist;

void on_wndmain_destroy( GtkObject *object, gpointer user_data) {
	globals->done++;
	gtk_main_quit();
}

void on_btnSave_clicked( GtkButton *button, gpointer user_data) {   
	globals->db->save("nconfig.txt");
	globals->userdb->save("userdb.txt");
}
 
void on_btnModules_clicked( GtkButton *button, gpointer user_data) {
	new WndModules();
}

void on_button13_clicked( GtkButton *button, gpointer user_data) {
	new WndNewBot( 0);
}

void on_button14_clicked( GtkButton *button, gpointer user_data) {
  new WndHashEdit();
}

void on_button15_clicked( GtkButton *button, gpointer user_data) {
	new WndUsers();
}

void on_button19_clicked( GtkButton *button, gpointer user_data) {
  // new WndUsers();
}   

void on_button20_clicked( GtkButton *button, gpointer user_data) {
	new WndBNStatus();
	// new WndUsers();
}   

void on_button21_clicked( GtkButton *button, gpointer user_data) {
  new WndQuotes();
}   

void on_button18_clicked( GtkButton *button, gpointer user_data) {
	new WndScripts();
}

void on_button17_clicked( GtkButton *button, gpointer user_data) {
  // new WndScanWarn();
}   

void on_button16_clicked( GtkButton *button, gpointer user_data) {
	new WndAbout();
}

//===
// Don't theads_enter, we are called from gtk!
void on_clist2_select_row(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
  //gdk_threads_enter();
  gtk_clist_unselect_all( (GtkCList *)((WndMain *)user_data)->clist2);
  //gdk_threads_leave();
  if (!column)
    new MnuMain( (WndMain *)user_data, row); //((WndMain *)user_data)->globals, row);
}

WndMain::WndMain( void) {
	displist = new std::list<WndChat *>;
	clist_rows = 0;
	lastidle = 0;

	//gdk_threads_enter();
	wndmain = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wndmain), "wndmain", wndmain);

	//===
	// Show off the version
		char buf[256];
		sprintf( buf, "zDSBot3 (build %d) - by Eurijk!\0________________________________________________________________", BUILD);
		gtk_window_set_title (GTK_WINDOW (wndmain), buf);
		gtk_window_set_default_size( (GtkWindow *)wndmain, 600, 250);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (wndmain), vbox4);

	//GTK1
	//toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);

	//GTK2
  toolbar1 = gtk_toolbar_new ();
	gtk_toolbar_set_orientation( GTK_TOOLBAR (toolbar1), GTK_ORIENTATION_HORIZONTAL);
	gtk_toolbar_set_style( GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_BOTH);
	
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox4), toolbar1, FALSE, FALSE, 0);

  tmp_toolbar_icon = create_xpm(wndmain, stock_save_xpm);
  btnSave = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Save",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_show (btnSave);
  gtk_container_set_border_width (GTK_CONTAINER (btnSave), 1);

  tmp_toolbar_icon = create_xpm(wndmain, stock_convert_xpm);
  btnModules = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Modules",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_show (btnModules);
  gtk_container_set_border_width (GTK_CONTAINER (btnModules), 1);

  tmp_toolbar_icon = create_xpm(wndmain, stock_new_xpm);
  button13 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "New Bot",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_show (button13);
  gtk_container_set_border_width (GTK_CONTAINER (button13), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_PROPERTIES);
  tmp_toolbar_icon = create_xpm(wndmain, stock_properties_xpm);
  button14 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Hashes",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button14);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button14", button14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button14);
  gtk_container_set_border_width (GTK_CONTAINER (button14), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_INDEX);
  tmp_toolbar_icon = create_xpm(wndmain, stock_index_xpm);
  button15 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Users",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button15);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button15", button15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button15);
  gtk_container_set_border_width (GTK_CONTAINER (button15), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_BOOK_RED);
  tmp_toolbar_icon = create_xpm(wndmain, stock_book_red_xpm);
  button19 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Ban",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button19);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button19", button19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button19);
  gtk_container_set_border_width (GTK_CONTAINER (button19), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_BOOK_GREEN);
  tmp_toolbar_icon = create_xpm(wndmain, stock_book_green_xpm);
  button20 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "BNStats",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button20);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button20", button20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button20);
  gtk_container_set_border_width (GTK_CONTAINER (button20), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_BOOK_OPEN);
  tmp_toolbar_icon = create_xpm(wndmain, stock_book_open_xpm2);
  button21 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Quotes",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button21);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button21", button21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button21);
  gtk_container_set_border_width (GTK_CONTAINER (button21), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_EXEC);
  tmp_toolbar_icon = create_xpm(wndmain, stock_exec_xpm);
  button18 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Scripts",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button18);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button18", button18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button18);
  gtk_container_set_border_width (GTK_CONTAINER (button18), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_SEARCH);
  tmp_toolbar_icon = create_xpm(wndmain, stock_search_xpm);
  button17 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Proxy",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button17);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button17", button17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button17);
  gtk_container_set_border_width (GTK_CONTAINER (button17), 1);

  //tmp_toolbar_icon = gnome_stock_pixmap_widget (wndmain, GNOME_STOCK_PIXMAP_HELP);
  tmp_toolbar_icon = create_xpm(wndmain, stock_menu_about_xpm);
  button16 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "About",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button16);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "button16", button16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button16);
  gtk_container_set_border_width (GTK_CONTAINER (button16), 1);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 1);

  clist2 = gtk_clist_new (8);
  gtk_widget_ref (clist2);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "clist2", clist2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist2);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 0, 24);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 2, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 4, 107);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 5, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 6, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 7, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist2));
  gtk_clist_set_row_height((GtkCList *)clist2, 21);

  label37 = gtk_label_new ("");
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 0, label37);

  label38 = gtk_label_new ("Active");
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label38);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 1, label38);

  label39 = gtk_label_new ("Bot");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 2, label39);

  label40 = gtk_label_new ("Channel");
  gtk_widget_ref (label40);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label40", label40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label40);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 3, label40);

  label41 = gtk_label_new ("Server");
  gtk_widget_ref (label41);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label41", label41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label41);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 4, label41);

  label42 = gtk_label_new ("Uptime");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 5, label42);

  label43 = gtk_label_new ("Send");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 6, label43);

  label44 = gtk_label_new ("Recv");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 7, label44);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (wndmain), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox4), statusbar1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (statusbar1), 1);

  gtk_signal_connect (GTK_OBJECT (wndmain), "destroy", 
                      GTK_SIGNAL_FUNC (on_wndmain_destroy), 
                      this);
  gtk_signal_connect (GTK_OBJECT (btnSave), "clicked",
                      GTK_SIGNAL_FUNC (on_btnSave_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (btnModules), "clicked",
                      GTK_SIGNAL_FUNC (on_btnModules_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button13), "clicked",
                      GTK_SIGNAL_FUNC (on_button13_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button14), "clicked",
                      GTK_SIGNAL_FUNC (on_button14_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button15), "clicked",
                      GTK_SIGNAL_FUNC (on_button15_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button19), "clicked",
                      GTK_SIGNAL_FUNC (on_button19_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button20), "clicked",
                      GTK_SIGNAL_FUNC (on_button20_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button21), "clicked",
                      GTK_SIGNAL_FUNC (on_button21_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button18), "clicked",
                      GTK_SIGNAL_FUNC (on_button18_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button17), "clicked",
                      GTK_SIGNAL_FUNC (on_button17_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button16), "clicked",
                      GTK_SIGNAL_FUNC (on_button16_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (clist2), "select_row",
                      GTK_SIGNAL_FUNC (on_clist2_select_row),
                      this);

  gtk_widget_show( wndmain);
 // gdk_threads_leave();
}

WndMain::~WndMain( void) {
	delete displist;

  //gdk_threads_enter();
  gtk_widget_destroy( wndmain);
  //gdk_threads_leave();
}

//===
// Todo:
//   See race condition.
//   A lot of text needs to check if it has changed, as text
//   that has not changed, does not need to be updated.
void WndMain::idle( void) {
	for (std::list<WndChat *>::iterator i = displist->begin(); i != displist->end(); i++) {
		(*i)->onHandler(); // ((*i)->bot)->disp);
 	}

	if ((time(0) - lastidle) < 5)
		return;

	lastidle = time(0);

	gtk_clist_freeze( (GtkCList *)clist2);

	sBotList *tmp = botlist.first; int row = 0;
	while (tmp) {
//    Obj *vars = tmp->bot->getVars();
//    
    //===
    // Do we have enough rows?
    // Help: How do you do this in gtk? I would think every time we create
    //       a row like this we would loose a little memory. What is the
    //       proper implementation for this?
    if (row >= clist_rows) {
      char *tmp[] = { "", "", "", "", "", "", "", "" };
      int n = gtk_clist_append( (GtkCList *)clist2, tmp);

      GdkColormap *colormap= gtk_widget_get_colormap( wndmain);
      GdkBitmap *mask;
      GdkPixmap *pixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask, NULL, stock_preferences_xpm);
      gtk_clist_set_pixmap( (GtkCList *)clist2, n, 0, pixmap, mask);
      gdk_pixmap_unref (pixmap);
      gdk_bitmap_unref (mask);

      clist_rows++;
    }

		if (tmp->data->isActive())
			gtk_clist_set_text( (GtkCList *)clist2, row, 1, "Yes");
		else
			gtk_clist_set_text( (GtkCList *)clist2, row, 1, "No");

		gtk_clist_set_text( (GtkCList *)clist2, row, 2, tmp->data->getName());
		gtk_clist_set_text( (GtkCList *)clist2, row, 3, tmp->data->getCurChannel());
		gtk_clist_set_text( (GtkCList *)clist2, row, 4, tmp->data->getServer());

	//===
	// Uptime
		{
			time_t t = tmp->data->getUpTime(); //time(0) - tmp->data->getCTime();
				
			char buf[ 32];
			int days = t / (3600*24); t -= days * 3600 * 24;
			int hours = t / (3600);   t -= hours * 3600;
			int mins = t / 60;        t -= mins * 60;
			int secs = t;

			if (days)
				sprintf( buf, "%dd %.2dh %.2dm %.2ds", days, hours, mins, secs);
			else
				sprintf( buf, "%.2dh %.2dm %.2ds", hours, mins, secs);

			gtk_clist_set_text( (GtkCList *)clist2, row, 5, buf);
		}

		//===
		// Send/Recv
		{
			char buf[ 16];
			sprintf( buf, "%u", tmp->data->getCountSend());
			gtk_clist_set_text( (GtkCList *)clist2, row, 6, buf);
			sprintf( buf, "%u", tmp->data->getCountRecv());
			gtk_clist_set_text( (GtkCList *)clist2, row, 7, buf);
		}

		tmp = tmp->next;
		row++;
	}
	
	gtk_clist_thaw( (GtkCList *)clist2);

//	gdk_threads_leave();
}
