#include <stdio.h>
#include <string.h>
#include "../tools/build.h"
#include "../globals.h"
#include "wndscriptedit.h"
#include "../mylib.h"

void onWndScriptEdit_dispatch( Obj *obj, char *txt) {

	trim( txt);
	if ((*txt == '/') && (*(txt + 1) == '/')) {
		obj->commentAppend( txt);
	} else {
		char *t2 = gettermnz( txt, 2);
		char *t1 = gettermn( txt, 1);
		if (t2 && t1)
			obj->appendVar( t1, t2);
		if (!t2 && t1)
			obj->appendVar( t1, "");
	}	
}

void onWndScriptEdit_button12_clicked( GtkButton *button, gpointer user_data) {
	// A little bit involved.
	// We will need to re-parse the function.
	
	char *fn_text = gtk_editable_get_chars(
		(GtkEditable *) ((WndScriptEdit *)user_data)->text2,
		0, -1);

	if (!fn_text)
		return;
		
	Obj *obj = new Obj( ((WndScriptEdit *)user_data)->cmd.c_str());

	char buf[ 512];
	char *start = fn_text;
	char *tmp   = fn_text;
	while (*tmp) {
		switch( *tmp) {
			case '\r':
			case '\n':
				*tmp = 0;
				if (*start)
					onWndScriptEdit_dispatch( obj, start);
				start = tmp + 1;
		}
		tmp++;
	}
	
	if (*start)
		onWndScriptEdit_dispatch( obj, start);

	//===
	// Get the dynamic commands.
		Obj *dyncmd = globals->db->getObj("dyncmd")->getObj( ((WndScriptEdit *)user_data)->cmdgroup.c_str());
		
	//===
	// Delete the old one, add the new one.
		Obj *oldobj = dyncmd->getObj( ((WndScriptEdit *)user_data)->cmd.c_str());
		if (oldobj)
			dyncmd->delObj( oldobj);

		//obj->save("erm.txt");

		dyncmd->append( obj);

	g_free( fn_text);
}


void
onWndScriptEdit_button13_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
onWndScriptEdit_button14_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{

}



WndScriptEdit::WndScriptEdit( const char *cmdgroup, const char *cmd) {
	//fprintf( stderr, "Debug: WndScriptEdit called with \"%s::%s\"\n", cmdgroup, cmd); fflush( stderr);

	WndScriptEdit::cmdgroup = cmdgroup;
	WndScriptEdit::cmd = cmd;

	wndscriptedit = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wndscriptedit), "wndscriptedit", wndscriptedit);
	gtk_container_set_border_width (GTK_CONTAINER (wndscriptedit), 2);
	char buf[ 256];
	sprintf( buf, "zDSBot3 (build %d) - %s", BUILD, cmd);
	gtk_window_set_title (GTK_WINDOW (wndscriptedit), buf);

	frame6 = gtk_frame_new ("Function Source");
	gtk_widget_ref (frame6);
	gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frame6);
	gtk_container_add (GTK_CONTAINER (wndscriptedit), frame6);
	gtk_container_set_border_width (GTK_CONTAINER (frame6), 2);

	vbox5 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox5);
	gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (frame6), vbox5);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox5), scrolledwindow3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow3), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2 Fixme
//  text2 = gtk_text_new (NULL, NULL);
//  gtk_widget_ref (text2);
//  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "text2", text2,
//                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (text2);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow3), text2);
//  gtk_text_set_editable (GTK_TEXT (text2), TRUE);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox5), hseparator2, FALSE, TRUE, 2);

  hbuttonbox5 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox5);
  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "hbuttonbox5", hbuttonbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox5);
  gtk_box_pack_start (GTK_BOX (vbox5), hbuttonbox5, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox5), GTK_BUTTONBOX_SPREAD);

  button12 = gtk_button_new_with_label ("Apply");
  gtk_widget_ref (button12);
  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "button12", button12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button12);
  gtk_container_add (GTK_CONTAINER (hbuttonbox5), button12);
  GTK_WIDGET_SET_FLAGS (button12, GTK_CAN_DEFAULT);

  button13 = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button13);
  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "button13", button13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button13);
  gtk_container_add (GTK_CONTAINER (hbuttonbox5), button13);
  GTK_WIDGET_SET_FLAGS (button13, GTK_CAN_DEFAULT);

  button14 = gtk_button_new_with_label ("Help");
  gtk_widget_ref (button14);
  gtk_object_set_data_full (GTK_OBJECT (wndscriptedit), "button14", button14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button14);
  gtk_container_add (GTK_CONTAINER (hbuttonbox5), button14);
  GTK_WIDGET_SET_FLAGS (button14, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (button12), "clicked",
                      GTK_SIGNAL_FUNC (onWndScriptEdit_button12_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button13), "clicked",
                      GTK_SIGNAL_FUNC (onWndScriptEdit_button13_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button14), "clicked",
                      GTK_SIGNAL_FUNC (onWndScriptEdit_button14_clicked),
                      this);

	//===
	// Get the dyncmd.
		Obj *dyncmd = globals->db->getObj("dyncmd")->getObj( cmdgroup);
		if (!dyncmd) {
			dyncmd = new Obj( cmdgroup);
			globals->db->getObj("dyncmd")->append( dyncmd);
		}

	//===
	// Get the object.
		Obj *obj = dyncmd->getObj( cmd);
		if (!obj) {
			obj = new Obj( cmd);
			dyncmd->append( obj);
		}

	//===
	// Add the object.
		sLList *tmp = obj->objFirst;
		while (tmp) {
			//===
			// First, grab all comments.
				sComments *cnode= tmp->obj->commentFirst;
				while (cnode) {
					//GTK2
					//gtk_text_insert( (GtkText *)text2, 0, 0, 0, cnode->data, strlen( cnode->data));
					//gtk_text_insert( (GtkText *)text2, 0, 0, 0, "\n", 1);
					cnode = cnode->next;
				}
				
			//===
			// Next, get the function data.
				if (tmp->obj->name[0]) {
					//GTK2
					//gtk_text_insert( (GtkText *)text2, 0, 0, 0, tmp->obj->name, strlen( tmp->obj->name));
					//gtk_text_insert( (GtkText *)text2, 0, 0, 0, " ", 1);
				
					if (tmp->obj->cdata) {
						//GTK2
						//gtk_text_insert( (GtkText *)text2, 0, 0, 0, tmp->obj->cdata, strlen( tmp->obj->cdata));
						//gtk_text_insert( (GtkText *)text2, 0, 0, 0, "\n", 1);
					}
				}

			tmp = tmp->next;
		}

	gtk_widget_show( wndscriptedit);
}

WndScriptEdit::~WndScriptEdit( void) {
}
