#include <stdio.h>
#include "../globals.h"
#include "../tools/build.h"
#include "wndscripts.h"
#include "wndscriptedit.h"
#include "wndnewscript.h"

void onWndScripts_clist1_select_row(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
	((WndScripts *)user_data)->myrow = row;
}

void onWndScripts_clist3_select_row(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
	((WndScripts *)user_data)->myrow2 = row;

	//===
	// Find the command from the list.
		char *cmd = NULL;
		int n2 = gtk_clist_get_text(
			(GtkCList *)((WndScripts *)user_data)->clist3,
			((WndScripts *)user_data)->myrow2,
			0,
			(gchar **)&cmd
		);

		if (!n2)
			return;
			
		if (!cmd || !*cmd)
			return;

	((WndScripts *)user_data)->showFunctionList( cmd);
}

void onWndScripts_button8_clicked( GtkButton *button, gpointer user_data) {
	new WndNewScript( (WndScripts *)user_data);
}

//===
// Delete
void onWndScripts_button9_clicked( GtkButton *button, gpointer user_data) {
	//===
	// Find the command from the list.
		char *cmd = NULL;
		int n2 = gtk_clist_get_text(
			(GtkCList *)((WndScripts *)user_data)->clist3,
			((WndScripts *)user_data)->myrow2,
			0,
			(gchar **)&cmd
		);

		if (!n2)
			return;
			
		if (!cmd || !*cmd)
			return;
		
	//===
	// Next, find the function.
		char *text = NULL;
		int n = gtk_clist_get_text(
			(GtkCList *)((WndScripts *)user_data)->clist1,
			((WndScripts *)user_data)->myrow,
			0,
			(gchar **)&text
		);

		if (!n)
			return;
			
		if (!text || !*text)
			return;
		
	//===
	// Delete it from the db.
		Obj *scripts = globals->db->getObj("dyncmd")->getObj( cmd);
		if (!scripts)
			return;

		Obj *myfn = scripts->getObj( text);
		if (myfn)
			scripts->delObj( myfn);

	//===
	// Remove it from the list.
		gtk_clist_remove(
			(GtkCList *)((WndScripts *)user_data)->clist1,
			((WndScripts *)user_data)->myrow
		);
		
}

//===
// Edit
void onWndScripts_button11_clicked( GtkButton *button, gpointer user_data) {
	//===
	// Find which option is selected in the function list.
		char *text1 = NULL;
		gtk_clist_get_text(
			(GtkCList *)((WndScripts *)user_data)->clist3,
			((WndScripts *)user_data)->myrow2,
			0,
			(gchar **)&text1
		);		

	//===
	// Find which option is selected in the function list.
		char *text2 = NULL;
		gtk_clist_get_text(
			(GtkCList *)((WndScripts *)user_data)->clist1,
			((WndScripts *)user_data)->myrow,
			0,
			(gchar **)&text2
		);

	if ((text1 && *text1) && (text2 && *text2))
		new WndScriptEdit( text1, text2);
}

WndScripts::WndScripts( void) {
	myrow = 0;
	myrow2 = 0;

	wndscripts = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wndscripts), "wndscripts", wndscripts);
	gtk_container_set_border_width (GTK_CONTAINER (wndscripts), 2);
	char buf[ 256];
	sprintf( buf, "zDSBot3 (build %d) - Scripts", BUILD);
	gtk_window_set_title (GTK_WINDOW (wndscripts), buf);

	hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_ref (hbox1);
	gtk_object_set_data_full (GTK_OBJECT (wndscripts), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hbox1);
	gtk_container_add (GTK_CONTAINER (wndscripts), hbox1);

	hpaned2 = gtk_hpaned_new ();
	gtk_widget_ref (hpaned2);
	gtk_object_set_data_full (GTK_OBJECT (wndscripts), "hpaned2", hpaned2,
	                         (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hpaned2);
	gtk_box_pack_start (GTK_BOX (hbox1), hpaned2, TRUE, TRUE, 0);
	gtk_paned_set_position (GTK_PANED (hpaned2), 186);

  frame20 = gtk_frame_new ("Command Handlers");
  gtk_widget_ref (frame20);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "frame20", frame20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame20);
  gtk_paned_pack1 (GTK_PANED (hpaned2), frame20, FALSE, TRUE);
  gtk_container_set_border_width (GTK_CONTAINER (frame20), 2);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox15);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "vbox15", vbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox15);
  gtk_container_add (GTK_CONTAINER (frame20), vbox15);

  scrolledwindow16 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow16);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "scrolledwindow16", scrolledwindow16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow16);
  gtk_box_pack_start (GTK_BOX (vbox15), scrolledwindow16, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow16), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow16), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  clist3 = gtk_clist_new (1);
  gtk_widget_ref (clist3);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "clist3", clist3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist3);
  gtk_container_add (GTK_CONTAINER (scrolledwindow16), clist3);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (clist3));

  label29 = gtk_label_new ("label29");
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 0, label29);

  hseparator8 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator8);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "hseparator8", hseparator8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator8);
  gtk_box_pack_start (GTK_BOX (vbox15), hseparator8, FALSE, TRUE, 2);

  hbuttonbox10 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox10);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "hbuttonbox10", hbuttonbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox10);
  gtk_box_pack_start (GTK_BOX (vbox15), hbuttonbox10, FALSE, TRUE, 0);

  button24 = gtk_button_new_with_label ("New");
  gtk_widget_ref (button24);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "button24", button24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button24);
  gtk_container_add (GTK_CONTAINER (hbuttonbox10), button24);
  GTK_WIDGET_SET_FLAGS (button24, GTK_CAN_DEFAULT);

  button25 = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (button25);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "button25", button25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button25);
  gtk_container_add (GTK_CONTAINER (hbuttonbox10), button25);
  GTK_WIDGET_SET_FLAGS (button25, GTK_CAN_DEFAULT);

  frame5 = gtk_frame_new ("Function List");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_paned_pack2 (GTK_PANED (hpaned2), frame5, TRUE, TRUE);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 2);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame5), vbox4);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow2), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  //gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow2)->hscrollbar), GTK_POLICY_NEVER);
  //gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow2)->vscrollbar), GTK_POLICY_NEVER);

  clist1 = gtk_clist_new (1);
  gtk_widget_ref (clist1);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "clist1", clist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), clist1);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (clist1));

  label16 = gtk_label_new ("label16");
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label16);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator3, FALSE, TRUE, 2);

  hbuttonbox4 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox4);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "hbuttonbox4", hbuttonbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox4);
  gtk_box_pack_start (GTK_BOX (vbox4), hbuttonbox4, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox4), GTK_BUTTONBOX_SPREAD);

  button8 = gtk_button_new_with_label ("New");
  gtk_widget_ref (button8);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "button8", button8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button8);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button8);
  GTK_WIDGET_SET_FLAGS (button8, GTK_CAN_DEFAULT);

  button9 = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (button9);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "button9", button9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button9);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button9);
  GTK_WIDGET_SET_FLAGS (button9, GTK_CAN_DEFAULT);

  button11 = gtk_button_new_with_label ("Edit");
  gtk_widget_ref (button11);
  gtk_object_set_data_full (GTK_OBJECT (wndscripts), "button11", button11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button11);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button11);
  GTK_WIDGET_SET_FLAGS (button11, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (button8), "clicked",
                      GTK_SIGNAL_FUNC (onWndScripts_button8_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (onWndScripts_button9_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button11), "clicked",
                      GTK_SIGNAL_FUNC (onWndScripts_button11_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (clist1), "select_row",
                      GTK_SIGNAL_FUNC (onWndScripts_clist1_select_row),
                      this);
  gtk_signal_connect (GTK_OBJECT (clist3), "select_row",
                      GTK_SIGNAL_FUNC (onWndScripts_clist3_select_row),
                      this);
                      
	gtk_widget_show( wndscripts);

	//===
	// Get the command handlers.
	Obj *dyncmd = globals->db->getObj("dyncmd");
	if (!dyncmd) {
		dyncmd = new Obj("dyncmd");
		globals->db->append( dyncmd);
	}

	//===
	// Append them all to the list, show the functions for the first in the list.
	sLList *tmp = dyncmd->objFirst;

	while (tmp) {
		char *text =  tmp->obj->getName();
		if (text) {
			char *tmp2[] = { "" };
			int n = gtk_clist_append( (GtkCList *)clist3, tmp2);
			if (!n) {
				gtk_clist_select_row( (GtkCList *)clist3, 0, 0);
				showFunctionList( text);
			}
		
			gtk_clist_set_text( (GtkCList *)clist3, n, 0, text);
		}
		
		tmp = tmp->next;
	}

}

WndScripts::~WndScripts( void) {
}

void WndScripts::showFunctionList( char *handler) {
	gtk_clist_freeze( (GtkCList *)clist1);
	gtk_clist_clear( (GtkCList *)clist1);

	Obj *dyncmd = globals->db->getObj("dyncmd");
	if (!dyncmd) {
		gtk_clist_thaw( (GtkCList *)clist1);
		return;
	}
	
	Obj *dynhndl = dyncmd->getObj( handler);
	if (!dynhndl) {
		gtk_clist_thaw( (GtkCList *)clist1);
		return;
	}

	sLList *tmp = dynhndl->objFirst;
	while (tmp) {
		char *text =  tmp->obj->getName();
		if (text) {
			char *tmp2[] = { "" };
			int n = gtk_clist_append( (GtkCList *)clist1, tmp2);

			if (!n)
				gtk_clist_select_row( (GtkCList *)clist1, 0, 0);

			gtk_clist_set_text( (GtkCList *)clist1, n, 0, text);
		}
	
		tmp = tmp->next;
	}
	

	gtk_clist_thaw( (GtkCList *)clist1);
}

void WndScripts::add( char *fn) {
	//===
	// Find the command from the list.
		char *cmd = NULL;
		int n2 = gtk_clist_get_text(
			(GtkCList *)clist3,
			myrow2,
			0,
			(gchar **)&cmd
		);

		if (!n2)
			return;
			
		if (!cmd || !*cmd)
			return;

	Obj *scripts = globals->db->getObj("dyncmd")->getObj( cmd);;
	if (!scripts)
		return;

	Obj *myfn = scripts->getObj( fn);
	if (myfn)
		return;
	
	myfn = new Obj( fn);
	scripts->append( myfn);

	char *tmp2[] = { "" };
	int n = gtk_clist_append( (GtkCList *)clist1, tmp2);
		
	gtk_clist_set_text( (GtkCList *)clist1, n, 0, fn);
}
