#include <string.h>
#include <stdio.h>
#include "../tools/build.h"
#include "../globals.h"
#include "wndusers.h"

gint WndUsers_cmpByName( GtkCList *clist, gconstpointer ptr1, gconstpointer ptr2) {
	return strcasecmp( (char *)*(char **)ptr1, (char *)*(char **)ptr2);
}

//===
// Don't theads_enter, we are called from gtk!
void onWndUsers_clist2_select_row(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
  //gdk_threads_enter();
  //gtk_clist_unselect_all( (GtkCList *)((WndMain *)user_data)->clist2);
  //gdk_threads_leave();
  //if (!column)
  //  new MnuMain( row); //((WndMain *)user_data)->globals, row);

	//===
	// Fill in the User Edit variables.
		char *username = NULL;
		gtk_clist_get_text( clist, row, 0, &username);

		if (username)
			((WndUsers *)user_data)->showUser( username);
}

void WndUsers::showUser( const char *username) {
	Obj *userdb = globals->userdb->getObj( "userdb");
	if (!userdb) return;
	
	Obj *objuser = userdb->getObj( username);
	if (!objuser) return;
	
	//===
	// Reset all the fields.
		gtk_entry_set_text( (GtkEntry *)entry10, "");
		gtk_entry_set_text( (GtkEntry *)entry11, "");
	
	//===
	// Fill in the stuff
		gtk_entry_set_text( (GtkEntry *)entry10, objuser->getName());
		if (char *tmp = objuser->getVar("flags"))
			gtk_entry_set_text( (GtkEntry *)entry11, tmp);
	
	//===
	// Fill in the vars about them.

	//===
	// Fill in the user comments.
		sComments *tmp = objuser->commentFirst;
		if (tmp) {
			//gtk_text_freeze
			//while (tmp) {
			//}
			//gtk_text_thaw( 
		}
}

gboolean onWndUsers_label25_button_press_event  (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data) {

	gtk_clist_set_compare_func( (GtkCList *)((WndUsers *)user_data)->clist2, WndUsers_cmpByName);
	gtk_clist_sort( (GtkCList *)((WndUsers *)user_data)->clist2);

	return FALSE;
}


gboolean onWndUsers_label26_button_press_event  (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data) {

	return FALSE;
}


void onWndUsers_button15_clicked            (GtkButton       *button,
                                        gpointer         user_data) {

}


void onWndUsers_button16_clicked            (GtkButton       *button,
                                        gpointer         user_data) {

}


//===
// Apply
void onWndUsers_button17_clicked( GtkButton *button, gpointer user_data) {
	//===
	// Is the username blank?
		const char *username = gtk_entry_get_text( (GtkEntry *)((WndUsers *)user_data)->entry10);
		const char *flags    = gtk_entry_get_text( (GtkEntry *)((WndUsers *)user_data)->entry11);
		
		if (!username)
			return;
	
		if (!flags)
			flags = "";

	//===
	// Update the clist.
	// Todo: Let's not use a linear search :)
		{
			int i = 0;
			for (; i < ((WndUsers *)user_data)->clistrows; i++) {
				char *tmp;
				gtk_clist_get_text( (GtkCList *)((WndUsers *)user_data)->clist2, i, 0, &tmp);
				if (tmp)
					if (!strcasecmp( tmp, username))
						break;
			}

			if (i != ((WndUsers *)user_data)->clistrows) {
				gtk_clist_set_text( (GtkCList *)((WndUsers *)user_data)->clist2, i, 1, flags);

			} else {
				char *blank[] = { "", "" };
				int n = gtk_clist_append( (GtkCList *)((WndUsers *)user_data)->clist2, blank);
				((WndUsers *)user_data)->clistrows++;
				
				gtk_clist_set_text( (GtkCList *)((WndUsers *)user_data)->clist2, n, 0, (const gchar *)username);
				gtk_clist_set_text( (GtkCList *)((WndUsers *)user_data)->clist2, n, 1, (const gchar *)flags);
			}
		}

	//===
	// Create a new user object.
		Obj *objuser = new Obj( username);
		objuser->setVar( "flags", flags);

	//===
	// Delete the old one
		Obj *userdb = globals->userdb->getObj("userdb");
		if (!userdb) {
			userdb = new Obj("userdb");
			globals->userdb->append( userdb);
		}
		
		Obj *objold = userdb->getObj( username);

		if (objold)
			userdb->delObj( objold);

		userdb->append( objuser);
}


void onWndUsers_button18_clicked            (GtkButton       *button,
                                        gpointer         user_data) {

}


WndUsers::WndUsers( void) {
	clistrows = 0;

  wndusers = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (wndusers), "wndusers", wndusers);
  char buf[ 256];
  sprintf( buf, "zDSBot3 (build %d) - User Edit", BUILD);
  gtk_window_set_title (GTK_WINDOW (wndusers), buf);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_ref (hpaned1);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "hpaned1", hpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hpaned1);
  gtk_container_add (GTK_CONTAINER (wndusers), hpaned1);
  gtk_paned_set_position (GTK_PANED (hpaned1), 200);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_paned_pack1 (GTK_PANED (hpaned1), vbox6, FALSE, TRUE);

  scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow7);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "scrolledwindow7", scrolledwindow7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow7);
  gtk_box_pack_start (GTK_BOX (vbox6), scrolledwindow7, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow7), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  //gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow7)->hscrollbar), GTK_POLICY_NEVER);
  //gtk_range_set_update_policy (GTK_RANGE (GTK_SCROLLED_WINDOW (scrolledwindow7)->vscrollbar), GTK_POLICY_NEVER);

  clist2 = gtk_clist_new (2);
  gtk_widget_ref (clist2);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "clist2", clist2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow7), clist2);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 0, 109);
  gtk_clist_set_column_width (GTK_CLIST (clist2), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist2));

  label25 = gtk_label_new ("Username");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 0, label25);

  label26 = gtk_label_new ("Flags");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_clist_set_column_widget (GTK_CLIST (clist2), 1, label26);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox6), hseparator4, FALSE, TRUE, 2);

  hbuttonbox6 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox6);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "hbuttonbox6", hbuttonbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox6);
  gtk_box_pack_start (GTK_BOX (vbox6), hbuttonbox6, FALSE, TRUE, 2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox6), GTK_BUTTONBOX_SPREAD);

  button15 = gtk_button_new_with_label ("Add User");
  gtk_widget_ref (button15);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "button15", button15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button15);
  gtk_container_add (GTK_CONTAINER (hbuttonbox6), button15);
  GTK_WIDGET_SET_FLAGS (button15, GTK_CAN_DEFAULT);

  button16 = gtk_button_new_with_label ("Delete User");
  gtk_widget_ref (button16);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "button16", button16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button16);
  gtk_container_add (GTK_CONTAINER (hbuttonbox6), button16);
  GTK_WIDGET_SET_FLAGS (button16, GTK_CAN_DEFAULT);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_paned_pack2 (GTK_PANED (hpaned1), vbox7, TRUE, TRUE);

  frame7 = gtk_frame_new ("User Edit");
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame7);
  gtk_box_pack_start (GTK_BOX (vbox7), frame7, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  table5 = gtk_table_new (6, 2, FALSE);
  gtk_widget_ref (table5);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "table5", table5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table5);
  gtk_container_add (GTK_CONTAINER (frame7), table5);

  label18 = gtk_label_new ("Username:");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_table_attach (GTK_TABLE (table5), label18, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_widget_set_usize (label18, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label18), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label18), 0, 0.5);

  label19 = gtk_label_new ("Flags:");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_table_attach (GTK_TABLE (table5), label19, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label19), 0, 0.5);

  entry10 = gtk_entry_new ();
  gtk_widget_ref (entry10);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "entry10", entry10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry10);
  gtk_table_attach (GTK_TABLE (table5), entry10, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 1);

  entry11 = gtk_entry_new ();
  gtk_widget_ref (entry11);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "entry11", entry11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry11);
  gtk_table_attach (GTK_TABLE (table5), entry11, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 1);

  label21 = gtk_label_new ("Vars:");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_table_attach (GTK_TABLE (table5), label21, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label21), 0, 0.5);

  label22 = gtk_label_new ("");
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_table_attach (GTK_TABLE (table5), label22, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 2, 2);
  gtk_misc_set_alignment (GTK_MISC (label22), 0, 0.5);

  label23 = gtk_label_new ("Comments:");
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_table_attach (GTK_TABLE (table5), label23, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label23), 0, 0.5);

  label24 = gtk_label_new ("");
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_table_attach (GTK_TABLE (table5), label24, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 2, 2);
  gtk_misc_set_alignment (GTK_MISC (label24), 0, 0.5);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow5, 1, 2, 2, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 2, 1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2
//  text3 = gtk_text_new (NULL, NULL);
//  gtk_widget_ref (text3);
//  gtk_object_set_data_full (GTK_OBJECT (wndusers), "text3", text3,
//                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (text3);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow5), text3);
//  gtk_text_set_editable (GTK_TEXT (text3), TRUE);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow6, 1, 2, 4, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 2, 1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2
//  text4 = gtk_text_new (NULL, NULL);
//  gtk_widget_ref (text4);
//  gtk_object_set_data_full (GTK_OBJECT (wndusers), "text4", text4,
//                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (text4);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow6), text4);
//  gtk_text_set_editable (GTK_TEXT (text4), TRUE);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator5);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "hseparator5", hseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator5);
  gtk_box_pack_start (GTK_BOX (vbox7), hseparator5, FALSE, TRUE, 2);

  hbuttonbox7 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox7);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "hbuttonbox7", hbuttonbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox7);
  gtk_box_pack_start (GTK_BOX (vbox7), hbuttonbox7, FALSE, TRUE, 2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox7), GTK_BUTTONBOX_SPREAD);

  button17 = gtk_button_new_with_label ("Apply");
  gtk_widget_ref (button17);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "button17", button17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button17);
  gtk_container_add (GTK_CONTAINER (hbuttonbox7), button17);
  GTK_WIDGET_SET_FLAGS (button17, GTK_CAN_DEFAULT);

  button18 = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button18);
  gtk_object_set_data_full (GTK_OBJECT (wndusers), "button18", button18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button18);
  gtk_container_add (GTK_CONTAINER (hbuttonbox7), button18);
  GTK_WIDGET_SET_FLAGS (button18, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (clist2), "select_row",
                      GTK_SIGNAL_FUNC (onWndUsers_clist2_select_row),
                      this);
  gtk_signal_connect (GTK_OBJECT (label25), "button_press_event",
                      GTK_SIGNAL_FUNC (onWndUsers_label25_button_press_event),
                      this);
  gtk_signal_connect (GTK_OBJECT (label26), "button_press_event",
                      GTK_SIGNAL_FUNC (onWndUsers_label26_button_press_event),
                      this);
  gtk_signal_connect (GTK_OBJECT (button15), "clicked",
                      GTK_SIGNAL_FUNC (onWndUsers_button15_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button16), "clicked",
                      GTK_SIGNAL_FUNC (onWndUsers_button16_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button17), "clicked",
                      GTK_SIGNAL_FUNC (onWndUsers_button17_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (button18), "clicked",
                      GTK_SIGNAL_FUNC (onWndUsers_button18_clicked),
                      this);

	//===
	// Add all the users to the list.
		Obj *userdb = globals->userdb->getObj("userdb");
		if (!userdb) {
			userdb = new Obj("userdb");
			globals->userdb->append( userdb);
		}
		sLList *tmp = userdb->objFirst;
		while (tmp) {
			char *username = tmp->obj->getName();
			char *flags    = tmp->obj->getVar("flags");
			
			if (username) {
				if (!flags)
					flags = "";

				char *blank[] = { "", "" };
				int n = gtk_clist_append( (GtkCList *)clist2, blank);
				clistrows++;
				
				gtk_clist_set_text( (GtkCList *)clist2, n, 0, (const gchar *)username);
				gtk_clist_set_text( (GtkCList *)clist2, n, 1, (const gchar *)flags);
			}

			tmp = tmp->next;
		}

	gtk_widget_show( wndusers);
}

WndUsers::~WndUsers( void) {
}
